/**
 * 
 */
package newprocess.diagram.cust.annotations.actions;

import newprocess.diagram.cust.annotations.utils.OpenAnnotationUtil;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.widgets.Event;


/**
 * The class representing a favourite Annotation
 * Action entry
 * @author sh
 *
 */
public class FavouriteAnnotationAction extends Action {
	private String projectName = null;
	private String path = null;
	/**
	 * Constructor
	 */
	public FavouriteAnnotationAction(String projectName, String path, ImageDescriptor imageDescriptor) {
		super(path, imageDescriptor);
		this.projectName = projectName;
		this.path = path;
	}
	
	/**
	 * runs the action and opens the Annotation
	 * in its specified editor
	 */
	@Override
	public void runWithEvent(Event event) {
		super.runWithEvent(event);
		
		// open the Annotation by the OpenAnnotation Utility
		OpenAnnotationUtil openUtil = new OpenAnnotationUtil();
		openUtil.openAnnotation(path, projectName);
	}
}
