/**
 * 
 */
package newprocess.diagram.cust.annotations.actions;

import newprocess.diagram.cust.annotations.commands.WriteCommand;
import newprocess.diagram.cust.annotations.dialogs.ElementChooserDialog;
import newprocess.diagram.cust.annotations.utils.URIConvertUtil;

import org.eclipse.core.resources.IFile;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.DecorationEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;



/**
 * @author sh
 *
 */
public class LinkToAction extends Action {
	private EditPart selectedEditPart = null;
	private String projectName = null;
	/**
	 * Constructor
	 */
	public LinkToAction(String text, ImageDescriptor imageDescriptor, 
			EditPart selectedEditPart, String projectName) {
		super(text, imageDescriptor);
		this.selectedEditPart = selectedEditPart;
		this.projectName = projectName;
	}
	
	/**
	 * runs the action an opens the Workspace selection dialog
	 */
	@Override
	public void run() {
		super.run();
				
		// open the Workspace Selection Dialog
		Shell shell = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();
		ElementChooserDialog chooserDia = new ElementChooserDialog(shell);
		chooserDia.open();
		
		// opens the selection dialog and fetch the project/file
		String project = chooserDia.getSelectedProject();
		IFile file = chooserDia.getSelectedFile();
		if((project == null) || (file == null) || (projectName == null)) return;
		
		// get the relative path for the created file
        URIConvertUtil uriUtil = new URIConvertUtil();
        String path = uriUtil.getPathForFile(file, projectName, project);
        				
		// Write the Annotation to the model
		WriteCommand writeCommand = new WriteCommand();
		writeCommand.executeWriteCommand(selectedEditPart, path);
	
		// notify the decorator
		Object editPolicy = selectedEditPart.getEditPolicy(EditPolicyRoles.DECORATION_ROLE);
		if(editPolicy instanceof DecorationEditPolicy) {
			((DecorationEditPolicy)editPolicy).refresh();
		}
	}
}
