/**
 * 
 */
package newprocess.diagram.cust.annotations.actions;

import newprocess.diagram.cust.annotations.dialogs.AnnotationDialog;

import org.eclipse.gef.EditPart;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;

/**
 * @author sh
 *
 */
public class ManageAnnotationAction extends Action {
	private EditPart selectedEditPart = null;
	private String projectName = null;
	
	/**
	 * Constructor
	 */
	public ManageAnnotationAction(String text, ImageDescriptor imageDescriptor, 
			EditPart selectedEditPart, String projectName) {
		super(text, imageDescriptor);
		this.selectedEditPart = selectedEditPart;
		this.projectName = projectName;
	}
	
	/**
	 * runs the action an opens the management dialog
	 */
	@Override
	public void run() {
		super.run();
		
		// open the management dialog
		Shell shell =  PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();
		AnnotationDialog annoDia = new AnnotationDialog(shell, selectedEditPart, projectName);
		annoDia.open();
	}
}
