/**
 * 
 */
package newprocess.diagram.cust.annotations.commands;

import newprocess.diagram.cust.annotations.utils.FeatureUtil;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.command.ReplaceCommand;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ConnectionNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.DiagramEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;

/**
 * @author sh
 *
 */
public class ChangeCommand {
	/**
	 * Constructor
	 */
	public ChangeCommand() {	
	}
	
	/**
	 * executes a ReplaceCommand
	 */
	public void executeReplaceCommand(EditPart editPart, Object oldValue, Object newValue) {
		// create the ReplaceCommand
		EObject elementToEdit = null;
		FeatureUtil featureUtil = new FeatureUtil();
		EAttribute feature = featureUtil.getFeature(editPart);
		TransactionalEditingDomain diagramEditDomain = null;
		if(editPart instanceof DiagramEditPart) { 
		   diagramEditDomain = ((DiagramEditPart)editPart).getEditingDomain();
		   elementToEdit = ((Diagram)editPart.getModel()).getElement();
		} 
		if(editPart instanceof ShapeNodeEditPart) { 
		   diagramEditDomain = ((ShapeNodeEditPart)editPart).getEditingDomain();
		   elementToEdit = ((Node)editPart.getModel()).getElement();
		}   
		if(editPart instanceof ConnectionNodeEditPart) {			
		   diagramEditDomain = ((ConnectionNodeEditPart)editPart).getEditingDomain();
		   elementToEdit = ((Edge)editPart.getModel()).getElement();
		}   
		
		// execute the ReplaceCommand
		ReplaceCommand repCommand = new ReplaceCommand(diagramEditDomain, elementToEdit, feature, oldValue, newValue);
		EditingDomain dom = repCommand.getDomain();
		dom.getCommandStack().execute(repCommand);
	}
}
