/**
 * 
 */
package newprocess.diagram.cust.annotations.commands;

import java.util.Collection;

import newprocess.diagram.cust.annotations.dialogs.AnnotationList;
import newprocess.diagram.cust.annotations.utils.FeatureUtil;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.command.RemoveCommand;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ConnectionNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.DiagramEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;

/**
 * @author sh
 *
 */
public class DeleteCommand {
	/**
	 * Constructor
	 */
	public DeleteCommand() {	
	}
	
	/**
	 * executes a RemoveCommand which removes the url
	 */
	public void executeRemoveCommand(EditPart editPart, Object value) {
		// do nothing if it is the default value
		if(value.equals(AnnotationList.STANDARD_TEXT)) return;
		
		// create the RemoveCommand
        EObject elementToEdit = null;
		TransactionalEditingDomain diagramEditDomain = null;
		if(editPart instanceof DiagramEditPart) {
			diagramEditDomain = ((DiagramEditPart)editPart).getEditingDomain();
			elementToEdit = ((Diagram)editPart.getModel()).getElement();
		}
		if(editPart instanceof ShapeNodeEditPart) {
			diagramEditDomain = ((ShapeNodeEditPart)editPart).getEditingDomain();
			elementToEdit = ((Node)editPart.getModel()).getElement();
		}	
		if(editPart instanceof ConnectionNodeEditPart) {
			diagramEditDomain = ((ConnectionNodeEditPart)editPart).getEditingDomain();
			elementToEdit = ((Edge)editPart.getModel()).getElement();
		}
		FeatureUtil featureUtil = new FeatureUtil();
		EAttribute feature = featureUtil.getFeature(editPart);
		
		// execute the RemoveCommmand
		RemoveCommand removeCommand = new RemoveCommand(diagramEditDomain, elementToEdit, feature, value);
		EditingDomain dom = removeCommand.getDomain();
		dom.getCommandStack().execute(removeCommand);
	}
	
	/**
	 * executes a RemoveCommand which removes a collection of urls
	 */
	public void executeRemoveCommand(EditPart editPart, Collection values) {
		// create the RemoveCommand
		EObject elementToEdit = null;
		TransactionalEditingDomain diagramEditDomain = null;
		if(editPart instanceof DiagramEditPart) {
			diagramEditDomain = ((DiagramEditPart)editPart).getEditingDomain();
			elementToEdit = ((Diagram)editPart.getModel()).getElement();
		}
		if(editPart instanceof ShapeNodeEditPart) {
			diagramEditDomain = ((ShapeNodeEditPart)editPart).getEditingDomain();
			elementToEdit = ((Node)editPart.getModel()).getElement();
		}
		if(editPart instanceof ConnectionNodeEditPart) {
			diagramEditDomain = ((ConnectionNodeEditPart)editPart).getEditingDomain();
			elementToEdit = ((Edge)editPart.getModel()).getElement();
		}
		FeatureUtil featureUtil = new FeatureUtil();
		EAttribute feature = featureUtil.getFeature(editPart);
		
		// execute the RemoveCommmand
		RemoveCommand removeCommand = new RemoveCommand(diagramEditDomain, elementToEdit, feature, values);
		EditingDomain dom = removeCommand.getDomain();
		dom.getCommandStack().execute(removeCommand);
	}
}
