/**
 * 
 */
package newprocess.diagram.cust.annotations.commands;

import newprocess.Actor;
import newprocess.AsyncActivity;
import newprocess.Conclusion;
import newprocess.Condition;
import newprocess.Event;
import newprocess.Expansion;
import newprocess.Listener;
import newprocess.Loader;
import newprocess.Message;
import newprocess.SyncActivity;
import newprocess.diagram.edit.parts.ActorEditPart;
import newprocess.diagram.edit.parts.AsyncActivity2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityEditPart;
import newprocess.diagram.edit.parts.ConclusionEditPart;
import newprocess.diagram.edit.parts.ConditionEditPart;
import newprocess.diagram.edit.parts.EventEditPart;
import newprocess.diagram.edit.parts.ExpansionEditPart;
import newprocess.diagram.edit.parts.ListenerEditPart;
import newprocess.diagram.edit.parts.LoaderEditPart;
import newprocess.diagram.edit.parts.MessageEditPart;
import newprocess.diagram.edit.parts.ProcessEditPart;
import newprocess.diagram.edit.parts.SyncActivityEditPart;

import org.eclipse.emf.common.util.EList;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Node;

/**
 * @author sh
 *
 */
public class ReadCommand {
	/**
	 * Constructor
	 */
	public ReadCommand() {	
	}
	
	/**
	 * Returns the list of urls for the given EditPart
	 * @param selectedEditPart
	 * @return
	 */
	public EList getValues(EditPart selectedEditPart) {
		if(selectedEditPart instanceof ProcessEditPart) 
		   return ((newprocess.Process)((Diagram)selectedEditPart.getModel()).getElement()).getUrl();
		if(selectedEditPart instanceof MessageEditPart)
		   return ((Message)((Node)selectedEditPart.getModel()).getElement()).getUrl();
		if(selectedEditPart instanceof LoaderEditPart) 
		   return ((Loader)((Node)selectedEditPart.getModel()).getElement()).getUrl();
		if(selectedEditPart instanceof ActorEditPart) 
		   return ((Actor)((Node)selectedEditPart.getModel()).getElement()).getUrl();
		if(selectedEditPart instanceof ConditionEditPart) 
		   return ((Condition)((Node)selectedEditPart.getModel()).getElement()).getUrl();
		if(selectedEditPart instanceof SyncActivityEditPart) 
		   return ((SyncActivity)((Node)selectedEditPart.getModel()).getElement()).getUrl();
		if(selectedEditPart instanceof AsyncActivityEditPart ||
		   selectedEditPart instanceof AsyncActivity2EditPart)
	 	   return ((AsyncActivity)((Node)selectedEditPart.getModel()).getElement()).getUrl();
		if(selectedEditPart instanceof EventEditPart) 
		   return ((Event)((Node)selectedEditPart.getModel()).getElement()).getUrl();
		if(selectedEditPart instanceof ListenerEditPart) 
		   return ((Listener)((Node)selectedEditPart.getModel()).getElement()).getUrl();
		if(selectedEditPart instanceof ConclusionEditPart) 
		   return ((Conclusion)((Node)selectedEditPart.getModel()).getElement()).getUrl();
		if(selectedEditPart instanceof ExpansionEditPart) 
		   return ((Expansion)((Node)selectedEditPart.getModel()).getElement()).getUrl();
		return null;
	}
}
