package newprocess.diagram.cust.annotations.commands;

import newprocess.diagram.cust.annotations.utils.FeatureUtil;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.command.MoveCommand;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ConnectionNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.DiagramEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;


/**
 * @author sh
 *
 */
public class SortCommand {
	/**
	 * Constructor
	 */
	public SortCommand() {	
	}
	
	/**
	 * executes a MoveCommand which moves the commited annotation one 
	 * position upwards or downwards, depending on the index
	 */
	public void executeMoveCommand(EditPart editPart, Object value, int index) {
		// create the MoveCommand
	    EObject elementToEdit = null;		
	    FeatureUtil featureUtil = new FeatureUtil();
	    EAttribute feature = featureUtil.getFeature(editPart);
		TransactionalEditingDomain diagramEditDomain = null;
		
		if(editPart instanceof DiagramEditPart) {
	    	diagramEditDomain = ((DiagramEditPart)editPart).getEditingDomain();
	    	elementToEdit = ((Diagram)editPart.getModel()).getElement();
	    }
		if(editPart instanceof ShapeNodeEditPart) {
	    	diagramEditDomain = ((ShapeNodeEditPart)editPart).getEditingDomain();
	    	elementToEdit = ((Node)editPart.getModel()).getElement();
	    }
	    if(editPart instanceof ConnectionNodeEditPart) {
	    	diagramEditDomain = ((ConnectionNodeEditPart)editPart).getEditingDomain();
	    	elementToEdit = ((Edge)editPart.getModel()).getElement();
	    }
		
	    // execute the MoveCommmand
	    MoveCommand moveCom = new MoveCommand(diagramEditDomain, elementToEdit, feature, value, index);
	    EditingDomain dom = moveCom.getDomain();
	    dom.getCommandStack().execute(moveCom);
	}
}
