/**
 * 
 */
package newprocess.diagram.cust.annotations.commands;

import newprocess.diagram.cust.annotations.utils.FeatureUtil;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.ui.commands.ICommandProxy;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ConnectionNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.DiagramEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.parts.IDiagramEditDomain;
import org.eclipse.gmf.runtime.emf.type.core.commands.SetValueCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.SetRequest;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;

/**
 * @author sh
 *
 */
public class WriteCommand {
	/**
	 * Constructor
	 */
	public WriteCommand() {	
	}
	
	/**
	 * executes a SetValueCommand which writes a value to the collection
	 */
	public void executeWriteCommand(EditPart editPart, Object value) {
		TransactionalEditingDomain writeEditingDomain = null;
		EObject elementToEdit = null;
		EAttribute feature = null;
		FeatureUtil featureUtil = null;
		IDiagramEditDomain diagramEditDomain = null;
		
		if(editPart instanceof DiagramEditPart) {
			// create the SetValueCommand
	        writeEditingDomain = ((DiagramEditPart)editPart).getEditingDomain();
	        elementToEdit = ((Diagram)editPart.getModel()).getElement();
			featureUtil = new FeatureUtil();
			feature = featureUtil.getFeature(editPart);
			diagramEditDomain = ((DiagramEditPart)editPart).getDiagramEditDomain();	
		}
		if(editPart instanceof ShapeNodeEditPart) {
			// create the SetValueCommand
	        writeEditingDomain = ((ShapeNodeEditPart)editPart).getEditingDomain();
	        elementToEdit = ((Node)editPart.getModel()).getElement();
			featureUtil = new FeatureUtil();
			feature = featureUtil.getFeature(editPart);
			diagramEditDomain = ((ShapeNodeEditPart)editPart).getDiagramEditDomain();	
		}
		if(editPart instanceof ConnectionNodeEditPart) {
			// create the SetValueCommand
	        writeEditingDomain = ((ConnectionNodeEditPart)editPart).getEditingDomain();
	        elementToEdit = ((Edge)editPart.getModel()).getElement();
			featureUtil = new FeatureUtil();
			feature = featureUtil.getFeature(editPart);
			diagramEditDomain = ((ConnectionNodeEditPart)editPart).getDiagramEditDomain();
		}
		
		
		// execute the SetValueCommmand
		SetRequest reqSet = new SetRequest(writeEditingDomain, elementToEdit, feature, value);
		SetValueCommand setCommand = new SetValueCommand(reqSet);
		ICommandProxy proxy = new ICommandProxy(setCommand);
		diagramEditDomain.getDiagramCommandStack().execute(proxy);
	}
		
	/**
	 * clear the annotations collection 
	 */
	/*
	public void clearValues(ShapeNodeEditPart editPart) {
		if(editPart instanceof PersonEditPart) {
			((person)((Node)editPart.getModel()).getElement()).getUrl().clear();
		}
	}
	*/
	
	/**
	 * checks if the given Object is already stored
	 * in the model
	 * @return
	 */
	/*
	public boolean containsObject(ShapeNodeEditPart editPart, Object value) {
		if(editPart instanceof PersonEditPart) {
			EList items = ((person)((Node)editPart.getModel()).getElement()).getUrl();
			if(items.contains(value)) return true;
		}	
		return false;
	}
	*/
}
