/**
 * 
 */
package newprocess.diagram.cust.annotations.dialogs;

import org.eclipse.jface.viewers.ICellModifier;
import org.eclipse.swt.widgets.TableItem;

/**
 * This class implements an ICellModifier
 * An ICellModifier is called when the user modifes a cell in the 
 * tableViewer
 * 
 * @author sh
 */

public class AnnotationCellModifier implements ICellModifier {
	private AnnotationDialog newAnnotationDialog;
	
	/**
	 * Constructor 
	 * @param newAnnotationDialog an instance of a NewAnnotationDialog 
	 */
	public AnnotationCellModifier(AnnotationDialog newAnnotationDialog) {
		super();
		this.newAnnotationDialog = newAnnotationDialog;
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.ICellModifier#canModify(java.lang.Object, java.lang.String)
	 */
	public boolean canModify(Object element, String property) {
		return true;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.ICellModifier#getValue(java.lang.Object, java.lang.String)
	 */
	public Object getValue(Object element, String property) {
		// Find the index of the column
		int columnIndex = newAnnotationDialog.getColumnNames().indexOf(property);

		Object result = null;
		Annotation annotation = (Annotation)element;
		
		switch (columnIndex) {
			case 0 : // URL_COLUMN 
				result = annotation.getUri();
				break;
			default :
				result = "";
		}
		return result;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.ICellModifier#modify(java.lang.Object, java.lang.String, java.lang.Object)
	 */
	public void modify(Object element, String property, Object value) {

		// Find the index of the column 
		int columnIndex	= newAnnotationDialog.getColumnNames().indexOf(property);
			
		TableItem item = (TableItem) element;
		Annotation annotation = (Annotation)item.getData();
		String valueString;
				
		switch (columnIndex) {
			case 0 : // URL_COLUMN
				valueString = ((String) value).trim();
				if(valueString.equals(AnnotationList.STANDARD_TEXT) || valueString.equals("")) {
					System.err.println("\"(standard)\" or an empty string is not accepted !");
					return;
				}
				annotation.setUri(valueString);
				break;
			default :
		}
		newAnnotationDialog.getAnnotationList().annotationChanged(annotation);
	}

}
