/**
 * 
 */
package newprocess.diagram.cust.annotations.utils;

import newprocess.NewprocessPackage;
import newprocess.diagram.edit.parts.ActorEditPart;
import newprocess.diagram.edit.parts.AsyncActivity2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityEditPart;
import newprocess.diagram.edit.parts.ConclusionEditPart;
import newprocess.diagram.edit.parts.ConditionEditPart;
import newprocess.diagram.edit.parts.EventEditPart;
import newprocess.diagram.edit.parts.ExpansionEditPart;
import newprocess.diagram.edit.parts.ListenerEditPart;
import newprocess.diagram.edit.parts.LoaderEditPart;
import newprocess.diagram.edit.parts.MessageEditPart;
import newprocess.diagram.edit.parts.ProcessEditPart;
import newprocess.diagram.edit.parts.SyncActivityEditPart;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.gef.EditPart;

/**
 * @author sh
 *
 */
public class FeatureUtil {
	/**
	 * Constructor
	 */
	public FeatureUtil() {
	}
	
	/**
	 * This method is used by Commands and fetchs the right 
	 * structural feature which value is to be set
	 */
	public EAttribute getFeature(EditPart editPart)  {		
		if(editPart instanceof ProcessEditPart) 
		   return NewprocessPackage.eINSTANCE.getElement_Url();
		if(editPart instanceof MessageEditPart)
		   return NewprocessPackage.eINSTANCE.getElement_Url();
		if(editPart instanceof LoaderEditPart) 
		   return NewprocessPackage.eINSTANCE.getElement_Url();	
		if(editPart instanceof ActorEditPart) 
		   return NewprocessPackage.eINSTANCE.getElement_Url();
		if(editPart instanceof ConditionEditPart) 
		   return NewprocessPackage.eINSTANCE.getElement_Url();
		if(editPart instanceof SyncActivityEditPart) 
		   return NewprocessPackage.eINSTANCE.getElement_Url();
		if(editPart instanceof AsyncActivityEditPart ||
		   editPart instanceof AsyncActivity2EditPart)
		   return NewprocessPackage.eINSTANCE.getElement_Url();
		if(editPart instanceof EventEditPart) 
		   return NewprocessPackage.eINSTANCE.getElement_Url();		
		if(editPart instanceof ListenerEditPart) 
		   return NewprocessPackage.eINSTANCE.getElement_Url();
		if(editPart instanceof ConclusionEditPart) 
		   return NewprocessPackage.eINSTANCE.getElement_Url();
		if(editPart instanceof ExpansionEditPart) 
		   return NewprocessPackage.eINSTANCE.getElement_Url();
		return null;
	}
	
	/**
	 * This method checks if the given EditPart supports
	 * Annotations. 
	 */
	public boolean isAttributeSupported(EditPart editPart) {		
		if(editPart instanceof ProcessEditPart ||
		   editPart instanceof MessageEditPart ||
		   editPart instanceof LoaderEditPart || 	   	
		   editPart instanceof ActorEditPart || 	   
		   editPart instanceof ConditionEditPart || 	   
		   editPart instanceof SyncActivityEditPart || 	   
		   editPart instanceof AsyncActivityEditPart ||
		   editPart instanceof AsyncActivity2EditPart ||	   
		   editPart instanceof EventEditPart || 	   		
		   editPart instanceof ListenerEditPart || 	   
		   editPart instanceof ConclusionEditPart || 	   
		   editPart instanceof ExpansionEditPart)
		   return true;
		return false;
	}
}
