/**
 * 
 */
package newprocess.diagram.cust.annotations.utils;

import java.util.Vector;

import newprocess.diagram.cust.annotations.actions.ProgramAnnotationAction;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.PlatformUI;

/**
 * This class is intended to fetch the programms
 * specified for an editor from the Annotations 
 * property sheet page.
 * @author sh
 */
public class PropertiesPageUtil {
	Vector<ProgramAnnotationAction> actions = new Vector<ProgramAnnotationAction>();
	private String projectName = null;
	
	/**
	 * Constructor
	 */
	public PropertiesPageUtil(String projectName) {
		super();
		this.projectName = projectName;
	}
	
	/**
	 * fetch the mappings of the Annotations
	 * property sheet page.
	 * This is just a dummy method
	 * @return
	 */
	public Object[] getAnnotationProperties() {
		return null;
		// FIXME "Preferences Sheet Page Workaround"
	}
	
	/**
	 * get the program actions
	 */
	public Vector<ProgramAnnotationAction> getProgramActions() {
		return actions;
	}
	
	/**
	 * create actions for each program
	 */
	public Vector<ProgramAnnotationAction> createProgramActions(IStructuredSelection structuredSelection) {
		// get the editormappings of the property sheet page
		//Object[] mappings = getAnnotationProperties();
		
		//***************************************************************
		// in the first release "MS Word", "MS Excel" are set as default
		if(structuredSelection == null) return null;
		// create a MS Word Action
		ProgramAnnotationAction wordAction = createMSWordAction(structuredSelection);
		actions.add(wordAction);
		
		// create a MS Excel Action
		ProgramAnnotationAction excelAction = createMSExcelAction(structuredSelection);
		actions.add(excelAction);
		//***************************************************************
		return actions;
		// FIXME "Preferences Sheet Page Workaround"
	}
	
	/**
	 * Create a MS Word Action
	 * This method is a workaound
	 */
	private ProgramAnnotationAction createMSWordAction(IStructuredSelection structuredSelection) {
		String text = "New " + AnnotationTypes.MSWORD + "...";
		ImageDescriptor wordImage = PlatformUI.getWorkbench()
						.getSharedImages().getImageDescriptor(AnnotationTypes.MSWORD_ICON_PATH);
		ProgramAnnotationAction wordAction = new ProgramAnnotationAction(text,wordImage,structuredSelection,projectName);
		return wordAction;
		// FIXME "Preferences Sheet Page Workaround"
	}
	
	/**
	 * Create a MS Excel Action
	 * This method is a workaound
	 */
	private ProgramAnnotationAction createMSExcelAction(IStructuredSelection structuredSelection) {
		String text = "New " + AnnotationTypes.MSEXCEL + "...";
		ImageDescriptor excelImage = PlatformUI.getWorkbench()
						.getSharedImages().getImageDescriptor(AnnotationTypes.MSEXCEL_ICON_PATH);
		ProgramAnnotationAction excelAction = new ProgramAnnotationAction(text,excelImage,structuredSelection,projectName);
		return excelAction;
		// FIXME "Preferences Sheet Page Workaround"
	}
}
