/**
 * 
 */
package newprocess.diagram.cust.annotations.wizards;

import newprocess.diagram.cust.annotations.utils.AnnotationTypes;

import org.eclipse.core.runtime.IPath;
import org.eclipse.emf.common.util.URI;
import org.eclipse.gmf.runtime.diagram.ui.resources.editor.ide.internal.l10n.EditorMessages;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.osgi.util.NLS;
import org.eclipse.ui.dialogs.WizardNewFileCreationPage;


/**
 * @author sh
 *
 */
public class NewFileCreationPage extends WizardNewFileCreationPage {
	private String annotationType = null;
	
	public NewFileCreationPage(String pageName, IStructuredSelection selection,
			String type) {
		super(pageName, selection);
		annotationType = type;
	}
	
	@Override
	protected boolean validatePage() {		
		if(super.validatePage()) {
			// do additional validation on the anticipated filename
			String filename = getFileName();
			if(filename == null) return false;
			
			IPath path = getContainerFullPath().append(filename);
			URI fileURI = URI.createURI(path.toString());
			
			// check if the file ends with the correct type
			if(!checkFiletype(fileURI)) {
		       // set an error message
			   setErrorMessage(NLS.bind(EditorMessages.EditorWizardPage_InvalidFilename, filename));
			   return false;
			}
			return true;
		}
		return false;
	}
	
	/*
     * Method to check if the commited file
     * is in the correct format
     */
    private boolean checkFiletype(URI fileuri) {   	
       	// FIXME "Preference Page Workaround"
    	String extension = fileuri.fileExtension();
    	if(annotationType.equals(AnnotationTypes.MSEXCEL)) {
    	  if(extension.equals(AnnotationTypes.MSEXCEL_FILEEXTENSION)) return true;	
    	}
    	else if(annotationType.equals(AnnotationTypes.MSWORD)) {
    	  if(extension.equals(AnnotationTypes.MSWORD_FILEEXTENSION)) return true;
    	}
    	return false;
    }
}
