package newprocess.diagram.cust.decorators;

import newprocess.AsyncActivity;
import newprocess.SyncActivity;
import newprocess.diagram.part.New_processDiagramEditorPlugin;

import org.eclipse.draw2d.Label;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.services.decorator.AbstractDecorator;
import org.eclipse.gmf.runtime.diagram.ui.services.decorator.IDecoratorTarget;
import org.eclipse.gmf.runtime.diagram.ui.services.decorator.IDecoratorTarget.Direction;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;

/**
 * @author sh
 *
 */
public class ActivityTypeDecorator extends AbstractDecorator {
	
	
	public ActivityTypeDecorator(IDecoratorTarget decoratorTarget) {
		super(decoratorTarget);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gmf.runtime.diagram.ui.services.decorator.IDecorator#activate()
	 */
	public void activate() {
		refresh();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gmf.runtime.diagram.ui.services.decorator.IDecorator#refresh()
	 */
	public void refresh() {
		removeDecoration();
		final EditPart editPart = (EditPart) getDecoratorTarget().getAdapter(EditPart.class);
					
		// decorate a shape 
		if(editPart instanceof ShapeNodeEditPart) {
			ImageDescriptor eventImage = null;
			Image image = null; 
			
			EObject model = ((Node)editPart.getModel()).getElement();
			
			if(model instanceof SyncActivity) {
			   eventImage = New_processDiagramEditorPlugin.
					getBundledImageDescriptor("icons/obj16/SyncActivity.gif");
			   image = eventImage.createImage();
				
			   // set the EventType docorator
			   setDecoration(getDecoratorTarget().addShapeDecoration(image,Direction.EAST, -5, false));
				
			   //add the tooltips
			   getDecoration().setToolTip(new Label("Sync Activity"));
			}
			else if(model instanceof AsyncActivity) {
				eventImage = New_processDiagramEditorPlugin.
					getBundledImageDescriptor("icons/obj16/AsyncActivity.gif");
				image = eventImage.createImage();
							   
				// set the EventType docorator
				setDecoration(getDecoratorTarget().addShapeDecoration(image,Direction.EAST, -5, false));
			
				//add the tooltips
				getDecoration().setToolTip(new Label("Async Activity"));
			}	
		}
	}
}

