package newprocess.diagram.cust.decorators;

import newprocess.AsyncActivity;
import newprocess.diagram.part.New_processDiagramEditorPlugin;

import org.eclipse.draw2d.Label;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.services.decorator.AbstractDecorator;
import org.eclipse.gmf.runtime.diagram.ui.services.decorator.IDecoratorTarget;
import org.eclipse.gmf.runtime.diagram.ui.services.decorator.IDecoratorTarget.Direction;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;

/**
 * @author sh
 *
 */
public class OptionalDecorator extends AbstractDecorator {

	
	public OptionalDecorator(IDecoratorTarget decoratorTarget) {
		super(decoratorTarget);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gmf.runtime.diagram.ui.services.decorator.IDecorator#activate()
	 */
	public void activate() {
		refresh();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gmf.runtime.diagram.ui.services.decorator.IDecorator#refresh()
	 */
	public void refresh() {
		removeDecoration();
		final EditPart editPart = (EditPart) getDecoratorTarget().getAdapter(EditPart.class);
		
		ImageDescriptor optionalImage = New_processDiagramEditorPlugin.
				getBundledImageDescriptor("icons/obj16/optional.gif");
		Image image = optionalImage.createImage();
		
		// decorate a shape 
		if(editPart instanceof ShapeNodeEditPart) {
			// handle the optional attribute
			if(checkOptionalCondition((EditPart)editPart)) {		
							
			   // set the Optional docorator if optional is set to true
			   setDecoration(getDecoratorTarget().addShapeDecoration(image,Direction.EAST,-20, false));
			   
			   //add the tooltips
		       getDecoration().setToolTip(new Label("optional"));	
			}
		}	
	}

	/**
	 * Returns the optional attribute setting
	 * @param element
	 * @return
	 */
	private boolean checkOptionalCondition(EditPart element) {
		EObject model = ((Node)element.getModel()).getElement();		
		if(model instanceof AsyncActivity) {
		   return ((AsyncActivity)model).isOptional();
		}
		return Boolean.FALSE;
	}
}

