package newprocess.diagram.cust.decorators;

import newprocess.Condition;
import newprocess.diagram.part.New_processDiagramEditorPlugin;

import org.eclipse.draw2d.Label;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.services.decorator.AbstractDecorator;
import org.eclipse.gmf.runtime.diagram.ui.services.decorator.IDecoratorTarget;
import org.eclipse.gmf.runtime.diagram.ui.services.decorator.IDecoratorTarget.Direction;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;

/**
 * @author sh
 *
 */
public class TemporalConditionDecorator extends AbstractDecorator {

	
	public TemporalConditionDecorator(IDecoratorTarget decoratorTarget) {
		super(decoratorTarget);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gmf.runtime.diagram.ui.services.decorator.IDecorator#activate()
	 */
	public void activate() {
		refresh();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gmf.runtime.diagram.ui.services.decorator.IDecorator#refresh()
	 */
	public void refresh() {
		removeDecoration();
		final EditPart editPart = (EditPart) getDecoratorTarget().getAdapter(EditPart.class);
		
		ImageDescriptor eventImage = New_processDiagramEditorPlugin.
				getBundledImageDescriptor("icons/obj16/temporal.gif");
		Image image = eventImage.createImage();
		
		// decorate a shape 
		if(editPart instanceof ShapeNodeEditPart) {
			// handle the temporal attribute
			if(checkTemporalCondition((EditPart)editPart)) {	 							
				// set the Temporal docorator if temporal is set to true
			    setDecoration(getDecoratorTarget().addShapeDecoration(image,Direction.EAST, -5, false));
			
			    //add the tooltips
		        getDecoration().setToolTip(new Label("temporal"));	
			}
		}
	}
	
	/**
	 * Returns the temporal attribute setting
	 * @param element
	 * @return
	 */
	private boolean checkTemporalCondition(EditPart element) {
		EObject model = ((Node)element.getModel()).getElement();
		
		if(model instanceof Condition) {
			return ((Condition)model).isTemporal();
		}
		/*
		if(model instanceof ConditionProxy) {
			if(((ConditionProxy)model).getCondition() != null)
				return ((ConditionProxy)model).getCondition().isTemporal();
		}
		*/
		return Boolean.FALSE;
	}
}

