package newprocess.diagram.cust.listener;

import java.util.Iterator;
import java.util.List;

import newprocess.diagram.edit.parts.ConditionProxyEditPart;
import newprocess.diagram.edit.parts.ConditionTermConditionProxyEditPart;
import newprocess.diagram.edit.parts.ConditionTermEditPart;
import newprocess.diagram.edit.parts.Expression2EditPart;
import newprocess.diagram.edit.parts.Expression3EditPart;
import newprocess.diagram.edit.parts.Expression4EditPart;
import newprocess.diagram.edit.parts.Expression5EditPart;
import newprocess.diagram.edit.parts.Expression6EditPart;
import newprocess.diagram.edit.parts.Expression7EditPart;
import newprocess.diagram.edit.parts.Expression8EditPart;
import newprocess.diagram.edit.parts.ExpressionEditPart;
import newprocess.diagram.edit.parts.ConditionProxyEditPart.ProxyFigure;

import org.eclipse.draw2d.FigureListener;
import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPart;

/**
 * Moving a Activity results in a refreshBounds of the Expression to rearrange
 * all Terms
 * 
 * @author sh & ts
 *
 */
public class ProxyFigureListener implements FigureListener {
	
	public final static ProxyFigureListener INSTANCE = new ProxyFigureListener();

	public void figureMoved(IFigure figure) {
		if (figure instanceof ProxyFigure) {
			ConditionProxyEditPart host = ((ProxyFigure)figure).getHost();
			List<ConditionTermConditionProxyEditPart> targets = host.getTargetConnections();
			
			Iterator<ConditionTermConditionProxyEditPart> it = targets.iterator();
			while (it.hasNext()) {
				EditPart part = it.next();
				if (part instanceof ConditionTermConditionProxyEditPart) {
					ConditionTermConditionProxyEditPart target = 
						(ConditionTermConditionProxyEditPart)part;
					ConditionTermEditPart source = (ConditionTermEditPart)target.getSource();
					if (source != null) {
						if(source.getParent() instanceof ExpressionEditPart) {
							ExpressionEditPart con = (ExpressionEditPart)source.getParent();
							if(con != null) con.refreshBounds();
						}
						else if(source.getParent() instanceof Expression2EditPart) {
							Expression2EditPart con = (Expression2EditPart)source.getParent();
							if(con != null) con.refreshBounds();
						}	
						else if(source.getParent() instanceof Expression3EditPart) {
							Expression3EditPart con = (Expression3EditPart)source.getParent();
							if(con != null) con.refreshBounds();
						}	
						else if(source.getParent() instanceof Expression4EditPart) {
							Expression4EditPart con = (Expression4EditPart)source.getParent();
							if(con != null) con.refreshBounds();
						}
						else if(source.getParent() instanceof Expression5EditPart) {
							Expression5EditPart con = (Expression5EditPart)source.getParent();
							if(con != null) con.refreshBounds();
						}
						else if(source.getParent() instanceof Expression6EditPart) {
							Expression6EditPart con = (Expression6EditPart)source.getParent();
							if(con != null) con.refreshBounds();
						}
						else if(source.getParent() instanceof Expression7EditPart) {
							Expression7EditPart con = (Expression7EditPart)source.getParent();
							if(con != null) con.refreshBounds();
						}
						else if(source.getParent() instanceof Expression8EditPart) {
							Expression8EditPart con = (Expression8EditPart)source.getParent();
							if(con != null) con.refreshBounds();
						}
					}
				}
			}
		}
	}
}
