/**
 * 
 */
package newprocess.diagram.cust.operation;

import java.util.Iterator;
import java.util.List;

import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPreconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.AsyncActivityEditPart;
import newprocess.diagram.edit.parts.ConditionTermEditPart;
import newprocess.diagram.edit.parts.Expression4EditPart;
import newprocess.diagram.edit.parts.Expression5EditPart;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CommandStack;
import org.eclipse.gef.requests.GroupRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.requests.EditCommandRequestWrapper;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;

/**
 * @author sh
 *
 */
public class AsyncActivityDeleteOperation {
	/**
	 * Delete all terms, if possible
	 * @param host
	 * @author sh
	 */
	public void doExecute(EditPart host) {	
		// exit if the host is not an AsyncActivity
 		if(host instanceof AsyncActivityEditPart == false) return; 				
			 		
 		List childs = host.getChildren();
 		for (Iterator iterator = childs.iterator(); iterator.hasNext();) {
			EditPart  childEP = (EditPart) iterator.next();
			// deleting the terms of the precondition
			if(childEP instanceof AsyncActivityAsyncActivityPreconditionCompartmentEditPart) {
				AsyncActivityAsyncActivityPreconditionCompartmentEditPart preEP = 
					(AsyncActivityAsyncActivityPreconditionCompartmentEditPart)childEP;
				List exprEP = preEP.getChildren();
				for (Iterator iterator2 = exprEP.iterator(); iterator2.hasNext();) {
					EditPart exprChildEP = (EditPart) iterator2.next();
					if(exprChildEP instanceof Expression4EditPart) {
					  Expression4EditPart expr4EP = (Expression4EditPart)exprChildEP;
					  List termsEP = expr4EP.getChildren();
					  for (Iterator iterator3 = termsEP.iterator(); iterator3.hasNext();) {
						EditPart termsChildEP = (EditPart) iterator3.next();
						if(termsChildEP instanceof ConditionTermEditPart) 
						   deleteTerms(termsChildEP, host);
					  }
					}
				}
			}
			
			// deleting the terms of the postconditon
			if(childEP instanceof AsyncActivityAsyncActivityPostconditionCompartmentEditPart) {
				AsyncActivityAsyncActivityPostconditionCompartmentEditPart postEP = 
					(AsyncActivityAsyncActivityPostconditionCompartmentEditPart)childEP;
				List exprEP = postEP.getChildren();
				for (Iterator iterator2 = exprEP.iterator(); iterator2.hasNext();) {
					EditPart exprChildEP = (EditPart) iterator2.next();
					if(exprChildEP instanceof Expression5EditPart) {
					  Expression5EditPart expr4EP = (Expression5EditPart)exprChildEP;
					  List termsEP = expr4EP.getChildren();
					  for (Iterator iterator3 = termsEP.iterator(); iterator3.hasNext();) {
						EditPart termsChildEP = (EditPart) iterator3.next();
						if(termsChildEP instanceof ConditionTermEditPart) 
						   deleteTerms(termsChildEP, host);
					  }
					}
				}
			}
		} 		
	}
	
	private void deleteTerms(EditPart termEP, EditPart host) {
		// create the request, fetch the command and execute it
		GroupRequest req = new GroupRequest(RequestConstants.REQ_DELETE);
		req.setEditParts(termEP);
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) host).getEditingDomain();
		EditCommandRequestWrapper semReq = new EditCommandRequestWrapper(
				new DestroyElementRequest(editingDomain, false), req.getExtendedData());	
		Command command = termEP.getCommand(semReq);
		if(command != null && command.canExecute()) {	
			CommandStack stack = host.getViewer().getEditDomain().getCommandStack();
			stack.execute(command);
		}
	}
}
