package newprocess.diagram.cust.operation;

import java.util.Iterator;
import java.util.List;

import newprocess.diagram.edit.parts.ConditionTermEditPart;
import newprocess.diagram.edit.parts.EventEditPart;
import newprocess.diagram.edit.parts.EventEventPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.Expression6EditPart;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CommandStack;
import org.eclipse.gef.requests.GroupRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.requests.EditCommandRequestWrapper;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;

/**
 * @author sh
 *
 */
public class EventDeleteOperation {
	/**
	 * Delete all terms, if possible
	 * @param host
	 * @author sh
	 */
	public void doExecute(EditPart host) {	
		// exit if the host is not an Event
 		if(host instanceof EventEditPart == false) return; 				
			 		
 		List childs = host.getChildren();
 		for (Iterator iterator = childs.iterator(); iterator.hasNext();) {
			EditPart  childEP = (EditPart) iterator.next();
			// deleting the terms of the postcondition
			if(childEP instanceof EventEventPostconditionCompartmentEditPart) {
				EventEventPostconditionCompartmentEditPart postEP = 
					(EventEventPostconditionCompartmentEditPart)childEP;
				List exprEP = postEP.getChildren();
				for (Iterator iterator2 = exprEP.iterator(); iterator2.hasNext();) {
					EditPart exprChildEP = (EditPart) iterator2.next();
					if(exprChildEP instanceof Expression6EditPart) {
					  Expression6EditPart expr4EP = (Expression6EditPart)exprChildEP;
					  List termsEP = expr4EP.getChildren();
					  for (Iterator iterator3 = termsEP.iterator(); iterator3.hasNext();) {
						EditPart termsChildEP = (EditPart) iterator3.next();
						if(termsChildEP instanceof ConditionTermEditPart) 
						   deleteTerms(termsChildEP, host);
					  }
					}
				}
			}
 		}
	}
	
	private void deleteTerms(EditPart termEP, EditPart host) {
		// create the request, fetch the command and execute it
		GroupRequest req = new GroupRequest(RequestConstants.REQ_DELETE);
		req.setEditParts(termEP);
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) host).getEditingDomain();
		EditCommandRequestWrapper semReq = new EditCommandRequestWrapper(
				new DestroyElementRequest(editingDomain, false), req.getExtendedData());	
		Command command = termEP.getCommand(semReq);
		if(command != null && command.canExecute()) {	
			CommandStack stack = host.getViewer().getEditDomain().getCommandStack();
			stack.execute(command);
		}
	}
}

