package newprocess.diagram.edit.helpers;

import newprocess.AsyncActivity;
import newprocess.Expression;
import newprocess.NewprocessFactory;
import newprocess.NewprocessPackage;
import newprocess.Root;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.common.core.command.ICommand;
import org.eclipse.gmf.runtime.emf.core.util.EMFCoreUtil;
import org.eclipse.gmf.runtime.emf.type.core.commands.ConfigureElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ConfigureRequest;

/**
 * @generated
 */
public class AsyncActivityEditHelper extends New_processBaseEditHelper {
	/**
	 * This method generates the Pre-and Postconditions
	 * and the Roots
	 */
	@Override
	protected ICommand getConfigureCommand(final ConfigureRequest req) {
		return new ConfigureElementCommand(req) {
			protected CommandResult doExecuteWithResult(
					IProgressMonitor monitor, IAdaptable info)
					throws ExecutionException {
				EObject element = req.getElementToConfigure();

				// add the pre and postcondition and essential roots
				doConfiguration(element, monitor);
				return CommandResult.newOKCommandResult(element);
			}
		};
	}

	/**
	 * By creating an SyncActivity the Pre-and Postconditions should also
	 * be generated
	 *  
	 * @param element
	 * @param monitor
	 */
	protected void doConfiguration(EObject element, IProgressMonitor monitor) {
		AsyncActivity activity = (AsyncActivity) element;

		// create the Precondition
		EReference preconditionContainer = NewprocessPackage.eINSTANCE
				.getAsyncActivity_HasPrecondition();
		Expression expressionPre = NewprocessFactory.eINSTANCE
				.createExpression();
		EClass expressionClassPre = expressionPre.eClass();
		EObject preCond = EMFCoreUtil.create(activity, preconditionContainer,
				expressionClassPre);

		// Create Root
		EReference rootContainer = NewprocessPackage.eINSTANCE
				.getExpression_HasRoot();
		Root root = NewprocessFactory.eINSTANCE.createRoot();
		EClass rootClass = root.eClass();
		EMFCoreUtil.create(preCond, rootContainer, rootClass);

		// create the Postcondition
		EReference postconditionContainer = NewprocessPackage.eINSTANCE
				.getAsyncActivity_HasPostcondition();
		Expression expressionPost = NewprocessFactory.eINSTANCE
				.createExpression();
		EClass expressionClassPost = expressionPost.eClass();

		EObject postCond = EMFCoreUtil.create(activity, postconditionContainer,
				expressionClassPost);

		// create Root
		rootContainer = NewprocessPackage.eINSTANCE.getExpression_HasRoot();
		root = NewprocessFactory.eINSTANCE.createRoot();
		rootClass = root.eClass();
		EMFCoreUtil.create(postCond, rootContainer, rootClass);
		
		// set the default value of the timeout property to "86400"
		activity.setTimeout(86400);
	}
}