package newprocess.diagram.edit.helpers;

import newprocess.Expansion;
import newprocess.Expression;
import newprocess.NewprocessFactory;
import newprocess.NewprocessPackage;
import newprocess.Root;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.common.core.command.ICommand;
import org.eclipse.gmf.runtime.emf.core.util.EMFCoreUtil;
import org.eclipse.gmf.runtime.emf.type.core.commands.ConfigureElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ConfigureRequest;

/**
 * @generated
 */
public class ExpansionEditHelper extends New_processBaseEditHelper {
	/**
	 * This method generates the Postconditions
	 * and the Root
	 */
	@Override
	protected ICommand getConfigureCommand(final ConfigureRequest req) {
		return new ConfigureElementCommand(req) {
			protected CommandResult doExecuteWithResult(
					IProgressMonitor monitor, IAdaptable info)
					throws ExecutionException {
				EObject element = req.getElementToConfigure();

				// add the postcondition and the Root
				doConfiguration(element, monitor);
				return CommandResult.newOKCommandResult(element);
			}
		};
	}

	/**
	 * By creating an Expansion the Postconditions should also
	 * be generated
	 *  
	 * @param element
	 * @param monitor
	 */
	protected void doConfiguration(EObject element, IProgressMonitor monitor) {
		Expansion expansion = (Expansion) element;

		// create the Postcondition
		EReference postconditionContainer = NewprocessPackage.eINSTANCE
				.getExpansion_HasPostcondition();
		Expression expressionPost = NewprocessFactory.eINSTANCE
				.createExpression();
		EClass expressionClassPost = expressionPost.eClass();
		EObject postCond = EMFCoreUtil.create(expansion,
				postconditionContainer, expressionClassPost);

		// create the Root
		EReference rootContainer = NewprocessPackage.eINSTANCE
				.getExpression_HasRoot();
		Root root = NewprocessFactory.eINSTANCE.createRoot();
		EClass rootClass = root.eClass();
		EMFCoreUtil.create(postCond, rootContainer, rootClass);
	}
}