package newprocess.diagram.edit.helpers;

import newprocess.Expression;
import newprocess.Listener;
import newprocess.NewprocessFactory;
import newprocess.NewprocessPackage;
import newprocess.Root;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.common.core.command.ICommand;
import org.eclipse.gmf.runtime.emf.core.util.EMFCoreUtil;
import org.eclipse.gmf.runtime.emf.type.core.commands.ConfigureElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ConfigureRequest;

/**
 * @generated
 */
public class ListenerEditHelper extends New_processBaseEditHelper {
	/**
	 * This method generates the Preconditions
	 * and the Root
	 */
	@Override
	protected ICommand getConfigureCommand(final ConfigureRequest req) {
		return new ConfigureElementCommand(req) {
			protected CommandResult doExecuteWithResult(
					IProgressMonitor monitor, IAdaptable info)
					throws ExecutionException {
				EObject element = req.getElementToConfigure();

				// add the precondition and the Root
				doConfiguration(element, monitor);
				return CommandResult.newOKCommandResult(element);
			}
		};
	}

	/**
	 * By creating an Listener the Preconditions should also
	 * be generated
	 *  
	 * @param element
	 * @param monitor
	 */
	protected void doConfiguration(EObject element, IProgressMonitor monitor) {
		Listener listener = (Listener) element;

		// create the Precondition
		EReference preconditionContainer = NewprocessPackage.eINSTANCE
				.getListener_HasPrecondition();
		Expression expressionPre = NewprocessFactory.eINSTANCE
				.createExpression();
		EClass expressionClassPre = expressionPre.eClass();
		EObject preCond = EMFCoreUtil.create(listener, preconditionContainer,
				expressionClassPre);

		// create the Root
		EReference rootContainer = NewprocessPackage.eINSTANCE
				.getExpression_HasRoot();
		Root root = NewprocessFactory.eINSTANCE.createRoot();
		EClass rootClass = root.eClass();
		EMFCoreUtil.create(preCond, rootContainer, rootClass);
	}
}