package newprocess.diagram.edit.parts;

import newprocess.diagram.edit.policies.ActorItemSemanticEditPolicy;
import newprocess.diagram.part.New_processVisualIDRegistry;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Ellipse;
import org.eclipse.draw2d.FreeformLayout;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Polygon;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.XYLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.PointList;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.ResizableShapeEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.XYLayoutEditPolicy;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrapLabel;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

/**
 * @generated
 */
public class ActorEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2007;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public ActorEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();

		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new ActorItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		XYLayoutEditPolicy lep = new XYLayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = super.createChildEditPolicy(child);
				if (result == null) {
					return new ResizableShapeEditPolicy();
				}
				return result;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		ActorFigure figure = new ActorFigure();
		return primaryShape = figure;
	}

	/**
	 * @generated
	 */
	public ActorFigure getPrimaryShape() {
		return (ActorFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof ActorNameEditPart) {
			((ActorNameEditPart) childEditPart).setLabel(getPrimaryShape()
					.getFigureActorNameFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {

		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {

		return super.getContentPaneFor(editPart);
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(getMapMode()
				.DPtoLP(40), getMapMode().DPtoLP(60));

		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			nodeShape.setLayoutManager(new FreeformLayout() {

				public Object getConstraint(IFigure figure) {
					Object result = constraints.get(figure);
					if (result == null) {
						result = new Rectangle(0, 0, -1, -1);
					}
					return result;
				}
			});
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(New_processVisualIDRegistry
				.getType(ActorNameEditPart.VISUAL_ID));
	}

	/**
	 * the figure ist extended to allow dynamic stretching of child components.
	 * @author sh
	 * @generated NOT
	 */
	public class ActorFigure extends RectangleFigure {
		// the objects to resize
		private Ellipse head = null;
		private Polygon body = null;

		// default sizes
		private Dimension defaultActorSize;
		private Dimension defaultHeadSize;
		private PointList defaultBodySize;

		// initial stretch factors
		private double stretchWidthFactor = 1.0;
		private double stretchHeightFactor = 1.0;

		/**
		 * store the default size for stretch calculations
		 * @author sh
		 * @generated  NOT
		 */

		public ActorFigure() {
			this.setLayoutManager(new XYLayout());
			this.setFill(true);
			this.setFillXOR(false);
			this.setOutline(false);
			this.setOutlineXOR(false);
			this.setLineWidth(1);
			this.setLineStyle(Graphics.LINE_SOLID);
			this.setPreferredSize(new Dimension(getMapMode().DPtoLP(40),
					getMapMode().DPtoLP(60)));
			defaultActorSize = this.getPreferredSize();
			createContents();
		}

		/**
		 * calculate stretch factors derived from new actors size
		 * @author ts
		 * @param newActorSize
		 */
		private void setStretchFactor(Rectangle bounds) {
			stretchWidthFactor = (double) bounds.width / defaultActorSize.width;
			stretchHeightFactor = (double) bounds.height
					/ defaultActorSize.height;
		}

		/**
		 * stretch a point
		 * @author ts
		 * @param p
		 */
		private Point stretch(Point p) {
			return new Point((int) (p.x * stretchWidthFactor),
					(int) (p.y * stretchHeightFactor));
		}

		/**
		 * stretch a dimension (for the head)
		 * @author ts
		 * @param d
		 */
		private Dimension stretch(Dimension d) {
			return new Dimension((int) (d.width * stretchWidthFactor),
					(int) (d.height * stretchHeightFactor));
		}

		/**
		 * do the job
		 * @author ts
		 */
		private void stretch() {
			setStretchFactor(getBounds());

			head.setSize(stretch(defaultHeadSize));

			PointList pl = new PointList();
			for (int i = 0; i < defaultBodySize.size(); i++) {
				Point p = defaultBodySize.getPoint(i);
				pl.addPoint(stretch(p));
			}
			body.setPoints(pl);
		}

		/**
		 * tests if all object references and default sizes are initialized
		 * @author ts
		 * @return
		 */
		private boolean isStretchable() {
			return (defaultActorSize != null && defaultBodySize != null
					&& defaultHeadSize != null && head != null && body != null);
		}

		/**
		 * extend repaint by a stretch calculation, if completly initialised
		 * @author ts
		 */
		public void repaint() {
			super.repaint();
			if (isStretchable())
				stretch();
		}

		/**
		 * call new methods to build head and body
		 * @author ts
		 * @generated NOT
		 */

		private void createContents() {
			createHead();
			createBody();

			WrapLabel actorNameFigure0 = new WrapLabel();
			actorNameFigure0.setText("<...>");
			// TODO: position the text label
			this.add(actorNameFigure0);
			setFigureActorNameFigure(actorNameFigure0);
		}

		/**
		 * create the head, store it in the figure and initialize default size
		 * @author ts
		 * create the head of an actor
		 */
		private void createHead() {
			head = new Ellipse();
			head.setFill(true);
			head.setFillXOR(false);
			head.setOutline(true);
			head.setOutlineXOR(false);
			head.setLineWidth(1);
			head.setLineStyle(Graphics.LINE_SOLID);
			head.setForegroundColor(FOREGROUND);
			head.setBackgroundColor(BACKGROUND);
			head.setSize(getMapMode().DPtoLP(40), getMapMode().DPtoLP(20));
			defaultHeadSize = head.getSize();

			this.add(head);
		}

		/**
		 * create the body, store it in the figure and initialize default size
		 * @author ts
		 * create the body of an actor
		 */
		private void createBody() {
			body = new Polygon();
			body.addPoint(new Point(getMapMode().DPtoLP(23), getMapMode()
					.DPtoLP(19)));
			body.addPoint(new Point(getMapMode().DPtoLP(23), getMapMode()
					.DPtoLP(24)));
			body.addPoint(new Point(getMapMode().DPtoLP(39), getMapMode()
					.DPtoLP(24)));
			body.addPoint(new Point(getMapMode().DPtoLP(39), getMapMode()
					.DPtoLP(29)));
			body.addPoint(new Point(getMapMode().DPtoLP(23), getMapMode()
					.DPtoLP(29)));
			body.addPoint(new Point(getMapMode().DPtoLP(23), getMapMode()
					.DPtoLP(36)));
			body.addPoint(new Point(getMapMode().DPtoLP(39), getMapMode()
					.DPtoLP(48)));
			body.addPoint(new Point(getMapMode().DPtoLP(39), getMapMode()
					.DPtoLP(53)));
			body.addPoint(new Point(getMapMode().DPtoLP(20), getMapMode()
					.DPtoLP(42)));
			body.addPoint(new Point(getMapMode().DPtoLP(1), getMapMode()
					.DPtoLP(53)));
			body.addPoint(new Point(getMapMode().DPtoLP(1), getMapMode()
					.DPtoLP(48)));
			body.addPoint(new Point(getMapMode().DPtoLP(17), getMapMode()
					.DPtoLP(36)));
			body.addPoint(new Point(getMapMode().DPtoLP(17), getMapMode()
					.DPtoLP(29)));
			body.addPoint(new Point(getMapMode().DPtoLP(1), getMapMode()
					.DPtoLP(29)));
			body.addPoint(new Point(getMapMode().DPtoLP(1), getMapMode()
					.DPtoLP(24)));
			body.addPoint(new Point(getMapMode().DPtoLP(17), getMapMode()
					.DPtoLP(24)));
			body.addPoint(new Point(getMapMode().DPtoLP(17), getMapMode()
					.DPtoLP(19)));
			body.setFill(true);
			body.setFillXOR(false);
			body.setOutline(true);
			body.setOutlineXOR(false);
			body.setLineWidth(1);
			body.setLineStyle(Graphics.LINE_SOLID);
			body.setForegroundColor(FOREGROUND);
			body.setBackgroundColor(BACKGROUND);
			defaultBodySize = body.getPoints().getCopy();
			this.add(body);
		}

		/**
		 * @generated
		 */
		private WrapLabel fActorNameFigure;

		/**
		 * @generated
		 */
		public WrapLabel getFigureActorNameFigure() {
			return fActorNameFigure;
		}

		/**
		 * @generated
		 */
		private void setFigureActorNameFigure(WrapLabel fig) {
			fActorNameFigure = fig;
		}

		/**
		 * @generated
		 */
		private boolean myUseLocalCoordinates = true;

		/**
		 * @generated
		 */
		protected boolean useLocalCoordinates() {
			return myUseLocalCoordinates;
		}

		/**
		 * @generated
		 */
		protected void setUseLocalCoordinates(boolean useLocalCoordinates) {
			myUseLocalCoordinates = useLocalCoordinates;
		}

	}

	/**
	 * @generated
	 */
	static final Color BODY_FORE = new Color(null, 220, 220, 250);

	/**
	 * @generated
	 */
	static final Color BODY_BACK = new Color(null, 230, 230, 255);

	/**
	 * @generated
	 */
	static final Color HEAD_FORE = new Color(null, 220, 220, 250);

	/**
	 * @generated
	 */
	static final Color HEAD_BACK = new Color(null, 230, 230, 255);

	/**
	 * @author ts
	 * @generated NOT
	 */
	static final Color FOREGROUND = ColorConstants.gray;
	static final Color BACKGROUND = new Color(null, 214, 231, 255);

}
