package newprocess.diagram.edit.parts;

import newprocess.diagram.edit.policies.AsyncActivityItemSemanticEditPolicy;
import newprocess.diagram.part.New_processVisualIDRegistry;
import newprocess.diagram.providers.New_processElementTypes;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.core.edithelpers.CreateElementRequestAdapter;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.CreationEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.DecorationEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.requests.CreateViewAndElementRequest;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrapLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

/**
 * @generated
 */
public class AsyncActivityEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2003;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public AsyncActivityEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		installEditPolicy(EditPolicyRoles.CREATION_ROLE,
				new CreationEditPolicy() {

					public Command getCommand(Request request) {
						if (understandsRequest(request)) {
							if (request instanceof CreateViewAndElementRequest) {
								CreateElementRequestAdapter adapter = ((CreateViewAndElementRequest) request)
										.getViewAndElementDescriptor()
										.getCreateElementRequestAdapter();
								IElementType type = (IElementType) adapter
										.getAdapter(IElementType.class);
								if (type == New_processElementTypes.Expression_3008) {
									EditPart compartmentEditPart = getChildBySemanticHint(New_processVisualIDRegistry
											.getType(AsyncActivityAsyncActivityPreconditionCompartmentEditPart.VISUAL_ID));
									return compartmentEditPart == null ? null
											: compartmentEditPart
													.getCommand(request);
								}
								if (type == New_processElementTypes.Expression_3009) {
									EditPart compartmentEditPart = getChildBySemanticHint(New_processVisualIDRegistry
											.getType(AsyncActivityAsyncActivityPostconditionCompartmentEditPart.VISUAL_ID));
									return compartmentEditPart == null ? null
											: compartmentEditPart
													.getCommand(request);
								}
							}
							return super.getCommand(request);
						}
						return null;
					}
				});
		super.createDefaultEditPolicies();

		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new AsyncActivityItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		LayoutEditPolicy lep = new LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child
						.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		AsyncActivityFigure figure = new AsyncActivityFigure();
		return primaryShape = figure;
	}

	/**
	 * @generated
	 */
	public AsyncActivityFigure getPrimaryShape() {
		return (AsyncActivityFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof AsyncActivityNameEditPart) {
			((AsyncActivityNameEditPart) childEditPart)
					.setLabel(getPrimaryShape()
							.getFigureAsyncActivityNameFigure());
			return true;
		}
		if (childEditPart instanceof AsyncActivityAsyncActivityPreconditionCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureAsyncActivityPreconditionFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane
					.add(((AsyncActivityAsyncActivityPreconditionCompartmentEditPart) childEditPart)
							.getFigure());
			return true;
		}
		if (childEditPart instanceof AsyncActivityAsyncActivityPostconditionCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureAsyncActivityPostconditionFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane
					.add(((AsyncActivityAsyncActivityPostconditionCompartmentEditPart) childEditPart)
							.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {

		if (childEditPart instanceof AsyncActivityAsyncActivityPreconditionCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureAsyncActivityPreconditionFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane
					.remove(((AsyncActivityAsyncActivityPreconditionCompartmentEditPart) childEditPart)
							.getFigure());
			return true;
		}
		if (childEditPart instanceof AsyncActivityAsyncActivityPostconditionCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureAsyncActivityPostconditionFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane
					.remove(((AsyncActivityAsyncActivityPostconditionCompartmentEditPart) childEditPart)
							.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {

		if (editPart instanceof AsyncActivityAsyncActivityPreconditionCompartmentEditPart) {
			return getPrimaryShape().getFigureAsyncActivityPreconditionFigure();
		}
		if (editPart instanceof AsyncActivityAsyncActivityPostconditionCompartmentEditPart) {
			return getPrimaryShape()
					.getFigureAsyncActivityPostconditionFigure();
		}
		return super.getContentPaneFor(editPart);
	}

	/**
	 * overwritten to update the ActivityDecorators
	 * @author sh
	 */
	@Override
	public void notifyChanged(Notification notification) {
		super.notifyChanged(notification);

		// notify the decorator
		Object editPolicy = this.getEditPolicy(EditPolicyRoles.DECORATION_ROLE);
		if (editPolicy instanceof DecorationEditPolicy) {
			((DecorationEditPolicy) editPolicy).refresh();
		}
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(getMapMode()
				.DPtoLP(100), getMapMode().DPtoLP(160));

		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated NOT
	 * @author sh
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(getMapMode().DPtoLP(0));
			layout.setMinorAlignment(ToolbarLayout.ALIGN_TOPLEFT);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(New_processVisualIDRegistry
				.getType(AsyncActivityNameEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public class AsyncActivityFigure extends RectangleFigure {
		/**
		 * @generated NOT
		 * @author sh
		 */
		public AsyncActivityFigure() {
			this.setFill(true);
			this.setFillXOR(false);
			this.setOutline(true);
			this.setOutlineXOR(false);
			this.setLineWidth(0);
			this.setLineStyle(Graphics.LINE_SOLID);
			this.setPreferredSize(new Dimension(getMapMode().DPtoLP(100),
					getMapMode().DPtoLP(160)));
			createContents();

			//******************* gradient *******************************
			Color[] highlight = { ColorConstants.black, ColorConstants.white };
			Color[] shadow = { ColorConstants.white, ColorConstants.black };
			//this.setBorder(new SchemeBorder(new SchemeBorder.Scheme(highlight,shadow)));
			this.setBorder(new LineBorder(ColorConstants.lightGray, 1));
			//************************************************************
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private void createContents() {
			// The Precondition Compartment
			RectangleFigure asyncActivityPreconditionFigure0 = new RectangleFigure();
			asyncActivityPreconditionFigure0.setFill(true);
			asyncActivityPreconditionFigure0.setFillXOR(false);
			asyncActivityPreconditionFigure0.setOutline(true);
			asyncActivityPreconditionFigure0.setOutlineXOR(false);
			asyncActivityPreconditionFigure0.setLineWidth(1);
			asyncActivityPreconditionFigure0.setLineStyle(Graphics.LINE_SOLID);
			this.add(asyncActivityPreconditionFigure0);
			setFigureAsyncActivityPreconditionFigure(asyncActivityPreconditionFigure0);

			// The Activity Name Figure
			WrapLabel asyncActivityNameFigure0 = new WrapLabel();
			asyncActivityNameFigure0.setText("<...>");
			this.add(asyncActivityNameFigure0);
			setFigureAsyncActivityNameFigure(asyncActivityNameFigure0);

			// The Postcondition Compartment
			RectangleFigure asyncActivityPostconditionFigure0 = new RectangleFigure();
			asyncActivityPostconditionFigure0.setFill(true);
			asyncActivityPostconditionFigure0.setFillXOR(false);
			asyncActivityPostconditionFigure0.setOutline(true);
			asyncActivityPostconditionFigure0.setOutlineXOR(false);
			asyncActivityPostconditionFigure0.setLineWidth(1);
			asyncActivityPostconditionFigure0.setLineStyle(Graphics.LINE_SOLID);
			this.add(asyncActivityPostconditionFigure0);
			setFigureAsyncActivityPostconditionFigure(asyncActivityPostconditionFigure0);
		}

		/**
		 * @generated
		 */
		private WrapLabel fAsyncActivityNameFigure;

		/**
		 * @generated
		 */
		public WrapLabel getFigureAsyncActivityNameFigure() {
			return fAsyncActivityNameFigure;
		}

		/**
		 * @generated
		 */
		private void setFigureAsyncActivityNameFigure(WrapLabel fig) {
			fAsyncActivityNameFigure = fig;
		}

		/**
		 * @generated
		 */
		private RectangleFigure fAsyncActivityPreconditionFigure;

		/**
		 * @generated
		 */
		public RectangleFigure getFigureAsyncActivityPreconditionFigure() {
			return fAsyncActivityPreconditionFigure;
		}

		/**
		 * @generated
		 */
		private void setFigureAsyncActivityPreconditionFigure(
				RectangleFigure fig) {
			fAsyncActivityPreconditionFigure = fig;
		}

		/**
		 * @generated
		 */
		private RectangleFigure fAsyncActivityPostconditionFigure;

		/**
		 * @generated
		 */
		public RectangleFigure getFigureAsyncActivityPostconditionFigure() {
			return fAsyncActivityPostconditionFigure;
		}

		/**
		 * @generated
		 */
		private void setFigureAsyncActivityPostconditionFigure(
				RectangleFigure fig) {
			fAsyncActivityPostconditionFigure = fig;
		}

		/**
		 * @generated
		 */
		private boolean myUseLocalCoordinates = false;

		/**
		 * @generated
		 */
		protected boolean useLocalCoordinates() {
			return myUseLocalCoordinates;
		}

		/**
		 * @generated
		 */
		protected void setUseLocalCoordinates(boolean useLocalCoordinates) {
			myUseLocalCoordinates = useLocalCoordinates;
		}

	}

}
