package newprocess.diagram.edit.parts;

import newprocess.ConditionProxy;
import newprocess.NewprocessPackage;
import newprocess.diagram.cust.listener.ProxyFigureListener;
import newprocess.diagram.cust.policies.HighlightEditPolicy;
import newprocess.diagram.edit.policies.ConditionProxyItemSemanticEditPolicy;
import newprocess.diagram.part.New_processVisualIDRegistry;

import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.RoundedRectangle;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.editpolicies.ResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrapLabel;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

/**
 * @generated
 */
public class ConditionProxyEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2006;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public ConditionProxyEditPart(View view) {
		super(view);
	}

	/**
	 * @generated NOT
	 * @author sh
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();

		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new ConditionProxyItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		installEditPolicy(EditPolicyRoles.SNAP_FEEDBACK_ROLE,
				new HighlightEditPolicy());
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		LayoutEditPolicy lep = new LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child
						.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated NOT
	 * @author sh
	 */
	protected IFigure createNodeShape() {
		ProxyFigure figure = new ProxyFigure();

		// tell the figure its host and register a FigureListner
		figure.setHost(this);
		figure.addFigureListener(ProxyFigureListener.INSTANCE);
		primaryShape = figure;

		// change the border corresponding to the invalid flag
		if (((ConditionProxy) ((Node) getModel()).getElement()).isInverted())
			this.getPrimaryShape().setLineWidth(2);
		else
			this.getPrimaryShape().setLineWidth(1);

		return primaryShape;
	}

	/**
	 * @generated
	 */
	public ProxyFigure getPrimaryShape() {
		return (ProxyFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof ConditionProxyProxyNameEditPart) {
			((ConditionProxyProxyNameEditPart) childEditPart)
					.setLabel(getPrimaryShape().getFigureProxyNameFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {

		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {

		return super.getContentPaneFor(editPart);
	}

	/**
	 * reacts on changes of the inverted flag.
	 * If the inverted flag was set we set a fat border.
	 * @author sh
	 */
	public void notifyChanged(Notification notification) {
		super.notifyChanged(notification);

		// react to the inverted property
		if (notification.getEventType() == Notification.SET
				&& notification.getFeatureID(NewprocessPackage.class) == NewprocessPackage.CONDITION_PROXY__INVERTED) {

			// return if we don't have a boolean value	  
			if (notification.getNewValue() == null
					|| notification.getNewValue() instanceof Boolean == false)
				return;

			// do our magic if the proxy has been edited
			if (notification.getNotifier() instanceof ConditionProxy) {
				if (notification.getNewBooleanValue() == true) {
					this.getPrimaryShape().setLineWidth(2);
				} else {
					this.getPrimaryShape().setLineWidth(1);
				}
			}
		}
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(getMapMode()
				.DPtoLP(100), getMapMode().DPtoLP(20));

		return result;
	}

	/**
	 * @generated
	 */
	public EditPolicy getPrimaryDragEditPolicy() {
		EditPolicy result = super.getPrimaryDragEditPolicy();
		if (result instanceof ResizableEditPolicy) {
			ResizableEditPolicy ep = (ResizableEditPolicy) result;
			ep.setResizeDirections(PositionConstants.NONE);
		}
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(getMapMode().DPtoLP(5));
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(New_processVisualIDRegistry
				.getType(ConditionProxyProxyNameEditPart.VISUAL_ID));
	}

	/**
	 * @generated NOT
	 * @author sh
	 */
	public class ProxyFigure extends RoundedRectangle {
		private ConditionProxyEditPart host;

		/**
		 * @generated
		 */
		public ProxyFigure() {
			this.setCornerDimensions(new Dimension(getMapMode().DPtoLP(20),
					getMapMode().DPtoLP(20)));
			this.setFill(true);
			this.setFillXOR(false);
			this.setOutline(true);
			this.setOutlineXOR(false);
			this.setLineWidth(1);
			this.setLineStyle(Graphics.LINE_SOLID);
			this.setBackgroundColor(PROXYFIGURE_BACK);
			this.setPreferredSize(new Dimension(getMapMode().DPtoLP(100),
					getMapMode().DPtoLP(20)));
			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents() {

			WrapLabel proxyNameFigure0 = new WrapLabel();
			proxyNameFigure0.setText("<...>");

			this.add(proxyNameFigure0);
			setFigureProxyNameFigure(proxyNameFigure0);

		}

		/**
		 * @generated
		 */
		private WrapLabel fProxyNameFigure;

		/**
		 * @generated
		 */
		public WrapLabel getFigureProxyNameFigure() {
			return fProxyNameFigure;
		}

		/**
		 * @generated
		 */
		private void setFigureProxyNameFigure(WrapLabel fig) {
			fProxyNameFigure = fig;
		}

		/**
		 * @generated
		 */
		private boolean myUseLocalCoordinates = false;

		/**
		 * @generated
		 */
		protected boolean useLocalCoordinates() {
			return myUseLocalCoordinates;
		}

		/**
		 * @generated
		 */
		protected void setUseLocalCoordinates(boolean useLocalCoordinates) {
			myUseLocalCoordinates = useLocalCoordinates;
		}

		public ConditionProxyEditPart getHost() {
			return host;
		}

		public void setHost(ConditionProxyEditPart host) {
			this.host = host;
		}
	}

	/**
	 * @generated
	 */
	static final Color PROXYFIGURE_BACK = new Color(null, 255, 255, 102);

}
