package newprocess.diagram.edit.parts;

import newprocess.diagram.cust.policies.HighlightEditPolicy;
import newprocess.diagram.edit.policies.ConditionTermConditionProxyItemSemanticEditPolicy;

import org.eclipse.draw2d.Connection;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.PolylineDecoration;
import org.eclipse.draw2d.RotatableDecoration;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ConnectionNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.PolylineConnectionEx;
import org.eclipse.gmf.runtime.notation.View;

/**
 * @generated
 */
public class ConditionTermConditionProxyEditPart extends ConnectionNodeEditPart {
	// needed to set the decorations
	private ConnectionFigure connection = null;

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 4004;

	/**
	 * @generated
	 */
	public ConditionTermConditionProxyEditPart(View view) {
		super(view);
	}

	/**
	 * @generated NOT
	 * @author sh
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new ConditionTermConditionProxyItemSemanticEditPolicy());
		installEditPolicy(EditPolicyRoles.SNAP_FEEDBACK_ROLE,
				new HighlightEditPolicy());
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated NOT
	 * @author sh
	 */
	protected Connection createConnectionFigure() {
		connection = new ConnectionFigure();
		return connection;
	}

	/**
	 * If the Reference Term/Proxy is in the Precondition,
	 * the reference shows to the Term
	 * I the Reference Term/Proxy is in the Postcondition,
	 * the reference shows to the Proxy
	 * 
	 * @author sh
	 */
	protected void refreshVisuals() {
		super.refreshVisuals();

		if (getSource() instanceof ConditionTermEditPart) {
			ConditionTermEditPart port = (ConditionTermEditPart) getSource();

			// set SourceDecoration for the Precondition terms
			if (port.getParent().getParent() instanceof SyncActivitySynActivityPreconditionCompartmentEditPart
					|| port.getParent().getParent() instanceof AsyncActivityAsyncActivityPreconditionCompartmentEditPart
					|| port.getParent().getParent() instanceof AsyncActivityAsyncActivityPreconditionCompartment2EditPart
					|| port.getParent().getParent() instanceof ListenerListenerPreconditionCompartmentEditPart
					|| port.getParent().getParent() instanceof ConclusionConclusionPostconditionCompartmentEditPart)
				connection.setSourceDecoration(connection
						.createSourceDecoration());

			// set TargetDecorations for the Postcondition terms
			else if (port.getParent().getParent() instanceof SyncActivitySynActivityPostconditionCompartmentEditPart
					|| port.getParent().getParent() instanceof AsyncActivityAsyncActivityPostconditionCompartmentEditPart
					|| port.getParent().getParent() instanceof AsyncActivityAsyncActivityPostconditionCompartment2EditPart
					|| port.getParent().getParent() instanceof EventEventPostconditionCompartmentEditPart
					|| port.getParent().getParent() instanceof ExpansionExpansionPostconditionCompartmentEditPart)
				connection.setTargetDecoration(connection
						.createTargetDecoration());
		}
	}

	/**
	 * @generated
	 */
	public class ConnectionFigure extends PolylineConnectionEx {

		/**
		 * @generated NOT
		 * @author sh
		 */
		public ConnectionFigure() {
			this.setFill(true);
			this.setFillXOR(false);
			this.setOutline(true);
			this.setOutlineXOR(false);
			this.setLineWidth(2);
			this.setLineStyle(Graphics.LINE_SOLID);

		}

		/**
		 * @generated NOT
		 * @author sh 
		 */
		private RotatableDecoration createSourceDecoration() {
			PolylineDecoration df = new PolylineDecoration();
			df.setFill(true);
			df.setFillXOR(false);
			df.setOutline(true);
			df.setOutlineXOR(false);
			df.setLineWidth(2);
			df.setLineStyle(Graphics.LINE_SOLID);
			return df;
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private RotatableDecoration createTargetDecoration() {
			PolylineDecoration df = new PolylineDecoration();
			df.setFill(true);
			df.setFillXOR(false);
			df.setOutline(true);
			df.setOutlineXOR(false);
			df.setLineWidth(2);
			df.setLineStyle(Graphics.LINE_SOLID);
			return df;
		}
	}

}
