package newprocess.diagram.edit.parts;

import newprocess.diagram.edit.policies.ExpansionItemSemanticEditPolicy;
import newprocess.diagram.part.New_processVisualIDRegistry;
import newprocess.diagram.providers.New_processElementTypes;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.core.edithelpers.CreateElementRequestAdapter;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.CreationEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.requests.CreateViewAndElementRequest;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrapLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

/**
 * @generated
 */
public class ExpansionEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2009;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public ExpansionEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		installEditPolicy(EditPolicyRoles.CREATION_ROLE,
				new CreationEditPolicy() {

					public Command getCommand(Request request) {
						if (understandsRequest(request)) {
							if (request instanceof CreateViewAndElementRequest) {
								CreateElementRequestAdapter adapter = ((CreateViewAndElementRequest) request)
										.getViewAndElementDescriptor()
										.getCreateElementRequestAdapter();
								IElementType type = (IElementType) adapter
										.getAdapter(IElementType.class);
								if (type == New_processElementTypes.Expression_3011) {
									EditPart compartmentEditPart = getChildBySemanticHint(New_processVisualIDRegistry
											.getType(ExpansionExpansionPostconditionCompartmentEditPart.VISUAL_ID));
									return compartmentEditPart == null ? null
											: compartmentEditPart
													.getCommand(request);
								}
							}
							return super.getCommand(request);
						}
						return null;
					}
				});
		super.createDefaultEditPolicies();

		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new ExpansionItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		LayoutEditPolicy lep = new LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child
						.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		ExpansionFigure figure = new ExpansionFigure();
		return primaryShape = figure;
	}

	/**
	 * @generated
	 */
	public ExpansionFigure getPrimaryShape() {
		return (ExpansionFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof ExpansionNameEditPart) {
			((ExpansionNameEditPart) childEditPart).setLabel(getPrimaryShape()
					.getFigureExpansionNameFigure());
			return true;
		}
		if (childEditPart instanceof ExpansionExpansionPostconditionCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureExpansionPostconditionFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane
					.add(((ExpansionExpansionPostconditionCompartmentEditPart) childEditPart)
							.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {

		if (childEditPart instanceof ExpansionExpansionPostconditionCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureExpansionPostconditionFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane
					.remove(((ExpansionExpansionPostconditionCompartmentEditPart) childEditPart)
							.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {

		if (editPart instanceof ExpansionExpansionPostconditionCompartmentEditPart) {
			return getPrimaryShape().getFigureExpansionPostconditionFigure();
		}
		return super.getContentPaneFor(editPart);
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(getMapMode()
				.DPtoLP(100), getMapMode().DPtoLP(88));

		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(getMapMode().DPtoLP(5));
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(New_processVisualIDRegistry
				.getType(ExpansionNameEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public class ExpansionFigure extends RectangleFigure {
		/**
		 * @generated NOT
		 * @author sh
		 */
		public ExpansionFigure() {
			this.setFill(true);
			this.setFillXOR(false);
			this.setOutline(true);
			this.setOutlineXOR(false);
			this.setLineWidth(0);
			this.setLineStyle(Graphics.LINE_SOLID);
			this.setPreferredSize(new Dimension(getMapMode().DPtoLP(100),
					getMapMode().DPtoLP(88)));
			createContents();

			//******************* gradient *******************************
			Color[] highlight = { ColorConstants.black, ColorConstants.white };
			Color[] shadow = { ColorConstants.white, ColorConstants.black };
			//this.setBorder(new SchemeBorder(new SchemeBorder.Scheme(highlight,shadow)));
			this.setBorder(new LineBorder(ColorConstants.lightGray, 1));
			//************************************************************
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private void createContents() {
			// The Expansion Name Figure
			WrapLabel expansionNameFigure0 = new WrapLabel();
			expansionNameFigure0.setText("<...>");
			this.add(expansionNameFigure0);
			setFigureExpansionNameFigure(expansionNameFigure0);

			// The Postcondition Compartment
			RectangleFigure expansionPostconditionFigure0 = new RectangleFigure();
			expansionPostconditionFigure0.setFill(true);
			expansionPostconditionFigure0.setFillXOR(false);
			expansionPostconditionFigure0.setOutline(true);
			expansionPostconditionFigure0.setOutlineXOR(false);
			expansionPostconditionFigure0.setLineWidth(1);
			expansionPostconditionFigure0.setLineStyle(Graphics.LINE_SOLID);
			this.add(expansionPostconditionFigure0);
			setFigureExpansionPostconditionFigure(expansionPostconditionFigure0);
		}

		/**
		 * @generated
		 */
		private WrapLabel fExpansionNameFigure;

		/**
		 * @generated
		 */
		public WrapLabel getFigureExpansionNameFigure() {
			return fExpansionNameFigure;
		}

		/**
		 * @generated
		 */
		private void setFigureExpansionNameFigure(WrapLabel fig) {
			fExpansionNameFigure = fig;
		}

		/**
		 * @generated
		 */
		private RectangleFigure fExpansionPostconditionFigure;

		/**
		 * @generated
		 */
		public RectangleFigure getFigureExpansionPostconditionFigure() {
			return fExpansionPostconditionFigure;
		}

		/**
		 * @generated
		 */
		private void setFigureExpansionPostconditionFigure(RectangleFigure fig) {
			fExpansionPostconditionFigure = fig;
		}

		/**
		 * @generated
		 */
		private boolean myUseLocalCoordinates = false;

		/**
		 * @generated
		 */
		protected boolean useLocalCoordinates() {
			return myUseLocalCoordinates;
		}

		/**
		 * @generated
		 */
		protected void setUseLocalCoordinates(boolean useLocalCoordinates) {
			myUseLocalCoordinates = useLocalCoordinates;
		}

	}

}
