package newprocess.diagram.edit.parts;

import java.util.Iterator;
import java.util.List;

import newprocess.diagram.cust.figures.TermDefaultSizeNodeFigure;
import newprocess.diagram.cust.locator.RootTermBorderItemLocator;
import newprocess.diagram.cust.locator.TermtBorderItemLocator;
import newprocess.diagram.cust.policies.NodeComponentEditPolicy;
import newprocess.diagram.edit.policies.Expression3CanonicalEditPolicy;
import newprocess.diagram.edit.policies.Expression3ItemSemanticEditPolicy;

import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.AbstractBorderedShapeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IBorderItemEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.BorderItemSelectionEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.CreationEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.DragDropEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

/**
 * @generated
 */
public class Expression3EditPart extends AbstractBorderedShapeEditPart {

	/**
	 * the BorderItemLocators which calculates the layout of BorderItems
	 */
	private TermtBorderItemLocator termLoc = null;
	private RootTermBorderItemLocator rootLoc = null;

	/**
	 * @generated NOT
	 * @author sh
	 * The Expression of the Listener Postcondition
	 */
	public static final int VISUAL_ID = 3007;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public Expression3EditPart(View view) {
		super(view);
	}

	/**
	 * @generated NOT
	 * @author sh
	 */
	protected void createDefaultEditPolicies() {
		installEditPolicy(EditPolicyRoles.CREATION_ROLE,
				new CreationEditPolicy());
		super.createDefaultEditPolicies();

		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new Expression3ItemSemanticEditPolicy());
		installEditPolicy(EditPolicyRoles.DRAG_DROP_ROLE,
				new DragDropEditPolicy());
		installEditPolicy(EditPolicyRoles.CANONICAL_ROLE,
				new Expression3CanonicalEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// install this policy to disable deleting of the Expression Compartment
		installEditPolicy(EditPolicy.COMPONENT_ROLE,
				new NodeComponentEditPolicy());
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		LayoutEditPolicy lep = new LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				if (child instanceof IBorderItemEditPart) {
					return new BorderItemSelectionEditPolicy();
				}
				EditPolicy result = child
						.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		ExpressionFigure figure = new ExpressionFigure();
		return primaryShape = figure;
	}

	/**
	 * @generated
	 */
	public ExpressionFigure getPrimaryShape() {
		return (ExpressionFigure) primaryShape;
	}

	@Override
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	@Override
	protected void removeChildVisual(EditPart child) {
		if (removeFixedChild(child)) {
			return;
		}
		super.removeChildVisual(child);
	}

	/**
	 * 	 
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof RootEditPart) {
			getBorderedFigure().getBorderItemContainer().remove(
					((RootEditPart) childEditPart).getFigure());
			return true;
		}
		if (childEditPart instanceof ConditionTermEditPart) {
			getBorderedFigure().getBorderItemContainer().remove(
					((ConditionTermEditPart) childEditPart).getFigure());
			return true;
		}
		return false;
	}

	@Override
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		if (editPart instanceof RootEditPart) {
			return getBorderedFigure().getBorderItemContainer();
		}
		if (editPart instanceof ConditionTermEditPart) {
			return getBorderedFigure().getBorderItemContainer();
		}
		return getContentPane();
	}

	/**
	 * @author sh
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof RootEditPart) {
			if (rootLoc == null) {
				rootLoc = new RootTermBorderItemLocator(getMainFigure(),
						PositionConstants.SOUTH);
			}
			getBorderedFigure().getBorderItemContainer().add(
					((RootEditPart) childEditPart).getFigure(), rootLoc);
			return true;
		}

		if (childEditPart instanceof ConditionTermEditPart) {
			TermtBorderItemLocator locator = new TermtBorderItemLocator(
					getMainFigure(), PositionConstants.NORTH);
			if (termLoc == null)
				termLoc = locator;
			getBorderedFigure().getBorderItemContainer().add(
					((ConditionTermEditPart) childEditPart).getFigure(),
					locator);
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(getMapMode()
				.DPtoLP(160), getMapMode().DPtoLP(100));

		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createMainFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(getMapMode().DPtoLP(5));
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * Relocates the bordered items on the expression.
	 * If the links to proxies are crossed over the relocate 
	 * moves the bordered items and resolves the crossings.
	 */
	public void refreshBounds() {
		super.refreshBounds();

		// get the item container where bordered items are added
		IFigure itemContainer = this.getBorderedFigure()
				.getBorderItemContainer();

		// iterate over all bordered items the expressio has and consider the root
		List<IFigure> childs = itemContainer.getChildren();
		for (Iterator<IFigure> iterator = childs.iterator(); iterator.hasNext();) {
			IFigure figure = iterator.next();
			if (figure instanceof TermDefaultSizeNodeFigure) {
				// relocate the default term
				this.getTermBorderItemLocator().relocate((IFigure) figure);
				continue;
			}
			if (figure instanceof DefaultSizeNodeFigure) {
				// relocate the root
				this.getRootTermBorderItemLocator().relocate((IFigure) figure);
			}
		}
	}

	/**
	 * get the TermBorderItemLocator
	 */
	public TermtBorderItemLocator getTermBorderItemLocator() {
		return termLoc;
	}

	/**
	 * get the RootTermBorderItemLocator
	 * @return 
	 */
	public RootTermBorderItemLocator getRootTermBorderItemLocator() {
		return rootLoc;
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	public class ExpressionFigure extends RectangleFigure {
		/**
		 * @generated
		 */
		public ExpressionFigure() {
			this.setFill(true);
			this.setFillXOR(false);
			this.setOutline(true);
			this.setOutlineXOR(false);
			this.setLineWidth(1);
			this.setLineStyle(Graphics.LINE_SOLID);
			this.setBackgroundColor(EXPRESSIONFIGURE_BACK);
			this.setPreferredSize(new Dimension(getMapMode().DPtoLP(160),
					getMapMode().DPtoLP(100)));
		}

		/**
		 * @generated
		 */
		private boolean myUseLocalCoordinates = false;

		/**
		 * @generated
		 */
		protected boolean useLocalCoordinates() {
			return myUseLocalCoordinates;
		}

		/**
		 * @generated
		 */
		protected void setUseLocalCoordinates(boolean useLocalCoordinates) {
			myUseLocalCoordinates = useLocalCoordinates;
		}

		@Override
		public void paintFigure(Graphics graphics) {
			super.paintFigure(graphics);
			graphics.setForegroundColor(new Color(null, 148, 255, 172));
			graphics.setBackgroundColor(new Color(null, 186, 255, 172));
			int x = getLocation().x;
			int y = getLocation().y;
			int width = getBounds().width;
			int height = getBounds().height;
			graphics.setLineWidth(1);
			graphics.setLineStyle(Graphics.LINE_SOLID);
			graphics.fillGradient(x, y, width, height, true);
		}
	}

	/**
	 * @generated NOT
	 * @author sh
	 */
	static final Color EXPRESSIONFIGURE_BACK = new Color(null, 0, 255, 0);

}
