package newprocess.diagram.edit.parts;

import newprocess.diagram.edit.policies.SyncActivityItemSemanticEditPolicy;
import newprocess.diagram.part.New_processVisualIDRegistry;
import newprocess.diagram.providers.New_processElementTypes;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.core.edithelpers.CreateElementRequestAdapter;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.CreationEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.DecorationEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.requests.CreateViewAndElementRequest;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrapLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

/**
 * @generated
 */
public class SyncActivityEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2001;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public SyncActivityEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		installEditPolicy(EditPolicyRoles.CREATION_ROLE,
				new CreationEditPolicy() {

					public Command getCommand(Request request) {
						if (understandsRequest(request)) {
							if (request instanceof CreateViewAndElementRequest) {
								CreateElementRequestAdapter adapter = ((CreateViewAndElementRequest) request)
										.getViewAndElementDescriptor()
										.getCreateElementRequestAdapter();
								IElementType type = (IElementType) adapter
										.getAdapter(IElementType.class);
								if (type == New_processElementTypes.Expression_3001) {
									EditPart compartmentEditPart = getChildBySemanticHint(New_processVisualIDRegistry
											.getType(SyncActivitySynActivityPreconditionCompartmentEditPart.VISUAL_ID));
									return compartmentEditPart == null ? null
											: compartmentEditPart
													.getCommand(request);
								}
								if (type == New_processElementTypes.Expression_3006) {
									EditPart compartmentEditPart = getChildBySemanticHint(New_processVisualIDRegistry
											.getType(SyncActivitySynActivityPostconditionCompartmentEditPart.VISUAL_ID));
									return compartmentEditPart == null ? null
											: compartmentEditPart
													.getCommand(request);
								}
							}
							return super.getCommand(request);
						}
						return null;
					}
				});
		super.createDefaultEditPolicies();

		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new SyncActivityItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		LayoutEditPolicy lep = new LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child
						.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		SyncActivityFigure figure = new SyncActivityFigure();	
		return primaryShape = figure;
	}

	/**
	 * @generated
	 */
	public SyncActivityFigure getPrimaryShape() {
		return (SyncActivityFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof SyncActivityNameEditPart) {
			((SyncActivityNameEditPart) childEditPart)
					.setLabel(getPrimaryShape()
							.getFigureSynActivityNameFigure());
			return true;
		}
		if (childEditPart instanceof SyncActivitySynActivityPreconditionCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureSyncActivityPreconditionFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane
					.add(((SyncActivitySynActivityPreconditionCompartmentEditPart) childEditPart)
							.getFigure());
			return true;
		}
		if (childEditPart instanceof SyncActivitySynActivityPostconditionCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureSyncActivityPostconditionFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane
					.add(((SyncActivitySynActivityPostconditionCompartmentEditPart) childEditPart)
							.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {

		if (childEditPart instanceof SyncActivitySynActivityPreconditionCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureSyncActivityPreconditionFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane
					.remove(((SyncActivitySynActivityPreconditionCompartmentEditPart) childEditPart)
							.getFigure());
			return true;
		}
		if (childEditPart instanceof SyncActivitySynActivityPostconditionCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureSyncActivityPostconditionFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane
					.remove(((SyncActivitySynActivityPostconditionCompartmentEditPart) childEditPart)
							.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {

		if (editPart instanceof SyncActivitySynActivityPreconditionCompartmentEditPart) {
			return getPrimaryShape().getFigureSyncActivityPreconditionFigure();
		}
		if (editPart instanceof SyncActivitySynActivityPostconditionCompartmentEditPart) {
			return getPrimaryShape().getFigureSyncActivityPostconditionFigure();
		}
		return super.getContentPaneFor(editPart);
	}

	/**
	 * overwritten to update the ActivityDecorators
	 * @author sh
	 */
	@Override
	public void notifyChanged(Notification notification) {
		super.notifyChanged(notification);

		// notify the decorator
		Object editPolicy = this.getEditPolicy(EditPolicyRoles.DECORATION_ROLE);
		if (editPolicy instanceof DecorationEditPolicy) {
			((DecorationEditPolicy) editPolicy).refresh();
		}
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(getMapMode()
				.DPtoLP(100), getMapMode().DPtoLP(160));

		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated NOT
	 * @author sh
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(getMapMode().DPtoLP(0));
			layout.setMinorAlignment(ToolbarLayout.ALIGN_TOPLEFT);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(New_processVisualIDRegistry
				.getType(SyncActivityNameEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public class SyncActivityFigure extends RectangleFigure {
		/**
		 * @generated NOT
		 * @author sh
		 */
		public SyncActivityFigure() {
			this.setFill(true);
			this.setFillXOR(false);
			this.setOutline(true);
			this.setOutlineXOR(false);
			this.setLineWidth(0);
			this.setLineStyle(Graphics.LINE_SOLID);
			this.setPreferredSize(new Dimension(getMapMode().DPtoLP(100),
					getMapMode().DPtoLP(160)));
			createContents();

			//******************* gradient *******************************
			Color[] highlight = { ColorConstants.black, ColorConstants.white };
			Color[] shadow = { ColorConstants.white, ColorConstants.black };
			//this.setBorder(new SchemeBorder(new SchemeBorder.Scheme(highlight,shadow)));
			this.setBorder(new LineBorder(ColorConstants.lightGray, 1));
			//************************************************************
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private void createContents() {
			// The Precondition Compartment
			RectangleFigure syncActivityPreconditionFigure0 = new RectangleFigure();
			syncActivityPreconditionFigure0.setFill(true);
			syncActivityPreconditionFigure0.setFillXOR(false);
			syncActivityPreconditionFigure0.setOutline(true);
			syncActivityPreconditionFigure0.setOutlineXOR(false);
			syncActivityPreconditionFigure0.setLineWidth(1);
			syncActivityPreconditionFigure0.setLineStyle(Graphics.LINE_SOLID);
			this.add(syncActivityPreconditionFigure0);
			setFigureSyncActivityPreconditionFigure(syncActivityPreconditionFigure0);

			// The Activity Name Figure
			WrapLabel synActivityNameFigure0 = new WrapLabel();
			synActivityNameFigure0.setText("<...>");
			this.add(synActivityNameFigure0);
			setFigureSynActivityNameFigure(synActivityNameFigure0);

			// The Postcondition Compartment
			RectangleFigure syncActivityPostconditionFigure0 = new RectangleFigure();
			syncActivityPostconditionFigure0.setFill(true);
			syncActivityPostconditionFigure0.setFillXOR(false);
			syncActivityPostconditionFigure0.setOutline(true);
			syncActivityPostconditionFigure0.setOutlineXOR(false);
			syncActivityPostconditionFigure0.setLineWidth(1);
			syncActivityPostconditionFigure0.setLineStyle(Graphics.LINE_SOLID);
			this.add(syncActivityPostconditionFigure0);
			setFigureSyncActivityPostconditionFigure(syncActivityPostconditionFigure0);
		}

		/**
		 * @generated
		 */
		private WrapLabel fSynActivityNameFigure;

		/**
		 * @generated
		 */
		public WrapLabel getFigureSynActivityNameFigure() {
			return fSynActivityNameFigure;
		}

		/**
		 * @generated
		 */
		private void setFigureSynActivityNameFigure(WrapLabel fig) {
			fSynActivityNameFigure = fig;
		}

		/**
		 * @generated
		 */
		private RectangleFigure fSyncActivityPreconditionFigure;

		/**
		 * @generated
		 */
		public RectangleFigure getFigureSyncActivityPreconditionFigure() {
			return fSyncActivityPreconditionFigure;
		}

		/**
		 * @generated
		 */
		private void setFigureSyncActivityPreconditionFigure(RectangleFigure fig) {
			fSyncActivityPreconditionFigure = fig;
		}

		/**
		 * @generated
		 */
		private RectangleFigure fSyncActivityPostconditionFigure;

		/**
		 * @generated
		 */
		public RectangleFigure getFigureSyncActivityPostconditionFigure() {
			return fSyncActivityPostconditionFigure;
		}

		/**
		 * @generated
		 */
		private void setFigureSyncActivityPostconditionFigure(
				RectangleFigure fig) {
			fSyncActivityPostconditionFigure = fig;
		}

		/**
		 * @generated
		 */
		private boolean myUseLocalCoordinates = false;

		/**
		 * @generated
		 */
		protected boolean useLocalCoordinates() {
			return myUseLocalCoordinates;
		}

		/**
		 * @generated
		 */
		protected void setUseLocalCoordinates(boolean useLocalCoordinates) {
			myUseLocalCoordinates = useLocalCoordinates;
		}

	}

}
