package newprocess.diagram.edit.policies;

import newprocess.Conclusion;
import newprocess.ConditionProxy;
import newprocess.ConditionTerm;
import newprocess.Expansion;
import newprocess.NewprocessPackage;
import newprocess.OperatorTerm;
import newprocess.Root;
import newprocess.diagram.cust.operation.ConditionProxyChainDeleteOperation;
import newprocess.diagram.providers.New_processElementTypes;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.UnexecutableCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.SetValueCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.SetRequest;
import org.eclipse.gmf.runtime.notation.View;

/**
 * @generated
 */
public class ConditionProxyItemSemanticEditPolicy extends
		New_processBaseItemSemanticEditPolicy {

	/**
	 * @generated NOT
	 * @author sh
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		return getMSLWrapper(new DestroyElementCommand(req) {

			protected EObject getElementToDestroy() {
				View view = (View) getHost().getModel();
				EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
				if (annotation != null) {
					return view;
				}

				// if the proxy should be deleted, also delete all linked terms
				ConditionProxyChainDeleteOperation deleteOperation = new ConditionProxyChainDeleteOperation();
				deleteOperation.doExecute(getHost());

				return super.getElementToDestroy();
			}

		});
	}

	/**
	 * @generated NOT
	 * @author sh
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		if (New_processElementTypes.OperatorTermSubTerm_4003 == req
				.getElementType()) {
			if (req.getTarget() != null)
				return getCreateCompleteIncomingOperatorTerm_ConditionProxyCommand(req);
		}
		if (New_processElementTypes.ConditionTermConditionProxy_4004 == req
				.getElementType()) {
			if (req.getTarget() == null)
				return null; // proxy --> term
			else
				return getCreateCompleteIncomingConditionTerm_ConditionProxy4004Command(req);
		}
		if (New_processElementTypes.RootTerm_4002 == req.getElementType()) {
			if (req.getTarget() == null)
				return null; // proxy --> root
			else
				return getCreateCompleteIncomingRoot_ConditionProxyCommand(req);
		}
		if (New_processElementTypes.ConclusionConclusionProxy_4005 == req
				.getElementType()) {
			return req.getTarget() == null ? null
					: getCreateCompleteIncomingConclusion_ConclusionProxy4005Command(req);
		}
		if (New_processElementTypes.ExpansionExpansionProxy_4006 == req
				.getElementType()) {
			return req.getTarget() == null ? null
					: getCreateCompleteIncomingExpansion_ExpansionProxy4006Command(req);
		}
		return super.getCreateRelationshipCommand(req);
	}

	/**
	 * @author sh
	 * @param req
	 * @return
	 */
	protected Command getCreateCompleteIncomingOperatorTerm_ConditionProxyCommand(
			CreateRelationshipRequest req) {

		// check source and target objects
		EObject sourceEObject = req.getSource();
		EObject targetEObject = req.getTarget();

		// if source is not an operator and target is not a proxy
		if (!(sourceEObject instanceof OperatorTerm)
				|| !(targetEObject instanceof ConditionProxy)) {
			return UnexecutableCommand.INSTANCE;
		}

		OperatorTerm source = (OperatorTerm) sourceEObject;
		ConditionProxy target = (ConditionProxy) targetEObject;

		if (!New_processBaseItemSemanticEditPolicy.LinkConstraints
				.canCreateOperatorTermConditionProxy(source, target)) {
			return UnexecutableCommand.INSTANCE;
		}

		return new Command() {
		};
	}

	/**
	 * @author sh
	 * @param req
	 * @return
	 */
	protected Command getCreateCompleteIncomingRoot_ConditionProxyCommand(
			CreateRelationshipRequest req) {

		// check source and target objects
		EObject sourceEObject = req.getSource();
		EObject targetEObject = req.getTarget();

		// if source is not an operator and target is not a proxy
		if (!(sourceEObject instanceof Root)
				|| !(targetEObject instanceof ConditionProxy)) {
			return UnexecutableCommand.INSTANCE;
		}

		Root source = (Root) sourceEObject;
		ConditionProxy target = (ConditionProxy) targetEObject;

		if (!New_processBaseItemSemanticEditPolicy.LinkConstraints
				.canCreateRootConditionProxy(source, target)) {
			return UnexecutableCommand.INSTANCE;
		}

		return new Command() {
		};
	}

	/**
	 * @generated
	 */
	protected Command getCreateCompleteIncomingConditionTerm_ConditionProxy4004Command(
			CreateRelationshipRequest req) {
		EObject sourceEObject = req.getSource();
		EObject targetEObject = req.getTarget();
		if (false == sourceEObject instanceof ConditionTerm
				|| false == targetEObject instanceof ConditionProxy) {
			return UnexecutableCommand.INSTANCE;
		}
		ConditionTerm source = (ConditionTerm) sourceEObject;
		ConditionProxy target = (ConditionProxy) targetEObject;
		if (!New_processBaseItemSemanticEditPolicy.LinkConstraints
				.canCreateConditionTermConditionProxy_4004(source, target)) {
			return UnexecutableCommand.INSTANCE;
		}
		SetRequest setReq = new SetRequest(req.getSource(),
				NewprocessPackage.eINSTANCE.getConditionTerm_ConditionProxy(),
				req.getTarget());
		return getMSLWrapper(new SetValueCommand(setReq));
	}

	/**
	 * @generated
	 */
	protected Command getCreateCompleteIncomingConclusion_ConclusionProxy4005Command(
			CreateRelationshipRequest req) {
		EObject sourceEObject = req.getSource();
		EObject targetEObject = req.getTarget();
		if (false == sourceEObject instanceof Conclusion
				|| false == targetEObject instanceof ConditionProxy) {
			return UnexecutableCommand.INSTANCE;
		}
		Conclusion source = (Conclusion) sourceEObject;
		ConditionProxy target = (ConditionProxy) targetEObject;
		if (!New_processBaseItemSemanticEditPolicy.LinkConstraints
				.canCreateConclusionConclusionProxy_4005(source, target)) {
			return UnexecutableCommand.INSTANCE;
		}
		SetRequest setReq = new SetRequest(req.getSource(),
				NewprocessPackage.eINSTANCE.getConclusion_ConclusionProxy(),
				req.getTarget());
		return getMSLWrapper(new SetValueCommand(setReq));
	}

	/**
	 * @generated
	 */
	protected Command getCreateCompleteIncomingExpansion_ExpansionProxy4006Command(
			CreateRelationshipRequest req) {
		EObject sourceEObject = req.getSource();
		EObject targetEObject = req.getTarget();
		if (false == sourceEObject instanceof Expansion
				|| false == targetEObject instanceof ConditionProxy) {
			return UnexecutableCommand.INSTANCE;
		}
		Expansion source = (Expansion) sourceEObject;
		ConditionProxy target = (ConditionProxy) targetEObject;
		if (!New_processBaseItemSemanticEditPolicy.LinkConstraints
				.canCreateExpansionExpansionProxy_4006(source, target)) {
			return UnexecutableCommand.INSTANCE;
		}
		SetRequest setReq = new SetRequest(req.getSource(),
				NewprocessPackage.eINSTANCE.getExpansion_ExpansionProxy(), req
						.getTarget());
		return getMSLWrapper(new SetValueCommand(setReq));
	}
}
