package newprocess.diagram.edit.policies;

import newprocess.ConditionProxy;
import newprocess.NewprocessPackage;
import newprocess.OperatorTerm;
import newprocess.Root;
import newprocess.Term;
import newprocess.diagram.cust.operation.OperatorTermChainDeleteOperation;
import newprocess.diagram.providers.New_processElementTypes;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.UnexecutableCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.SetValueCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.SetRequest;
import org.eclipse.gmf.runtime.notation.View;

/**
 * @generated
 */
public class OrOperatorItemSemanticEditPolicy extends
		New_processBaseItemSemanticEditPolicy {

	/**
	 * @generated NOT
	 * @author sh
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		return getMSLWrapper(new DestroyElementCommand(req) {

			protected EObject getElementToDestroy() {
				View view = (View) getHost().getModel();
				EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
				if (annotation != null) {
					return view;
				}

				// if the operator should be deleted, also delete all linked ports
				OperatorTermChainDeleteOperation deleteOperation = new OperatorTermChainDeleteOperation();
				deleteOperation.doExecute(getHost());

				return super.getElementToDestroy();
			}

		});
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		if (New_processElementTypes.RootTerm_4002 == req.getElementType()) {
			return req.getTarget() == null ? null
					: getCreateCompleteIncomingRoot_Term4002Command(req);
		}
		if (New_processElementTypes.OperatorTermSubTerm_4003 == req
				.getElementType()) {
			return req.getTarget() == null ? getCreateStartOutgoingOperatorTerm_SubTerm4003Command(req)
					: getCreateCompleteIncomingOperatorTerm_SubTerm4003Command(req);
		}
		return super.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getCreateCompleteIncomingRoot_Term4002Command(
			CreateRelationshipRequest req) {
		EObject sourceEObject = req.getSource();
		EObject targetEObject = req.getTarget();
		if (false == sourceEObject instanceof Root
				|| false == targetEObject instanceof Term) {
			return UnexecutableCommand.INSTANCE;
		}
		Root source = (Root) sourceEObject;
		Term target = (Term) targetEObject;
		if (!New_processBaseItemSemanticEditPolicy.LinkConstraints
				.canCreateRootTerm_4002(source, target)) {
			return UnexecutableCommand.INSTANCE;
		}
		SetRequest setReq = new SetRequest(req.getSource(),
				NewprocessPackage.eINSTANCE.getRoot_Term(), req.getTarget());
		return getMSLWrapper(new SetValueCommand(setReq));
	}

	/**
	 * @generated NOT
	 * @author sh
	 */
	protected Command getCreateStartOutgoingOperatorTerm_SubTerm4003Command(
			CreateRelationshipRequest req) {
		/*
		 EObject sourceEObject = req.getSource();
		 EObject targetEObject = req.getTarget();
		 if (false == sourceEObject instanceof OperatorTerm
		 || (targetEObject != null && false == targetEObject instanceof Term)) {
		 return UnexecutableCommand.INSTANCE;
		 }
		 OperatorTerm source = (OperatorTerm) sourceEObject;
		 Term target = (Term) targetEObject;
		 if (!New_processBaseItemSemanticEditPolicy.LinkConstraints
		 .canCreateOperatorTermSubTerm_4003(source, target)) {
		 return UnexecutableCommand.INSTANCE;
		 }
		 return new Command() {
		 };
		 */

		EObject sourceEObject = req.getSource();
		EObject targetEObject = req.getTarget();
		if (false == sourceEObject instanceof OperatorTerm
				|| (targetEObject != null && false == targetEObject instanceof ConditionProxy)) {
			return UnexecutableCommand.INSTANCE;
		}
		OperatorTerm source = (OperatorTerm) sourceEObject;
		Term target = (Term) targetEObject;
		if (!New_processBaseItemSemanticEditPolicy.LinkConstraints
				.canCreateOperatorTermSubTerm_4003(source, target)) {
			return UnexecutableCommand.INSTANCE;
		}
		return new Command() {
		};
	}

	/**
	 * @generated
	 */
	protected Command getCreateCompleteIncomingOperatorTerm_SubTerm4003Command(
			CreateRelationshipRequest req) {
		EObject sourceEObject = req.getSource();
		EObject targetEObject = req.getTarget();
		if (false == sourceEObject instanceof OperatorTerm
				|| false == targetEObject instanceof Term) {
			return UnexecutableCommand.INSTANCE;
		}
		OperatorTerm source = (OperatorTerm) sourceEObject;
		Term target = (Term) targetEObject;
		if (!New_processBaseItemSemanticEditPolicy.LinkConstraints
				.canCreateOperatorTermSubTerm_4003(source, target)) {
			return UnexecutableCommand.INSTANCE;
		}
		SetRequest setReq = new SetRequest(req.getSource(),
				NewprocessPackage.eINSTANCE.getOperatorTerm_SubTerm(), req
						.getTarget());
		return getMSLWrapper(new SetValueCommand(setReq));
	}
}
