package newprocess.diagram.edit.policies;

import java.util.List;
import java.util.Collection;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.emf.ecore.EObject;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map;

import newprocess.AsyncActivity;
import newprocess.Conclusion;
import newprocess.ConditionTerm;
import newprocess.Expansion;
import newprocess.NewprocessPackage;
import newprocess.OperatorTerm;
import newprocess.Process;
import newprocess.Root;

import newprocess.diagram.edit.parts.ActorEditPart;
import newprocess.diagram.edit.parts.AndOperatorEditPart;
import newprocess.diagram.edit.parts.AsyncActivity2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityActorEditPart;
import newprocess.diagram.edit.parts.AsyncActivityEditPart;
import newprocess.diagram.edit.parts.ConclusionConclusionProxyEditPart;
import newprocess.diagram.edit.parts.ConclusionEditPart;
import newprocess.diagram.edit.parts.ConditionEditPart;
import newprocess.diagram.edit.parts.ConditionProxyEditPart;
import newprocess.diagram.edit.parts.ConditionTermConditionProxyEditPart;
import newprocess.diagram.edit.parts.ConditionTermEditPart;
import newprocess.diagram.edit.parts.EventEditPart;
import newprocess.diagram.edit.parts.ExpansionEditPart;
import newprocess.diagram.edit.parts.ExpansionExpansionProxyEditPart;
import newprocess.diagram.edit.parts.Expression2EditPart;
import newprocess.diagram.edit.parts.Expression3EditPart;
import newprocess.diagram.edit.parts.Expression4EditPart;
import newprocess.diagram.edit.parts.Expression5EditPart;
import newprocess.diagram.edit.parts.Expression6EditPart;
import newprocess.diagram.edit.parts.Expression7EditPart;
import newprocess.diagram.edit.parts.Expression8EditPart;
import newprocess.diagram.edit.parts.ExpressionEditPart;
import newprocess.diagram.edit.parts.GlobalsEditPart;
import newprocess.diagram.edit.parts.ListenerEditPart;
import newprocess.diagram.edit.parts.LoaderEditPart;
import newprocess.diagram.edit.parts.MessageEditPart;
import newprocess.diagram.edit.parts.OperatorTermSubTermEditPart;
import newprocess.diagram.edit.parts.OrOperatorEditPart;
import newprocess.diagram.edit.parts.ProcessEditPart;
import newprocess.diagram.edit.parts.RootEditPart;
import newprocess.diagram.edit.parts.RootTermEditPart;
import newprocess.diagram.edit.parts.SyncActivityEditPart;

import newprocess.diagram.part.New_processVisualIDRegistry;

import newprocess.diagram.providers.New_processElementTypes;

import org.eclipse.core.runtime.IAdaptable;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.gef.EditPart;

import org.eclipse.gef.commands.Command;

import org.eclipse.gmf.runtime.diagram.core.util.ViewUtil;

import org.eclipse.gmf.runtime.diagram.ui.commands.DeferredLayoutCommand;
import org.eclipse.gmf.runtime.diagram.ui.commands.ICommandProxy;

import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;

import org.eclipse.gmf.runtime.diagram.ui.editpolicies.CanonicalConnectionEditPolicy;

import org.eclipse.gmf.runtime.diagram.ui.requests.CreateConnectionViewRequest;
import org.eclipse.gmf.runtime.diagram.ui.requests.RequestConstants;

import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;

import org.eclipse.gmf.runtime.emf.type.core.IElementType;

import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

/**
 * @generated
 */
public class ProcessCanonicalEditPolicy extends CanonicalConnectionEditPolicy {

	/**
	 * @generated
	 */
	protected List getSemanticChildrenList() {
		List result = new LinkedList();
		EObject modelObject = ((View) getHost().getModel()).getElement();
		View viewObject = (View) getHost().getModel();
		EObject nextValue;
		int nodeVID;
		for (Iterator values = ((Process) modelObject).getHasSyncActivities()
				.iterator(); values.hasNext();) {
			nextValue = (EObject) values.next();
			nodeVID = New_processVisualIDRegistry.getNodeVisualID(viewObject,
					nextValue);
			if (SyncActivityEditPart.VISUAL_ID == nodeVID) {
				result.add(nextValue);
			}
		}
		for (Iterator values = ((Process) modelObject).getHasListeners()
				.iterator(); values.hasNext();) {
			nextValue = (EObject) values.next();
			nodeVID = New_processVisualIDRegistry.getNodeVisualID(viewObject,
					nextValue);
			if (ListenerEditPart.VISUAL_ID == nodeVID) {
				result.add(nextValue);
			}
		}
		for (Iterator values = ((Process) modelObject).getHasAsyncActivities()
				.iterator(); values.hasNext();) {
			nextValue = (EObject) values.next();
			nodeVID = New_processVisualIDRegistry.getNodeVisualID(viewObject,
					nextValue);
			if (AsyncActivityEditPart.VISUAL_ID == nodeVID) {
				result.add(nextValue);
			}
		}
		for (Iterator values = ((Process) modelObject).getHasEvents()
				.iterator(); values.hasNext();) {
			nextValue = (EObject) values.next();
			nodeVID = New_processVisualIDRegistry.getNodeVisualID(viewObject,
					nextValue);
			if (EventEditPart.VISUAL_ID == nodeVID) {
				result.add(nextValue);
			}
		}
		for (Iterator values = ((Process) modelObject).getHasConditionProxy()
				.iterator(); values.hasNext();) {
			nextValue = (EObject) values.next();
			nodeVID = New_processVisualIDRegistry.getNodeVisualID(viewObject,
					nextValue);
			if (ConditionProxyEditPart.VISUAL_ID == nodeVID) {
				result.add(nextValue);
			}
		}
		for (Iterator values = ((Process) modelObject).getHasActors()
				.iterator(); values.hasNext();) {
			nextValue = (EObject) values.next();
			nodeVID = New_processVisualIDRegistry.getNodeVisualID(viewObject,
					nextValue);
			if (ActorEditPart.VISUAL_ID == nodeVID) {
				result.add(nextValue);
			}
		}
		for (Iterator values = ((Process) modelObject).getHasMessages()
				.iterator(); values.hasNext();) {
			nextValue = (EObject) values.next();
			nodeVID = New_processVisualIDRegistry.getNodeVisualID(viewObject,
					nextValue);
			if (MessageEditPart.VISUAL_ID == nodeVID) {
				result.add(nextValue);
			}
		}
		for (Iterator values = ((Process) modelObject).getHasExpansions()
				.iterator(); values.hasNext();) {
			nextValue = (EObject) values.next();
			nodeVID = New_processVisualIDRegistry.getNodeVisualID(viewObject,
					nextValue);
			if (ExpansionEditPart.VISUAL_ID == nodeVID) {
				result.add(nextValue);
			}
		}
		for (Iterator values = ((Process) modelObject).getHasConclusions()
				.iterator(); values.hasNext();) {
			nextValue = (EObject) values.next();
			nodeVID = New_processVisualIDRegistry.getNodeVisualID(viewObject,
					nextValue);
			if (ConclusionEditPart.VISUAL_ID == nodeVID) {
				result.add(nextValue);
			}
		}
		nextValue = ((Process) modelObject).getHasGlobals();
		nodeVID = New_processVisualIDRegistry.getNodeVisualID(viewObject,
				nextValue);
		if (GlobalsEditPart.VISUAL_ID == nodeVID) {
			result.add(nextValue);
		}
		return result;
	}

	/**
	 * @generated
	 */
	protected boolean shouldDeleteView(View view) {
		return view.isSetElement() && view.getElement() != null
				&& view.getElement().eIsProxy();
	}

	/**
	 * @generated
	 */
	protected String getDefaultFactoryHint() {
		return null;
	}

	/**
	 * @generated
	 */
	protected List getSemanticConnectionsList() {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	protected EObject getSourceElement(EObject relationship) {
		return null;
	}

	/**
	 * @generated
	 */
	protected EObject getTargetElement(EObject relationship) {
		return null;
	}

	/**
	 * @generated
	 */
	protected boolean shouldIncludeConnection(Edge connector,
			Collection children) {
		return false;
	}

	/**
	 * @generated
	 */
	protected void refreshSemantic() {
		List createdViews = new LinkedList();
		createdViews.addAll(refreshSemanticChildren());
		List createdConnectionViews = new LinkedList();
		createdConnectionViews.addAll(refreshSemanticConnections());
		createdConnectionViews.addAll(refreshConnections());

		if (createdViews.size() > 1) {
			// perform a layout of the container
			DeferredLayoutCommand layoutCmd = new DeferredLayoutCommand(host()
					.getEditingDomain(), createdViews, host());
			executeCommand(new ICommandProxy(layoutCmd));
		}

		createdViews.addAll(createdConnectionViews);
		makeViewsImmutable(createdViews);
	}

	/**
	 * @generated
	 */
	private Collection myLinkDescriptors = new LinkedList();

	/**
	 * @generated
	 */
	private Map myEObject2ViewMap = new HashMap();

	/**
	 * @generated
	 */
	private Collection refreshConnections() {
		try {
			collectAllLinks(getDiagram());
			Collection existingLinks = new LinkedList(getDiagram().getEdges());
			for (Iterator diagramLinks = existingLinks.iterator(); diagramLinks
					.hasNext();) {
				Edge nextDiagramLink = (Edge) diagramLinks.next();
				EObject diagramLinkObject = nextDiagramLink.getElement();
				EObject diagramLinkSrc = nextDiagramLink.getSource()
						.getElement();
				EObject diagramLinkDst = nextDiagramLink.getTarget()
						.getElement();
				int diagramLinkVisualID = New_processVisualIDRegistry
						.getVisualID(nextDiagramLink);
				for (Iterator modelLinkDescriptors = myLinkDescriptors
						.iterator(); modelLinkDescriptors.hasNext();) {
					LinkDescriptor nextLinkDescriptor = (LinkDescriptor) modelLinkDescriptors
							.next();
					if (diagramLinkObject == nextLinkDescriptor
							.getLinkElement()
							&& diagramLinkSrc == nextLinkDescriptor.getSource()
							&& diagramLinkDst == nextLinkDescriptor
									.getDestination()
							&& diagramLinkVisualID == nextLinkDescriptor
									.getVisualID()) {
						diagramLinks.remove();
						modelLinkDescriptors.remove();
					}
				}
			}
			deleteViews(existingLinks.iterator());
			return createConnections(myLinkDescriptors);
		} finally {
			myLinkDescriptors.clear();
			myEObject2ViewMap.clear();
		}
	}

	/**
	 * @generated
	 */
	private void collectAllLinks(View view) {
		EObject modelElement = view.getElement();
		int diagramElementVisualID = New_processVisualIDRegistry
				.getVisualID(view);
		switch (diagramElementVisualID) {
		case SyncActivityEditPart.VISUAL_ID:
		case ListenerEditPart.VISUAL_ID:
		case AsyncActivityEditPart.VISUAL_ID:
		case EventEditPart.VISUAL_ID:
		case ConditionProxyEditPart.VISUAL_ID:
		case ActorEditPart.VISUAL_ID:
		case MessageEditPart.VISUAL_ID:
		case ExpansionEditPart.VISUAL_ID:
		case ConclusionEditPart.VISUAL_ID:
		case GlobalsEditPart.VISUAL_ID:
		case ExpressionEditPart.VISUAL_ID:
		case RootEditPart.VISUAL_ID:
		case OrOperatorEditPart.VISUAL_ID:
		case AndOperatorEditPart.VISUAL_ID:
		case ConditionTermEditPart.VISUAL_ID:
		case Expression2EditPart.VISUAL_ID:
		case Expression3EditPart.VISUAL_ID:
		case Expression4EditPart.VISUAL_ID:
		case Expression5EditPart.VISUAL_ID:
		case Expression6EditPart.VISUAL_ID:
		case Expression7EditPart.VISUAL_ID:
		case Expression8EditPart.VISUAL_ID:
		case LoaderEditPart.VISUAL_ID:
		case ConditionEditPart.VISUAL_ID:
		case ProcessEditPart.VISUAL_ID: {
			myEObject2ViewMap.put(modelElement, view);
			storeLinks(modelElement, getDiagram());
		}
		default: {
		}
			for (Iterator children = view.getChildren().iterator(); children
					.hasNext();) {
				View childView = (View) children.next();
				collectAllLinks(childView);
			}
		}
	}

	/**
	 * @generated
	 */
	private Collection createConnections(Collection linkDescriptors) {
		if (linkDescriptors.isEmpty()) {
			return Collections.EMPTY_LIST;
		}
		List adapters = new LinkedList();
		for (Iterator linkDescriptorsIterator = linkDescriptors.iterator(); linkDescriptorsIterator
				.hasNext();) {
			final LinkDescriptor nextLinkDescriptor = (LinkDescriptor) linkDescriptorsIterator
					.next();
			EditPart sourceEditPart = getEditPartFor(nextLinkDescriptor
					.getSource());
			EditPart targetEditPart = getEditPartFor(nextLinkDescriptor
					.getDestination());
			if (sourceEditPart == null || targetEditPart == null) {
				continue;
			}
			CreateConnectionViewRequest.ConnectionViewDescriptor descriptor = new CreateConnectionViewRequest.ConnectionViewDescriptor(
					nextLinkDescriptor.getSemanticAdapter(), null,
					ViewUtil.APPEND, false, ((IGraphicalEditPart) getHost())
							.getDiagramPreferencesHint());
			CreateConnectionViewRequest ccr = new CreateConnectionViewRequest(
					descriptor);
			ccr.setType(RequestConstants.REQ_CONNECTION_START);
			ccr.setSourceEditPart(sourceEditPart);
			sourceEditPart.getCommand(ccr);
			ccr.setTargetEditPart(targetEditPart);
			ccr.setType(RequestConstants.REQ_CONNECTION_END);
			Command cmd = targetEditPart.getCommand(ccr);
			if (cmd != null && cmd.canExecute()) {
				executeCommand(cmd);
				IAdaptable viewAdapter = (IAdaptable) ccr.getNewObject();
				if (viewAdapter != null) {
					adapters.add(viewAdapter);
				}
			}
		}
		return adapters;
	}

	/**
	 * @generated
	 */
	private EditPart getEditPartFor(EObject modelElement) {
		View view = (View) myEObject2ViewMap.get(modelElement);
		if (view != null) {
			return (EditPart) getHost().getViewer().getEditPartRegistry().get(
					view);
		}
		return null;
	}

	/**
	 *@generated
	 */
	private void storeLinks(EObject container, Diagram diagram) {
		EClass containerMetaclass = container.eClass();
		storeFeatureModelFacetLinks(container, containerMetaclass, diagram);
		storeTypeModelFacetLinks(container, containerMetaclass);
	}

	/**
	 * @generated
	 */
	private void storeTypeModelFacetLinks(EObject container,
			EClass containerMetaclass) {
	}

	/**
	 *@generated
	 */
	private void storeFeatureModelFacetLinks(EObject container,
			EClass containerMetaclass, Diagram diagram) {

		if (NewprocessPackage.eINSTANCE.getAsyncActivity().isSuperTypeOf(
				containerMetaclass)) {
			EObject nextDestination = (EObject) ((AsyncActivity) container)
					.getActor();
			myLinkDescriptors.add(new LinkDescriptor(container,
					nextDestination,
					New_processElementTypes.AsyncActivityActor_4001,
					AsyncActivityActorEditPart.VISUAL_ID));

		}
		if (NewprocessPackage.eINSTANCE.getRoot().isSuperTypeOf(
				containerMetaclass)) {
			EObject nextDestination = (EObject) ((Root) container).getTerm();
			myLinkDescriptors.add(new LinkDescriptor(container,
					nextDestination, New_processElementTypes.RootTerm_4002,
					RootTermEditPart.VISUAL_ID));

		}
		if (NewprocessPackage.eINSTANCE.getOperatorTerm().isSuperTypeOf(
				containerMetaclass)) {
			for (Iterator destinations = ((OperatorTerm) container)
					.getSubTerm().iterator(); destinations.hasNext();) {
				EObject nextDestination = (EObject) destinations.next();
				myLinkDescriptors.add(new LinkDescriptor(container,
						nextDestination,
						New_processElementTypes.OperatorTermSubTerm_4003,
						OperatorTermSubTermEditPart.VISUAL_ID));

			}
		}
		if (NewprocessPackage.eINSTANCE.getConditionTerm().isSuperTypeOf(
				containerMetaclass)) {
			EObject nextDestination = (EObject) ((ConditionTerm) container)
					.getConditionProxy();
			myLinkDescriptors.add(new LinkDescriptor(container,
					nextDestination,
					New_processElementTypes.ConditionTermConditionProxy_4004,
					ConditionTermConditionProxyEditPart.VISUAL_ID));

		}
		if (NewprocessPackage.eINSTANCE.getConclusion().isSuperTypeOf(
				containerMetaclass)) {
			EObject nextDestination = (EObject) ((Conclusion) container)
					.getConclusionProxy();
			myLinkDescriptors.add(new LinkDescriptor(container,
					nextDestination,
					New_processElementTypes.ConclusionConclusionProxy_4005,
					ConclusionConclusionProxyEditPart.VISUAL_ID));

		}
		if (NewprocessPackage.eINSTANCE.getExpansion().isSuperTypeOf(
				containerMetaclass)) {
			EObject nextDestination = (EObject) ((Expansion) container)
					.getExpansionProxy();
			myLinkDescriptors.add(new LinkDescriptor(container,
					nextDestination,
					New_processElementTypes.ExpansionExpansionProxy_4006,
					ExpansionExpansionProxyEditPart.VISUAL_ID));

		}
	}

	/**
	 * @generated
	 */
	private Diagram getDiagram() {
		return ((View) getHost().getModel()).getDiagram();
	}

	/**
	 * @generated
	 */
	private class LinkDescriptor {

		/**
		 * @generated
		 */
		private EObject mySource;

		/**
		 * @generated
		 */
		private EObject myDestination;

		/**
		 * @generated
		 */
		private EObject myLinkElement;

		/**
		 * @generated
		 */
		private int myVisualID;

		/**
		 * @generated
		 */
		private IAdaptable mySemanticAdapter;

		/**
		 * @generated
		 */
		protected LinkDescriptor(EObject source, EObject destination,
				EObject linkElement, int linkVID) {
			this(source, destination, linkVID);
			myLinkElement = linkElement;
			mySemanticAdapter = new EObjectAdapter(linkElement);
		}

		/**
		 * @generated
		 */
		protected LinkDescriptor(EObject source, EObject destination,
				IElementType elementType, int linkVID) {
			this(source, destination, linkVID);
			myLinkElement = null;
			final IElementType elementTypeCopy = elementType;
			mySemanticAdapter = new IAdaptable() {
				public Object getAdapter(Class adapter) {
					if (IElementType.class.equals(adapter)) {
						return elementTypeCopy;
					}
					return null;
				}
			};
		}

		/**
		 * @generated
		 */
		private LinkDescriptor(EObject source, EObject destination, int linkVID) {
			mySource = source;
			myDestination = destination;
			myVisualID = linkVID;
		}

		/**
		 * @generated
		 */
		protected EObject getSource() {
			return mySource;
		}

		/**
		 * @generated
		 */
		protected EObject getDestination() {
			return myDestination;
		}

		/**
		 * @generated
		 */
		protected EObject getLinkElement() {
			return myLinkElement;
		}

		/**
		 * @generated
		 */
		protected int getVisualID() {
			return myVisualID;
		}

		/**
		 * @generated
		 */
		protected IAdaptable getSemanticAdapter() {
			return mySemanticAdapter;
		}
	}

}
