package newprocess.diagram.edit.policies;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.commands.core.commands.DuplicateEObjectsCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;
import newprocess.NewprocessPackage;

import newprocess.diagram.edit.commands.ActorCreateCommand;
import newprocess.diagram.edit.commands.AsyncActivity2CreateCommand;
import newprocess.diagram.edit.commands.AsyncActivityCreateCommand;
import newprocess.diagram.edit.commands.ConclusionCreateCommand;
import newprocess.diagram.edit.commands.ConditionProxyCreateCommand;
import newprocess.diagram.edit.commands.EventCreateCommand;
import newprocess.diagram.edit.commands.ExpansionCreateCommand;
import newprocess.diagram.edit.commands.GlobalsCreateCommand;
import newprocess.diagram.edit.commands.ListenerCreateCommand;
import newprocess.diagram.edit.commands.MessageCreateCommand;
import newprocess.diagram.edit.commands.SyncActivityCreateCommand;

import newprocess.diagram.providers.New_processElementTypes;

import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;

/**
 * @generated
 */
public class ProcessItemSemanticEditPolicy extends
		New_processBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (New_processElementTypes.SyncActivity_2001 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(NewprocessPackage.eINSTANCE
						.getProcess_HasSyncActivities());
			}
			return getMSLWrapper(new SyncActivityCreateCommand(req));
		}
		if (New_processElementTypes.Listener_2002 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(NewprocessPackage.eINSTANCE
						.getProcess_HasListeners());
			}
			return getMSLWrapper(new ListenerCreateCommand(req));
		}
		if (New_processElementTypes.AsyncActivity_2003 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(NewprocessPackage.eINSTANCE
						.getProcess_HasAsyncActivities());
			}
			return getMSLWrapper(new AsyncActivityCreateCommand(req));
		}
		if (New_processElementTypes.Event_2005 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(NewprocessPackage.eINSTANCE
						.getProcess_HasEvents());
			}
			return getMSLWrapper(new EventCreateCommand(req));
		}
		if (New_processElementTypes.ConditionProxy_2006 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(NewprocessPackage.eINSTANCE
						.getProcess_HasConditionProxy());
			}
			return getMSLWrapper(new ConditionProxyCreateCommand(req));
		}
		if (New_processElementTypes.Actor_2007 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(NewprocessPackage.eINSTANCE
						.getProcess_HasActors());
			}
			return getMSLWrapper(new ActorCreateCommand(req));
		}
		if (New_processElementTypes.Message_2008 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(NewprocessPackage.eINSTANCE
						.getProcess_HasMessages());
			}
			return getMSLWrapper(new MessageCreateCommand(req));
		}
		if (New_processElementTypes.Expansion_2009 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(NewprocessPackage.eINSTANCE
						.getProcess_HasExpansions());
			}
			return getMSLWrapper(new ExpansionCreateCommand(req));
		}
		if (New_processElementTypes.Conclusion_2010 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(NewprocessPackage.eINSTANCE
						.getProcess_HasConclusions());
			}
			return getMSLWrapper(new ConclusionCreateCommand(req));
		}
		if (New_processElementTypes.Globals_2011 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(NewprocessPackage.eINSTANCE
						.getProcess_HasGlobals());
			}
			return getMSLWrapper(new GlobalsCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDuplicateCommand(DuplicateElementsRequest req) {
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) getHost())
				.getEditingDomain();
		return getMSLWrapper(new DuplicateAnythingCommand(editingDomain, req));
	}

	/**
	 * @generated
	 */
	private static class DuplicateAnythingCommand extends
			DuplicateEObjectsCommand {

		/**
		 * @generated
		 */
		public DuplicateAnythingCommand(
				TransactionalEditingDomain editingDomain,
				DuplicateElementsRequest req) {
			super(editingDomain, req.getLabel(), req
					.getElementsToBeDuplicated(), req
					.getAllDuplicatedElementsMap());
		}
	}
}
