package newprocess.diagram.part;

import newprocess.Actor;
import newprocess.AndOperator;
import newprocess.AsyncActivity;
import newprocess.Conclusion;
import newprocess.Condition;
import newprocess.ConditionProxy;
import newprocess.ConditionTerm;
import newprocess.Event;
import newprocess.Expansion;
import newprocess.Expression;
import newprocess.Globals;
import newprocess.Listener;
import newprocess.Loader;
import newprocess.Message;
import newprocess.NewprocessPackage;
import newprocess.OrOperator;
import newprocess.Process;
import newprocess.Root;
import newprocess.SyncActivity;

import newprocess.diagram.edit.parts.ActorEditPart;
import newprocess.diagram.edit.parts.ActorNameEditPart;
import newprocess.diagram.edit.parts.AndOperatorEditPart;
import newprocess.diagram.edit.parts.AsyncActivity2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPostconditionCompartment2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPreconditionCompartment2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityAsyncActivityPreconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.AsyncActivityEditPart;
import newprocess.diagram.edit.parts.AsyncActivityName2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityNameEditPart;
import newprocess.diagram.edit.parts.ConclusionConclusionPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.ConclusionEditPart;
import newprocess.diagram.edit.parts.ConclusionNameEditPart;
import newprocess.diagram.edit.parts.ConditionEditPart;
import newprocess.diagram.edit.parts.ConditionNameEditPart;
import newprocess.diagram.edit.parts.ConditionProxyEditPart;
import newprocess.diagram.edit.parts.ConditionProxyProxyNameEditPart;
import newprocess.diagram.edit.parts.ConditionTermEditPart;
import newprocess.diagram.edit.parts.EventEditPart;
import newprocess.diagram.edit.parts.EventEventPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.EventNameEditPart;
import newprocess.diagram.edit.parts.ExpansionEditPart;
import newprocess.diagram.edit.parts.ExpansionExpansionPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.ExpansionNameEditPart;
import newprocess.diagram.edit.parts.Expression2EditPart;
import newprocess.diagram.edit.parts.Expression3EditPart;
import newprocess.diagram.edit.parts.Expression4EditPart;
import newprocess.diagram.edit.parts.Expression5EditPart;
import newprocess.diagram.edit.parts.Expression6EditPart;
import newprocess.diagram.edit.parts.Expression7EditPart;
import newprocess.diagram.edit.parts.Expression8EditPart;
import newprocess.diagram.edit.parts.ExpressionEditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment2EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment3EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment4EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment5EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment6EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment7EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartment8EditPart;
import newprocess.diagram.edit.parts.ExpressionExpressionCompartmentEditPart;
import newprocess.diagram.edit.parts.GlobalsEditPart;
import newprocess.diagram.edit.parts.GlobalsGlobalsConditionCompartmentEditPart;
import newprocess.diagram.edit.parts.GlobalsGlobalsLoaderCompartmentEditPart;
import newprocess.diagram.edit.parts.ListenerEditPart;
import newprocess.diagram.edit.parts.ListenerListenerPreconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.ListenerNameEditPart;
import newprocess.diagram.edit.parts.LoaderEditPart;
import newprocess.diagram.edit.parts.LoaderNameEditPart;
import newprocess.diagram.edit.parts.MessageEditPart;
import newprocess.diagram.edit.parts.MessageNameEditPart;
import newprocess.diagram.edit.parts.OrOperatorEditPart;
import newprocess.diagram.edit.parts.ProcessEditPart;
import newprocess.diagram.edit.parts.RootEditPart;
import newprocess.diagram.edit.parts.SyncActivityEditPart;
import newprocess.diagram.edit.parts.SyncActivityNameEditPart;
import newprocess.diagram.edit.parts.SyncActivitySynActivityPostconditionCompartmentEditPart;
import newprocess.diagram.edit.parts.SyncActivitySynActivityPreconditionCompartmentEditPart;

import org.eclipse.core.runtime.Platform;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented 
 * by a domain model object.
 *
 * @generated
 */
public class New_processVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = New_processDiagramEditorPlugin
			.getInstance().getBundle().getSymbolicName()
			+ "/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (ProcessEditPart.MODEL_ID.equals(view.getType())) {
				return ProcessEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				New_processDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return String.valueOf(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		EClass domainElementMetaclass = domainElement.eClass();
		return getDiagramVisualID(domainElement, domainElementMetaclass);
	}

	/**
	 * @generated
	 */
	private static int getDiagramVisualID(EObject domainElement,
			EClass domainElementMetaclass) {
		if (NewprocessPackage.eINSTANCE.getProcess().isSuperTypeOf(
				domainElementMetaclass)
				&& isDiagramProcess_1000((Process) domainElement)) {
			return ProcessEditPart.VISUAL_ID;
		}
		return getUnrecognizedDiagramID(domainElement);
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		EClass domainElementMetaclass = domainElement.eClass();
		return getNodeVisualID(containerView, domainElement,
				domainElementMetaclass, null);
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView,
			EObject domainElement, EClass domainElementMetaclass,
			String semanticHint) {
		String containerModelID = getModelID(containerView);
		if (!ProcessEditPart.MODEL_ID.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (ProcessEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = ProcessEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		int nodeVisualID = semanticHint != null ? getVisualID(semanticHint)
				: -1;
		switch (containerVisualID) {
		case SyncActivityEditPart.VISUAL_ID:
			if (SyncActivityNameEditPart.VISUAL_ID == nodeVisualID) {
				return SyncActivityNameEditPart.VISUAL_ID;
			}
			if (SyncActivitySynActivityPreconditionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return SyncActivitySynActivityPreconditionCompartmentEditPart.VISUAL_ID;
			}
			if (SyncActivitySynActivityPostconditionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return SyncActivitySynActivityPostconditionCompartmentEditPart.VISUAL_ID;
			}
			return getUnrecognizedSyncActivity_2001ChildNodeID(domainElement,
					semanticHint);
		case ListenerEditPart.VISUAL_ID:
			if (ListenerNameEditPart.VISUAL_ID == nodeVisualID) {
				return ListenerNameEditPart.VISUAL_ID;
			}
			if (ListenerListenerPreconditionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return ListenerListenerPreconditionCompartmentEditPart.VISUAL_ID;
			}
			return getUnrecognizedListener_2002ChildNodeID(domainElement,
					semanticHint);
		case AsyncActivityEditPart.VISUAL_ID:
			if (AsyncActivityNameEditPart.VISUAL_ID == nodeVisualID) {
				return AsyncActivityNameEditPart.VISUAL_ID;
			}
			if (AsyncActivityAsyncActivityPreconditionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return AsyncActivityAsyncActivityPreconditionCompartmentEditPart.VISUAL_ID;
			}
			if (AsyncActivityAsyncActivityPostconditionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return AsyncActivityAsyncActivityPostconditionCompartmentEditPart.VISUAL_ID;
			}
			return getUnrecognizedAsyncActivity_2003ChildNodeID(domainElement,
					semanticHint);
		case EventEditPart.VISUAL_ID:
			if (EventNameEditPart.VISUAL_ID == nodeVisualID) {
				return EventNameEditPart.VISUAL_ID;
			}
			if (EventEventPostconditionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return EventEventPostconditionCompartmentEditPart.VISUAL_ID;
			}
			return getUnrecognizedEvent_2005ChildNodeID(domainElement,
					semanticHint);
		case ConditionProxyEditPart.VISUAL_ID:
			if (ConditionProxyProxyNameEditPart.VISUAL_ID == nodeVisualID) {
				return ConditionProxyProxyNameEditPart.VISUAL_ID;
			}
			return getUnrecognizedConditionProxy_2006ChildNodeID(domainElement,
					semanticHint);
		case ActorEditPart.VISUAL_ID:
			if (ActorNameEditPart.VISUAL_ID == nodeVisualID) {
				return ActorNameEditPart.VISUAL_ID;
			}
			return getUnrecognizedActor_2007ChildNodeID(domainElement,
					semanticHint);
		case MessageEditPart.VISUAL_ID:
			if (MessageNameEditPart.VISUAL_ID == nodeVisualID) {
				return MessageNameEditPart.VISUAL_ID;
			}
			return getUnrecognizedMessage_2008ChildNodeID(domainElement,
					semanticHint);
		case ExpansionEditPart.VISUAL_ID:
			if (ExpansionNameEditPart.VISUAL_ID == nodeVisualID) {
				return ExpansionNameEditPart.VISUAL_ID;
			}
			if (ExpansionExpansionPostconditionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return ExpansionExpansionPostconditionCompartmentEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpansion_2009ChildNodeID(domainElement,
					semanticHint);
		case ConclusionEditPart.VISUAL_ID:
			if (ConclusionNameEditPart.VISUAL_ID == nodeVisualID) {
				return ConclusionNameEditPart.VISUAL_ID;
			}
			if (ConclusionConclusionPostconditionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return ConclusionConclusionPostconditionCompartmentEditPart.VISUAL_ID;
			}
			return getUnrecognizedConclusion_2010ChildNodeID(domainElement,
					semanticHint);
		case GlobalsEditPart.VISUAL_ID:
			if (GlobalsGlobalsLoaderCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return GlobalsGlobalsLoaderCompartmentEditPart.VISUAL_ID;
			}
			if (GlobalsGlobalsConditionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return GlobalsGlobalsConditionCompartmentEditPart.VISUAL_ID;
			}
			return getUnrecognizedGlobals_2011ChildNodeID(domainElement,
					semanticHint);
		case ExpressionEditPart.VISUAL_ID:
			if (ExpressionExpressionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return ExpressionExpressionCompartmentEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || RootEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getRoot().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeRoot_3002((Root) domainElement))) {
				return RootEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || ConditionTermEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getConditionTerm()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeConditionTerm_3005((ConditionTerm) domainElement))) {
				return ConditionTermEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpression_3001ChildNodeID(domainElement,
					semanticHint);
		case RootEditPart.VISUAL_ID:
			return getUnrecognizedRoot_3002ChildNodeID(domainElement,
					semanticHint);
		case OrOperatorEditPart.VISUAL_ID:
			return getUnrecognizedOrOperator_3003ChildNodeID(domainElement,
					semanticHint);
		case AndOperatorEditPart.VISUAL_ID:
			return getUnrecognizedAndOperator_3004ChildNodeID(domainElement,
					semanticHint);
		case ConditionTermEditPart.VISUAL_ID:
			return getUnrecognizedConditionTerm_3005ChildNodeID(domainElement,
					semanticHint);
		case Expression2EditPart.VISUAL_ID:
			if (ExpressionExpressionCompartment2EditPart.VISUAL_ID == nodeVisualID) {
				return ExpressionExpressionCompartment2EditPart.VISUAL_ID;
			}
			if ((semanticHint == null || RootEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getRoot().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeRoot_3002((Root) domainElement))) {
				return RootEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || ConditionTermEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getConditionTerm()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeConditionTerm_3005((ConditionTerm) domainElement))) {
				return ConditionTermEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpression_3006ChildNodeID(domainElement,
					semanticHint);
		case Expression3EditPart.VISUAL_ID:
			if (ExpressionExpressionCompartment3EditPart.VISUAL_ID == nodeVisualID) {
				return ExpressionExpressionCompartment3EditPart.VISUAL_ID;
			}
			if ((semanticHint == null || RootEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getRoot().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeRoot_3002((Root) domainElement))) {
				return RootEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || ConditionTermEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getConditionTerm()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeConditionTerm_3005((ConditionTerm) domainElement))) {
				return ConditionTermEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpression_3007ChildNodeID(domainElement,
					semanticHint);
		case Expression4EditPart.VISUAL_ID:
			if (ExpressionExpressionCompartment4EditPart.VISUAL_ID == nodeVisualID) {
				return ExpressionExpressionCompartment4EditPart.VISUAL_ID;
			}
			if ((semanticHint == null || RootEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getRoot().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeRoot_3002((Root) domainElement))) {
				return RootEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || ConditionTermEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getConditionTerm()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeConditionTerm_3005((ConditionTerm) domainElement))) {
				return ConditionTermEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpression_3008ChildNodeID(domainElement,
					semanticHint);
		case Expression5EditPart.VISUAL_ID:
			if (ExpressionExpressionCompartment5EditPart.VISUAL_ID == nodeVisualID) {
				return ExpressionExpressionCompartment5EditPart.VISUAL_ID;
			}
			if ((semanticHint == null || RootEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getRoot().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeRoot_3002((Root) domainElement))) {
				return RootEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || ConditionTermEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getConditionTerm()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeConditionTerm_3005((ConditionTerm) domainElement))) {
				return ConditionTermEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpression_3009ChildNodeID(domainElement,
					semanticHint);
		case Expression6EditPart.VISUAL_ID:
			if (ExpressionExpressionCompartment6EditPart.VISUAL_ID == nodeVisualID) {
				return ExpressionExpressionCompartment6EditPart.VISUAL_ID;
			}
			if ((semanticHint == null || RootEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getRoot().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeRoot_3002((Root) domainElement))) {
				return RootEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || ConditionTermEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getConditionTerm()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeConditionTerm_3005((ConditionTerm) domainElement))) {
				return ConditionTermEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpression_3010ChildNodeID(domainElement,
					semanticHint);
		case Expression7EditPart.VISUAL_ID:
			if (ExpressionExpressionCompartment7EditPart.VISUAL_ID == nodeVisualID) {
				return ExpressionExpressionCompartment7EditPart.VISUAL_ID;
			}
			if ((semanticHint == null || RootEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getRoot().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeRoot_3002((Root) domainElement))) {
				return RootEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || ConditionTermEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getConditionTerm()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeConditionTerm_3005((ConditionTerm) domainElement))) {
				return ConditionTermEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpression_3011ChildNodeID(domainElement,
					semanticHint);
		case Expression8EditPart.VISUAL_ID:
			if (ExpressionExpressionCompartment8EditPart.VISUAL_ID == nodeVisualID) {
				return ExpressionExpressionCompartment8EditPart.VISUAL_ID;
			}
			if ((semanticHint == null || RootEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getRoot().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeRoot_3002((Root) domainElement))) {
				return RootEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || ConditionTermEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getConditionTerm()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeConditionTerm_3005((ConditionTerm) domainElement))) {
				return ConditionTermEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpression_3012ChildNodeID(domainElement,
					semanticHint);
		case LoaderEditPart.VISUAL_ID:
			if (LoaderNameEditPart.VISUAL_ID == nodeVisualID) {
				return LoaderNameEditPart.VISUAL_ID;
			}
			return getUnrecognizedLoader_3013ChildNodeID(domainElement,
					semanticHint);
		case ConditionEditPart.VISUAL_ID:
			if (ConditionNameEditPart.VISUAL_ID == nodeVisualID) {
				return ConditionNameEditPart.VISUAL_ID;
			}
			return getUnrecognizedCondition_3014ChildNodeID(domainElement,
					semanticHint);
		case SyncActivitySynActivityPreconditionCompartmentEditPart.VISUAL_ID:
			if ((semanticHint == null || ExpressionEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getExpression()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeExpression_3001((Expression) domainElement))) {
				return ExpressionEditPart.VISUAL_ID;
			}
			return getUnrecognizedSyncActivitySynActivityPreconditionCompartment_7001ChildNodeID(
					domainElement, semanticHint);
		case SyncActivitySynActivityPostconditionCompartmentEditPart.VISUAL_ID:
			if ((semanticHint == null || Expression2EditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getExpression()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeExpression_3006((Expression) domainElement))) {
				return Expression2EditPart.VISUAL_ID;
			}
			return getUnrecognizedSyncActivitySynActivityPostconditionCompartment_7002ChildNodeID(
					domainElement, semanticHint);
		case ExpressionExpressionCompartmentEditPart.VISUAL_ID:
			if ((semanticHint == null || OrOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getOrOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeOrOperator_3003((OrOperator) domainElement))) {
				return OrOperatorEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || AndOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getAndOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeAndOperator_3004((AndOperator) domainElement))) {
				return AndOperatorEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpressionExpressionCompartment_7003ChildNodeID(
					domainElement, semanticHint);
		case ExpressionExpressionCompartment2EditPart.VISUAL_ID:
			if ((semanticHint == null || OrOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getOrOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeOrOperator_3003((OrOperator) domainElement))) {
				return OrOperatorEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || AndOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getAndOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeAndOperator_3004((AndOperator) domainElement))) {
				return AndOperatorEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpressionExpressionCompartment_7004ChildNodeID(
					domainElement, semanticHint);
		case ListenerListenerPreconditionCompartmentEditPart.VISUAL_ID:
			if ((semanticHint == null || Expression3EditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getExpression()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeExpression_3007((Expression) domainElement))) {
				return Expression3EditPart.VISUAL_ID;
			}
			return getUnrecognizedListenerListenerPreconditionCompartment_7005ChildNodeID(
					domainElement, semanticHint);
		case ExpressionExpressionCompartment3EditPart.VISUAL_ID:
			if ((semanticHint == null || OrOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getOrOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeOrOperator_3003((OrOperator) domainElement))) {
				return OrOperatorEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || AndOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getAndOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeAndOperator_3004((AndOperator) domainElement))) {
				return AndOperatorEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpressionExpressionCompartment_7006ChildNodeID(
					domainElement, semanticHint);
		case AsyncActivityAsyncActivityPreconditionCompartmentEditPart.VISUAL_ID:
			if ((semanticHint == null || Expression4EditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getExpression()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeExpression_3008((Expression) domainElement))) {
				return Expression4EditPart.VISUAL_ID;
			}
			return getUnrecognizedAsyncActivityAsyncActivityPreconditionCompartment_7007ChildNodeID(
					domainElement, semanticHint);
		case AsyncActivityAsyncActivityPostconditionCompartmentEditPart.VISUAL_ID:
			if ((semanticHint == null || Expression5EditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getExpression()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeExpression_3009((Expression) domainElement))) {
				return Expression5EditPart.VISUAL_ID;
			}
			return getUnrecognizedAsyncActivityAsyncActivityPostconditionCompartment_7008ChildNodeID(
					domainElement, semanticHint);
		case ExpressionExpressionCompartment4EditPart.VISUAL_ID:
			if ((semanticHint == null || OrOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getOrOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeOrOperator_3003((OrOperator) domainElement))) {
				return OrOperatorEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || AndOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getAndOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeAndOperator_3004((AndOperator) domainElement))) {
				return AndOperatorEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpressionExpressionCompartment_7009ChildNodeID(
					domainElement, semanticHint);
		case ExpressionExpressionCompartment5EditPart.VISUAL_ID:
			if ((semanticHint == null || OrOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getOrOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeOrOperator_3003((OrOperator) domainElement))) {
				return OrOperatorEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || AndOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getAndOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeAndOperator_3004((AndOperator) domainElement))) {
				return AndOperatorEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpressionExpressionCompartment_7010ChildNodeID(
					domainElement, semanticHint);
		case EventEventPostconditionCompartmentEditPart.VISUAL_ID:
			if ((semanticHint == null || Expression6EditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getExpression()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeExpression_3010((Expression) domainElement))) {
				return Expression6EditPart.VISUAL_ID;
			}
			return getUnrecognizedEventEventPostconditionCompartment_7013ChildNodeID(
					domainElement, semanticHint);
		case ExpressionExpressionCompartment6EditPart.VISUAL_ID:
			if ((semanticHint == null || OrOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getOrOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeOrOperator_3003((OrOperator) domainElement))) {
				return OrOperatorEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || AndOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getAndOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeAndOperator_3004((AndOperator) domainElement))) {
				return AndOperatorEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpressionExpressionCompartment_7014ChildNodeID(
					domainElement, semanticHint);
		case ExpansionExpansionPostconditionCompartmentEditPart.VISUAL_ID:
			if ((semanticHint == null || Expression7EditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getExpression()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeExpression_3011((Expression) domainElement))) {
				return Expression7EditPart.VISUAL_ID;
			}
			return getUnrecognizedExpansionExpansionPostconditionCompartment_7015ChildNodeID(
					domainElement, semanticHint);
		case ExpressionExpressionCompartment7EditPart.VISUAL_ID:
			if ((semanticHint == null || OrOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getOrOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeOrOperator_3003((OrOperator) domainElement))) {
				return OrOperatorEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || AndOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getAndOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeAndOperator_3004((AndOperator) domainElement))) {
				return AndOperatorEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpressionExpressionCompartment_7016ChildNodeID(
					domainElement, semanticHint);
		case ConclusionConclusionPostconditionCompartmentEditPart.VISUAL_ID:
			if ((semanticHint == null || Expression8EditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getExpression()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeExpression_3012((Expression) domainElement))) {
				return Expression8EditPart.VISUAL_ID;
			}
			return getUnrecognizedConclusionConclusionPostconditionCompartment_7017ChildNodeID(
					domainElement, semanticHint);
		case ExpressionExpressionCompartment8EditPart.VISUAL_ID:
			if ((semanticHint == null || OrOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getOrOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeOrOperator_3003((OrOperator) domainElement))) {
				return OrOperatorEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || AndOperatorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getAndOperator()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeAndOperator_3004((AndOperator) domainElement))) {
				return AndOperatorEditPart.VISUAL_ID;
			}
			return getUnrecognizedExpressionExpressionCompartment_7018ChildNodeID(
					domainElement, semanticHint);
		case GlobalsGlobalsLoaderCompartmentEditPart.VISUAL_ID:
			if ((semanticHint == null || LoaderEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getLoader().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeLoader_3013((Loader) domainElement))) {
				return LoaderEditPart.VISUAL_ID;
			}
			return getUnrecognizedGlobalsGlobalsLoaderCompartment_7019ChildNodeID(
					domainElement, semanticHint);
		case GlobalsGlobalsConditionCompartmentEditPart.VISUAL_ID:
			if ((semanticHint == null || ConditionEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getCondition()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeCondition_3014((Condition) domainElement))) {
				return ConditionEditPart.VISUAL_ID;
			}
			return getUnrecognizedGlobalsGlobalsConditionCompartment_7020ChildNodeID(
					domainElement, semanticHint);
		case ProcessEditPart.VISUAL_ID:
			if ((semanticHint == null || SyncActivityEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getSyncActivity()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeSyncActivity_2001((SyncActivity) domainElement))) {
				return SyncActivityEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || ListenerEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getListener().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeListener_2002((Listener) domainElement))) {
				return ListenerEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || AsyncActivityEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getAsyncActivity()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeAsyncActivity_2003((AsyncActivity) domainElement))) {
				return AsyncActivityEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || EventEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getEvent().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeEvent_2005((Event) domainElement))) {
				return EventEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || ConditionProxyEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getConditionProxy()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeConditionProxy_2006((ConditionProxy) domainElement))) {
				return ConditionProxyEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || ActorEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getActor().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeActor_2007((Actor) domainElement))) {
				return ActorEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || MessageEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getMessage().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeMessage_2008((Message) domainElement))) {
				return MessageEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || ExpansionEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getExpansion()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeExpansion_2009((Expansion) domainElement))) {
				return ExpansionEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || ConclusionEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getConclusion()
							.isSuperTypeOf(domainElementMetaclass)
					&& (domainElement == null || isNodeConclusion_2010((Conclusion) domainElement))) {
				return ConclusionEditPart.VISUAL_ID;
			}
			if ((semanticHint == null || GlobalsEditPart.VISUAL_ID == nodeVisualID)
					&& NewprocessPackage.eINSTANCE.getGlobals().isSuperTypeOf(
							domainElementMetaclass)
					&& (domainElement == null || isNodeGlobals_2011((Globals) domainElement))) {
				return GlobalsEditPart.VISUAL_ID;
			}
			return getUnrecognizedProcess_1000ChildNodeID(domainElement,
					semanticHint);
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		EClass domainElementMetaclass = domainElement.eClass();
		return getLinkWithClassVisualID(domainElement, domainElementMetaclass);
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement,
			EClass domainElementMetaclass) {
		{
			return getUnrecognizedLinkWithClassID(domainElement);
		}
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isDiagramProcess_1000(Process element) {
		return true;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedDiagramID(EObject domainElement) {
		return -1;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeSyncActivity_2001(SyncActivity element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeListener_2002(Listener element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeAsyncActivity_2003(AsyncActivity element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeEvent_2005(Event element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeConditionProxy_2006(ConditionProxy element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeActor_2007(Actor element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeMessage_2008(Message element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeExpansion_2009(Expansion element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeConclusion_2010(Conclusion element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeGlobals_2011(Globals element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeExpression_3001(Expression element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeRoot_3002(Root element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeOrOperator_3003(OrOperator element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeAndOperator_3004(AndOperator element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeConditionTerm_3005(ConditionTerm element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeExpression_3006(Expression element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeExpression_3007(Expression element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeExpression_3008(Expression element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeExpression_3009(Expression element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeExpression_3010(Expression element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeExpression_3011(Expression element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeExpression_3012(Expression element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeLoader_3013(Loader element) {
		return true;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private static boolean isNodeCondition_3014(Condition element) {
		return true;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedSyncActivity_2001ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedListener_2002ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedAsyncActivity_2003ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedEvent_2005ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedConditionProxy_2006ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedActor_2007ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedMessage_2008ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpansion_2009ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedConclusion_2010ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedGlobals_2011ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpression_3001ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedRoot_3002ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedOrOperator_3003ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedAndOperator_3004ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedConditionTerm_3005ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpression_3006ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpression_3007ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpression_3008ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpression_3009ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpression_3010ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpression_3011ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpression_3012ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedLoader_3013ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedCondition_3014ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedSyncActivitySynActivityPreconditionCompartment_7001ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedSyncActivitySynActivityPostconditionCompartment_7002ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpressionExpressionCompartment_7003ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpressionExpressionCompartment_7004ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedListenerListenerPreconditionCompartment_7005ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpressionExpressionCompartment_7006ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedAsyncActivityAsyncActivityPreconditionCompartment_7007ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedAsyncActivityAsyncActivityPostconditionCompartment_7008ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpressionExpressionCompartment_7009ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpressionExpressionCompartment_7010ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedEventEventPostconditionCompartment_7013ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpressionExpressionCompartment_7014ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpansionExpansionPostconditionCompartment_7015ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpressionExpressionCompartment_7016ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedConclusionConclusionPostconditionCompartment_7017ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedExpressionExpressionCompartment_7018ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedGlobalsGlobalsLoaderCompartment_7019ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedGlobalsGlobalsConditionCompartment_7020ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedProcess_1000ChildNodeID(
			EObject domainElement, String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private static int getUnrecognizedLinkWithClassID(EObject domainElement) {
		return -1;
	}
}
