package newprocess.diagram.providers;

import java.lang.reflect.InvocationTargetException;
import java.util.Map;

import newprocess.Actor;
import newprocess.AsyncActivity;
import newprocess.Condition;
import newprocess.ConditionProxy;
import newprocess.Event;
import newprocess.Expression;
import newprocess.Listener;
import newprocess.Loader;
import newprocess.Message;
import newprocess.NewprocessPackage;
import newprocess.Process;
import newprocess.SyncActivity;
import newprocess.diagram.edit.parts.ProcessEditPart;
import newprocess.diagram.expressions.New_processAbstractExpression;
import newprocess.diagram.part.New_processDiagramEditorPlugin;
import newprocess.diagram.part.New_processDiagramEditorUtil;
import newprocess.diagram.part.New_processVisualIDRegistry;
import newprocess.impl.ActorImpl;
import newprocess.impl.AsyncActivityImpl;
import newprocess.impl.ConditionImpl;
import newprocess.impl.ConditionProxyImpl;
import newprocess.impl.EventImpl;
import newprocess.impl.ExpressionImpl;
import newprocess.impl.ListenerImpl;
import newprocess.impl.LoaderImpl;
import newprocess.impl.MessageImpl;
import newprocess.impl.ProcessImpl;
import newprocess.impl.SyncActivityImpl;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.Status;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.transaction.util.TransactionUtil;
import org.eclipse.emf.validation.AbstractModelConstraint;
import org.eclipse.emf.validation.IValidationContext;
import org.eclipse.emf.validation.model.EvaluationMode;
import org.eclipse.emf.validation.model.IClientSelector;
import org.eclipse.emf.validation.service.IBatchValidator;
import org.eclipse.emf.validation.service.ModelValidationService;
import org.eclipse.emf.workspace.util.WorkspaceSynchronizer;
import org.eclipse.gmf.runtime.common.ui.services.action.contributionitem.AbstractContributionItemProvider;
import org.eclipse.gmf.runtime.common.ui.util.IWorkbenchPartDescriptor;
import org.eclipse.gmf.runtime.diagram.ui.OffscreenEditPartFactory;
import org.eclipse.gmf.runtime.diagram.ui.editparts.DiagramEditPart;
import org.eclipse.gmf.runtime.diagram.ui.parts.IDiagramWorkbenchPart;
import org.eclipse.gmf.runtime.emf.core.util.EMFCoreUtil;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.actions.WorkspaceModifyDelegatingOperation;

/**
 * @generated
 */
public class New_processValidationProvider extends
		AbstractContributionItemProvider {
	/**
	 * @generated
	 */
	private static boolean constraintsActive = false;

	/**
	 * @generated
	 */
	public static boolean shouldConstraintsBePrivate() {
		return false;
	}

	/**
	 * @generated
	 */
	protected IAction createAction(String actionId,
			IWorkbenchPartDescriptor partDescriptor) {
		if (ValidateAction.VALIDATE_ACTION_KEY.equals(actionId)) {
			return new ValidateAction(partDescriptor);
		}
		return super.createAction(actionId, partDescriptor);
	}

	/**
	 * @generated
	 */
	public static class ValidateAction extends Action {
		/**
		 * @generated
		 */
		public static final String VALIDATE_ACTION_KEY = "validateAction"; //$NON-NLS-1$
		/**
		 * @generated
		 */
		private IWorkbenchPartDescriptor workbenchPartDescriptor;

		/**
		 * @generated
		 */
		public ValidateAction(IWorkbenchPartDescriptor workbenchPartDescriptor) {
			setId(VALIDATE_ACTION_KEY);
			setText("Validate");
			this.workbenchPartDescriptor = workbenchPartDescriptor;
		}

		/**
		 * @generated
		 */
		public void run() {
			IWorkbenchPart workbenchPart = workbenchPartDescriptor
					.getPartPage().getActivePart();
			if (workbenchPart instanceof IDiagramWorkbenchPart) {
				final IDiagramWorkbenchPart part = (IDiagramWorkbenchPart) workbenchPart;
				try {
					new WorkspaceModifyDelegatingOperation(
							new IRunnableWithProgress() {
								public void run(IProgressMonitor monitor)
										throws InterruptedException,
										InvocationTargetException {
									runValidation(part.getDiagramEditPart(),
											part.getDiagram());
								}
							}).run(new NullProgressMonitor());
				} catch (Exception e) {
					New_processDiagramEditorPlugin.getInstance().logError(
							"Validation action failed", e); //$NON-NLS-1$
				}
			}
		}

		/** 
		 * @generated
		 */
		public static void runValidation(View view) {
			try {
				if (New_processDiagramEditorUtil.openDiagram(view.eResource())) {
					IEditorPart editorPart = PlatformUI.getWorkbench()
							.getActiveWorkbenchWindow().getActivePage()
							.getActiveEditor();
					if (editorPart instanceof IDiagramWorkbenchPart) {
						runValidation(((IDiagramWorkbenchPart) editorPart)
								.getDiagramEditPart(), view);
					} else {
						runNonUIValidation(view);
					}
				}
			} catch (Exception e) {
				New_processDiagramEditorPlugin.getInstance().logError(
						"Validation action failed", e); //$NON-NLS-1$
			}
		}

		/**
		 * @generated
		 */
		public static void runNonUIValidation(View view) {
			DiagramEditPart diagramEditPart = OffscreenEditPartFactory
					.getInstance().createDiagramEditPart(view.getDiagram());
			runValidation(diagramEditPart, view);
		}

		/**
		 * @generated
		 */
		public static void runValidation(DiagramEditPart diagramEditPart,
				View view) {
			final View target = view;
			final DiagramEditPart diagramPart = diagramEditPart;
			Runnable task = new Runnable() {
				public void run() {
					try {
						constraintsActive = true;
						validate(diagramPart, target);
					} finally {
						constraintsActive = false;
					}
				}
			};
			TransactionalEditingDomain txDomain = TransactionUtil
					.getEditingDomain(target);
			if (txDomain != null) {
				try {
					txDomain.runExclusive(task);
				} catch (Exception e) {
					New_processDiagramEditorPlugin.getInstance().logError(
							"Validation action failed", e); //$NON-NLS-1$
				}
			} else {
				task.run();
			}
		}

		/**
		 * @generated
		 */
		private static Diagnostic runEMFValidator(View target) {
			if (target.isSetElement() && target.getElement() != null) {
				return new Diagnostician() {
					public String getObjectLabel(EObject eObject) {
						return EMFCoreUtil.getQualifiedName(eObject, true);
					}
				}.validate(target.getElement());
			}
			return Diagnostic.OK_INSTANCE;
		}

		/**
		 * @generated
		 */
		private static void validate(DiagramEditPart diagramEditPart,
				View target) {
			IFile diagramFile = (target.eResource() != null) ? WorkspaceSynchronizer
					.getFile(target.eResource())
					: null;
			if (diagramFile != null) {
				New_processMarkerNavigationProvider.deleteMarkers(diagramFile);
			}

			Diagnostic diagnostic = runEMFValidator(target);
			if (diagramFile != null) {
				New_processMarkerNavigationProvider.createMarkers(diagramFile,
						diagnostic, diagramEditPart);
			}

			IBatchValidator validator = (IBatchValidator) ModelValidationService
					.getInstance().newValidator(EvaluationMode.BATCH);
			validator.setIncludeLiveConstraints(true);
			IStatus status = Status.OK_STATUS;
			if (target.isSetElement() && target.getElement() != null) {
				status = validator.validate(target.getElement());
				if (diagramFile != null) {
					New_processMarkerNavigationProvider.createMarkers(
							diagramFile, status, diagramEditPart);
				}
			}

		}
	}

	/**
	 * @generated
	 */
	static boolean isInDefaultEditorContext(Object object) {
		if (shouldConstraintsBePrivate() && !constraintsActive) {
			return false;
		}
		if (object instanceof View) {
			return constraintsActive
					&& ProcessEditPart.MODEL_ID
							.equals(New_processVisualIDRegistry
									.getModelID((View) object));
		}
		return true;
	}

	/**
	 * @generated
	 */
	public static class DefaultCtx implements IClientSelector {
		/**
		 * @generated
		 */
		public boolean selects(Object object) {
			return isInDefaultEditorContext(object);
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter11 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter11() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getProcess()) {
				protected Object doEvaluate(Object context, Map env) {
					Process self = (Process) context;
					return JavaAudits.processNameValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter12 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter12() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getProcess()) {
				protected Object doEvaluate(Object context, Map env) {
					Process self = (Process) context;
					return JavaAudits.processImplementationValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter13 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter13() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getProcess()) {
				protected Object doEvaluate(Object context, Map env) {
					Process self = (Process) context;
					return JavaAudits.processSubjectValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter14 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter14() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getProcess()) {
				protected Object doEvaluate(Object context, Map env) {
					Process self = (Process) context;
					return JavaAudits.processNamespaceValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter21 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter21() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getActor()) {
				protected Object doEvaluate(Object context, Map env) {
					Actor self = (Actor) context;
					return JavaAudits.processActorNameValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter22 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter22() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getActor()) {
				protected Object doEvaluate(Object context, Map env) {
					Actor self = (Actor) context;
					return JavaAudits
							.processActorImplementationValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter31 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter31() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getMessage()) {
				protected Object doEvaluate(Object context, Map env) {
					Message self = (Message) context;
					return JavaAudits.processMessageNameValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter41 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter41() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getExpression()) {
				protected Object doEvaluate(Object context, Map env) {
					Expression self = (Expression) context;
					return JavaAudits.expressionExpressionValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter51 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter51() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getSyncActivity()) {
				protected Object doEvaluate(Object context, Map env) {
					SyncActivity self = (SyncActivity) context;
					return JavaAudits.syncActivityNameValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter52 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter52() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getSyncActivity()) {
				protected Object doEvaluate(Object context, Map env) {
					SyncActivity self = (SyncActivity) context;
					return JavaAudits
							.syncActivityImplementationValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter61 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter61() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getAsyncActivity()) {
				protected Object doEvaluate(Object context, Map env) {
					AsyncActivity self = (AsyncActivity) context;
					return JavaAudits.asyncActivityNameValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter62 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter62() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getAsyncActivity()) {
				protected Object doEvaluate(Object context, Map env) {
					AsyncActivity self = (AsyncActivity) context;
					return JavaAudits
							.asyncActivityImplementationValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter71 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter71() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getEvent()) {
				protected Object doEvaluate(Object context, Map env) {
					Event self = (Event) context;
					return JavaAudits.eventNameValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter72 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter72() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getEvent()) {
				protected Object doEvaluate(Object context, Map env) {
					Event self = (Event) context;
					return JavaAudits.eventImplementationValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter81 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter81() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getListener()) {
				protected Object doEvaluate(Object context, Map env) {
					Listener self = (Listener) context;
					return JavaAudits.listenerNameValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter82 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter82() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getListener()) {
				protected Object doEvaluate(Object context, Map env) {
					Listener self = (Listener) context;
					return JavaAudits.listenerImplementationValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter91 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter91() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getConditionProxy()) {
				protected Object doEvaluate(Object context, Map env) {
					ConditionProxy self = (ConditionProxy) context;
					return JavaAudits.proxyConditionValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter101 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter101() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getLoader()) {
				protected Object doEvaluate(Object context, Map env) {
					Loader self = (Loader) context;
					return JavaAudits.loaderNameValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter102 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter102() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getLoader()) {
				protected Object doEvaluate(Object context, Map env) {
					Loader self = (Loader) context;
					return JavaAudits.loaderImplementationValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter111 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter111() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getCondition()) {
				protected Object doEvaluate(Object context, Map env) {
					Condition self = (Condition) context;
					return JavaAudits.conditionNameValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	public static class Adapter112 extends AbstractModelConstraint {
		/**
		 * @generated
		 */
		private New_processAbstractExpression expression;

		/**
		 * @generated
		 */
		public Adapter112() {
			expression = new New_processAbstractExpression(
					NewprocessPackage.eINSTANCE.getCondition()) {
				protected Object doEvaluate(Object context, Map env) {
					Condition self = (Condition) context;
					return JavaAudits.conditionImplementationValidation(self);
				}
			};
		}

		/**
		 * @generated
		 */
		public IStatus validate(IValidationContext ctx) {
			Object evalCtx = ctx.getTarget();
			Object result = expression.evaluate(evalCtx);
			if (result instanceof Boolean && ((Boolean) result).booleanValue()) {
				return Status.OK_STATUS;
			}
			return ctx.createFailureStatus(new Object[] { EMFCoreUtil
					.getQualifiedName(ctx.getTarget(), true) });
		}
	}

	/**
	 * @generated
	 */
	static class JavaAudits {

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean processNamespaceValidation(Process self) {
			return ((ProcessImpl) self).validateNamespace(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean processNameValidation(Process self) {
			return ((ProcessImpl) self).validateName(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean processImplementationValidation(Process self) {
			return ((ProcessImpl) self).validateImplementation(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean processSubjectValidation(Process self) {
			return ((ProcessImpl) self).validateSubject(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean processActorNameValidation(Actor self) {
			return ((ActorImpl) self).validateName(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean processActorImplementationValidation(Actor self) {
			return ((ActorImpl) self).validateImplementation(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean processMessageNameValidation(Message self) {
			return ((MessageImpl) self).validateName(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean expressionExpressionValidation(Expression self) {
			return ((ExpressionImpl) self).validateExpression(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean syncActivityNameValidation(SyncActivity self) {
			return ((SyncActivityImpl) self).validateName(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean syncActivityImplementationValidation(
				SyncActivity self) {
			return ((SyncActivityImpl) self).validateImplementation(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean asyncActivityNameValidation(AsyncActivity self) {
			return ((AsyncActivityImpl) self).validateName(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean asyncActivityImplementationValidation(
				AsyncActivity self) {
			return ((AsyncActivityImpl) self).validateImplementation(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean eventNameValidation(Event self) {
			return ((EventImpl) self).validateName(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean eventImplementationValidation(Event self) {
			return ((EventImpl) self).validateImplementation(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean listenerNameValidation(Listener self) {
			return ((ListenerImpl) self).validateName(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean listenerImplementationValidation(Listener self) {
			return ((ListenerImpl) self).validateImplementation(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean proxyConditionValidation(ConditionProxy self) {
			return ((ConditionProxyImpl) self).validateCondition(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean loaderNameValidation(Loader self) {
			return ((LoaderImpl) self).validateName(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean loaderImplementationValidation(Loader self) {
			return ((LoaderImpl) self).validateImplementation(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean conditionNameValidation(Condition self) {
			return ((ConditionImpl) self).validateName(self);
		}

		/**
		 * @generated NOT
		 * @author sh
		 */
		private static Boolean conditionImplementationValidation(Condition self) {
			return ((ConditionImpl) self).validateImplementation(self);
		}
	} //JavaAudits
} //New_processValidationProvider
