/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package newprocess.provider;

import java.util.ArrayList;
import java.util.Collection;

import newprocess.util.NewprocessAdapterFactory;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class NewprocessItemProviderAdapterFactory extends NewprocessAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection supportedTypes = new ArrayList();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NewprocessItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);		
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.Process} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProcessItemProvider processItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.Process}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createProcessAdapter() {
		if (processItemProvider == null) {
			processItemProvider = new ProcessItemProvider(this);
		}

		return processItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.Condition} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConditionItemProvider conditionItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.Condition}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createConditionAdapter() {
		if (conditionItemProvider == null) {
			conditionItemProvider = new ConditionItemProvider(this);
		}

		return conditionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.Element} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ElementItemProvider elementItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.Element}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createElementAdapter() {
		if (elementItemProvider == null) {
			elementItemProvider = new ElementItemProvider(this);
		}

		return elementItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.SyncActivity} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SyncActivityItemProvider syncActivityItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.SyncActivity}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createSyncActivityAdapter() {
		if (syncActivityItemProvider == null) {
			syncActivityItemProvider = new SyncActivityItemProvider(this);
		}

		return syncActivityItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.Loader} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LoaderItemProvider loaderItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.Loader}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createLoaderAdapter() {
		if (loaderItemProvider == null) {
			loaderItemProvider = new LoaderItemProvider(this);
		}

		return loaderItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.AsyncActivity} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AsyncActivityItemProvider asyncActivityItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.AsyncActivity}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createAsyncActivityAdapter() {
		if (asyncActivityItemProvider == null) {
			asyncActivityItemProvider = new AsyncActivityItemProvider(this);
		}

		return asyncActivityItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.Event} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EventItemProvider eventItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.Event}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createEventAdapter() {
		if (eventItemProvider == null) {
			eventItemProvider = new EventItemProvider(this);
		}

		return eventItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.Actor} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ActorItemProvider actorItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.Actor}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createActorAdapter() {
		if (actorItemProvider == null) {
			actorItemProvider = new ActorItemProvider(this);
		}

		return actorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.Listener} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ListenerItemProvider listenerItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.Listener}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createListenerAdapter() {
		if (listenerItemProvider == null) {
			listenerItemProvider = new ListenerItemProvider(this);
		}

		return listenerItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.EnvEntry} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnvEntryItemProvider envEntryItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.EnvEntry}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createEnvEntryAdapter() {
		if (envEntryItemProvider == null) {
			envEntryItemProvider = new EnvEntryItemProvider(this);
		}

		return envEntryItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.Message} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MessageItemProvider messageItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.Message}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createMessageAdapter() {
		if (messageItemProvider == null) {
			messageItemProvider = new MessageItemProvider(this);
		}

		return messageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.ConditionProxy} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConditionProxyItemProvider conditionProxyItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.ConditionProxy}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createConditionProxyAdapter() {
		if (conditionProxyItemProvider == null) {
			conditionProxyItemProvider = new ConditionProxyItemProvider(this);
		}

		return conditionProxyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.Conclusion} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConclusionItemProvider conclusionItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.Conclusion}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createConclusionAdapter() {
		if (conclusionItemProvider == null) {
			conclusionItemProvider = new ConclusionItemProvider(this);
		}

		return conclusionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.Expansion} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExpansionItemProvider expansionItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.Expansion}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createExpansionAdapter() {
		if (expansionItemProvider == null) {
			expansionItemProvider = new ExpansionItemProvider(this);
		}

		return expansionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.Expression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExpressionItemProvider expressionItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.Expression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createExpressionAdapter() {
		if (expressionItemProvider == null) {
			expressionItemProvider = new ExpressionItemProvider(this);
		}

		return expressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.Term} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TermItemProvider termItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.Term}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createTermAdapter() {
		if (termItemProvider == null) {
			termItemProvider = new TermItemProvider(this);
		}

		return termItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.ConditionTerm} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConditionTermItemProvider conditionTermItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.ConditionTerm}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createConditionTermAdapter() {
		if (conditionTermItemProvider == null) {
			conditionTermItemProvider = new ConditionTermItemProvider(this);
		}

		return conditionTermItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.OperatorTerm} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OperatorTermItemProvider operatorTermItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.OperatorTerm}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createOperatorTermAdapter() {
		if (operatorTermItemProvider == null) {
			operatorTermItemProvider = new OperatorTermItemProvider(this);
		}

		return operatorTermItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.OrOperator} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OrOperatorItemProvider orOperatorItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.OrOperator}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createOrOperatorAdapter() {
		if (orOperatorItemProvider == null) {
			orOperatorItemProvider = new OrOperatorItemProvider(this);
		}

		return orOperatorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.AndOperator} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AndOperatorItemProvider andOperatorItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.AndOperator}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createAndOperatorAdapter() {
		if (andOperatorItemProvider == null) {
			andOperatorItemProvider = new AndOperatorItemProvider(this);
		}

		return andOperatorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.Root} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RootItemProvider rootItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.Root}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRootAdapter() {
		if (rootItemProvider == null) {
			rootItemProvider = new RootItemProvider(this);
		}

		return rootItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link newprocess.Globals} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GlobalsItemProvider globalsItemProvider;

	/**
	 * This creates an adapter for a {@link newprocess.Globals}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createGlobalsAdapter() {
		if (globalsItemProvider == null) {
			globalsItemProvider = new GlobalsItemProvider(this);
		}

		return globalsItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (processItemProvider != null) processItemProvider.dispose();
		if (conditionItemProvider != null) conditionItemProvider.dispose();
		if (elementItemProvider != null) elementItemProvider.dispose();
		if (syncActivityItemProvider != null) syncActivityItemProvider.dispose();
		if (loaderItemProvider != null) loaderItemProvider.dispose();
		if (asyncActivityItemProvider != null) asyncActivityItemProvider.dispose();
		if (eventItemProvider != null) eventItemProvider.dispose();
		if (actorItemProvider != null) actorItemProvider.dispose();
		if (listenerItemProvider != null) listenerItemProvider.dispose();
		if (envEntryItemProvider != null) envEntryItemProvider.dispose();
		if (messageItemProvider != null) messageItemProvider.dispose();
		if (conditionProxyItemProvider != null) conditionProxyItemProvider.dispose();
		if (conclusionItemProvider != null) conclusionItemProvider.dispose();
		if (expansionItemProvider != null) expansionItemProvider.dispose();
		if (expressionItemProvider != null) expressionItemProvider.dispose();
		if (termItemProvider != null) termItemProvider.dispose();
		if (conditionTermItemProvider != null) conditionTermItemProvider.dispose();
		if (operatorTermItemProvider != null) operatorTermItemProvider.dispose();
		if (orOperatorItemProvider != null) orOperatorItemProvider.dispose();
		if (andOperatorItemProvider != null) andOperatorItemProvider.dispose();
		if (rootItemProvider != null) rootItemProvider.dispose();
		if (globalsItemProvider != null) globalsItemProvider.dispose();
	}

}
