/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package newprocess.provider;


import java.util.Collection;
import java.util.List;

import newprocess.NewprocessFactory;
import newprocess.NewprocessPackage;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link newprocess.Process} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ProcessItemProvider
	extends ElementItemProvider
	implements	
		IEditingDomainItemProvider,	
		IStructuredItemContentProvider,	
		ITreeItemContentProvider,	
		IItemLabelProvider,	
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProcessItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addSubjectPropertyDescriptor(object);
			addNamespacePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Subject feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addSubjectPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Process_subject_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Process_subject_feature", "_UI_Process_type"),
				 NewprocessPackage.Literals.PROCESS__SUBJECT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Namespace feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamespacePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Process_namespace_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Process_namespace_feature", "_UI_Process_type"),
				 NewprocessPackage.Literals.PROCESS__NAMESPACE,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Collection getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(NewprocessPackage.Literals.PROCESS__HAS_SYNC_ACTIVITIES);
			childrenFeatures.add(NewprocessPackage.Literals.PROCESS__HAS_ASYNC_ACTIVITIES);
			childrenFeatures.add(NewprocessPackage.Literals.PROCESS__HAS_EVENTS);
			childrenFeatures.add(NewprocessPackage.Literals.PROCESS__HAS_LISTENERS);
			childrenFeatures.add(NewprocessPackage.Literals.PROCESS__HAS_ACTORS);
			childrenFeatures.add(NewprocessPackage.Literals.PROCESS__HAS_MESSAGES);
			childrenFeatures.add(NewprocessPackage.Literals.PROCESS__HAS_CONCLUSIONS);
			childrenFeatures.add(NewprocessPackage.Literals.PROCESS__HAS_EXPANSIONS);
			childrenFeatures.add(NewprocessPackage.Literals.PROCESS__HAS_CONDITION_PROXY);
			childrenFeatures.add(NewprocessPackage.Literals.PROCESS__HAS_GLOBALS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns Process.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Process"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getText(Object object) {
		String label = ((newprocess.Process)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_Process_type") :
			getString("_UI_Process_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(newprocess.Process.class)) {
			case NewprocessPackage.PROCESS__SUBJECT:
			case NewprocessPackage.PROCESS__NAMESPACE:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case NewprocessPackage.PROCESS__HAS_SYNC_ACTIVITIES:
			case NewprocessPackage.PROCESS__HAS_ASYNC_ACTIVITIES:
			case NewprocessPackage.PROCESS__HAS_EVENTS:
			case NewprocessPackage.PROCESS__HAS_LISTENERS:
			case NewprocessPackage.PROCESS__HAS_ACTORS:
			case NewprocessPackage.PROCESS__HAS_MESSAGES:
			case NewprocessPackage.PROCESS__HAS_CONCLUSIONS:
			case NewprocessPackage.PROCESS__HAS_EXPANSIONS:
			case NewprocessPackage.PROCESS__HAS_CONDITION_PROXY:
			case NewprocessPackage.PROCESS__HAS_GLOBALS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds to the collection of {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing all of the children that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(NewprocessPackage.Literals.PROCESS__HAS_SYNC_ACTIVITIES,
				 NewprocessFactory.eINSTANCE.createSyncActivity()));

		newChildDescriptors.add
			(createChildParameter
				(NewprocessPackage.Literals.PROCESS__HAS_ASYNC_ACTIVITIES,
				 NewprocessFactory.eINSTANCE.createAsyncActivity()));

		newChildDescriptors.add
			(createChildParameter
				(NewprocessPackage.Literals.PROCESS__HAS_EVENTS,
				 NewprocessFactory.eINSTANCE.createEvent()));

		newChildDescriptors.add
			(createChildParameter
				(NewprocessPackage.Literals.PROCESS__HAS_LISTENERS,
				 NewprocessFactory.eINSTANCE.createListener()));

		newChildDescriptors.add
			(createChildParameter
				(NewprocessPackage.Literals.PROCESS__HAS_ACTORS,
				 NewprocessFactory.eINSTANCE.createActor()));

		newChildDescriptors.add
			(createChildParameter
				(NewprocessPackage.Literals.PROCESS__HAS_MESSAGES,
				 NewprocessFactory.eINSTANCE.createMessage()));

		newChildDescriptors.add
			(createChildParameter
				(NewprocessPackage.Literals.PROCESS__HAS_CONCLUSIONS,
				 NewprocessFactory.eINSTANCE.createConclusion()));

		newChildDescriptors.add
			(createChildParameter
				(NewprocessPackage.Literals.PROCESS__HAS_EXPANSIONS,
				 NewprocessFactory.eINSTANCE.createExpansion()));

		newChildDescriptors.add
			(createChildParameter
				(NewprocessPackage.Literals.PROCESS__HAS_CONDITION_PROXY,
				 NewprocessFactory.eINSTANCE.createConditionProxy()));

		newChildDescriptors.add
			(createChildParameter
				(NewprocessPackage.Literals.PROCESS__HAS_GLOBALS,
				 NewprocessFactory.eINSTANCE.createGlobals()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceLocator getResourceLocator() {
		return New_processEditPlugin.INSTANCE;
	}

}
