/**
 * 
 */
package core;

import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTNode;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.CompilationUnit;

/**
 * @author sh
 *
 */
public abstract class AbstractAST {
	/**
	 * Called from Refactorings.
	 * 
	 * @param lwUnit the Java Model handle
	 * 				to the compilation unit that has to be processed.
	 */
	protected CompilationUnit parse(ICompilationUnit lwUnit) {
		ASTParser parser = ASTParser.newParser(AST.JLS3);
		parser.setKind(ASTParser.K_COMPILATION_UNIT);
		parser.setSource(lwUnit);
		parser.setResolveBindings(true);
		ASTNode root = parser.createAST(null);
		CompilationUnit cu = (CompilationUnit)root;
		cu.recordModifications();
		return cu;
	}
}
