package core;

import org.eclipse.jdt.core.IJavaElement;

/**
 * All code refactorings do some modifications
 * in the surce code.
 *  
 * @author sh
 *
 */
public interface ICodeRefactoring {
	/**
	 * Takes a compilation unit and modifies its its content.
	 * 
	 * @param modelElement the model element to refactor
	 */
	public void updateSource(IJavaElement modelElement);
	
	/**
	 * Starts the refactoring process.
	 * It invokes the code refactoring.
	 * 
	 * @param info the info object containing all important 
	 * 				information of the source
	 */
	public void process(RefactorInfo info);
	
	/**
	 * Starts the refactoring process.
	 * It invokes the code refactoring.
	 * 
	 * @param info the info object containing all important 
	 * 				information of the model
	 */
	public void process(ModelInfo info);
}
