/**
 * 
 */
package core;

import model.ModelEditor;

import org.openarchitectureware.workflow.issues.Issues;


/**
 * @author sh
 *
 */
public class ModelAccessTest {
	
	// singleton
	public static final ModelAccessTest INSTANCE = new ModelAccessTest();
	
	/**
	 * This is a method used for ModelEditor.loadModels method.
	 * If no models were found or a meta model file could't be 
	 * found and exception is returned which is added as error.
	 * All problems e.g. errors and warnings found during loading 
	 * the models are returned by an Issues object. 
	 * 
	 * @return an issues object containing errors and warings
	 */
	public Issues readModel() {
		// try to load the models
		ModelEditor.INSTANCE.loadModels();
		
		// get the problems
		return ModelEditor.INSTANCE.getIssues();
	}
}
