/**
 * 
 */
package core;

import org.eclipse.jdt.core.ICompilationUnit;

/** <p>an info object that holds the information that is passed from
 * the user to the refactoring.</p> Primarilly used by Source Code Refactoring.
 *
 * @author sh
 */
public class RefactorInfo {
	// the new full qualified name of the type
	private String newName;
	  
	// the old type (as selected by the user)
	private String oldName;
	
	// the new variable name
	private String newVarName;
	
	// the old variable name
	private String oldVarName;
	
	// the java element
	private Object element;
	
	// the compilation unit containing the type
	private ICompilationUnit unit;
	  
	// whether the refactoring should also change the name of the property
	// in corresponding properties files in the same bundle (i.e. which start
	// with the same name)
	private boolean updateBundle;
	  
	// whether the refactoring should also update referencing files in other
	// projects than the current one
	private boolean allProjects;

	  
	public String getNewName() {
		return newName;
	}

	public void setNewName(final String newName) {
		this.newName = newName;
	}

	public String getOldName() {
		return oldName;
	}

	public void setOldName(final String oldName) {
		this.oldName = oldName;
	}

	public ICompilationUnit getUnit() {
		return unit;
	}

	public void setUnit(final ICompilationUnit unit) {
		this.unit = unit;
	}

	public boolean isUpdateBundle() {
		return updateBundle;
	}

	public void setUpdateBundle(final boolean updateBundle) {
		this.updateBundle = updateBundle;
	}

	public boolean isAllProjects() {
		return allProjects;
	}

	public void setAllProjects(final boolean allProjects) {
		this.allProjects = allProjects;
	}

	public Object getElement() {
		return element;
	}

	public void setElement(final Object element) {
		this.element = element;
	}

	public String getNewVarName() {
		return newVarName;
	}

	public void setNewVarName(final String newVarName) {
		this.newVarName = newVarName;
	}

	public String getOldVarName() {
		return oldVarName;
	}

	public void setOldVarName(final String oldVarName) {
		this.oldVarName = oldVarName;
	}
}
