package core;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.FieldDeclaration;
import org.eclipse.jdt.internal.core.SourceField;

/**
 * This class is responsible for execute the type
 * refactoring in the source.
 * 
 * @author sh
 */
public class RenameFieldDeclaration extends AbstractAST
	implements ICodeRefactoring {
	
	// the Info Object containing all nesessary refactor info
	private RefactorInfo info = null;
	
	/**
	 * performs the source modifications.
	 * The compilation unit of the info object 
	 * will be investigated and modified by the fild visitor.
	 * 
	 * @param modelElement the field to refactor
	 */
	public void updateSource(IJavaElement modelElement) {				
		// investigate the cu by the visitor
		FieldDeclarationVisitor fieldVisitor = new FieldDeclarationVisitor();
		CompilationUnit u = parse(info.getUnit());
		fieldVisitor.process(u, info);
		
		// write changes
		ManipulateHelper.saveDirectlyModifiedUnit(u);
	}
		
	@Override
	public void process(ModelInfo info) {
	}

	/**
	 * Start the refactoring process.
	 * 
	 * @param info the info object
	 */
	public void process(RefactorInfo info) {
		//if (info.getElement() instanceof SourceField == false) return;
		if (info.getElement() instanceof SourceField ||
			info.getElement() instanceof FieldDeclaration) {
			this.info = info;
		
			updateSource(null);
		}
	}
}
