/**
 * 
 */
package gui.section;

import diagram.section.EnvEntry;

/**
 * @author sh
 *
 */
public interface IEnvEntryViewer {
	/**
	 * Update the view to reflect the fact that an EnvEntry was added 
	 * to the EnvEntry list
	 * 
	 * @param envEntry
	 */
	public void addEnvEntry(EnvEntry envEntry);
	
	/**
	 * Update the view to reflect the fact that an EnvEntry was removed 
	 * from the EnvEntry list
	 * 
	 * @param envEntry
	 */
	public void removeEnvEntry(EnvEntry envEntry);
	
	/**
	 * Update the view to reflect the fact that one of the EnvEntry
	 * was modified 
	 * 
	 * @param envEntry
	 */
	public void updateEnvEntry(EnvEntry envEntry);
}
