/**
 * 
 */
package gui.wizards;

import org.eclipse.ltk.ui.refactoring.RefactoringWizard;

import core.ModelInfo;
import core.RenameProcessorHolder;

/** <p>The wizard that is shown to the user for entering the necessary 
 * information for type renaming.</p>
 * 
 * <p>The wizard class is primarily needed for deciding which pages are 
 * shown to the user. The actual user interface creation goes on the 
 * pages.</p>
 * 
 * @author sh
 */
public class RenameImplementationWizard extends RefactoringWizard {
	
	private final ModelInfo info;
	
	public RenameImplementationWizard(final RenameProcessorHolder refactoring,
            final ModelInfo info) {
		super(refactoring, DIALOG_BASED_USER_INTERFACE);
		this.info = info;
	}
	
	/**
	 * interface methods of RefactoringWizard
	 */
	protected void addUserInputPages() {
		setDefaultPageTitle(getRefactoring().getName());
	    addPage(new RenameImplementationInputPage(info));
	}
}
