/**
 * 
 */
package gui.wizards;

import org.eclipse.ltk.ui.refactoring.RefactoringWizard;

import core.RefactorInfo;
import core.RenameProcessorHolder;

/** <p>The wizard that is shown to the user for entering the necessary 
 * information for type renaming.</p>
 * 
 * <p>The wizard class is primarily needed for deciding which pages are 
 * shown to the user. The actual user interface creation goes on the 
 * pages.</p>
 * 
 * @author sh
 */
public class RenameTypeWizard extends RefactoringWizard {
	
	private final RefactorInfo info;

	public RenameTypeWizard(final RenameProcessorHolder refactoring,
            final RefactorInfo info) {
		super(refactoring, DIALOG_BASED_USER_INTERFACE);
		this.info = info;
	}
	 
	/**
	 * interface methods of RefactoringWizard
	 */
	protected void addUserInputPages() {
		setDefaultPageTitle(getRefactoring().getName());
	    addPage(new RenameTypeInputPage(info));
	}
}
