package newprocess.adapter;

import newprocess.ConditionTerm;
import newprocess.NewprocessPackage;
import newprocess.Term;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.impl.SingletonAdapterImpl;


/**
 * @author sh
 *
 */
public class ConditionTermAdapter extends SingletonAdapterImpl {
	// Singleton
	public static ConditionTermAdapter INSTANCE = new ConditionTermAdapter();
	
	/**
	 * If a Term has been deleted we perform an update to set the expression
	 */
	public void notifyChanged(Notification msg) {
		super.notifyChanged(msg);
		
		int featureID = msg.getFeatureID(NewprocessPackage.class);
		if (msg.getEventType() == Notification.SET
				&& msg.getNotifier() instanceof ConditionTerm) {
			((Term)msg.getNotifier()).performUpdate();
		}
	}
}

