package newprocess.adapter;

import newprocess.Expression;
import newprocess.NewprocessPackage;
import newprocess.OperatorTerm;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.impl.SingletonAdapterImpl;

/**
 * @author ts
 * listens on changes of the operator linkings to update the expression
 *
 */
public class OperatorAdapter extends SingletonAdapterImpl {

	// Singleton
	public static OperatorAdapter INSTANCE = new OperatorAdapter();
	
	/**
	 * @author ts + sh
	 * 
	 * @see org.eclipse.emf.common.notify.impl.SingletonAdapterImpl#notifyChanged(org.eclipse.emf.common.notify.Notification)
	 */
	@Override
	public void notifyChanged(Notification msg) {
		super.notifyChanged(msg);
				
		// react on Operator - Operator Link creations
		if (msg.getEventType() == Notification.ADD
				&& msg.getFeatureID(NewprocessPackage.class) == NewprocessPackage.OPERATOR_TERM__SUB_TERM) {
			
			if(msg.getNotifier() instanceof OperatorTerm && msg.getNewValue() instanceof OperatorTerm)
			   ((OperatorTerm)msg.getNotifier()).performUpdate();
		}
		
		// react on Root - Operator Link creations
		if (msg.getEventType() == Notification.ADD
				&& msg.getFeatureID(NewprocessPackage.class) == NewprocessPackage.ROOT__TERM) {		
			
			if(msg.getNotifier() instanceof OperatorTerm) {
				OperatorTerm op = (OperatorTerm)msg.getNotifier();
				Expression expr = (Expression)op.eContainer();
				expr.updateExpression();
			}
		}
		
		// react on Operator - Operator Link changes
		if (msg.getEventType() == Notification.REMOVE
				&& msg.getFeatureID(NewprocessPackage.class) == NewprocessPackage.OPERATOR_TERM__SUB_TERM) {
			((OperatorTerm)msg.getNotifier()).performUpdate();
		}
	}
}

