/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package newprocess.impl;

import newprocess.Actor;
import newprocess.AndOperator;
import newprocess.AsyncActivity;
import newprocess.Conclusion;
import newprocess.Condition;
import newprocess.ConditionProxy;
import newprocess.ConditionTerm;
import newprocess.Direction;
import newprocess.Element;
import newprocess.EnvEntry;
import newprocess.Event;
import newprocess.Expansion;
import newprocess.Expression;
import newprocess.Globals;
import newprocess.Listener;
import newprocess.Loader;
import newprocess.Message;
import newprocess.NewprocessFactory;
import newprocess.NewprocessPackage;
import newprocess.OperatorTerm;
import newprocess.OrOperator;
import newprocess.Root;
import newprocess.SyncActivity;
import newprocess.Term;
import newprocess.adapter.ConditionTermAdapter;
import newprocess.adapter.OperatorAdapter;
import newprocess.adapter.ProxyAdapter;
import newprocess.adapter.RootTermAdapter;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class NewprocessFactoryImpl extends EFactoryImpl implements NewprocessFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static NewprocessFactory init() {
		try {
			NewprocessFactory theNewprocessFactory = (NewprocessFactory)EPackage.Registry.INSTANCE.getEFactory("http://www.wilken.de/mod/newprocess"); 
			if (theNewprocessFactory != null) {
				return theNewprocessFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new NewprocessFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NewprocessFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case NewprocessPackage.PROCESS: return createProcess();
			case NewprocessPackage.CONDITION: return createCondition();
			case NewprocessPackage.ELEMENT: return createElement();
			case NewprocessPackage.SYNC_ACTIVITY: return createSyncActivity();
			case NewprocessPackage.LOADER: return createLoader();
			case NewprocessPackage.ASYNC_ACTIVITY: return createAsyncActivity();
			case NewprocessPackage.EVENT: return createEvent();
			case NewprocessPackage.ACTOR: return createActor();
			case NewprocessPackage.LISTENER: return createListener();
			case NewprocessPackage.ENV_ENTRY: return createEnvEntry();
			case NewprocessPackage.MESSAGE: return createMessage();
			case NewprocessPackage.CONDITION_PROXY: return createConditionProxy();
			case NewprocessPackage.CONCLUSION: return createConclusion();
			case NewprocessPackage.EXPANSION: return createExpansion();
			case NewprocessPackage.EXPRESSION: return createExpression();
			case NewprocessPackage.TERM: return createTerm();
			case NewprocessPackage.CONDITION_TERM: return createConditionTerm();
			case NewprocessPackage.OPERATOR_TERM: return createOperatorTerm();
			case NewprocessPackage.OR_OPERATOR: return createOrOperator();
			case NewprocessPackage.AND_OPERATOR: return createAndOperator();
			case NewprocessPackage.ROOT: return createRoot();
			case NewprocessPackage.GLOBALS: return createGlobals();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case NewprocessPackage.DIRECTION:
				return createDirectionFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case NewprocessPackage.DIRECTION:
				return convertDirectionToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public newprocess.Process createProcess() {
		ProcessImpl process = new ProcessImpl();
		return process;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Condition createCondition() {
		ConditionImpl condition = new ConditionImpl();
		return condition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Element createElement() {
		ElementImpl element = new ElementImpl();
		return element;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SyncActivity createSyncActivity() {
		SyncActivityImpl syncActivity = new SyncActivityImpl();
		return syncActivity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Loader createLoader() {
		LoaderImpl loader = new LoaderImpl();
		return loader;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AsyncActivity createAsyncActivity() {
		AsyncActivityImpl asyncActivity = new AsyncActivityImpl();
		return asyncActivity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Event createEvent() {
		EventImpl event = new EventImpl();
		return event;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Actor createActor() {
		ActorImpl actor = new ActorImpl();
		return actor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Listener createListener() {
		ListenerImpl listener = new ListenerImpl();
		return listener;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EnvEntry createEnvEntry() {
		EnvEntryImpl envEntry = new EnvEntryImpl();
		return envEntry;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Message createMessage() {
		MessageImpl message = new MessageImpl();
		return message;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 * @author sh
	 */
	public ConditionProxy createConditionProxy() {
		ConditionProxyImpl conditionProxy = new ConditionProxyImpl();
		conditionProxy.eAdapters().add(ProxyAdapter.INSTANCE);			// register adapter
		return conditionProxy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Conclusion createConclusion() {
		ConclusionImpl conclusion = new ConclusionImpl();
		return conclusion;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Expansion createExpansion() {
		ExpansionImpl expansion = new ExpansionImpl();
		return expansion;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Expression createExpression() {
		ExpressionImpl expression = new ExpressionImpl();
		return expression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Term createTerm() {
		TermImpl term = new TermImpl();
		return term;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 * @author sh
	 */
	public ConditionTerm createConditionTerm() {
		ConditionTermImpl conditionTerm = new ConditionTermImpl();
		conditionTerm.eAdapters().add(ConditionTermAdapter.INSTANCE);				// register adapter
		return conditionTerm;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OperatorTerm createOperatorTerm() {
		OperatorTermImpl operatorTerm = new OperatorTermImpl();
		return operatorTerm;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 * @author sh
	 */
	public OrOperator createOrOperator() {
		OrOperatorImpl orOperator = new OrOperatorImpl();
		orOperator.eAdapters().add(OperatorAdapter.INSTANCE);			// register adapter
		return orOperator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 * @author sh
	 */
	public AndOperator createAndOperator() {
		AndOperatorImpl andOperator = new AndOperatorImpl();
		andOperator.eAdapters().add(OperatorAdapter.INSTANCE);			// register adapter
		return andOperator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 * @author sh
	 */
	public Root createRoot() {
		RootImpl root = new RootImpl();
		root.eAdapters().add(RootTermAdapter.INSTANCE);				// register adapter
		return root;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Globals createGlobals() {
		GlobalsImpl globals = new GlobalsImpl();
		return globals;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Direction createDirectionFromString(EDataType eDataType, String initialValue) {
		Direction result = Direction.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertDirectionToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NewprocessPackage getNewprocessPackage() {
		return (NewprocessPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static NewprocessPackage getPackage() {
		return NewprocessPackage.eINSTANCE;
	}

} //NewprocessFactoryImpl
