/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package newprocess.impl;

import java.util.Collection;
import java.util.Iterator;

import newprocess.AndOperator;
import newprocess.ConditionTerm;
import newprocess.Expression;
import newprocess.NewprocessPackage;
import newprocess.OperatorTerm;
import newprocess.Root;
import newprocess.Term;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Operator Term</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link newprocess.impl.OperatorTermImpl#getSubTerm <em>Sub Term</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class OperatorTermImpl extends TermImpl implements OperatorTerm {
	/**
	 * The cached value of the '{@link #getSubTerm() <em>Sub Term</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSubTerm()
	 * @generated
	 * @ordered
	 */
	protected EList<Term> subTerm = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OperatorTermImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return NewprocessPackage.Literals.OPERATOR_TERM;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Term> getSubTerm() {
		if (subTerm == null) {
			subTerm = new EObjectResolvingEList<Term>(Term.class, this, NewprocessPackage.OPERATOR_TERM__SUB_TERM);
		}
		return subTerm;
	}

	/**
	 * <!-- begin-user-doc -->
	 *  get the level of this operator or 0 if not correctly linked.
	 * <!-- end-user-doc -->
	 * @generated NOT
	 * @author sh
	 */
	public int getLevel() {
		int level = 0;
		OperatorTerm operator = this;
		Expression condition = (Expression)this.eContainer();
		Root root = condition.getHasRoot(); 
		if (root.getTerm() == null)
				return 0;				// no operator is connected to root
		++level;						// first is guaranteed
		while (operator != root.getTerm()) {
			operator = getParentTerm(operator);	    // get the parent
			if (operator == null)
				return 0;				// no parent found means: disconnected somewhere
			++level;		
		}
		return level;	
	}
	
	/**
	 * getTermLevel needs to find parents 
	 * @param op 
	 * @return a parent or null
	 * @author ts
	 */
	private OperatorTerm getParentTerm (OperatorTerm op) {
		Iterator<Term> it = ((Expression)op.eContainer()).getHasTerms().iterator();
		while (it.hasNext()) {
			Term term = it.next();
			if (term instanceof OperatorTerm 
					&& ((OperatorTerm)term).getSubTerm().contains(op))
				return (OperatorTerm)term;
		}	
		return null; // no parent found
	}

	/**
	 * <!-- begin-user-doc -->
	 *  each operator must only have one incoming link.
	 * <!-- end-user-doc -->
	 * @generated NOT
	 * @author sh
	 */
	public boolean acceptIncomingLink() {
		if (((Expression)eContainer()).getHasRoot().getTerm() == this)
			return false;
		
		Iterator<Term> it = ((Expression)eContainer()).getHasTerms().iterator();
		while (it.hasNext()) {
			Term term = it.next();
			if (term instanceof OperatorTerm 
					&& term != this 
					&& ((OperatorTerm)term).getSubTerm().contains(this))
				return false;
		}
		return true;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case NewprocessPackage.OPERATOR_TERM__SUB_TERM:
				return getSubTerm();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case NewprocessPackage.OPERATOR_TERM__SUB_TERM:
				getSubTerm().clear();
				getSubTerm().addAll((Collection<? extends Term>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case NewprocessPackage.OPERATOR_TERM__SUB_TERM:
				getSubTerm().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case NewprocessPackage.OPERATOR_TERM__SUB_TERM:
				return subTerm != null && !subTerm.isEmpty();
		}
		return super.eIsSet(featureID);
	}
	
	/**
	 * @see de.wilken.mod.process.impl.AbstractTermImpl#getExpression()
	 * 
	 * build a expression by navigation over the subterms.
	 * 
	 * @generated NOT
	 * @author sh
	 */
	@Override
	public String getExpression() {		
		String operator;
		if (this instanceof AndOperator) operator = " && ";
		else operator = " || ";
				
		String expr = null;
		Iterator<Term> it = getSubTerm().iterator();
		while (it.hasNext()) {
			Term term = it.next();
			String subExpr = term.getExpression();
			
			// add brackets if complex expression
			if(term instanceof OperatorTerm	
				&& ((OperatorTerm)term).getSubTerm().size() > 1) 
				if(subExpr != null) subExpr = "(".concat(subExpr).concat(")");
			
			if(term instanceof ConditionTerm) {
				ConditionTerm port = (ConditionTerm)term;
			   if(port.getConditionProxy() != null){
				 if(port.getConditionProxy().getProxyName() != null) 
					 subExpr = port.getConditionProxy().getProxyName(); 
			   }
			}

			if(expr == null) expr = subExpr;
			// add operator 
			else {
				if(subExpr != null)
				   expr = expr.concat(operator).concat(subExpr);
			}
				
		}
		return expr;	
	}

} //OperatorTermImpl
