/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package newprocess.impl;

import java.util.Collection;

import newprocess.Actor;
import newprocess.AsyncActivity;
import newprocess.Conclusion;
import newprocess.ConditionProxy;
import newprocess.Event;
import newprocess.Expansion;
import newprocess.Globals;
import newprocess.Listener;
import newprocess.Message;
import newprocess.NewprocessPackage;
import newprocess.Process;
import newprocess.SyncActivity;
import newprocess.validation.ProcessValidator;
import newprocess.validation.ProcessValidatorImpl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Process</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link newprocess.impl.ProcessImpl#getSubject <em>Subject</em>}</li>
 *   <li>{@link newprocess.impl.ProcessImpl#getHasSyncActivities <em>Has Sync Activities</em>}</li>
 *   <li>{@link newprocess.impl.ProcessImpl#getHasAsyncActivities <em>Has Async Activities</em>}</li>
 *   <li>{@link newprocess.impl.ProcessImpl#getHasEvents <em>Has Events</em>}</li>
 *   <li>{@link newprocess.impl.ProcessImpl#getHasListeners <em>Has Listeners</em>}</li>
 *   <li>{@link newprocess.impl.ProcessImpl#getHasActors <em>Has Actors</em>}</li>
 *   <li>{@link newprocess.impl.ProcessImpl#getHasMessages <em>Has Messages</em>}</li>
 *   <li>{@link newprocess.impl.ProcessImpl#getHasConclusions <em>Has Conclusions</em>}</li>
 *   <li>{@link newprocess.impl.ProcessImpl#getHasExpansions <em>Has Expansions</em>}</li>
 *   <li>{@link newprocess.impl.ProcessImpl#getHasConditionProxy <em>Has Condition Proxy</em>}</li>
 *   <li>{@link newprocess.impl.ProcessImpl#getHasGlobals <em>Has Globals</em>}</li>
 *   <li>{@link newprocess.impl.ProcessImpl#getNamespace <em>Namespace</em>}</li>
 * </ul>
 * </p>
 *
 * @generated NOT
 * @author sh
 */
public class ProcessImpl extends ElementImpl 
	implements newprocess.Process, ProcessValidator {
	
	/**
	 * The default value of the '{@link #getSubject() <em>Subject</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSubject()
	 * @generated
	 * @ordered
	 */
	protected static final String SUBJECT_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getSubject() <em>Subject</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSubject()
	 * @generated
	 * @ordered
	 */
	protected String subject = SUBJECT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getHasSyncActivities() <em>Has Sync Activities</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHasSyncActivities()
	 * @generated
	 * @ordered
	 */
	protected EList<SyncActivity> hasSyncActivities = null;

	/**
	 * The cached value of the '{@link #getHasAsyncActivities() <em>Has Async Activities</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHasAsyncActivities()
	 * @generated
	 * @ordered
	 */
	protected EList<AsyncActivity> hasAsyncActivities = null;

	/**
	 * The cached value of the '{@link #getHasEvents() <em>Has Events</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHasEvents()
	 * @generated
	 * @ordered
	 */
	protected EList<Event> hasEvents = null;

	/**
	 * The cached value of the '{@link #getHasListeners() <em>Has Listeners</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHasListeners()
	 * @generated
	 * @ordered
	 */
	protected EList<Listener> hasListeners = null;

	/**
	 * The cached value of the '{@link #getHasActors() <em>Has Actors</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHasActors()
	 * @generated
	 * @ordered
	 */
	protected EList<Actor> hasActors = null;

	/**
	 * The cached value of the '{@link #getHasMessages() <em>Has Messages</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHasMessages()
	 * @generated
	 * @ordered
	 */
	protected EList<Message> hasMessages = null;

	/**
	 * The cached value of the '{@link #getHasConclusions() <em>Has Conclusions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHasConclusions()
	 * @generated
	 * @ordered
	 */
	protected EList<Conclusion> hasConclusions = null;

	/**
	 * The cached value of the '{@link #getHasExpansions() <em>Has Expansions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHasExpansions()
	 * @generated
	 * @ordered
	 */
	protected EList<Expansion> hasExpansions = null;

	/**
	 * The cached value of the '{@link #getHasConditionProxy() <em>Has Condition Proxy</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHasConditionProxy()
	 * @generated
	 * @ordered
	 */
	protected EList<ConditionProxy> hasConditionProxy = null;

	/**
	 * The cached value of the '{@link #getHasGlobals() <em>Has Globals</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHasGlobals()
	 * @generated
	 * @ordered
	 */
	protected Globals hasGlobals = null;

	/**
	 * The default value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNamespace()
	 * @generated
	 * @ordered
	 */
	protected static final String NAMESPACE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getNamespace() <em>Namespace</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNamespace()
	 * @generated
	 * @ordered
	 */
	protected String namespace = NAMESPACE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProcessImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return NewprocessPackage.Literals.PROCESS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getSubject() {
		return subject;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSubject(String newSubject) {
		String oldSubject = subject;
		subject = newSubject;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, NewprocessPackage.PROCESS__SUBJECT, oldSubject, subject));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SyncActivity> getHasSyncActivities() {
		if (hasSyncActivities == null) {
			hasSyncActivities = new EObjectContainmentEList<SyncActivity>(SyncActivity.class, this, NewprocessPackage.PROCESS__HAS_SYNC_ACTIVITIES);
		}
		return hasSyncActivities;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<AsyncActivity> getHasAsyncActivities() {
		if (hasAsyncActivities == null) {
			hasAsyncActivities = new EObjectContainmentEList<AsyncActivity>(AsyncActivity.class, this, NewprocessPackage.PROCESS__HAS_ASYNC_ACTIVITIES);
		}
		return hasAsyncActivities;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Event> getHasEvents() {
		if (hasEvents == null) {
			hasEvents = new EObjectContainmentEList<Event>(Event.class, this, NewprocessPackage.PROCESS__HAS_EVENTS);
		}
		return hasEvents;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Listener> getHasListeners() {
		if (hasListeners == null) {
			hasListeners = new EObjectContainmentEList<Listener>(Listener.class, this, NewprocessPackage.PROCESS__HAS_LISTENERS);
		}
		return hasListeners;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Actor> getHasActors() {
		if (hasActors == null) {
			hasActors = new EObjectContainmentEList<Actor>(Actor.class, this, NewprocessPackage.PROCESS__HAS_ACTORS);
		}
		return hasActors;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Message> getHasMessages() {
		if (hasMessages == null) {
			hasMessages = new EObjectContainmentEList<Message>(Message.class, this, NewprocessPackage.PROCESS__HAS_MESSAGES);
		}
		return hasMessages;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Conclusion> getHasConclusions() {
		if (hasConclusions == null) {
			hasConclusions = new EObjectContainmentEList<Conclusion>(Conclusion.class, this, NewprocessPackage.PROCESS__HAS_CONCLUSIONS);
		}
		return hasConclusions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Expansion> getHasExpansions() {
		if (hasExpansions == null) {
			hasExpansions = new EObjectContainmentEList<Expansion>(Expansion.class, this, NewprocessPackage.PROCESS__HAS_EXPANSIONS);
		}
		return hasExpansions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ConditionProxy> getHasConditionProxy() {
		if (hasConditionProxy == null) {
			hasConditionProxy = new EObjectContainmentEList<ConditionProxy>(ConditionProxy.class, this, NewprocessPackage.PROCESS__HAS_CONDITION_PROXY);
		}
		return hasConditionProxy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Globals getHasGlobals() {
		return hasGlobals;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetHasGlobals(Globals newHasGlobals, NotificationChain msgs) {
		Globals oldHasGlobals = hasGlobals;
		hasGlobals = newHasGlobals;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, NewprocessPackage.PROCESS__HAS_GLOBALS, oldHasGlobals, newHasGlobals);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setHasGlobals(Globals newHasGlobals) {
		if (newHasGlobals != hasGlobals) {
			NotificationChain msgs = null;
			if (hasGlobals != null)
				msgs = ((InternalEObject)hasGlobals).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - NewprocessPackage.PROCESS__HAS_GLOBALS, null, msgs);
			if (newHasGlobals != null)
				msgs = ((InternalEObject)newHasGlobals).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - NewprocessPackage.PROCESS__HAS_GLOBALS, null, msgs);
			msgs = basicSetHasGlobals(newHasGlobals, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, NewprocessPackage.PROCESS__HAS_GLOBALS, newHasGlobals, newHasGlobals));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getNamespace() {
		return namespace;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNamespace(String newNamespace) {
		String oldNamespace = namespace;
		namespace = newNamespace;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, NewprocessPackage.PROCESS__NAMESPACE, oldNamespace, namespace));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case NewprocessPackage.PROCESS__HAS_SYNC_ACTIVITIES:
				return ((InternalEList<?>)getHasSyncActivities()).basicRemove(otherEnd, msgs);
			case NewprocessPackage.PROCESS__HAS_ASYNC_ACTIVITIES:
				return ((InternalEList<?>)getHasAsyncActivities()).basicRemove(otherEnd, msgs);
			case NewprocessPackage.PROCESS__HAS_EVENTS:
				return ((InternalEList<?>)getHasEvents()).basicRemove(otherEnd, msgs);
			case NewprocessPackage.PROCESS__HAS_LISTENERS:
				return ((InternalEList<?>)getHasListeners()).basicRemove(otherEnd, msgs);
			case NewprocessPackage.PROCESS__HAS_ACTORS:
				return ((InternalEList<?>)getHasActors()).basicRemove(otherEnd, msgs);
			case NewprocessPackage.PROCESS__HAS_MESSAGES:
				return ((InternalEList<?>)getHasMessages()).basicRemove(otherEnd, msgs);
			case NewprocessPackage.PROCESS__HAS_CONCLUSIONS:
				return ((InternalEList<?>)getHasConclusions()).basicRemove(otherEnd, msgs);
			case NewprocessPackage.PROCESS__HAS_EXPANSIONS:
				return ((InternalEList<?>)getHasExpansions()).basicRemove(otherEnd, msgs);
			case NewprocessPackage.PROCESS__HAS_CONDITION_PROXY:
				return ((InternalEList<?>)getHasConditionProxy()).basicRemove(otherEnd, msgs);
			case NewprocessPackage.PROCESS__HAS_GLOBALS:
				return basicSetHasGlobals(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case NewprocessPackage.PROCESS__SUBJECT:
				return getSubject();
			case NewprocessPackage.PROCESS__HAS_SYNC_ACTIVITIES:
				return getHasSyncActivities();
			case NewprocessPackage.PROCESS__HAS_ASYNC_ACTIVITIES:
				return getHasAsyncActivities();
			case NewprocessPackage.PROCESS__HAS_EVENTS:
				return getHasEvents();
			case NewprocessPackage.PROCESS__HAS_LISTENERS:
				return getHasListeners();
			case NewprocessPackage.PROCESS__HAS_ACTORS:
				return getHasActors();
			case NewprocessPackage.PROCESS__HAS_MESSAGES:
				return getHasMessages();
			case NewprocessPackage.PROCESS__HAS_CONCLUSIONS:
				return getHasConclusions();
			case NewprocessPackage.PROCESS__HAS_EXPANSIONS:
				return getHasExpansions();
			case NewprocessPackage.PROCESS__HAS_CONDITION_PROXY:
				return getHasConditionProxy();
			case NewprocessPackage.PROCESS__HAS_GLOBALS:
				return getHasGlobals();
			case NewprocessPackage.PROCESS__NAMESPACE:
				return getNamespace();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
		@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case NewprocessPackage.PROCESS__SUBJECT:
				setSubject((String)newValue);
				return;
			case NewprocessPackage.PROCESS__HAS_SYNC_ACTIVITIES:
				getHasSyncActivities().clear();
				getHasSyncActivities().addAll((Collection<? extends SyncActivity>)newValue);
				return;
			case NewprocessPackage.PROCESS__HAS_ASYNC_ACTIVITIES:
				getHasAsyncActivities().clear();
				getHasAsyncActivities().addAll((Collection<? extends AsyncActivity>)newValue);
				return;
			case NewprocessPackage.PROCESS__HAS_EVENTS:
				getHasEvents().clear();
				getHasEvents().addAll((Collection<? extends Event>)newValue);
				return;
			case NewprocessPackage.PROCESS__HAS_LISTENERS:
				getHasListeners().clear();
				getHasListeners().addAll((Collection<? extends Listener>)newValue);
				return;
			case NewprocessPackage.PROCESS__HAS_ACTORS:
				getHasActors().clear();
				getHasActors().addAll((Collection<? extends Actor>)newValue);
				return;
			case NewprocessPackage.PROCESS__HAS_MESSAGES:
				getHasMessages().clear();
				getHasMessages().addAll((Collection<? extends Message>)newValue);
				return;
			case NewprocessPackage.PROCESS__HAS_CONCLUSIONS:
				getHasConclusions().clear();
				getHasConclusions().addAll((Collection<? extends Conclusion>)newValue);
				return;
			case NewprocessPackage.PROCESS__HAS_EXPANSIONS:
				getHasExpansions().clear();
				getHasExpansions().addAll((Collection<? extends Expansion>)newValue);
				return;
			case NewprocessPackage.PROCESS__HAS_CONDITION_PROXY:
				getHasConditionProxy().clear();
				getHasConditionProxy().addAll((Collection<? extends ConditionProxy>)newValue);
				return;
			case NewprocessPackage.PROCESS__HAS_GLOBALS:
				setHasGlobals((Globals)newValue);
				return;
			case NewprocessPackage.PROCESS__NAMESPACE:
				setNamespace((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case NewprocessPackage.PROCESS__SUBJECT:
				setSubject(SUBJECT_EDEFAULT);
				return;
			case NewprocessPackage.PROCESS__HAS_SYNC_ACTIVITIES:
				getHasSyncActivities().clear();
				return;
			case NewprocessPackage.PROCESS__HAS_ASYNC_ACTIVITIES:
				getHasAsyncActivities().clear();
				return;
			case NewprocessPackage.PROCESS__HAS_EVENTS:
				getHasEvents().clear();
				return;
			case NewprocessPackage.PROCESS__HAS_LISTENERS:
				getHasListeners().clear();
				return;
			case NewprocessPackage.PROCESS__HAS_ACTORS:
				getHasActors().clear();
				return;
			case NewprocessPackage.PROCESS__HAS_MESSAGES:
				getHasMessages().clear();
				return;
			case NewprocessPackage.PROCESS__HAS_CONCLUSIONS:
				getHasConclusions().clear();
				return;
			case NewprocessPackage.PROCESS__HAS_EXPANSIONS:
				getHasExpansions().clear();
				return;
			case NewprocessPackage.PROCESS__HAS_CONDITION_PROXY:
				getHasConditionProxy().clear();
				return;
			case NewprocessPackage.PROCESS__HAS_GLOBALS:
				setHasGlobals((Globals)null);
				return;
			case NewprocessPackage.PROCESS__NAMESPACE:
				setNamespace(NAMESPACE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case NewprocessPackage.PROCESS__SUBJECT:
				return SUBJECT_EDEFAULT == null ? subject != null : !SUBJECT_EDEFAULT.equals(subject);
			case NewprocessPackage.PROCESS__HAS_SYNC_ACTIVITIES:
				return hasSyncActivities != null && !hasSyncActivities.isEmpty();
			case NewprocessPackage.PROCESS__HAS_ASYNC_ACTIVITIES:
				return hasAsyncActivities != null && !hasAsyncActivities.isEmpty();
			case NewprocessPackage.PROCESS__HAS_EVENTS:
				return hasEvents != null && !hasEvents.isEmpty();
			case NewprocessPackage.PROCESS__HAS_LISTENERS:
				return hasListeners != null && !hasListeners.isEmpty();
			case NewprocessPackage.PROCESS__HAS_ACTORS:
				return hasActors != null && !hasActors.isEmpty();
			case NewprocessPackage.PROCESS__HAS_MESSAGES:
				return hasMessages != null && !hasMessages.isEmpty();
			case NewprocessPackage.PROCESS__HAS_CONCLUSIONS:
				return hasConclusions != null && !hasConclusions.isEmpty();
			case NewprocessPackage.PROCESS__HAS_EXPANSIONS:
				return hasExpansions != null && !hasExpansions.isEmpty();
			case NewprocessPackage.PROCESS__HAS_CONDITION_PROXY:
				return hasConditionProxy != null && !hasConditionProxy.isEmpty();
			case NewprocessPackage.PROCESS__HAS_GLOBALS:
				return hasGlobals != null;
			case NewprocessPackage.PROCESS__NAMESPACE:
				return NAMESPACE_EDEFAULT == null ? namespace != null : !NAMESPACE_EDEFAULT.equals(namespace);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (subject: ");
		result.append(subject);
		result.append(", namespace: ");
		result.append(namespace);
		result.append(')');
		return result.toString();
	}

	/**
	 * Validates the Implementation of the Process
	 * @author sh
	 */
	public boolean validateImplementation(Process proc) {
		return ProcessValidatorImpl.INSTANCE.validateImplementation(proc);
	}

	/**
	 * Validates the Name of the Process
	 * @author sh
	 */
	public boolean validateName(Process proc) {
		return ProcessValidatorImpl.INSTANCE.validateName(proc);
	}

	/**
	 * Validates the Namespace of the Process
	 * @author sh
	 */
	public boolean validateNamespace(Process proc) {
		return ProcessValidatorImpl.INSTANCE.validateNamespace(proc);
	}

	/**
	 * Validates the Subject of the Process
	 * @author sh
	 */
	public boolean validateSubject(Process proc) {
		return ProcessValidatorImpl.INSTANCE.validateSubject(proc);
	}
} //ProcessImpl
