package newprocess.validation;

import java.util.Iterator;

import newprocess.Actor;

import org.eclipse.emf.common.util.EList;


/**
 * @author sh
 *
 */
public class ActorValidatorImpl implements ActorValidator {

	// singleton
	public static final ActorValidatorImpl INSTANCE = new ActorValidatorImpl();
				
	/**
	 * validates the name of the Actor
	 * @param act
	 * @return
	 */
	public boolean validateName(Actor act) {
		String actName = act.getName();
		if(actName == null || actName == "") return false;
			
		// uniqueness check
		EList<Actor> actors = ((newprocess.Process)act.eContainer()).getHasActors();
		for (Iterator iterator = actors.iterator(); iterator.hasNext();) {
			Actor actor = (Actor) iterator.next();
			if(actor == act) continue;
			String curName = actor.getName();
			if(curName != null && curName.equals(actName)) return false;
		}
		return true;		
	}
	
	/**
	 * validates the implementation of the Actor
	 * @param act
	 * @return
	 */
	public boolean validateImplementation(Actor act) {
		if(ImplementationValidator.INSTANCE.validate(act)) return true;
		return false;
	}
}

