package newprocess.validation;

import java.util.Iterator;

import newprocess.Condition;

import org.eclipse.emf.common.util.EList;

/**
 * validate conditions
 * @author sh
 *
 */
public class ConditionValidatorImpl implements ConditionValidator {
	
	// singelton
	public static ConditionValidatorImpl INSTANCE = new ConditionValidatorImpl();
	
	/**
	 * check if the conditions has a correct name
	 * 
	 * @param
	 * @author sh
	 */
	public boolean validateName(Condition con) {
		String conName = con.getName();
		// name check
		if(conName == null || conName== "") return false; 
				
		// uniqueness check
		if(con.eContainer() instanceof Process) {
			EList<Condition> conditions =((newprocess.Process)con.eContainer()).getHasGlobals().getHasCondition();
			for (Iterator<Condition> iterator = conditions.iterator(); iterator.hasNext();) {
				Condition aktCond = (Condition) iterator.next();
				if(aktCond == con) continue;
					
				String itName = aktCond.getName();
				if(itName.equals(conName)) return false;
			}
		}
		return true;
	}
	
	/**
	 * determinate the correctness of implementation property
	 * 
	 * @param con
	 * @author sh
	 */
	public boolean validateImplementation(Condition con) {
		if(ImplementationValidator.INSTANCE.validate(con)) return true;
		return false;
	}
}
