/**
 * 
 */
package newprocess.validation;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.jdt.core.JavaConventions;
import org.eclipse.jdt.internal.compiler.impl.CompilerOptions;

/**
 * This validator is used by the EnvEntryValidatorImpl to determinate the correctness of
 * type properties.
 * 
 * A type has to be a simple idetifier.
 * 
 * @author sh 
 */
public class EnvEntryValidatorImpl implements EnvEntryValidator {
	
	// singleton
	public static final EnvEntryValidatorImpl INSTANCE = new EnvEntryValidatorImpl();
	
	// deafault types available for the environment entry type property
	public static final String[] TYPES = new String[] { "boolean",
														"byte",
														"char",
														"String",
														"short",
														"int",
														"long",
														"float",
														"double"};

	/* (non-Javadoc)
	 * @see newprocess.validation.EnvEntryValidator#validate()
	 */
	@Override
	public String validate() {
		return null;
	}

	/* (non-Javadoc)
	 * @see newprocess.validation.EnvEntryValidator#validateName(java.lang.String)
	 */
	@Override
	public String validateName(String value) {
		return null;
	}

	/* (non-Javadoc)
	 * @see newprocess.validation.EnvEntryValidator#validateType(java.lang.String)
	 */
	@Override
	public String validateType(String value) {
		// check if the selected value exists in the default type collection
		boolean contained = false;
		for (int j = 0; j < TYPES.length; j++) {
			String type = TYPES[j];
			if (type.equals(value)) contained = true;
		}
		
		// if not, check if the current value is valid
		if (!contained) {
			IStatus status = JavaConventions.validateJavaTypeName(value, CompilerOptions.VERSION_1_3,CompilerOptions.VERSION_1_3);
			if(status.isOK())
			   return null;
			else if(status.ERROR == IStatus.ERROR) {
				return status.getMessage();
			}	
		}
		return null;
	}

	/* (non-Javadoc)
	 * @see newprocess.validation.EnvEntryValidator#validateValue(java.lang.String)
	 */
	@Override
	public String validateValue(String value) {
		return null;
	}
}
