/**
 * 
 */
package newprocess.validation;

import java.util.Iterator;

import newprocess.Message;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

/**
 * @author sh
 *
 */
public class MessageValidatorImpl implements MessageValidator {
	
	// singleton
	public static final MessageValidatorImpl INSTANCE = new MessageValidatorImpl();

	public boolean validate(EObject obj) {
		if (!(obj instanceof Message)) return false;
		Message msg = (Message)obj;
		if (!validateName(msg)) return false;
		return true;
	}

	public boolean validateName(Message msg) {
		String msgName = msg.getName();
		if(msgName == null || msgName == "") return false;
				
		// uniqueness check
		EList<Message> messages = ((newprocess.Process)msg.eContainer()).getHasMessages();
		for (Iterator<Message> iterator = messages.iterator(); iterator.hasNext();) {
			Message message = (Message) iterator.next();
			if(message == msg) continue;
			String curName = message.getName();
			if(curName != null && curName.equals(msgName)) return false;
		}
		return true;
	}
}
