package newprocess.validation;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.jdt.core.JavaConventions;


/**
 * 
 * perform validations on the process itself
 * @author sh
 *
 */
public class ProcessValidatorImpl implements ProcessValidator {
	
	public static final ProcessValidatorImpl INSTANCE = new ProcessValidatorImpl();
		
	public boolean validate(EObject obj) {
		if (!(obj instanceof newprocess.Process)) return false;
		newprocess.Process proc = (newprocess.Process)obj;
		if (!validateName(proc) || 
			!validateImplementation(proc) || 
			!validateSubject(proc))
			return false;
		return true;
	}

	public boolean validateName(newprocess.Process proc) {
		if((proc).getName() == null || (proc).getName() == "") 
			return false;
		return true;
	}
	
	public boolean validateImplementation(newprocess.Process proc) {
		if(ImplementationValidator.INSTANCE.validate(proc)) return true;
		return false;
	}
	
	/**
	 * a subject has to exist and to be a valid fully  identifier
	 * @param proc
	 * @return
	 */
	public boolean validateSubject(newprocess.Process proc) {
		String subj = proc.getSubject();
		if(subj == null || subj == "") return false;
		if (!JavaConventions.validatePackageName(subj, null, null).isOK())
			return false;
		return true;
	}
	
	/**
	 * a namespace can exist and if, has to be a fully  indentifier
	 * @param proc
	 * @return
	 */
	public boolean validateNamespace(newprocess.Process proc) {
		String ns = proc.getNamespace();
		if(!JavaConventions.validatePackageName(ns, null, null).isOK())
		   return false;
		return true;
	}
	
} // ProcessValidator
