/**
 * 
 */
package diagram.commands;

import newprocess.Actor;
import newprocess.AsyncActivity;
import newprocess.Condition;
import newprocess.Event;
import newprocess.Listener;
import newprocess.Loader;
import newprocess.SyncActivity;
import newprocess.diagram.edit.parts.ActorEditPart;
import newprocess.diagram.edit.parts.AsyncActivity2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityEditPart;
import newprocess.diagram.edit.parts.ConditionEditPart;
import newprocess.diagram.edit.parts.EventEditPart;
import newprocess.diagram.edit.parts.ListenerEditPart;
import newprocess.diagram.edit.parts.LoaderEditPart;
import newprocess.diagram.edit.parts.ProcessEditPart;
import newprocess.diagram.edit.parts.SyncActivityEditPart;

import org.eclipse.emf.common.util.EList;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Node;

/**
 * Reads the EnvEntries of the selected EditPart
 * 
 * @author sh
 */
public class ReadCommand {
		
	/**
	 * Returns the list of EnvEntries for the given EditPart.
	 * 
	 * @param selectedEditPart the EditPart containing the EnvEntries.
	 * 
	 * @return a list of EnvEntries.
	 */
	public EList getValues(EditPart selectedEditPart) {
		if(selectedEditPart instanceof ActorEditPart) 
		   return ((Actor)((Node)selectedEditPart.getModel()).getElement()).getHasEnvEntries();
		if(selectedEditPart instanceof ProcessEditPart) 
		   return ((newprocess.Process)((Diagram)selectedEditPart.getModel()).getElement()).getHasEnvEntries();
		if(selectedEditPart instanceof LoaderEditPart) 
		   return ((Loader)((Node)selectedEditPart.getModel()).getElement()).getHasEnvEntries();
		if(selectedEditPart instanceof ConditionEditPart) 
		   return ((Condition)((Node)selectedEditPart.getModel()).getElement()).getHasEnvEntries();
		if(selectedEditPart instanceof SyncActivityEditPart) 
		   return ((SyncActivity)((Node)selectedEditPart.getModel()).getElement()).getHasEnvEntries();
		if(selectedEditPart instanceof AsyncActivityEditPart ||
		   selectedEditPart instanceof AsyncActivity2EditPart)
	 	   return ((AsyncActivity)((Node)selectedEditPart.getModel()).getElement()).getHasEnvEntries();
		if(selectedEditPart instanceof EventEditPart) 
		   return ((Event)((Node)selectedEditPart.getModel()).getElement()).getHasEnvEntries();
		if(selectedEditPart instanceof ListenerEditPart) 
		   return ((Listener)((Node)selectedEditPart.getModel()).getElement()).getHasEnvEntries();
		return null;
	}
}
