/**
 * 
 */
package diagram.section;

/**
 * Class used as a trivial case of an EnvEntry 
 * Serves as the business object for the EnvEntryTableViewer.
 * 
 * An EnvEntry has the following properties: Entry name, Entry type, Entry value 
 * 
 * @author sh
 */
public class EnvEntry {
	private String name = "";
	private String type = "";
	private String value = "";
	
	/**
	 * Create an EnvEntry with an initial Entry name
	 * @param name
	 */
	public EnvEntry(String name) {
		super();
		setName(name);
	}
	
	/**
	 * @return String Entry name
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * sets the "name" property
	 * @param name
	 */
	public void setName(String name) {
		this.name = name;
	}
		
	/**
	 * @return String Entry type
	 */
	public String getType() {
		return type;
	}
	
	/**
	 * sets the "type" property
	 * @param type
	 */
	public void setType(String type) {
		this.type = type;
	}
	
	/**
	 * @return String Entry value
	 */
	public String getValue() {
		return value;
	}
	
	/**
	 * sets the "value" property
	 * @param value
	 */
	public void setValue(String value) {
		this.value = value;
	}
}
