/**
 * 
 */
package model;

import newprocess.Element;
import newprocess.diagram.edit.parts.ActorEditPart;
import newprocess.diagram.edit.parts.AsyncActivity2EditPart;
import newprocess.diagram.edit.parts.AsyncActivityEditPart;
import newprocess.diagram.edit.parts.ConditionEditPart;
import newprocess.diagram.edit.parts.EventEditPart;
import newprocess.diagram.edit.parts.ListenerEditPart;
import newprocess.diagram.edit.parts.LoaderEditPart;
import newprocess.diagram.edit.parts.ProcessEditPart;
import newprocess.diagram.edit.parts.SyncActivityEditPart;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.DiagramEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Node;

/**
 * @author sh
 *
 */
public class PropertyUtil {
	/**
	 * This utility method is used to refactor a
	 * model element. It checks if the selected
	 * EditPart is defined for refactoring.
	 * 
	 * @param editPart the EditPart to check
	 * @return true if the given EditPart is accepted
	 */
	public static boolean isEditPartSupported(EditPart editPart) {
		if (editPart instanceof ActorEditPart ||
			editPart instanceof ProcessEditPart ||
			editPart instanceof LoaderEditPart ||
			editPart instanceof ConditionEditPart ||
			editPart instanceof AsyncActivityEditPart ||
			editPart instanceof AsyncActivity2EditPart ||
			editPart instanceof SyncActivityEditPart ||
			editPart instanceof EventEditPart ||
			editPart instanceof ListenerEditPart)
			return true;
		return false;
	}
	
	/**
	 * Returs the implementation value for the given EditPart
	 * 
	 * @param editPart the EditPart containing the implementation
	 * @return the implementation value
	 */
	public static String getImplementation(EditPart editPart) {
		EObject modelElement = null;
		if (editPart instanceof ShapeNodeEditPart) {
			modelElement = ((Node)editPart.getModel()).getElement();
		}
		else if (editPart instanceof DiagramEditPart) {
			modelElement = ((Diagram)editPart.getModel()).getElement();
		}
		
		if (modelElement instanceof Element == false) return null; 
		return ((Element)modelElement).getImplementation();
	}
}
