package org.concern.library.collaboration;

import org.concern.controller.AbstractSynchronousActivity;
import org.concern.controller.ActivityExecutionException;
import org.concern.*;
import ognl.Ognl;
import ognl.OgnlException;

import java.sql.Timestamp;

/**
 * @author hengels
 * @version $Revision$
 */
public class CallActivity
    extends AbstractSynchronousActivity
{
    private String message;
    private String flag;
    private String stamp;

    public void setMessage(String message) {
        this.message = message;
    }

    public void setFlag(String flag) {
        this.flag = flag;
    }

    public void setStamp(String stamp) {
        this.stamp = stamp;
    }

    public void execute(Object subject) throws ActivityExecutionException {
        try {
            Collaboration collaboration = ControllerLookup.getInstance().getCollaboration();
            collaboration.call(new Message(message, controller.getProcessName(), this.controller.getLoader().idOf(subject)));
        }
        catch (Exception e) {
            throw new ActivityExecutionException(e);
        }
        mark(subject);
    }

    protected void mark(Object subject) throws ActivityExecutionException {
        try {
            if (flag != null)
                Ognl.setValue(flag, subject, true);
        }
        catch (OgnlException e) {
            throw new ActivityExecutionException(flag + ": " + e.getMessage());
        }
        try {
            if (stamp != null)
                Ognl.setValue(stamp, subject, new Timestamp(System.currentTimeMillis()));
        }
        catch (OgnlException e) {
            throw new ActivityExecutionException(stamp + ": " + e.getMessage());
        }
    }
}
