package org.concern.library.generic;

import org.concern.controller.AbstractCondition;
import org.concern.controller.ConditionEvaluationException;
import ognl.Ognl;
import ognl.OgnlException;

/**
 * @author hengels
 * @version $Revision$
 */
public class BooleanCondition
    extends AbstractCondition
{
    String expression;

    public String getExpression() {
        return expression;
    }

    public void setExpression(String expression) {
        this.expression = expression;
    }

    public boolean eval(Object subject) throws ConditionEvaluationException {
        try {
            Boolean result = (Boolean)Ognl.getValue(expression, subject);
            if (result == null)
                throw new ConditionEvaluationException(expression + " is null");
            return result;
        }
        catch (OgnlException e) {
            throw new ConditionEvaluationException(e.getMessage());
        }
    }
}
