/*
 * $Id: DestroyListener.java 580 2005-11-09 10:37:28Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.library.generic;


import org.concern.*;
import org.concern.controller.AbstractListener;
import org.concern.controller.ActivityExecutionException;

import java.util.*;


public class DestroyListener
    extends AbstractListener
{
    public void notify(Object subject) throws ActivityExecutionException {
        try {
            Map map = controller.getLoader().formatSubjectLines(subject);
            System.out.println("DESTROY " + map.get("*"));
            controller.destroySubject(controller.getLoader().idOf(subject));
        }
        catch (LoaderException e) {
            throw new ActivityExecutionException(e);
        }
        catch (SubjectNotFoundException e) {
            throw new ActivityExecutionException(e);
        }
        catch (UnknownSubjectException e) {
            throw new ActivityExecutionException(e);
        }
    }
}
        