package org.concern.library.generic;

import org.concern.controller.AbstractAsynchronousActivity;
import org.concern.controller.ActivityExecutionException;

/**
 * @author hengels
 * @version $Revision: 576 $
 */
public class FormClassNameActivity<S>
    extends AbstractAsynchronousActivity<S>
{
    String formClassName;
    boolean forwardable;
    boolean forwardOnEscalation;

    public String getFormClassName() {
        return formClassName;
    }

    public void setFormClassName(String formClassName) {
        this.formClassName = formClassName;
    }

    public boolean isForwardable() {
        return forwardable;
    }

    public void setForwardable(boolean forwardable) {
        this.forwardable = forwardable;
    }

    public boolean isForwardOnEscalation() {
        return forwardOnEscalation;
    }

    public void setForwardOnEscalation(boolean forwardOnEscalation) {
        this.forwardOnEscalation = forwardOnEscalation;
    }

    public void enlist(S object) throws ActivityExecutionException {
    }

    public void delist(S object) throws ActivityExecutionException {
    }

    public void escalate(S subject) throws ActivityExecutionException {
        if (forwardOnEscalation) {
            try {
                controller.forward(controller.getLoader().idOf(subject), getName());
            }
            catch (Exception e) {
                throw new ActivityExecutionException(e);
            }
        }
    }
}
