package org.concern.library.mail;

import org.concern.controller.AbstractCondition;

import javax.mail.MessagingException;
import javax.mail.internet.MimeMessage;


public class ContainsCustomFlag
    extends AbstractCondition {

    public boolean eval(Object subject) {
        return eval((MimeMessage)subject);
    }

    public boolean eval(MimeMessage subject) {
        try {
            return subject.getFlags().contains(getFlag());
        }
        catch (MessagingException e) {
            e.printStackTrace();
            return false;
        }
    }

    private String getFlag() {
        return  (String)environment.get("flag");
    }
}

