package org.concern.library.mail;

import org.concern.controller.AbstractCondition;

import javax.mail.MessagingException;
import javax.mail.internet.MimeMessage;


public class ContainsHeader
    extends AbstractCondition {
    String header;

    public boolean eval(Object subject) {
        return eval((MimeMessage)subject);
    }

    public boolean eval(MimeMessage subject) {
        try {
            return subject.getHeader(getHeader()) != null;
        }
        catch (MessagingException e) {
            e.printStackTrace();
            return false;
        }
    }

    public String getHeader() {
        if (header == null) {
            header = (String)environment.get("header");
            if (header == null)
                header = "";
        }
        return header;
    }
}
