package org.concern.library.mail;


import org.concern.controller.AbstractCondition;

import javax.mail.Flags;
import javax.mail.MessagingException;
import javax.mail.internet.MimeMessage;
import java.util.HashMap;
import java.util.Map;


public class ContainsStandardFlag
    extends AbstractCondition {
    static Map FLAGS = new HashMap();
    private Flags.Flag flag;

    static {
        FLAGS.put("answered", Flags.Flag.ANSWERED);
        FLAGS.put("deleted", Flags.Flag.DELETED);
        FLAGS.put("draft", Flags.Flag.DRAFT);
        FLAGS.put("flagged", Flags.Flag.FLAGGED);
        FLAGS.put("recent", Flags.Flag.RECENT);
        FLAGS.put("seen", Flags.Flag.SEEN);
        FLAGS.put("user", Flags.Flag.USER);
    }

    public boolean eval(Object subject) {
        boolean eval = eval((MimeMessage)subject);
        return eval;
    }

    public boolean eval(MimeMessage subject) {
        try {
            return subject.getFlags().contains(getFlag());
        }
        catch (MessagingException e) {
            e.printStackTrace();
            return false;
        }
    }

    Flags.Flag getFlag() {
        if (flag == null)
            flag = (Flags.Flag)FLAGS.get(environment.get("flag"));
        return flag;
    }
}