package org.concern.library.mail;

import org.concern.controller.AbstractCondition;

import javax.mail.MessagingException;
import javax.mail.internet.MimeMessage;
import java.util.regex.Pattern;


public class MatchHeader
    extends AbstractCondition {
    Pattern pattern;

    public boolean eval(Object subject) {
        return eval((MimeMessage)subject);
    }

    public boolean eval(MimeMessage subject) {
        try {
            String[] values = subject.getHeader(getHeader());
            if (values != null) {
                for (int i = 0; i < values.length; i++) {
                    String value = values[i];
                    if (getPattern().matcher(value).matches()) {
                        return true;
                    }

                }
            }
            return false;
        }
        catch (MessagingException e) {
            e.printStackTrace();
            return false;
        }
    }

    public String getHeader() {
        return (String)environment.get("header");
    }

    public Pattern getPattern() {
        if (pattern == null) pattern = Pattern.compile((String)environment.get("match"));
        return pattern;
    }
}
