package org.concern.library.mail;

import org.concern.controller.AbstractSynchronousActivity;
import org.concern.controller.ActivityExecutionException;
import org.conform.format.TemplateFormat;

import javax.mail.*;
import javax.mail.internet.*;
import java.util.*;
import java.sql.Timestamp;

import ognl.Ognl;
import ognl.OgnlException;

/**
 * @author hengels
 * @version $Revision$
 */
public class SendMail
    extends AbstractSynchronousActivity
{
    private String from;
    private String to;
    private String cc;
    private String subject;
    private String body;
    private String flag;
    private String stamp;

    public String getFrom() {
        return from;
    }

    public void setFrom(String from) {
        this.from = from;
    }

    public String getTo() {
        return to;
    }

    public void setTo(String to) {
        this.to = to;
    }

    public String getCc() {
        return cc;
    }

    public void setCc(String cc) {
        this.cc = cc;
    }

    public String getSubject() {
        return subject;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

    public String getBody() {
        return body;
    }

    public void setBody(String body) {
        this.body = body;
    }

    public String getFlag() {
        return flag;
    }

    public void setFlag(String flag) {
        this.flag = flag;
    }

    public String getStamp() {
        return stamp;
    }

    public void setStamp(String stamp) {
        this.stamp = stamp;
    }

    public void execute(Object subject) throws ActivityExecutionException {
        Transport transport = null;
        try {
            Map context = new HashMap();
            context.put("subject", subject);
            context.putAll(environment);

            javax.mail.Session mailSession = (javax.mail.Session)controller.getResourceLocator().lookup("mailSession");
            MimeMessage message = new MimeMessage(mailSession);
            message.setFrom(from(context));
            message.setRecipients(Message.RecipientType.TO, to(context));
            message.setRecipients(Message.RecipientType.CC, cc(context));
            message.setSubject(new TemplateFormat(getSubject()).format(context));
            message.setText(new TemplateFormat(getBody()).format(context));

            if (message.getRecipients(Message.RecipientType.TO) != null && message.getRecipients(Message.RecipientType.TO).length > 0) {
                transport = mailSession.getTransport("smtp");
                transport.connect();
                transport.sendMessage(message, message.getRecipients(Message.RecipientType.TO));
            }

            mark(subject);
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        finally {
            try {
                if (transport != null) transport.close();
            }
            catch (MessagingException e) {
            }
        }
    }

    protected InternetAddress from(Map context) throws AddressException {
        try {
            return new InternetAddress((String)Ognl.getValue(getFrom(), context));
        }
        catch (OgnlException e) {
            return null;
        }
    }

    // TODO: multiple TOs
    protected InternetAddress[] to(Map context) throws AddressException {
        try {
            return new InternetAddress[] { new InternetAddress((String)Ognl.getValue(getTo(), context)) };
        }
        catch (OgnlException e) {
            return null;
        }
    }

    // TODO: multiple CCs
    protected InternetAddress[] cc(Map context) throws AddressException {
        try {
            return new InternetAddress[] { new InternetAddress((String)Ognl.getValue(getCc(), context)) };
        }
        catch (OgnlException e) {
            return null;
        }
    }

    protected void mark(Object subject) throws ActivityExecutionException {
        try {
            if (flag != null)
                Ognl.setValue(flag, subject, true);
        }
        catch (OgnlException e) {
            throw new ActivityExecutionException(flag + ": " + e.getMessage());
        }
        try {
            if (stamp != null)
                Ognl.setValue(stamp, subject, new Timestamp(System.currentTimeMillis()));
        }
        catch (OgnlException e) {
            throw new ActivityExecutionException(stamp + ": " + e.getMessage());
        }
    }
}
