package org.concern;

import java.sql.Timestamp;
import java.util.*;

/**
 * An assignment of a task or option to an assignee.
 * @author hengels
 * @version $Revision: 661 $
 */
public class Assignment
    extends Work
{
    String assignee;

    public Assignment() {
    }

    public Assignment(String process, String activity, String subjectId, String subjectLine, String originator, Timestamp due, int level, String lockedBy, Timestamp lockedUntil, String assignee) {
        super(process, activity, subjectId, subjectLine, originator, due, level, lockedBy, lockedUntil);
        this.assignee = assignee;
    }

    public Assignment(String process, String activity, String subjectId, String subjectLine, String originator, long due, int level, String lockedBy, Date lockedUntil, String assignee) {
        super(process, activity, subjectId, subjectLine, originator, due, level, lockedBy, lockedUntil);
        this.assignee = assignee;
    }

    public String getAssignee() {
        return assignee;
    }

    public void setAssignee(String assignee) {
        this.assignee = assignee;
    }

    public boolean isOption() {
        return due.getTime() == Long.MAX_VALUE;
    }

    public String toString() {
        return super.toString() + ":" + assignee;
    }
}
