/*
 * $Id: Log.java 1178 2007-06-19 11:56:51Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern;

import java.sql.Timestamp;
import java.io.Serializable;
import java.util.Map;

/**
 * @author hengels
 */
public class Log
    implements Serializable
{
    private String userValue;
    private String activity;
    private boolean success;
    private String message;
    private String details;
    private Map<String,String> annotations;
    private Timestamp timestamp;

    public Log(String userValue, String activity, boolean success, String message, String details, Map<String, String> annotations, Timestamp timestamp) {
        this.userValue = userValue;
        this.activity = activity;
        this.success = success;
        this.message = message;
        this.details = details;
        this.annotations = annotations;
        this.timestamp = timestamp;
    }

    public String getUserValue() {
        return userValue;
    }

    public String getActivity() {
        return activity;
    }

    public boolean isSuccess() {
        return success;
    }

    public String getMessage() {
        return message;
    }

    public String getDetails() {
        return details;
    }
  
    public Map<String, String> getAnnotations() {
        return annotations;
    }
  
    public Timestamp getTimestamp() {
        return timestamp;
    }

    public String toString() {
        return (success ? "+ " : "- ") + userValue + " " + activity + ": " + message;
    }
}
