/*
 * $Id: Subject.java 654 2006-01-25 09:11:56Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern;

import java.util.*;
import java.sql.Timestamp;

/**
 * @author hengels
 * @version $Revision: 654 $
 */
public class Subject
{
    private String process;
    private String subjectId;
    private Object subject;
    private String subjectLine;
    private String originator;
    private Timestamp created;
    private int state;
    private Set options;

    public Subject(String process, String subjectId, String subjectLine, String originator, Date created, int state) {
        this.process = process;
        this.subjectId = subjectId;
        this.subjectLine = subjectLine;
        this.originator = originator;
        if (created != null)
            this.created = new Timestamp(created.getTime());
        this.state = state;
    }

    public String getProcess() {
        return process;
    }

    public void setProcess(String process) {
        this.process = process;
    }

    public String getSubjectId() {
        return subjectId;
    }

    public void setSubjectId(String subjectId) {
        this.subjectId = subjectId;
    }

    public Object getSubject() {
        return subject;
    }

    public void setSubject(Object subject) {
        this.subject = subject;
    }

    public String getSubjectLine() {
        return subjectLine;
    }

    public void setSubjectLine(String subjectLine) {
        this.subjectLine = subjectLine;
    }

    public String getOriginator() {
        return originator;
    }

    public void setOriginator(String originator) {
        this.originator = originator;
    }

    public Timestamp getCreated() {
        return created;
    }

    public void setCreated(Timestamp created) {
        this.created = created;
    }

    public Set getOptions() {
        if (options == null)
            options = new TreeSet();
        return options;
    }

    public void setOptions(Set options) {
        this.options = options;
    }

    public int getState() {
        return state;
    }

    public void setState(int state) {
        this.state = state;
    }

    public String toString() {
        return process + ": " + subjectId + " (" + subjectLine + ")";
    }
}
