/*
 * $Id: Command.java 674 2006-10-06 12:15:59Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.client.commandline;

import org.concern.Controller;

/**
 * @author hengels
 */
public abstract class Command
    implements Runnable
{
    protected String[] args;
    protected Controller controller;
    protected String usage;

    public void setController(Controller controller) {
        this.controller = controller;
    }

    public void setArguments(String[] args) {
        this.args = args;
    }

    public abstract void run();

    public String usage() {
        return usage;
    }
}
