/*
 * $Id: MatchPostconditionCommand.java 674 2006-10-06 12:15:59Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.client.commandline;


/**
 * @author hengels
 */
public class MatchPostconditionCommand
    extends Command
{
    private String activity;
    private String[] subjects;

    public MatchPostconditionCommand() {
        usage = "ACTIVITY SUBJECT...\n   Check if the subjects match the precondition of the activity.";
    }

    public String[] getSubjects() {
        return subjects;
    }

    public void setSubjects(String[] subjects) {
        this.subjects = subjects;
    }

    public void setArguments(String[] args) {
        activity = args[0];

        subjects = new String[args.length-1];
        for (int i = 1; i < args.length; i++) {
            String subject = args[i];
            subjects[i-1] = subject;
        }
    }

    public void run() {
        for (int i = 0; i < subjects.length; i++) {
            String subject = subjects[i];

            try {
                boolean match = controller.matchPostcondition(subject, activity);
                System.out.println("match postcondition " + subject + " " + activity + ": " + match);
            }
            catch (Exception e) {
                System.out.println("match postcondition " + subject + " " + activity + ": ERROR");
                e.printStackTrace();
            }
        }
    }
}
