/*
 * $Id: TouchCommand.java 674 2006-10-06 12:15:59Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.client.commandline;



/**
 * <b>Example</b>: touch project 99 (for example after manual modification)<br>
 * <pre>
 * concern.sh Project touch 99
 * </pre>
 *
 * @author hengels
 */
public class TouchCommand
    extends Command
{
    private String[] subjects;

    public TouchCommand() {
        usage = "SUBJECT...\n   Announce a change of a subject.";
    }

    public String[] getSubjects() {
        return subjects;
    }

    public void setSubjects(String[] subjects) {
        this.subjects = subjects;
    }

    public void setArguments(String[] args) {
        subjects = new String[args.length];
        for (int i = 0; i < args.length; i++) {
            String subject = args[i];
            subjects[i] = subject;
        }
    }

    public void run() {
        for (int i = 0; i < subjects.length; i++) {
            String subject = subjects[i];
            try {
                controller.announceSubject(subject);
                System.out.println("touch " + subject + ": OK");
            }
            catch (Exception e) {
                System.out.println("touch " + subject + ": ERROR");
                e.printStackTrace();
            }
        }
    }
}
