/*
 * $Id: XMLCommand.java 674 2006-10-06 12:15:59Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.client.commandline;

import java.beans.XMLDecoder;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;

/**
 * Run command from XML file.
 * @version $Revision: 674 $
 */
public class XMLCommand extends Command
{
    String fileName;

    public String getFileName() {
        return fileName;
    }

    public void setFileName(String fileName) {
        this.fileName = fileName;
    }

    public void setArguments(String[] args) {
        fileName = args[0];
    }

    public void run() {
        try {
            File file = new File(fileName);
            Command command = decode(file);
            command.setController(controller);
            command.run();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    private Command decode(File file) throws FileNotFoundException {
        FileInputStream in = new FileInputStream(file);
        XMLDecoder decoder = new XMLDecoder(in);
        Command command = (Command)decoder.readObject();
        decoder.close();
        return command;
    }
}
