package org.concern.client.remote;

import java.util.Map;
import org.concern.Controller;
import org.concern.ControllerException;
import org.jboss.jmx.adaptor.rmi.RMIAdaptor;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.management.ObjectName;
import javax.management.MalformedObjectNameException;
import java.lang.reflect.Proxy;

public class JBossConnector
    implements ControllerConnector
{
    private static String adapterName = "jmx/invoker/RMIAdaptor";

    public Controller connect(String name, Map environment) {
        try {
            RMIAdaptor adaptor = (RMIAdaptor) new InitialContext().lookup(adapterName);

            ObjectName objectName = new ObjectName(name);
            JBossProxyHandler handler = new JBossProxyHandler(adaptor, objectName);
            Class[] ifaces = { Controller.class };
            ClassLoader loader = Thread.currentThread().getContextClassLoader();
            loader = ClassLoader.getSystemClassLoader();
            return (Controller)Proxy.newProxyInstance(loader, ifaces, handler);
        }
        catch (NamingException e) {
            throw new ControllerException(e);
        }
        catch (MalformedObjectNameException e) {
            throw new ControllerException(e);
        }
    }
}
