/*
 * $Id: JMXConnector.java 674 2006-10-06 12:15:59Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.client.remote;

import java.util.Map;
import org.concern.Controller;
import org.concern.ControllerException;
import org.concern.client.remote.ControllerConnector;

import javax.management.remote.JMXConnectorFactory;
import javax.management.remote.JMXServiceURL;
import javax.management.MBeanServerConnection;
import javax.management.ObjectName;
import java.lang.reflect.Proxy;

public class JMXConnector
    implements ControllerConnector
{

    public Controller connect(String name, Map env) {
        try {
            JMXServiceURL url = new JMXServiceURL("service:jmx:rmi:///jndi/JMXConnectorServer");
            javax.management.remote.JMXConnector connector = JMXConnectorFactory.connect(url, env);
            connector.connect();
            MBeanServerConnection connection = connector.getMBeanServerConnection();
            ObjectName objectName = new ObjectName(name);
            JMXProxyHandler handler = new JMXProxyHandler(connection, objectName);
            Class[] ifaces = { Controller.class };
            return (Controller) Proxy.newProxyInstance(Controller.class.getClassLoader(), ifaces, handler);
        }
        catch (Exception e) {
            throw new ControllerException(e);
        }
    }
}
