/*
 * $Id: AbstractActivity.java 881 2007-02-12 07:54:31Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;

public abstract class AbstractActivity<S>
    extends AbstractNode
    implements Activity<S>
{
    protected AbstractActivity() {
    }

    protected AbstractActivity(String name) {
        environment.put("activity.name", name);
    }

    public final String getName() {
        return (String)environment.get("activity.name");
    }

    public void setController(Controller controller) {
        super.setController(controller);
    }

    public void escalate(S subject) throws ActivityExecutionException {
    }

    public final String getPrecondition() {
        return (String)environment.get("activity.precondition");
    }

    public final String getPostcondition() {
        return (String)environment.get("activity.postcondition");
    }

    public final boolean isReentrant() {
        return ((Boolean)environment.get("activity.reentrant")).booleanValue();
    }

    public final String getActor() {
        return (String)environment.get("activity.actor");
    }
}
