/*
 * $Id: AbstractAsynchronousActivity.java 881 2007-02-12 07:54:31Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;

public abstract class AbstractAsynchronousActivity<S>
    extends AbstractActivity<S>
    implements AsynchronousActivity<S>
{
    protected AbstractAsynchronousActivity() {
    }

    protected AbstractAsynchronousActivity(String name) {
        super(name);
    }

    public int getTimeout() {
        Integer integer = (Integer)getEnvironment().get("activity.timeout");
        return integer != null ? integer.intValue() : -1;
    }

    public final boolean isOptional() {
        return Boolean.TRUE.equals(getEnvironment().get("activity.optional"));
    }

    public void enlist(S subject) throws ActivityExecutionException {
    }

    public void delist(S subject) throws ActivityExecutionException {
    }

    public void assign(S subject, String assignee, int level) {
    }

    public void unassign(S subject, String assignee, int level) {
    }
}
