/*
 * $Id: AbstractEvent.java 881 2007-02-12 07:54:31Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;

import org.concern.ControllerException;
import org.concern.Loader;
import org.concern.model.parser.ParseException;

public abstract class AbstractEvent<S>
    extends AbstractNode
    implements Event<S>
{
    protected AbstractEvent() {
    }

    protected AbstractEvent(String name) {
        environment.put("event.name", name);
    }

    public final String getName() {
        return (String)environment.get("event.name");
    }

    public void setController(Controller controller) {
        super.setController(controller);
    }

    protected final Loader getLoader() {
        return controller.getLoader();
    }

    public final String getPostcondition() {
        return (String)environment.get("event.postcondition");
    }
}
