/*
 * $Id: AbstractListener.java 881 2007-02-12 07:54:31Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;

import org.concern.ControllerException;
import org.concern.Loader;
import org.concern.model.parser.ParseException;

public abstract class AbstractListener<S>
    extends AbstractNode
    implements Listener<S>
{
    protected AbstractListener() {
    }

    protected AbstractListener(String name) {
        environment.put("listener.name", name);
    }

    public final String getName() {
        return (String)environment.get("listener.name");
    }

    public void setController(Controller controller) {
        super.setController(controller);
    }

    protected Loader getLoader() {
        return controller.getLoader();
    }

    public final String getPrecondition() {
        return (String)environment.get("listener.precondition");
    }

    public void escalate(S subject) throws ActivityExecutionException {
    }

    public int getRetryDelay() {
        Integer integer = (Integer)getEnvironment().get("listener.retryDelay");
        return integer != null ? integer.intValue() : 0;
    }

    public int getTrials() {
        Integer integer = (Integer)getEnvironment().get("listener.trials");
        return integer != null ? integer.intValue() : 1;
    }
}
