/*
 * $Id: AbstractSynchronousActivity.java 881 2007-02-12 07:54:31Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;


public abstract class AbstractSynchronousActivity<S>
    extends AbstractActivity<S>
    implements SynchronousActivity<S>
{
    protected AbstractSynchronousActivity() {
    }

    protected AbstractSynchronousActivity(String name) {
        super(name);
    }

    public int getRetryDelay() {
        Integer integer = (Integer)getEnvironment().get("activity.retryDelay");
        return integer != null ? integer.intValue() : 0;
    }

    public int getTrials() {
        Integer integer = (Integer)getEnvironment().get("activity.trials");
        return integer != null ? integer.intValue() : 1;
    }
}
