/*
 * $Id: Activity.java 881 2007-02-12 07:54:31Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;



/**
 * An activity is an atomic unit of concern, executed on a subject as part of the process.
 */
public interface Activity<S> extends Node {

    String getPrecondition();
    String getPostcondition();
    boolean isReentrant();
    String getActor();

    /**
     * This method is called, when the timeout of an asynchronous activity is exceeded or n trials
     * have failed.
     * @param subject the subject
     * @throws ActivityExecutionException
     */
    void escalate(S subject) throws ActivityExecutionException;
}
