/*
 * $Id: ArchiveSubject.java 574 2005-11-04 16:43:26Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;

import java.util.*;
import java.sql.Timestamp;

/**
 * @version $Revision: 574 $
 */
public class ArchiveSubject
{
    private Integer id;
    private String process;

    private String userValue;
    private String originator;
    private Set subjectLines;
    private List logs;
    private Timestamp created;

    public ArchiveSubject() {
    }

    public ArchiveSubject(String userValue) {
        this.userValue = userValue;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getProcess() {
        return process;
    }

    public void setProcess(String process) {
        this.process = process;
    }

    public String getUserValue() {
        return userValue;
    }

    public void setUserValue(String userValue) {
        this.userValue = userValue;
    }

    public String getOriginator() {
        return originator;
    }

    public void setOriginator(String originator) {
        this.originator = originator;
    }

    public Timestamp getCreated() {
        return created;
    }

    public void setCreated(Timestamp created) {
        this.created = created;
    }

    public Set getSubjectLines() {
        if (subjectLines == null)
            subjectLines = new HashSet();
        return subjectLines;
    }

    public void setSubjectLines(Set subjectLines) {
        this.subjectLines = subjectLines;
    }

    public List getLogs() {
        if (logs == null)
            logs = new LinkedList();
        return logs;
    }

    public void setLogs(List logs) {
        this.logs = logs;
    }

    public String toString() {
        return userValue;
    }
}
