/*
 * $Id: Assignment.java 986 2007-05-03 08:09:24Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;

/**
 * @author hengels
 * @version $Revision: 986 $
 */
public class Assignment
{
    protected Integer id;
    protected String assignee;

    public Assignment() {
    }

    public Assignment(String assignee) {
        this.assignee = assignee;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getAssignee() {
        return assignee;
    }

    public void setAssignee(String assignee) {
        this.assignee = assignee;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Assignment)) return false;

        final Assignment assignment = (Assignment)o;

        if (!assignee.equals(assignment.assignee)) return false;

        return true;
    }

    public int hashCode() {
        return assignee != null ? assignee.hashCode() : 0;
    }

    public String toString() {
        return assignee;
    }
}
