/*
 * $Id: DefaultResourceLocator.java 430 2005-04-14 13:51:34Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;

import org.concern.controller.ResourceLocator;

import java.util.Map;
import java.util.HashMap;
import org.concern.controller.Controller;

public class DefaultResourceLocator
    implements ResourceLocator
{
    private Controller controller;
    
    Map resources = new HashMap();
    
    public DefaultResourceLocator() {
    }

    public DefaultResourceLocator(Map resources) {
        this.resources = resources;
    }

    public Map getResources() {
        return resources;
    }

    public void setResources(Map resources) {
        this.resources = resources;
    }

    public Object lookup(String name) {
        return resources.get(name);
    }

    public void setController(Controller controller) {
        this.controller = controller;
    }
}
