package org.concern.controller;

import org.hibernate.Session;
import org.hibernate.HibernateException;
import org.hibernate.SessionFactory;

import javax.transaction.TransactionManager;
import javax.transaction.Transaction;
import javax.transaction.Synchronization;
import java.util.HashMap;
import java.util.Map;

public class DefaultSessions
    implements Sessions
{
    private TransactionManager transactionManager;
    private SessionFactory sessionFactory;
    Map map = new HashMap();

    public SessionFactory getSessionFactory() {
        return sessionFactory;
    }

    public void setSessionFactory(SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }

    public void setTransactionManager(TransactionManager transactionManager) {
        this.transactionManager = transactionManager;
    }

    public Session getSession() throws HibernateException {
        try {
            final Transaction transaction = transactionManager.getTransaction();
            Session session = (Session)map.get(transaction);
            if (session == null) {
                System.out.println("OPEN OPEN OPEN OPEN OPEN " + new Throwable().getStackTrace()[1]);
                session = sessionFactory.openSession();
                final Session session1 = session;
                transaction.registerSynchronization(new Synchronization() {
                    public void beforeCompletion() {
                        session1.flush();
                        System.out.println("FLUSH FLUSH FLUSH FLUSH FLUSH");
                    }

                    public void afterCompletion(int i) {
                        session1.close();
                        System.out.println("CLOSE CLOSE CLOSE CLOSE CLOSE");
                        map.remove(transaction);
                    }
                });
                map.put(transaction, session);
            }
            return session;
        }
        catch (Exception e) {
            e.printStackTrace();
            throw new HibernateException(e);
        }
    }
}
