package org.concern.controller;

import java.util.*;
import java.sql.Timestamp;

/**
 * @author hengels
 * @version $Revision: 666 $
 */
class Logs
{
    static void logCreated(Subject subject) {
        Log log = new Log("CREATED", (String)null);
        log.setSuccess(true);
        log.setSubject(subject);
        subject.getLogs().add(log);
    }

    static void logDestroyed(Subject subject) {
        Log log = new Log("DESTROYED", (String)null);
        log.setSuccess(true);
        log.setSubject(subject);
        subject.getLogs().add(log);
    }

    static void logRevived(Subject subject) {
        Log log = new Log("REVIVED", (String)null);
        log.setSuccess(true);
        log.setSubject(subject);
        subject.getLogs().add(log);
    }

    static void logSuspended(Subject subject) {
        Log log = new Log("SUSPENDED", (String)null);
        log.setSuccess(true);
        log.setSubject(subject);
        subject.getLogs().add(log);
    }

    static void logResumed(Subject subject) {
        Log log = new Log("RESUMED", (String)null);
        log.setSuccess(true);
        log.setSubject(subject);
        subject.getLogs().add(log);
    }

    static void logStalled(Subject subject, String details) {
        Log log = new Log("STALLED", null, details);
        log.setSubject(subject);
        subject.getLogs().add(log);
    }

    static void logSuccess(Subject subject, String name, Map /* <String, String> */ logAnnotations) {
        Log log = new Log(name, "EXECUTED");
        log.setSuccess(true);
        log.setAnnotations(logAnnotations);
        log.setSubject(subject);
        subject.getLogs().add(log);
    }

    static void logForwarded(Subject subject, String name, Map /* <String, String> */ logAnnotations) {
        Log log = new Log(name, "FORWARDED");
        log.setSubject(subject);
        log.setAnnotations(logAnnotations);
        subject.getLogs().add(log);
    }

    static void logBackwarded(Subject subject, String name, Map /* <String, String> */ logAnnotations) {
        Log log = new Log(name, "BACKWARDED");
        log.setSubject(subject);
        log.setAnnotations(logAnnotations);
        subject.getLogs().add(log);
    }

    static void logReset(Subject subject, String name) {
        Log log = new Log(name, "RESET");
        log.setSubject(subject);
        subject.getLogs().add(log);
    }

    static void logEscalation(Subject subject, String name) {
        Log log = new Log(name, "ESCALATED");
        log.setSubject(subject);
        subject.getLogs().add(log);
    }

    public static void logFailure(Subject subject, String name, String details) {
        Log log = new Log(name, "FAILED", details);
        log.setSubject(subject);
        subject.getLogs().add(log);
    }

    public static void log(Subject subject, org.concern.Log blub) {
        Log log = new Log();
        log.setActivity(blub.getActivity());
        log.setAnnotations(blub.getAnnotations());
        log.setDetails(blub.getDetails());
        log.setMessage(blub.getMessage());
        log.setSubject(subject);
        log.setSuccess(blub.isSuccess());
        log.setTimestamp(new Timestamp(System.currentTimeMillis()));
        subject.getLogs().add(log);
    }
}
