/*
 * $Id: SubjectLine.java 494 2005-08-17 16:45:19Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;

/**
 * @author hengels
 * @version $Revision: 494 $
 */
public class SubjectLine
{
    Integer id;
    String language;
    String line;

    public SubjectLine() {
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public SubjectLine(String language, String line) {
        this.language = language;
        this.line = line;
    }

    public String getLanguage() {
        return language;
    }

    public void setLanguage(String language) {
        this.language = language;
    }

    public String getLine() {
        return line;
    }

    public void setLine(String line) {
        this.line = line;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof SubjectLine)) return false;

        final SubjectLine subjectLine = (SubjectLine)o;

        if (!language.equals(subjectLine.language)) return false;

        return true;
    }

    public int hashCode() {
        return language.hashCode();
    }

    public String toString() {
        return language + ": " + line;
    }
}
