/*
 * $Id: SynchronousActivity.java 881 2007-02-12 07:54:31Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;



public interface SynchronousActivity<S>
    extends Activity<S>
{
    /**
     * Retry to execute the activity after a delay.
     * @return the retry delay
     */
    int getRetryDelay();

    /**
     * Try to execute the activity at maximum n times.
     * @return the maximum trials
     */
    int getTrials();

    /**
     * This method is called by the controller, when the precondition is matching.
     * @param subject identifies the subject
     * @throws ActivityExecutionException
     */
    void execute(S subject) throws ActivityExecutionException;
}
