package org.concern.controller.jmx;

import java.io.Serializable;
import java.lang.reflect.InvocationHandler;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

class ControllerProxy
    implements InvocationHandler, Serializable
{
    private String name;

    public ControllerProxy(String name) {
        this.name = name;
    }

    public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
       try {
          return method.invoke(ControllerService.getController(name), args);
       }
       catch (InvocationTargetException e) {
           throw e.getTargetException();
       }
       catch (Throwable e) {
           e.printStackTrace();
           throw e;
       }
    }
}
