package org.concern.controller.jmx;

import org.concern.controller.ResourceLocator;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import org.concern.controller.Controller;

public class JndiResourceLocator
    implements ResourceLocator
{
    
    private Controller controller;
    
    private String prefix = "";

    public JndiResourceLocator() {
    }

    public String getPrefix() {
        return prefix;
    }

    public void setPrefix(String prefix) {
        this.prefix = prefix;
    }
    
    public Object lookup(String name) {
        try {
            return new InitialContext().lookup(prefix + name);
        }
        catch (NamingException e) {
            throw new RuntimeException(e);
        }
    }

    public void setController(Controller controller) {
        this.controller = controller;
    }
}
