/*
 * $Id: WorklistProxy.java 494 2005-08-17 16:45:19Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller.jmx;

import java.io.Serializable;
import java.lang.reflect.InvocationHandler;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

class WorklistProxy
    implements InvocationHandler, Serializable
{
    private String name;

    public WorklistProxy(String name) {
        this.name = name;
    }

    public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
       try {
          return method.invoke(WorklistService.getWorklist(name), args);
       }
       catch (InvocationTargetException e) {
           throw e.getTargetException();
       }
       catch (Throwable e) {
           e.printStackTrace();
           throw e;
       }
    }
}
