/*
 * $Id: WorklistServiceMBean.java 668 2006-05-09 06:25:38Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller.jmx;

import org.concern.*;
import org.concern.Worklist;

/**
 * @see ControllerService
 * @author hengels
 */
public interface WorklistServiceMBean
    extends Worklist
{
    /**
     * Create the <tt>Controller</tt> and bind it to the jndi name
     */
    public void start() throws ControllerException;
    /**
     * Unbind the <tt>Worklist</tt> or stub from jndi
     */
    public void stop();

    String getJndiName();

    void setJndiName(String jndiName);

    String getSessionFactoryJndiName();

    void setSessionFactoryJndiName(String sessionFactoryJndiName);

    String getTransactionManagerJndiName();

    void setTransactionManagerJndiName(String transactionManagerJndiName);
}
