/*
 * $Id: BeanFactoryInJndiResourceLocator.java 911 2007-02-20 13:53:49Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller.spring;

import org.concern.controller.ResourceLocator;

import org.concern.controller.Controller;
import org.springframework.beans.factory.BeanFactory;

import javax.naming.InitialContext;
import javax.naming.NamingException;

public class BeanFactoryInJndiResourceLocator
    implements ResourceLocator
{
    public BeanFactoryInJndiResourceLocator() {
    }

    public Object lookup(String name) {
        int pos = name.lastIndexOf('/');
        String beanFactoryName = name.substring(0, pos);
        String beanName = name.substring(pos + 1);

        try {
            BeanFactory beanFactory = (BeanFactory)new InitialContext().lookup(beanFactoryName);
            if ("this".equals(beanName) || beanName.length() == 0)
                return beanFactory;
            else
                return beanFactory.getBean(beanName);
        }
        catch (NamingException e) {
            throw new RuntimeException(e);
        }
    }

    public void setController(Controller controller) {
    }
}
