package org.concern.controller.spring;

import org.springframework.beans.factory.*;
import org.hibernate.SessionFactory;
import org.concern.controller.Worklist;
import org.concern.controller.Collaboration;

import javax.transaction.TransactionManager;

public class CollaborationFactoryBean
    implements FactoryBean, InitializingBean, DisposableBean
{
    protected Collaboration collaboration;

    public Object getObject() throws Exception {
        return collaboration;
    }

    public Class getObjectType() {
        return org.concern.Collaboration.class;
    }

    public boolean isSingleton() {
        return false;
    }


    public void afterPropertiesSet() throws Exception {
        collaboration = new Collaboration();

        System.setProperty("concern.controller.lookup", LocalControllerLookup.class.getName());
        ((LocalControllerLookup)LocalControllerLookup.getInstance()).setCollaboration(collaboration);
    }

    public void destroy() throws Exception {
        ((LocalControllerLookup)LocalControllerLookup.getInstance()).setCollaboration(null);
    }
}
