package org.concern.controller.spring;

import org.concern.*;
import org.springframework.beans.factory.FactoryBean;

import java.util.*;

public class LocalControllerLookup
    extends ControllerLookup
    implements FactoryBean
{
    private Map controllers = new HashMap();
    private Worklist worklist;
    private Collaboration collaboration;

    public LocalControllerLookup() {
    }

    public Object getObject() throws Exception {
        System.setProperty("concern.controller.lookup", LocalControllerLookup.class.getName());
        return getInstance();
    }

    public Class getObjectType() {
        return ControllerLookup.class;
    }

    public boolean isSingleton() {
        return true;
    }

    public void add(Controller controller) {
        controllers.put(controller.getProcessName(), controller);
    }

    public void remove(String processName) {
        controllers.remove(processName);
    }

    public Controller getController(String processName) {
        return (Controller)controllers.get(processName);
    }

    public String[] getControllerNames() {
        List names = new ArrayList(controllers.size());
        for (Iterator iterator = controllers.keySet().iterator(); iterator.hasNext();) {
            String name = (String)iterator.next();
            names.add(name);
        }
        return (String[])names.toArray(new String[names.size()]);
    }

    public Worklist getWorklist() {
        return worklist;
    }

    public void setWorklist(Worklist worklist) {
        this.worklist = worklist;
    }

    public Collaboration getCollaboration() {
        return collaboration;
    }

    public void setCollaboration(Collaboration collaboration) {
        this.collaboration = collaboration;
    }
}
