/*
 * $Id: TestConfiguration.java 667 2006-04-25 08:01:58Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller.test;

import org.hibernate.SessionFactory;
import org.concern.ControllerException;
import org.concern.controller.Configuration;

import javax.transaction.TransactionManager;

/**
 * @author hengels
 * @version $Revision: 667 $
 */
public class TestConfiguration
    extends Configuration
{
    public TestController buildTestController() {
        try {
            TestController controller = new TestController();
            initializeController(controller);

            SessionFactory sessionFactory = getSessionFactory();
            controller.setSessionFactory(sessionFactory);
            TransactionManager transactionManager = getTransactionManager();
            if (transactionManager != null)
                controller.setTransactionManager(transactionManager);

            controller.setResourceLocator(getResourceLocator());
            return controller;
        }
        catch (Exception e) {
            e.printStackTrace();
            throw new ControllerException(e);
        }
    }
}
