/*
 * $Id: TestController.java 911 2007-02-20 13:53:49Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller.test;

import org.concern.UnknownSubjectException;
import org.concern.controller.*;

import javax.transaction.TransactionManager;

/**
 * @author hengels
 * @version $Revision: 911 $
 */
public class TestController
    extends Controller
{
    public void executeSynchronousActivity(String userValue, String activityName) throws ActivityExecutionException, UnknownSubjectException {
        AbstractSynchronousActivity activity = (AbstractSynchronousActivity)activitiesByName.get(activityName);
        activity.execute(userValue);
    }

    public void executeListener(String userValue, String listenerName) throws ActivityExecutionException, UnknownSubjectException {
        AbstractListener listener = (AbstractListener)listenersByName.get(listenerName);
        listener.notify(userValue);
    }

    public TransactionManager getTransactionManager() {
        return transactionManager;
    }

    public Activity getActivityByName(String name) {
        return activitiesByName.get(name);
    }

    public Event getEventByName(String name) {
        return eventsByName.get(name);
    }

    public Listener getListenerByName(String name) {
        return listenersByName.get(name);
    }

    public Condition getConditionByName(String name) {
        return conditionsByName.get(name);
    }
}
