/*
 * $Id: JMXConnectorService.java 590 2005-11-24 14:07:44Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.jboss;

import org.jboss.system.ServiceMBeanSupport;

import javax.management.remote.JMXConnectorServer;
import javax.management.remote.JMXConnectorServerFactory;
import javax.management.remote.JMXServiceURL;
import java.io.IOException;

/**
 * @author hengels
 * @version $Revision: 590 $
 */
public class JMXConnectorService
    extends ServiceMBeanSupport
    implements JMXConnectorServiceMBean
{

    private String jndiName = "JMXConnectorServer";
    JMXConnectorServer connectorServer;

    public String getJndiName() {
        return jndiName;
    }

    public void setJndiName(String jndiName) {
        this.jndiName = jndiName;
    }

    public void start() throws Exception {
        super.start();
        if (connectorServer == null) {
            JMXServiceURL url = new JMXServiceURL("service:jmx:rmi:///jndi/JMXConnectorServer");
            connectorServer = JMXConnectorServerFactory.newJMXConnectorServer(url, null, getServer());
            connectorServer.start();
        }
    }

    public void stop() {
        if (connectorServer != null) {
            try {
                connectorServer.stop();
                connectorServer = null;
            }
            catch (IOException e) {
                e.printStackTrace();
                //log.error(connectorServer, e);
            }
        }
        super.stop();
    }
}
