/*
 * $Id: Actor.java 542 2005-10-05 15:38:43Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.model;


public class Actor
    extends Element
    implements Implementable
{
    String implementation = "";

    public Actor() {
        super(null);
    }

    public Actor(String name) {
        super(name);
    }

    public Actor(String name, String implementation) {
        super(name);
        this.implementation = implementation;
    }

    public String getImplementation() {
        return implementation;
    }

    public void setImplementation(String implementation) {
        Object old = this.implementation;
        this.implementation = implementation;
        changes.firePropertyChange("implementation", old, implementation);
    }
}
