package org.concern.model;

public class AsynchronousActivity extends Activity {

    boolean user;
    String actor;
    boolean optional;
    int timeout = 60 * 60 * 24;

    public AsynchronousActivity() {
        super(null);
    }

    public AsynchronousActivity(String name) {
        super(name);
    }

    public AsynchronousActivity(String name, String implementation) {
        super(name, implementation);
    }

    public boolean isUser() {
        return user;
    }

    public void setUser(boolean user) {
        boolean old = this.user;
        this.user = user;
        changes.firePropertyChange("user", old, user);
    }

    public String getActor() {
        return actor;
    }

    public void setActor(String actor) {
        Object old = this.actor;
        this.actor = actor;
        changes.firePropertyChange("actor", old, actor);
    }

    public boolean isOptional() {
        return optional;
    }

    public int getTimeout() {
        return timeout;
    }

    public void setTimeout(int timeout) {
        int old = this.timeout;
        this.timeout = timeout;
        changes.firePropertyChange("timeout", old, timeout);
    }

    public void setOptional(boolean optional) {
        boolean old = this.optional;
        this.optional = optional;
        changes.firePropertyChange("optional", old, optional);
    }

    public Object clone() {
        return super.clone();
    }
}
