/*
 * $Id: Condition.java 520 2005-09-14 08:18:37Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.model;




/**
 * @author hengels
 */
public class Condition
    extends Element
    implements Implementable
{
    private boolean temporal;
    private String implementation = "";

    public Condition(String name) {
        super(name);
    }

    public Condition(String name, String implementation) {
        super(name);
        this.implementation = implementation;
    }

    public Condition() {
        super(null);
    }

    public boolean isTemporal() {
        return temporal;
    }

    public void setTemporal(boolean temporal) {
        boolean old = this.temporal;
        this.temporal = temporal;
        changes.firePropertyChange("temporal", old, temporal);
    }

    public String getImplementation() {
        return implementation;
    }

    public void setImplementation(String implementation) {
        Object old = this.implementation;
        this.implementation = implementation;
        changes.firePropertyChange("implementation", old, implementation);
    }
}
