/*
 * $Id: EnvironmentEntry.java 752 2006-11-10 21:16:47Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.model;

import java.io.Serializable;
import java.lang.reflect.Constructor;

/**
 * @author hengels[at]mercatis[dot]de
 * @version $Revision: 752 $
 */
public class EnvironmentEntry
    implements Serializable
{
    String name;
    String description;
    String type = "java.lang.String";
    String value;
    public static final Object[] TYPES = new Object[] { "java.lang.Boolean",
                                                  "java.lang.Byte",
                                                  "java.lang.Character",
                                                  "java.lang.String",
                                                  "java.lang.Short",
                                                  "java.lang.Integer",
                                                  "java.lang.Long",
                                                  "java.lang.Float",
                                                  "java.lang.Double",
                                                  "java.math.BigInteger",
                                                  "java.math.BigDecimal",
                                                  "java.net.URL"};

    public EnvironmentEntry() {
    }

    public EnvironmentEntry(String name, String type, String value) {
        this.name = name;
        this.type = type;
        this.value = value;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public String toString() {
        return "name=" + name + ", type=" + type + ", value=" + value;
    }

    public static Object createInstance(String type, String value) {
        try {
            Class clazz = Class.forName(type);
            Constructor constructor = clazz.getConstructor(new Class[] { String.class });
            return constructor.newInstance(new Object[] { value });
        }
        catch (Exception e) {
            return null;
        }
    }
}
