/*
 * $Id: ProcessChangeEvent.java 490 2005-08-15 12:50:16Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.model;

import java.util.EventObject;

/**
 * @version $Revision: 490 $
 */
public class ProcessChangeEvent extends EventObject
{
    public static final int ADDED = 1;
    public static final int CHANGED = 2;
    public static final int REMOVED = 3;

    int action;
    private Element element;

    public ProcessChangeEvent(Object source, Element element, int action) {
        super(source);
        this.element = element;
        this.action = action;
    }

    public Element getNode() {
        return element;
    }

    public int getAction() {
        return action;
    }
}
