package org.concern.model;

public class SynchronousActivity extends Activity {

    int retryDelay = 60 * 60;
    int trials = 3;

    public SynchronousActivity() {
        super(null);
    }

    public SynchronousActivity(String name) {
        super(name);
    }

    public SynchronousActivity(String name, String implementation) {
        super(name, implementation);
    }

    public int getRetryDelay() {
        return retryDelay;
    }

    public void setRetryDelay(int retryDelay) {
        int old = this.retryDelay;
        this.retryDelay = retryDelay;
        changes.firePropertyChange("retryDelay", old, retryDelay);
    }

    public int getTrials() {
        return trials;
    }

    public void setTrials(int trials) {
        int old = this.trials;
        this.trials = trials;
        changes.firePropertyChange("trials", old, trials);
    }

    public Object clone() {
        return super.clone();
    }
}
