/*
 * $Id: ConditionHandler.java 401 2005-01-07 13:20:01Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.model.cpd;

import org.concern.model.Condition;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

public class ConditionHandler
    extends ScopeHandler
{
    private Condition condition;
    private TextHandler descriptionHandler = new TextHandler();
    private EnvironmentEntryHandler environmentEntryHandler = new EnvironmentEntryHandler();

    public ConditionHandler() {
    }

    public Condition getCondition() {
        return condition;
    }

    public void startElement(String uri, String localName, String qName, Attributes attributes)
        throws SAXException {
        condition = new Condition(attributes.getValue("name"));
        condition.setImplementation(attributes.getValue("class"));
        condition.setTemporal("true".equals(attributes.getValue("temporal")));
    }

    public void characters(char ch[], int start, int length) throws SAXException {
    }

    public void endElement(String uri, String localName, String qName)
        throws SAXException {
    }

    public ScopeHandler getHandler(String localName, String qName) {
        if ("description".equals(qName))
            return descriptionHandler;
        else if ("env-entry".equals(qName))
            return environmentEntryHandler;
        else
            throw new RuntimeException("unexpected tag " + localName + " " + qName);
    }

    public void fetchChild(ScopeHandler handler) {
        if (handler == descriptionHandler)
            condition.setDescription(descriptionHandler.getText());
        else if (handler == environmentEntryHandler)
            condition.getEnvironment().add(environmentEntryHandler.getEnvironmentEntry());
    }
}
