/*
 * $Id: EnvironmentEntryHandler.java 404 2005-01-28 17:06:24Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.model.cpd;

import org.concern.model.EnvironmentEntry;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

public class EnvironmentEntryHandler
    extends ScopeHandler
{
    private EnvironmentEntry environmentEntry;
    private TextHandler envEntryNameHandler = new TextHandler();
    private TextHandler envEntryDescriptionHandler = new TextHandler();
    private TextHandler envEntryTypeHandler = new TextHandler();
    private TextHandler envEntryValueHandler = new TextHandler();

    public EnvironmentEntryHandler() {
    }

    public EnvironmentEntry getEnvironmentEntry() {
        return environmentEntry;
    }

    public void startElement(String uri, String localName, String qName, Attributes attributes)
        throws SAXException {
        environmentEntry = new EnvironmentEntry();
    }

    public void characters(char ch[], int start, int length) throws SAXException {
    }

    public void endElement(String uri, String localName, String qName)
        throws SAXException {
    }

    public ScopeHandler getHandler(String localName, String qName) {
        if ("env-entry-name".equals(qName))
            return envEntryNameHandler;
        else if ("description".equals(qName))
            return envEntryDescriptionHandler;
        else if ("env-entry-type".equals(qName))
            return envEntryTypeHandler;
        else if ("env-entry-value".equals(qName))
            return envEntryValueHandler;
        else
            throw new RuntimeException("unexpected tag " + localName + " " + qName);
    }

    public void fetchChild(ScopeHandler handler) {
        if (handler == envEntryNameHandler)
            environmentEntry.setName(envEntryNameHandler.getText());
        else if (handler == envEntryDescriptionHandler)
            environmentEntry.setDescription(envEntryDescriptionHandler.getText());
        else if (handler == envEntryTypeHandler)
            environmentEntry.setType(envEntryTypeHandler.getText());
        else if (handler == envEntryValueHandler)
            environmentEntry.setValue(envEntryValueHandler.getText());
    }
}
