/*
 * $Id: InteractionHandler.java 543 2005-10-06 09:09:08Z nebulosu $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.model.cpd;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.concern.model.Interaction;

public class InteractionHandler
    extends ScopeHandler
{
    private Interaction interaction;

    public InteractionHandler() {
    }

    public Interaction getInteraction() {
        return interaction;
    }

    public void startElement(String uri, String localName, String qName, Attributes attributes)
        throws SAXException {
        interaction = new Interaction();
        if ("in".equals(attributes.getValue("direction")))
            interaction.setDirection(Interaction.IN);
        else if ("out".equals(attributes.getValue("direction")))
            interaction.setDirection(Interaction.OUT);
        else if ("both".equals(attributes.getValue("direction")))
            interaction.setDirection(Interaction.BOTH);
        interaction.setMessage(attributes.getValue("message"));
        interaction.setCollaborator(attributes.getValue("collaborator"));
    }

    public void characters(char ch[], int start, int length) throws SAXException {
    }

    public void endElement(String uri, String localName, String qName)
        throws SAXException {
    }

    public ScopeHandler getHandler(String localName, String qName) {
        throw new RuntimeException("unexpected tag " + localName + " " + qName);
    }

    public void fetchChild(ScopeHandler handler) {
    }
}
