/*
 * $Id: LoaderHandler.java 341 2004-08-11 08:15:27Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.model.cpd;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.concern.model.Loader;

public class LoaderHandler
    extends ScopeHandler
{
    private Loader loader;
    private TextHandler descriptionHandler = new TextHandler();
    private EnvironmentEntryHandler environmentEntryHandler = new EnvironmentEntryHandler();

    public LoaderHandler() {
    }

    public Loader getLoader() {
        return loader;
    }

    public void startElement(String uri, String localName, String qName, Attributes attributes)
        throws SAXException {
        loader = new Loader(attributes.getValue("name"));
        loader.setImplementation(attributes.getValue("class"));
    }

    public void characters(char ch[], int start, int length) throws SAXException {
    }

    public void endElement(String uri, String localName, String qName)
        throws SAXException {
    }

    public ScopeHandler getHandler(String localName, String qName) {
        if ("description".equals(qName))
            return descriptionHandler;
        else if ("env-entry".equals(qName))
            return environmentEntryHandler;
        else
            throw new RuntimeException("unexpected tag " + localName + " " + qName);
    }

    public void fetchChild(ScopeHandler handler) {
        if (handler == descriptionHandler)
            loader.setDescription(descriptionHandler.getText());
        else if (handler == environmentEntryHandler)
            loader.getEnvironment().add(environmentEntryHandler.getEnvironmentEntry());
    }
}
