/*
 * $Id: ProcessLoader.java 476 2005-07-11 17:25:19Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.model.cpd;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import java.io.*;

public class ProcessLoader
{
    public static org.concern.model.Process load(File file) {
        InputStream in = null;
        try {
            in = new FileInputStream(file);
            SAXParserFactory factory = SAXParserFactory.newInstance();
            SAXParser saxParser = factory.newSAXParser();
            ProcessHandler processHandler = new ProcessHandler();
            Dispatcher dispatcher = new Dispatcher(processHandler);
            saxParser.parse(in, dispatcher);
            return processHandler.getProcess();
        }
        catch (Exception e) {
            throw new RuntimeException(e);
        }
        finally {
            try {
                if (in != null) in.close();
            }
            catch (IOException ignore) {}
        }
    }
}
