/*
 * $Id: PropertiesHandler.java 265 2004-04-15 13:08:31Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.model.cpd;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.*;

public class PropertiesHandler
    extends ScopeHandler
{
    private StringBuffer text = new StringBuffer();
    private Properties properties;

    public PropertiesHandler() {
    }

    public Properties getProperties() {
        return properties;
    }

    public void startElement(String uri, String localName, String qName, Attributes attributes)
        throws SAXException {
    }

    public void characters(char ch[], int start, int length) throws SAXException {
        text.append(new String(ch, start, length));
    }

    public void endElement(String uri, String localName, String qName)
        throws SAXException {
        try {
            properties = new Properties();
            InputStream in = new ByteArrayInputStream(text.toString().getBytes());
            properties.load(in);
        }
        catch (IOException e) {
            e.printStackTrace();
        }
    }

    public ScopeHandler getHandler(String localName, String qName) {
        throw new RuntimeException("unexpected tag " + localName + " " + qName);
    }

    public void fetchChild(ScopeHandler handler) {
    }
}
