/*
 * $Id: AbstractNode.java 265 2004-04-15 13:08:31Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.model.parser.ast;

import java.util.ArrayList;
import java.util.List;

/**
 * @version $Revision: 265 $
 */
public abstract class AbstractNode
{
    private List children = new ArrayList();

    public List getChildren() {
        return children;
    }

    public void setChildren(List children) {
        this.children = children;
    }

    public void addChild(AbstractNode node) {
        children.add(node);
    }

    public abstract Object accept(NodeVisitor v);
}
