package org.concern.controller;

import org.hibernate.LockMode;
import org.hibernate.HibernateException;
import org.concern.*;

import java.util.*;

public class DummyCondition
    extends AbstractCondition
{
    String depends = "";

    public DummyCondition() {
    }

    public DummyCondition(String name) {
        super(name);
    }

    public DummyCondition(String name, String depends) {
        super(name);
        this.depends = depends;
    }

    protected boolean wasAlreadPerformed(Object object, String name) throws ConditionEvaluationException {
        try {
            Subject subject = controller.getSubject(controller.getLoader().idOf(object), LockMode.NONE);
            System.out.println("subject.getLogs() = " + subject.getLogs());
            for (Iterator iterator = subject.getLogs().iterator(); iterator.hasNext();) {
                Log log = (Log)iterator.next();
                if (log.isSuccess() && name.equals(log.getActivity()))
                    return true;
            }
            return false;
        }
        catch (SubjectNotFoundException e) {
            throw new ConditionEvaluationException(e);
        }
        catch (LoaderException e) {
            throw new ConditionEvaluationException(e);
        }
        catch (UnknownSubjectException e) {
            throw new ConditionEvaluationException(e);
        }
        catch (HibernateException e) {
            throw new ConditionEvaluationException(e);
        }
    }

    protected boolean wasAlreadPerformed(Object subject) throws ConditionEvaluationException {
        return wasAlreadPerformed(subject, getName());
    }

    public boolean eval(Object subject) throws ConditionEvaluationException {
        if (wasAlreadPerformed(subject)) {
            System.out.println(getName() + ":" + subject + " already performed");
            return false;
        }
        // after dependencies
        StringTokenizer tokens = new StringTokenizer(depends, ",");
        while (tokens.hasMoreTokens()) {
            String dependency = tokens.nextToken();
            if (!wasAlreadPerformed(subject, dependency)) {
                System.out.println(getName() + ":" + subject + " depends on " + dependency);
                return false;
            }
        }
        return true;
    }

    Integer dummy;

    public void setDummy(Integer dummy) {
        this.dummy = dummy;
    }

    public Integer getDummy() {
        return dummy;
    }
}
