/*
 * $Id: DummyTemporalCondition.java 542 2005-10-05 15:38:43Z hengels $
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.org).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.concern.controller;

public class DummyTemporalCondition
    extends AbstractTemporalCondition
{
    boolean result = false;
    long anticipatedTransition;

    public DummyTemporalCondition() {
    }

    public DummyTemporalCondition(String name) {
        super(name);
    }

    public DummyTemporalCondition(String name, boolean result) {
        getEnvironment().put("condition.name", name);
        this.result = result;
    }

    public DummyTemporalCondition(String name, boolean result, long anticipatedTransition) {
        getEnvironment().put("condition.name", name);
        this.result = result;
        this.anticipatedTransition = anticipatedTransition;
    }

    public boolean eval(Object subject) {
        return result;
    }

    public long getAnticipatedTransition(Object subject) {
        return anticipatedTransition;
    }

    Integer dummy;

    public void setDummy(Integer dummy) {
        this.dummy = dummy;
    }

    public Integer getDummy() {
        return dummy;
    }
}
