package org.conform;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;


@Target({ElementType.TYPE})
@Retention(RetentionPolicy.RUNTIME)
public @interface Bean
{
    FormatType format() default FormatType.NONE;
    String formatClass() default "";

    /**
     * @return pattern for the Format (usage depends on the FormatType).
     */
    String pattern() default "";

    /**
     * @return key for looking up the pattern for the Format in the resource bundle (localized formatting)
     */
    String patternKey() default "";
}