package org.conform;

/**
 * Data binding interface.
 */
public interface Data
{
    void initialize();
    void flush();
    void update();
    void clear();

    void setValue(Object value);
    Object getValue();

    void addValidationListener(ValidationListener listener);
    void removeValidationListener(ValidationListener listener);

    void fireAddIssue(ValidationEvent event);
    void fireRemoveIssue(ValidationEvent event);

    boolean isIssuePublishingActive();
    void setIssuePublishingActive(boolean issuePublishingActive);

    void revalidate();

    Meta getMeta();
}
