package org.conform;

import org.apache.commons.logging.LogFactory;

/**
 * @author hengels
 * @version $Revision: 812 $
 */
public class DefaultPropertyData
    extends AbstractPropertyData
{
    private static org.apache.commons.logging.Log LOG = LogFactory.getLog(Data.class);

    BeanMeta beanMeta;
    Data relationData;

    public DefaultPropertyData(DefaultBeanData beanData, PropertyMeta property) {
        super(beanData, property);
        this.beanMeta = beanData.getBeanMeta();
    }

    public Object doGetValue() {
        return ((DefaultBeanData)beanData).doGetValue(propertyMeta);
    }

    public void doSetValue(Object value) {
        ((DefaultBeanData)beanData).doSetValue(propertyMeta, value);
    }

    public Data getRelationData() {
        if (relationData == null) {
            if (propertyMeta.getRelationType() == PropertyMeta.ONE_TO_MANY_RELATION)
                relationData = new DefaultTableData(propertyMeta.getRelationBean());
            else if (propertyMeta.getRelationType() == PropertyMeta.ONE_TO_ONE_RELATION)
                relationData = new DefaultBeanData(propertyMeta.getRelationBean());
            else
                LOG.warn("na so was property.getRelationType() = " + propertyMeta.getRelationType());

            relationData.addValidationListener(new ValidationListener() {
                public void addIssues(ValidationEvent event) {
                    fireAddIssue(event);
                }

                public void removeIssues(ValidationEvent event) {
                    fireRemoveIssue(event);
                }

                public void clearIssues(Meta meta) {
                }
            });
        }
        return relationData;
    }

    /*
    Object bean;
    private Method setter;
    private Method getter;

    protected void doSetValue(Object value) {
        if (setter == null)
            reflect();

        try {
            setter.invoke(bean, value);
        }
        catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    protected Object doGetValue() {
        if (getter == null)
            reflect();

        try {
            return getter.invoke(bean);
        }
        catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    private void reflect() {
        String name = propertyMeta.getName();
        char chars[] = new char[name.length() + 3];
        name.getChars(0, name.length(), chars, 3);
        chars[3] = Character.toUpperCase(chars[3]);
        chars[2] = 't';
        chars[1] = 'e';
        try {
            chars[0] = 's';
            setter = beanMeta.getType().getMethod(new String(chars));
        }
        catch (NoSuchMethodException e) {
            e.printStackTrace();
        }
        try {
            chars[0] = 'g';
            getter = beanMeta.getType().getMethod(new String(chars));
        }
        catch (NoSuchMethodException e) {
            e.printStackTrace();
        }
    }
    */
}
