package org.conform;

import java.util.*;

/**
 * @author hengels
 * @version $Revision: 831 $
 */
public abstract class DelegatingBeanMetaProvider
    implements BeanMetaProvider
{
    BeanMetaProvider parent;
    Map cache = new HashMap();

    protected DelegatingBeanMetaProvider() {
    }

    protected DelegatingBeanMetaProvider(BeanMetaProvider parent) {
        this.parent = parent;
    }

    public void setParent(BeanMetaProvider parent) {
        this.parent = parent;
    }

    public void clearCache() {
        cache.clear();
        parent.clearCache();
    }

    public BeanMeta getBeanMeta(Class type) {
        BeanMeta meta = (BeanMeta)cache.get(type);
        if (meta == null) {
            meta = parent.getBeanMeta(type);
            meta = (BeanMeta)meta.clone();
            cache.put(type, meta);
            configure(meta);
        }
        return meta;
    }

    protected abstract void configure(BeanMeta meta);
}
