package org.conform;


/**
 * Other standard formatters are appliead based on the property type.
 */
public enum FormatType
{
    NONE(null),
    /**
     * String template with variable expansion.
     */
    TEMPLATE("template"),
    /**
     * Simply prints the size of a collection valued property.
     */
    COLLECTION_SIZE("collection-size"),
    /**
     * Formats the numerical value as a currency.
     */
    CURRENCY("currency"),

    /**
     * Formats the numerical value as a percentage.
     */
    PERCENTAGE("percentage"),

    CUSTOM("custom");

    private final String value;

    FormatType(String value) {
        this.value = value;
    }

    public String getValue() {
        return value;
    }
}
