package org.conform;

/**
 * A Modifier modifies the BeanMeta. Typically it enriches the provided BeanMeta by a certain aspect like
 * <ul>
 * <li>Validation rules</li>
 * <li>Localization of labels</li>
 * <li>Authorization (readable, writable)</li>
 * <li>. . .</li>
 * </ul>
 *
 */
public interface Modifier
{
    void modify(BeanMeta beanMeta) throws ModifierException;
}
