package org.conform;

import org.conform.FormatType;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;


@Target({ElementType.FIELD})
@Retention(RetentionPolicy.RUNTIME)
public @interface Property
{
    /**
     * @return "true", "false"
     */
    String mandatory() default "";
    /**
     * @return "true", "false"
     */
    String readable() default "";
    /**
     * @return "true", "false"
     */
    String writable() default "";
    /**
     * @return "true", "false"
     */
    String applicable() default "";

    FormatType format() default FormatType.NONE;
    String formatClass() default "";

    /**
     * @return pattern for the Format (usage depends on the FormatType).
     */
    String pattern() default "";

    /**
     * @return key for looking up the pattern for the Format in the resource bundle (localized formatting)
     */
    String patternKey() default "";

    int scale() default -1;
    int precision() default -1;
    int length() default -1;

    /**
     * @return properties can be ordered by priority
     */
    int priority() default -1;
}
