package org.conform;

import java.lang.annotation.Target;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;


/**
 * PropertyReference
 * <p/>
 * This annotation can be used for DTO fields to tell that a
 * specific DTO property maps to a specific property of aother BO.
 */
@Target({ElementType.FIELD})
@Retention(RetentionPolicy.RUNTIME)
public @interface PropertyReference
{
    /**
     * @return the class name of the referenced class this property maps to.
     */
    String className();

    /**
     * @return the property name of the referenced class this property maps to.
     */
    String propertyName();
}
