/* $Id: ValidationEvent.java 768 2006-12-05 14:55:00Z hengels $ */
package org.conform;

import java.util.*;

/**
 * @version $Revision: 768 $
 */
public class ValidationEvent
    extends EventObject
{
    Set<Issue> issues = new HashSet<Issue>();

    public ValidationEvent(Object source) {
        super(source);
    }

    public ValidationEvent(Object source, Issue issue) {
        super(source);
        addIssue(issue);
    }

    void addIssues(Collection<Issue> issues) {
        this.issues.addAll(issues);
    }

    void addIssue(Issue issue) {
        issues.add(issue);
    }

    public Collection<Issue> getIssues() {
        return issues;
    }

    public String toString() {
        return "ValidationEvent{" +
            "issues=" + issues +
            '}';
    }
}
