package org.conform;

import java.io.Serializable;

/**
 * A validator is used to validate data, that might have been provided by a user or supplied as part of a service call.
 */
public interface Validator extends Serializable
{	

	/**
     * Validate and optionally normalize user input.
     * @param value the value to be validated
     * @return the possibly normalized value
     * @throws ValidationException if the value does not comply
     */
    Object validate(Object value) throws ValidationException;
}
