/*
 *
 * (c) Copyright 2004 con:cern development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * con:cern is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.conform;

import java.util.*;

/**
 * @version $Revision: 675 $
 */
public class VariationBeanMetaProvider
    extends DelegatingBeanMetaProvider
{
    private List<Modifier> modifiers = new LinkedList<Modifier>();

    public VariationBeanMetaProvider() {
    }

    public VariationBeanMetaProvider(BeanMetaProvider parent) {
        setParent(parent);
    }

    public VariationBeanMetaProvider addModifier(Modifier modifier) {
        modifiers.add(modifier);
        return this;
    }

    protected void configure(BeanMeta beanMeta) {
        for (Modifier modifier : modifiers)
            modifier.modify(beanMeta);
    }

    public void setModifiers(List<Modifier> modifiers) {
        for (Modifier modifier : modifiers)
            addModifier(modifier);
    }
}
