/* $Id: AbstractFormat.java 722 2006-10-30 10:15:22Z hengels $ */
package org.conform.format;

import java.text.*;
import java.io.Serializable;

/**
 * @version $Revision: 722 $
 */
public abstract class AbstractFormat
    implements Format, Serializable
{
    protected String message;
    protected String help;
    protected String pattern;

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public String getHelp() {
        return help;
    }

    public void setHelp(String help) {
        this.help = help;
    }

    public String getPattern() {
        return pattern;
    }

    public void setPattern(String pattern) {
        this.pattern = pattern;
    }

    public Object parse(String string)
        throws ParseException {
        return null;
    }

    public String toString() {
        String name = getClass().getName();
        int pos = name.lastIndexOf('.');
        if (pos != -1)
            name = name.substring(pos + 1);
        if (name.endsWith("Format"))
            name = name.substring(0, name.length() - "Format".length());
        String pattern = getPattern();
        return pattern != null ? name + ": " + pattern : name;
    }

    public Object clone() {
        try {
            return super.clone();
        }
        catch (CloneNotSupportedException e) {
            throw new RuntimeException(e);
        }
    }
}
