/* $Id: BigDecimalFormat.java 626 2005-12-16 14:44:33Z hengels $ */
package org.conform.format;

import java.text.*;
import java.math.BigDecimal;


/**
 * java.sql.Date
 * @version $Revision: 626 $
 */
public class BigDecimalFormat extends AbstractFormat implements Format
{
    int scale = -1;

    public BigDecimalFormat() {
        message = "validation.unparsableNumber";
        help = "+/-3456.78";
    }

    public int getScale() {
        return scale;
    }

    public void setScale(int scale) {
        this.scale = scale;
    }

    public String getPattern() {
        StringBuffer builder = new StringBuffer(scale + 1);
        builder.append(".");
        for (int i=0; i < scale; i++)
            builder.append('#');
        return builder.toString();
    }

    public void setPattern(String pattern) {
        scale = 0;
        for (int i=0; i < pattern.length(); i++)
            if ('#' == pattern.charAt(i))
                scale++;
    }

    public String format(Object value) {
        value = scale((BigDecimal)value);
        return value.toString();
    }

    public Object parse(String string) throws ParseException {
        try {
            BigDecimal value = new BigDecimal(string);
            value = scale((BigDecimal)value);
            return value;
        }
        catch (NumberFormatException e) {
            throw new ParseException(string, 0);
        }
    }

    private BigDecimal scale(BigDecimal value) {
        if (scale != -1)
            value = value.setScale(scale, BigDecimal.ROUND_HALF_EVEN);
        return value;
    }
}
