package org.conform.format;

import java.lang.reflect.Method;

public class CallGetterFormat
    extends AbstractFormat
{
    private String[] getterNames;

    public CallGetterFormat(String... getterNames) {
        this.getterNames = getterNames;
    }

    public String format(Object value) {
        return value != null ? callGetters(value) : "";
    }

    private String callGetters(Object object) {
        try {
            for (int i = 0; i < getterNames.length; i++) {
                String getterName = getterNames[i];
                Method getter = object.getClass().getMethod(getterName);
                Object value = getter.invoke(object);
                if (value != null)
                    return value.toString();
            }
            return null;
        }
        catch (Exception e) {
            return null;
        }
    }
}
