/* $Id: Format.java 674 2006-10-06 12:15:59Z hengels $ */
package org.conform.format;

import java.text.ParseException;

/**
 * Generates a formatted string representation of a value and vice versa, parses a string into a value.
 * @author hengels
 */
public interface Format extends Cloneable
{
    String format(Object value);
    Object parse(String string) throws ParseException;

    /**
     * Many Format implementations use a pattern.
     * @return the pattern string
     */
    String getPattern();

    /**
     * Many Format implementations use a pattern.
     * @param pattern the pattern string
     */
    void setPattern(String pattern);

    /**
     * The error message code.
     * @return the message code
     */
    String getMessage();

    /**
     * A hint for users to get the format right.
     * @return a help string
     */
    String getHelp();

    /**
     * Format implementations have to be clonable.
     */
    Object clone();
}
