/* $Id: TemplateFormat.java 722 2006-10-30 10:15:22Z hengels $ */
package org.conform.format;

import ognl.*;

import java.io.Serializable;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author hengels
 */
public class TemplateFormat
    extends AbstractFormat
    implements Serializable
{
    /*
    {
        OgnlRuntime.setMethodAccessor(Object.class, new ObjectMethodAccessor() {
            public Object callMethod(Map map, Object object, String methodName, Object[] objects)
                throws MethodFailedException
            {
                if ("format".equals(methodName)) {
                    if (object == null)
                        return "-";
                    else {
                        format("");
                    }
                }
                else
                    return super.callMethod(map, object, methodName, objects);
            }
        });
    }
    */

    protected Pattern compiledPattern;

    public TemplateFormat() {
    }

    public TemplateFormat(String pattern) {
        this.pattern = pattern;
    }

    public void setPattern(String pattern) {
        super.setPattern(pattern);
        this.compiledPattern = null;
    }

    public String format(Object obj) {
        StringBuffer buffer = new StringBuffer();
        Map context = new HashMap();
        if (obj instanceof Map)
            context.putAll((Map)obj);
        else
            context.put("root", obj);

        try {
            Pattern pattern = compiledPattern();
            Matcher matcher = pattern.matcher(this.pattern);
            while (matcher.find()) {
                String expression = this.pattern.substring(matcher.start() + 1, matcher.end() - 1);
                Object value = Ognl.getValue(expression, context);
                matcher.appendReplacement(buffer, "" + value);
            }
            matcher.appendTail(buffer);
        }
        catch (OgnlException e) {
            e.printStackTrace();
            throw new IllegalArgumentException(e.getMessage());
        }
        return buffer.toString();
    }

    private Pattern compiledPattern() {
        if (compiledPattern == null)
            compiledPattern = Pattern.compile("\\{[^\\{\\}]+\\}");
        return compiledPattern;
    }

    public static void main(String[] args) {
        System.out.println(new TemplateFormat("{format(root.firstName)} {root.lastName}").format(new Object()
        {
            public List getFirstName() {
                return Arrays.asList("Holger", "The Boss");
            }

            public String getLastName() {
                return "Engels";
            }
        }));
    }
}
