/* $Id: TimeFormat.java 722 2006-10-30 10:15:22Z hengels $ */
package org.conform.format;

import java.text.*;
import java.util.*;


/**
 * java.sql.Date
 * @version $Revision: 722 $
 */
public class TimeFormat extends AbstractFormat
{
    public TimeFormat() {
        message = "validation.unparsableTime";
    }

    public TimeFormat(String pattern) {
        message = "validation.unparsableTime";
        this.pattern = pattern;
    }

    public java.text.DateFormat getFormat() {
        if (pattern != null)
            return new SimpleDateFormat(pattern, FormatFactory.getInstance().getLocale());
        else
            return java.text.DateFormat.getTimeInstance(java.text.DateFormat.SHORT,
                                                        FormatFactory.getInstance().getLocale());

    }

    public String getHelp() {
        return ((SimpleDateFormat)getFormat()).toPattern();
    }

    public String format(Object value) {
        return getFormat().format(value);
    }

    public Object parse(String string) throws ParseException {
        Date date = (Date)getFormat().parseObject(string);
        return new java.sql.Time(date.getTime());
    }
}
