package org.conform.mdl;

import org.xml.sax.AttributeList;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.conform.*;
import org.apache.commons.logging.LogFactory;

import java.beans.ExceptionListener;

public class AttributeHandler
    extends ScopeHandler
    implements ObjectScope
{
    private static org.apache.commons.logging.Log LOG = LogFactory.getLog(Meta.class);

    private String attributeName;
    private Object object;

    public AttributeHandler(ExceptionListener exceptionListener) {
        super(exceptionListener);
    }

    public void startElement(String name, AttributeList attributes) throws SAXException {
        if ("attribute".equals(name)) {
            attributeName = attributes.getValue("name");
            LOG.trace("attribute name = " + attributeName);
        }
        else {
            getHandler("java").setScope(this);
            getHandler("java").startElement(name, attributes);
        }
    }

    public void endElement(String name) throws SAXException {
        if ("attribute".equals(name)) {
            if (getScope() instanceof PropertyMeta) {
                PropertyMeta propertyMeta = (PropertyMeta)getScope();
                propertyMeta.setAttribute(attributeName, object);
            }
            else if (getScope() instanceof BeanMeta) {
                BeanMeta beanMeta = (BeanMeta)getScope();
                beanMeta.setAttribute(attributeName, object);
            }
        }
        else
            getHandler("java").endElement(name);
    }

    public void characters(char ch[], int start, int length) throws SAXException {
        if (attributeName != null)
            getHandler("java").characters(ch, start, length);
        else
            exceptionListener.exceptionThrown(new SAXParseException("don't extpect characters", locator));
    }

    public void setObject(Object object) {
        LOG.debug("attribute value = " + object);
        this.object = object;
    }

    public Object getObject() {
        return object;
    }
}
