package org.conform.mdl;

import org.conform.*;
import org.xml.sax.AttributeList;
import org.xml.sax.SAXException;
import org.apache.commons.logging.LogFactory;

import java.beans.ExceptionListener;

public class DomainProviderHandler
    extends ScopeHandler
    implements ObjectScope
{
    private static org.apache.commons.logging.Log LOG = LogFactory.getLog(Meta.class);

    private Object object;

    public DomainProviderHandler(ExceptionListener exceptionListener) {
        super(exceptionListener);
    }

    public void startElement(String name, AttributeList attributes) throws SAXException {
        if ("domain-provider".equals(name)) {
            LOG.trace("domain-provider");
        }
        else {
            getHandler("java").setScope(this);
            getHandler("java").startElement(name, attributes);
        }
    }

    public void endElement(String name) throws SAXException {
        if ("domain-provider".equals(name)) {
            if (getScope() instanceof PropertyMeta) {
                PropertyMeta propertyMeta = (PropertyMeta)getScope();
                propertyMeta.setDomainProvider((DomainProvider)object);
            }
            else if (getScope() instanceof BeanMeta) {
                BeanMeta beanMeta = (BeanMeta)getScope();
                beanMeta.setDomainProvider((DomainProvider)object);
            }
        }
        else
            getHandler("java").endElement(name);
    }

    public void characters(char ch[], int start, int length) throws SAXException {
        getHandler("java").characters(ch, start, length);
    }

    public void setObject(Object object) {
        LOG.debug("domain provider = " + object);
        this.object = object;
    }

    public Object getObject() {
        return object;
    }
}
