package org.conform.mdl;

import org.xml.sax.*;

import java.beans.ExceptionListener;

import org.conform.*;

public class MandatoryHandler extends ScopeHandler
{
    private boolean mandatory;

    public MandatoryHandler(ExceptionListener exceptionListener) {
        super(exceptionListener);
    }

    public void startElement(String name, AttributeList attributes) throws SAXException {
        if (!"mandatory".equals(name))
            exceptionListener.exceptionThrown(new SAXParseException("mandatory doesn't have nested elements", locator));
        mandatory = true;
    }

    public void endElement(String name) throws SAXException {
        if ("mandatory".equals(name))
            ((PropertyMeta)getScope()).setMandatory(mandatory);
    }

    public void characters(char ch[], int start, int length) throws SAXException {
        String string = new String(ch, start, length);
        if ("true".equalsIgnoreCase(string))
            mandatory = true;
        else if ("false".equalsIgnoreCase(string))
            mandatory = false;
        else
            exceptionListener.exceptionThrown(new SAXParseException("true or false expected: " + string, locator));
    }
}
