package org.conform.mdl;

import org.xml.sax.*;

import java.beans.ExceptionListener;

import org.conform.*;

public class PriorityHandler extends ScopeHandler
{
    private int priority;

    public PriorityHandler(ExceptionListener exceptionListener) {
        super(exceptionListener);
    }

    public void startElement(String name, AttributeList attributes) throws SAXException {
        if (!"priority".equals(name))
            exceptionListener.exceptionThrown(new SAXParseException("priority doesn't have nested elements", locator));
        priority = 0;
    }

    public void endElement(String name) throws SAXException {
        if ("priority".equals(name))
            ((PropertyMeta)getScope()).setPriority(priority);
    }

    public void characters(char ch[], int start, int length) throws SAXException {
        String string = new String(ch, start, length);
        try {
            priority = Integer.parseInt(string);
        }
        catch (NumberFormatException e) {
            exceptionListener.exceptionThrown(new SAXParseException("number expected: " + string, locator));
        }
    }
}
