package org.conform.mdl;

import org.xml.sax.*;

import java.beans.ExceptionListener;

import org.conform.*;

public class ReadableHandler extends ScopeHandler
{
    private boolean readable;

    public ReadableHandler(ExceptionListener exceptionListener) {
        super(exceptionListener);
    }

    public void startElement(String name, AttributeList attributes) throws SAXException {
        if (!"readable".equals(name))
            exceptionListener.exceptionThrown(new SAXParseException("readable doesn't have nested elements", locator));
        readable = true;
    }

    public void endElement(String name) throws SAXException {
        if ("readable".equals(name))
            ((PropertyMeta)getScope()).setReadable(readable);
    }

    public void characters(char ch[], int start, int length) throws SAXException {
        String string = new String(ch, start, length);
        if ("true".equalsIgnoreCase(string))
            readable = true;
        else if ("false".equalsIgnoreCase(string))
            readable = false;
        else
            exceptionListener.exceptionThrown(new SAXParseException("true or false expected: " + string, locator));
    }
}
