package org.conform.mdl;

import org.xml.sax.*;

import java.beans.ExceptionListener;

import org.conform.*;

public class RelationBeanHandler extends ScopeHandler
{
    private BeanMeta relationBean;

    public RelationBeanHandler(ExceptionListener exceptionListener) {
        super(exceptionListener);
    }

    public void startElement(String name, AttributeList attributes) throws SAXException {
        if (!"relation-bean".equals(name))
            exceptionListener.exceptionThrown(new SAXParseException("relation-bean doesn't have nested elements", locator));
        relationBean = null;
    }

    public void endElement(String name) throws SAXException {
        if ("relation-bean".equals(name))
            ((PropertyMeta)getScope()).setRelationBean(relationBean);
    }

    public void characters(char ch[], int start, int length) throws SAXException {
        String string = new String(ch, start, length);
        ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
        if (classLoader == null)
            classLoader = getClass().getClassLoader();
        try {
            relationBean = MDLModifier.getBeans().getBeanMeta(classLoader.loadClass(string));
            if (relationBean == null)
                exceptionListener.exceptionThrown(new SAXParseException("relation-bean expected: " + string, locator));
        }
        catch (ClassNotFoundException e) {
            e.printStackTrace(System.err);
        }
    }
}
