package org.conform.mdl;

import org.xml.sax.*;

import java.beans.ExceptionListener;

import org.conform.*;

public class RelationPropertyHandler extends ScopeHandler
{
    private String propertyName;

    public RelationPropertyHandler(ExceptionListener exceptionListener) {
        super(exceptionListener);
    }

    public void startElement(String name, AttributeList attributes) throws SAXException {
        if (!"relation-property".equals(name))
            exceptionListener.exceptionThrown(new SAXParseException("relation-property doesn't have nested elements", locator));
        propertyName = null;
    }

    public void endElement(String name) throws SAXException {
        if ("relation-property".equals(name)) {
            ((PropertyMeta)getScope()).setAttribute("relation-property", propertyName);
        }
    }

    public void characters(char ch[], int start, int length) throws SAXException {
        propertyName = new String(ch, start, length);
    }
}
