package org.conform.mdl;

import org.xml.sax.*;

import java.beans.ExceptionListener;
import java.util.*;

import org.conform.*;

public class RelationTypeHandler extends ScopeHandler
{
    static Map relationTypes = new HashMap();
    static {
        relationTypes.put("one-to-one", new Integer(PropertyMeta.ONE_TO_ONE_RELATION));
        relationTypes.put("one-to-many", new Integer(PropertyMeta.ONE_TO_MANY_RELATION));
        relationTypes.put("many-to-many", new Integer(PropertyMeta.MANY_TO_MANY_RELATION));
        relationTypes.put("many-to-one", new Integer(PropertyMeta.MANY_TO_ONE_RELATION));
    }
    private int relationType;

    public RelationTypeHandler(ExceptionListener exceptionListener) {
        super(exceptionListener);
    }

    public void startElement(String name, AttributeList attributes) throws SAXException {
        if (!"relation-type".equals(name))
            exceptionListener.exceptionThrown(new SAXParseException("relation-type doesn't have nested elements", locator));
        relationType = PropertyMeta.NO_RELATION;
    }

    public void endElement(String name) throws SAXException {
        if ("relation-type".equals(name))
            ((PropertyMeta)getScope()).setRelationType(relationType);
    }

    public void characters(char ch[], int start, int length) throws SAXException {
        String string = new String(ch, start, length);
        try {
            Integer integer = (Integer)relationTypes.get(string);
            relationType = integer.intValue();
        }
        catch (NullPointerException e) {
            exceptionListener.exceptionThrown(new SAXParseException("relation-type expected: " + string, locator));
        }
    }
}
