package org.conform.mdl;

import org.xml.sax.*;

import java.beans.ExceptionListener;

import org.conform.*;

public class WritableHandler extends ScopeHandler
{
    private boolean writable;

    public WritableHandler(ExceptionListener exceptionListener) {
        super(exceptionListener);
    }

    public void startElement(String name, AttributeList attributes) throws SAXException {
        if (!"writable".equals(name))
            exceptionListener.exceptionThrown(new SAXParseException("writable doesn't have nested elements", locator));
        writable = true;
    }

    public void endElement(String name) throws SAXException {
        if ("writable".equals(name))
            ((PropertyMeta)getScope()).setWritable(writable);
    }

    public void characters(char ch[], int start, int length) throws SAXException {
        String string = new String(ch, start, length);
        if ("true".equalsIgnoreCase(string))
            writable = true;
        else if ("false".equalsIgnoreCase(string))
            writable = false;
        else
            exceptionListener.exceptionThrown(new SAXParseException("true or false expected: " + string, locator));
    }
}
