package org.conform.modifier;

import org.conform.*;

import java.beans.PropertyChangeListener;

public abstract class InlineModifier
    implements Modifier
{
    BeanMeta beanMeta;

    public InlineModifier() {
    }

    public void modify(BeanMeta beanMeta) {
        this.beanMeta = beanMeta;
        configure();
    }

    protected abstract void configure();

    public PropertyMeta property(String name) {
        PropertyMeta property = beanMeta.getProperty(name);
        if (property == null)
            throw new IllegalArgumentException("No property with name " + name);
        return property;
    }

    public BeanMeta bean() {
        return beanMeta;
    }

    protected void addChangeListener(PropertyChangeListener listener, String... propertyNames) {
        for (String propertyName : propertyNames) {
            property(propertyName).setAttribute(PropertyMeta.ATTRIBUTE_CHANGE_LISTENER, listener);
        }
    }
}
