/* $Id: PropertyOrderModifier.java 787 2007-01-03 16:19:50Z hengels $ */
package org.conform.modifier;

import org.conform.*;
import org.apache.commons.logging.LogFactory;

import java.net.URL;
import java.io.*;
import java.util.*;

/**
 * @version $Revision: 787 $
 */
public class PropertyOrderModifier
    implements Modifier, Comparator<PropertyMeta>
{
    private List<String> propertyNames;

    public PropertyOrderModifier(String... propertyNames) {
        this.propertyNames = Arrays.asList(propertyNames);
    }

    public void modify(BeanMeta beanMeta) {
        Arrays.sort(beanMeta.getProperties(), this);
    }

    public int compare(PropertyMeta m1, PropertyMeta m2) {
        int i1 = propertyNames.indexOf(m1.getName());
        int i2 = propertyNames.indexOf(m2.getName());
        if (i1 == -1)
            i1 = 1000;
        if (i2 == -1)
            i2 = 1000;
        return i1 - i2;
    }
}
