package org.conform.util;

import java.util.*;

public class ListView
    implements List
{
    Collection collection = Collections.EMPTY_LIST;
    Iterator iterator;
    int index = -1;
    Object object;

    public ListView(Collection collection) {
        this.collection = collection;
    }

    public Object get(int index) {
        if (index < this.index || iterator == null) {
            iterator = collection.iterator();
            this.index = -1;
        }
        for (; this.index < index; this.index++)
            object = iterator.next();

        return object;
    }

    public Object remove(int index) {
        Object object = get(index);
        collection.remove(object);
        iterator = null;
        return object;
    }

    public void add(int index, Object element) {
        add(object);
    }

    public int indexOf(Object o) {
        throw new UnsupportedOperationException("index of not supported");
    }

    public int lastIndexOf(Object o) {
        return indexOf(o);
    }

    public boolean addAll(int index, Collection c) {
        boolean result = addAll(c);
        if (result) iterator = null;
        return result;
    }

    public List subList(int fromIndex, int toIndex) {
        throw new UnsupportedOperationException("sublist not supported");
    }

    public ListIterator listIterator() {
        throw new UnsupportedOperationException("list iterator not supported");
    }

    public ListIterator listIterator(int index) {
        throw new UnsupportedOperationException("list iterator not supported");
    }

    public Object set(int index, Object element) {
        Object object = get(index);
        collection.remove(object);
        add(element);
        return object;
    }

    public int hashCode() {
        return collection.hashCode();
    }

    public int size() {
        return collection.size();
    }

    public void clear() {
        collection.clear();
    }

    public boolean isEmpty() {
        return collection.isEmpty();
    }

    public Object[] toArray() {
        return collection.toArray();
    }

    public boolean add(Object o) {
        boolean result = collection.add(o);
        if (result) iterator = null;
        return result;
    }

    public boolean contains(Object o) {
        return collection.contains(o);
    }

    public boolean equals(Object o) {
        return collection.equals(o);
    }

    public boolean remove(Object o) {
        return collection.remove(o);
    }

    public boolean addAll(Collection c) {
        boolean result = collection.addAll(c);
        if (result) iterator = null;
        return result;
    }

    public boolean containsAll(Collection c) {
        return collection.containsAll(c);
    }

    public boolean removeAll(Collection c) {
        boolean result = collection.removeAll(c);
        if (result) iterator = null;
        return result;
    }

    public boolean retainAll(Collection c) {
        boolean result = collection.retainAll(c);
        if (result) iterator = null;
        return result;
    }

    public Iterator iterator() {
        return collection.iterator();
    }

    public Object[] toArray(Object a[]) {
        return collection.toArray(a);
    }

    public Collection getCollection() {
        return collection;
    }
}
