package org.conform.validator;

public enum RegularExpressionType
{
    CUSTOM(null),

    LOWER("[a-z\\s]*"),
    UPPER("[A-Z]*"),
    alpha("[a-z\\sA-Z]*"),
    digit("[0-9]*"),
    alnum("[a-z\\sA-Z0-9]*"),

    hex("[0-9a-fA-F]*"),
    email("^.+@[^\\.].*\\.[a-z]{2,}$");


    private final String expression;

    RegularExpressionType(String expression) {
        this.expression = expression;
    }

    public String getExpression() {
        return expression;
    }
}
