package org.conform.validator;

import org.conform.Validator;
import org.conform.ValidationException;

public class StringLengthValidator implements Validator
{
    private String message = "validation.stringlength";
    private int length;

    public StringLengthValidator() {
    }

    public StringLengthValidator(int length) {
        this.length = length;
    }

    public int getLength() {
        return length;
    }

    public void setLength(int length) {
        this.length = length;
    }

    public void setMessage(String message)
    {
        this.message = message;
    }

    public String getMessage()
    {
        return message;
    }

    public Object validate(Object value) {
        if (value == null)
            return null;

        String string = (String)value;
        if (string.length() > length)
            throw new ValidationException(new ValidationException.Message(getMessage(), new Object[] { value, new Integer(length) }));

        return value;
    }
}
