package org.conform.wings;

import org.wings.table.STableCellEditor;
import org.wings.*;
import org.conform.*;
import org.wingx.table.EditableTableCellRenderer;

import javax.swing.event.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.EventObject;
import java.io.Serializable;

public class PropertyEditableCellRenderer
    implements EditableTableCellRenderer
{
    protected SComponent editorComponent;
    private PropertyData propertyData;
    private Editor editor;

    public PropertyEditableCellRenderer(Editor editor, final PropertyMeta propertyMeta) {
        this.editor = editor;
        this.editorComponent = editor.createComponent(propertyMeta);
        propertyData = new EditorPropertyData(propertyMeta);
        this.editor.setPropertyData(this.editorComponent, propertyData);

        //addActionListener(this);
    }

    public Object getValue() {
        return propertyData.getValue();
    }

    public SComponent getTableCellRendererComponent(STable table, Object value, boolean isSelected, int row, int column) {
        editorComponent.setEnabled(table.isEnabled());
        propertyData.setValue(value);
        return editorComponent;
    }

public LowLevelEventListener getLowLevelEventListener(STable table, int row, int column) {
        return (LowLevelEventListener)editorComponent;
    }

    public void actionPerformed(ActionEvent e) {
    }

    class EditorPropertyData
        extends AbstractPropertyData
    {
        private Object value;
        private Object invalidValue;

        protected EditorPropertyData(PropertyMeta propertyMeta) {
            super(null, propertyMeta);
        }

        public void setValue(Object value) {
            this.value = value;
        }

        public Object getValue() {
            return value;
        }

        public Data getRelationData() {
            return null;
        }

        public void setInvalidValue(Object text) {
            invalidValue = text;
        }

        protected void doSetValue(Object value) {
        }

        protected Object doGetValue() {
            return null;
        }

        public Object getInvalidValue() {
            return invalidValue;
        }
    }
}
