/* $Id: ClassEditor.java 746 2006-11-08 13:34:23Z hengels $ */
package org.conform.wings.editor;

import org.conform.*;
import org.conform.wings.Editor;
import org.conform.wings.PropertyAdapter;
import org.wings.SComponent;
import org.wings.SLabel;

public class ClassEditor
    implements Editor
{
    public SComponent createComponent(PropertyMeta propertyMeta) {
        PropertyDataLabel propertyDataLabel = new PropertyDataLabel(propertyMeta);
        configureComponent(propertyMeta, propertyDataLabel, false);
        return propertyDataLabel;
    }

    public void configureComponent(PropertyMeta propertyMeta, SComponent component, boolean erroneous) {
        PropertyDataLabel propertyDataLabel = (PropertyDataLabel)component;
        propertyDataLabel.setVisible(propertyMeta.isReadable());
        DefaultEditorStyles.applyEditorAlignment(propertyMeta, component);
        DefaultEditorStyles.applyEditorState(propertyMeta, component, erroneous);
    }

    public void setPropertyData(SComponent component, PropertyData propertyData) {
        BeanData beanData = propertyData.getBeanData();
        if (beanData != null)
            beanData.addPropertyChangeListener(propertyData.getPropertyMeta().getName(), new ComponentInvalidator(component));
        ((PropertyDataLabel)component).setPropertyData(propertyData);
    }

    public PropertyData getPropertyData(SComponent component) {
        return ((PropertyDataLabel)component).getPropertyData();
    }

    static class PropertyDataLabel
        extends SLabel
        implements PropertyAdapter
    {
        private PropertyData propertyData;
        private PropertyMeta property;

        public PropertyDataLabel(PropertyMeta field) {
            this.property = field;
        }

        public void setPropertyData(PropertyData propertyData) {
            this.propertyData = propertyData;
        }

        public PropertyData getPropertyData() {
            return propertyData;
        }

        public void setText(String string) {
        }

        public String getText() {
            Class value = (Class)propertyData.getValue();
            return value.getName();
        }
    }
}
