package org.conform.wings.editor;

import org.wings.SComponent;
import org.wings.SComboBox;
import org.wings.event.SParentFrameListener;
import org.wings.event.SParentFrameEvent;
import org.conform.*;

import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;

public class DynamicDomainEditor
    extends DomainEditor
    implements SParentFrameListener
{
    public SComponent createComponent(PropertyMeta propertyMeta) {
        SComponent component = super.createComponent(propertyMeta);
        component.addParentFrameListener(this);
        return component;
    }

    public void parentFrameAdded(SParentFrameEvent e) {
        final SComboBox component = (SComboBox)e.getSource();
        PropertyData propertyData = getPropertyData(component);
        PropertyMeta propertyMeta = propertyData.getPropertyMeta();
        DynamicDomainProvider domainProvider = (DynamicDomainProvider)propertyMeta.getDomainProvider();
        ChangeListener listener = new ChangeListener() {
            public void stateChanged(ChangeEvent e) {
                ((ComboBoxModelPropertyAdapter)component.getModel()).refresh();
            }
        };
        domainProvider.addChangeListener(listener);
        component.putClientProperty("domainChangeListener", listener);
    }

    public void parentFrameRemoved(SParentFrameEvent e) {
        final SComboBox component = (SComboBox)e.getSource();
        PropertyData propertyData = getPropertyData(component);
        PropertyMeta propertyMeta = propertyData.getPropertyMeta();
        DynamicDomainProvider domainProvider = (DynamicDomainProvider)propertyMeta.getDomainProvider();
        ChangeListener listener = (ChangeListener)component.getClientProperty("domainChangeListener");
        domainProvider.removeChangeListener(listener);
    }
}
