package org.conform.wings.editor;

import java.awt.GridBagConstraints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.ListModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.ListDataListener;

import org.wings.SButton;
import org.wings.SContainer;
import org.wings.SGridBagLayout;
import org.wings.SList;
import org.wings.SListCellRenderer;

public class SubSet extends SContainer implements ActionListener {
    
	protected SubSetModel model;
    private ChangeListener adapter = new ChangeListener() {
                public void stateChanged(ChangeEvent e) {
                    ((IncludedModel)included.getModel()).list = null;
                    ((ExcludedModel)excluded.getModel()).list = null;
                }
            };
    protected SList included;
    protected SList excluded;
    private SButton include;
    private SButton exclude;

    
    public SubSet() {
        super(new SGridBagLayout());
        GridBagConstraints constraints = new GridBagConstraints();

        included = new SList();
        included.setModel(new IncludedModel());
        constraints.gridwidth = GridBagConstraints.RELATIVE;
        constraints.gridheight = 2;
        add(included, constraints);

        include = new SButton(">>>");
        include.addActionListener(this);
        constraints.gridheight = 1;
        add(include, constraints);

        exclude = new SButton("<<<");
        exclude.addActionListener(this);
        constraints.gridheight = 1;
        add(exclude, constraints);

        excluded = new SList();
        excluded.setModel(new ExcludedModel());
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.gridheight = 2;
        add(excluded, constraints);
    }

    public SubSetModel getModel() {
        return model;
    }

    public void setModel(SubSetModel model) {
        if (this.model != null)
            this.model.removeChangeListener(adapter);
        this.model = model;
        model.addChangeListener(adapter);
    }

    public void actionPerformed(ActionEvent e) {
        if (include == e.getSource()) {
            Object[] objects = excluded.getSelectedValues();
            for (int i = 0; i < objects.length; i++) {
                Object object = objects[i];
                model.include(object);
            }
        }
        else if (exclude == e.getSource()) {
            Object[] objects = included.getSelectedValues();
            for (int i = 0; i < objects.length; i++) {
                Object object = objects[i];
                model.exclude(object);
            }
        }
    }

    public void setRenderer(SListCellRenderer renderer) {
        included.setCellRenderer(renderer);
        excluded.setCellRenderer(renderer);
    }

    class IncludedModel
        implements ListModel
    {
        private List list;

        private List getList() {
            if (list == null)
                list = new ArrayList(model.getIncludedSubSet());
            return list;
        }

        public int getSize() {
            return getList().size();
        }

        public Object getElementAt(int index) {
            return getList().get(index);
        }

        public void addListDataListener(ListDataListener l) {
        }

        public void removeListDataListener(ListDataListener l) {
        }
    }

    class ExcludedModel
        implements ListModel
    {
        private List list;

        private List getList() {
            if (list == null)
                list = new ArrayList(model.getExcludedSubSet());
            return list;
        }

        public int getSize() {
            return getList().size();
        }

        public Object getElementAt(int index) {
            return getList().get(index);
        }

        public void addListDataListener(ListDataListener l) {
        }

        public void removeListDataListener(ListDataListener l) {
        }
    }
}
