package org.osbl.inventory;

import org.osbl.inventory.model.*;
import org.osbl.ReferenceChecker;
import org.osbl.ServiceProvider;
import org.osbl.identity.model.Identity;
import org.osbl.persistence.*;
import org.conform.hibernate.HibernateEnvironment;

import java.util.*;

public class EmployeeToLocationReferenceChecker
    implements ReferenceChecker<Identity, Location>
{
    private Persistence persistence;

    public Persistence getPersistence() {
        if (persistence == null)
            persistence = (Persistence)ServiceProvider.getInstance().getService("InventoryPersistence");
        return persistence;
    }

    public Collection<Identity> check(Collection<Location> objects) {
        try {
            HibernateEnvironment.getInstance().beginTransaction();

            SimpleQueryCommand command = (SimpleQueryCommand)getPersistence().createCommand("list");

            command.setType(Employee.class);
            command.clearFilters();
            command.addFetch("general", Fetch.JOIN);
            command.addFilter("location", Operator.IN, objects);
            List<Employee> employees = command.execute();
            List<Identity> identities = new ArrayList<Identity>(employees.size());
            for (Employee employee : employees)
                identities.add(employee.getGeneral());

            return identities;
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }
}
