package org.osbl.inventory;

import org.osbl.inventory.model.*;
import org.osbl.ReferenceChecker;
import org.osbl.ServiceProvider;
import org.osbl.persistence.*;
import org.conform.hibernate.HibernateEnvironment;

import java.util.*;

public class InventoryToCostTypeReferenceChecker
    implements ReferenceChecker<Inventory, CostType>
{
    private Persistence persistence;

    public Persistence getPersistence() {
        if (persistence == null)
            persistence = (Persistence)ServiceProvider.getInstance().getService("InventoryPersistence");
        return persistence;
    }

    public Collection<Inventory> check(Collection<CostType> objects) {
        try {
            HibernateEnvironment.getInstance().beginTransaction();

            SimpleQueryCommand command = (SimpleQueryCommand)getPersistence().createCommand("list");
            command.setType(Inventory.class);
            command.addFilter("costType", Operator.IN, objects);
            return (List<Inventory>)command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }
}
