package org.osbl.inventory;

import org.osbl.inventory.model.*;
import org.osbl.ReferenceChecker;
import org.osbl.ServiceProvider;
import org.osbl.identity.model.Identity;
import org.osbl.persistence.*;
import org.conform.hibernate.HibernateEnvironment;

import java.util.*;

public class InventoryToIdentityReferenceChecker
    implements ReferenceChecker<Inventory, Identity>
{
    private Persistence persistence;

    public Persistence getPersistence() {
        if (persistence == null)
            persistence = (Persistence)ServiceProvider.getInstance().getService("InventoryPersistence");
        return persistence;
    }

    public Collection<Inventory> check(Collection<Identity> objects) {
        try {
            HibernateEnvironment.getInstance().beginTransaction();

            JoinedQueryCommand command = (JoinedQueryCommand)getPersistence().createCommand("list");
            command.setType(Inventory.class);
            command.addFilter("employee", Operator.IN, objects);
            List<Inventory> inventoriesByEmployee = command.execute();

            command.setType(Inventory.class);
            command.clearFilters();
            command.addFilter("supplier", Operator.IN, objects);
            List<Inventory> inventoriesBySupplier = command.execute();

            /*
            command.setType(Inventory.class);
            command.addJoin("allocations", "a");
            command.addFilter("a.costCenter", Operator.IN, objects);
            List inventoriesByCostCenter = command.execute();
            */

            List<Inventory> list = new ArrayList<Inventory>(inventoriesByEmployee.size() + inventoriesBySupplier.size());// + inventoriesByCostCenter.size());
            list.addAll(inventoriesByEmployee);
            list.addAll(inventoriesBySupplier);
            //list.addAll(inventoriesByCostCenter);
            return list;
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }
}
