package org.osbl.inventory;

import org.osbl.ReferenceChecker;
import org.osbl.ServiceProvider;
import org.osbl.identity.model.Identity;
import org.osbl.persistence.*;
import org.osbl.inventory.model.*;
import org.conform.hibernate.HibernateEnvironment;

import java.util.*;

public class InventoryToLocationReferenceChecker
    implements ReferenceChecker<Inventory, Location>
{
    private Persistence persistence;

    public Persistence getPersistence() {
        if (persistence == null)
            persistence = (Persistence)ServiceProvider.getInstance().getService("InventoryPersistence");
        return persistence;
    }

    public Collection<Inventory> check(Collection<Location> objects) {
        try {
            HibernateEnvironment.getInstance().beginTransaction();

            SimpleQueryCommand command = (SimpleQueryCommand)getPersistence().createCommand("list");
            command.setType(Inventory.class);
            command.addFilter("location", Operator.IN, objects);
            return (List<Inventory>)command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }
}
