package org.osbl.inventory.gui;

import org.osbl.client.wings.form.*;
import org.osbl.client.wings.shell.Client;
import org.osbl.persistence.Persistence;
import org.osbl.inventory.model.Allocation;
import org.conform.BeanMeta;
import org.conform.VariationBeanMetaProvider;
import org.conform.modifier.InlineModifier;

public class AllocationList
    extends GenericObjectList
{
    Persistence persistence;

    protected BeanMeta createBeanMeta() {
        return new VariationBeanMetaProvider(Client.getInstance().getBeanMetaProvider()).addModifier(new InlineModifier() {
            protected void configure() {
                property("key").setWritable(false);
                property("percentage").setWritable(false);
                property("amount").setWritable(false);
            }
        }).getBeanMeta(Allocation.class);
    }

    protected ObjectTableModel createModel(BeanMeta beanMeta) {
        return new GenericObjectTableModel(beanMeta, "key", "percentage", "amount");
    }

    public Object getRow(int index) {
        return ((GenericObjectTableModel)getModel()).getRow(index);
    }

    protected Object idOf(Object object) {
        Allocation allocation = (Allocation)object;
        return allocation.getKey();
    }
}
