package org.osbl.inventory.gui;

import org.conform.*;
import org.conform.wings.editor.StringEditor;
import org.conform.validator.StringLengthValidator;
import org.conform.modifier.InlineModifier;
import org.osbl.client.wings.form.*;
import org.osbl.client.wings.form.layouter.*;
import org.osbl.client.wings.shell.Client;
import org.osbl.inventory.model.CostType;

public class CostTypeForm
    extends GenericObjectForm
    implements HierarchicalContextAware
{
    @Override
    protected Object getObject(String path) {
        if (ComponentProvider.ROOT.equals(path))
            return object;

        return null;
    }

    @Override
    protected void setObject(String path, Object object) {
        if (ComponentProvider.ROOT.equals(path))
            this.object = object;
    }

    @Override
    protected Instruction createLayoutInstruction() {
        return new Page(CostType.class.getName(),
            new Division(CostType.class.getName(),
                         new Column(
                             new LabelAndEditor(ComponentProvider.ROOT, "key"),
                             new LabelAndEditor(ComponentProvider.ROOT, "name")
                         ),
                         new Column(
                             new LabelAndEditors("businessobject.created",
                                 new Editor(ComponentProvider.ROOT, "created"),
                                 new Editor(ComponentProvider.ROOT, "createdBy")
                             ),
                             new LabelAndEditors("businessobject.valid",
                                 new Editor(ComponentProvider.ROOT, "validFrom"),
                                 new Editor(ComponentProvider.ROOT, "validUntil")
                             )
                         )
            ),
            new Division("businessobject.description",
                         new Column(
                             new LabelAndEditor(ComponentProvider.ROOT, "description")
                         )
            )
        );
    }

    @Override
    protected BeanMeta createBeanMeta(String path) {
        return new VariationBeanMetaProvider(Client.getInstance().getBeanMetaProvider())
            .addModifier(new InlineModifier() {
                protected void configure() {
                    property("key").setWritable(true);
                    property("path").setApplicable(false);
                    property("tree").setApplicable(false);

                    property("key").setAttribute(StringEditor.COLS, 6);
                }
            })
            .getBeanMeta(CostType.class);
    }

    public void setNode(GenericObjectTreeNode node) {
    }
}
