package org.osbl.inventory.gui;

import org.osbl.client.wings.form.GenericObjectTreeNode;
import org.osbl.client.wings.shell.Client;
import org.osbl.inventory.logic.InventoryLogic;
import org.osbl.inventory.model.CostTypeHierarchy;

import java.util.*;

/**
 * @author hengels
 * @version $Revision$
 */
public class CostTypeHierarchiesTreeNode
    extends GenericObjectTreeNode
{
    public CostTypeHierarchiesTreeNode(String object) {
        setObject(object);
    }

    protected void loadChildren() {
        CostTypeTreeModel model = (CostTypeTreeModel)getModel();
        InventoryLogic logic = model.getTreeLogic();
        List<CostTypeHierarchy> costTypes = logic.trees();
        children = new ArrayList<GenericObjectTreeNode>();
        for (Iterator<CostTypeHierarchy> iterator = costTypes.iterator(); iterator.hasNext();) {
            CostTypeHierarchy costTypeHierarchy = iterator.next();
            CostTypeHierarchyTreeNode child = new CostTypeHierarchyTreeNode(costTypeHierarchy);
            children.add(child);
            child.setParent(this);
        }
        sortChildren();
    }

    public boolean getAllowsChildren() {
        return true;
    }

    public boolean isLeaf() {
        return false;
    }

    public String toString() {
        return Client.getInstance().getResourceProvider().getMessage("org.osbl.inventory.model.CostType.editor.title");
    }

    public Class getObjectType() {
        return String.class;
    }

    public Class[] getChildTypes() {
        return new Class[] { CostTypeHierarchy.class };
    }

    public String loadObject() {
        return (String)object;
    }
}
