package org.osbl.inventory.gui;

import org.osbl.client.wings.form.GenericObjectTreeNode;
import org.osbl.inventory.logic.InventoryLogic;
import org.osbl.inventory.model.CostType;
import org.osbl.inventory.model.CostTypeHierarchy;
import org.osbl.persistence.LoadCommand;

import java.util.*;

/**
 * @author hengels
 * @version $Revision$
 */
public class CostTypeHierarchyTreeNode
    extends GenericObjectTreeNode<CostTypeHierarchy>
{
    public CostTypeHierarchyTreeNode() {
    }

    public CostTypeHierarchyTreeNode(CostTypeHierarchy object) {
        setObject(object);
    }

    public CostTypeHierarchiesTreeNode getParent() {
        return (CostTypeHierarchiesTreeNode)parent;
    }

    protected void loadChildren() {
        CostTypeTreeModel model = (CostTypeTreeModel)getModel();
        InventoryLogic logic = model.getTreeLogic();
        List<CostType> groups = logic.roots(object.getId());
        children = new ArrayList<GenericObjectTreeNode>(groups.size());
        for (Iterator<CostType> iterator = groups.iterator(); iterator.hasNext();) {
            CostType costType = iterator.next();
            CostTypeTreeNode child = new CostTypeTreeNode(costType);
            children.add(child);
            child.setParent(this);
        }
        sortChildren();
    }

    public boolean getAllowsChildren() {
        return true;
    }

    public boolean isLeaf() {
        return false;
    }

    public Class getObjectType() {
        return CostTypeHierarchy.class;
    }

    public Class[] getChildTypes() {
        return new Class[] { CostType.class };
    }

    public CostTypeHierarchy loadObject() {
        CostTypeHierarchy object = getObject();
        LoadCommand loadCommand = (LoadCommand)((CostTypeTreeModel)getModel()).getPersistence().createCommand("load");
        loadCommand.setType(CostTypeHierarchy.class);
        loadCommand.setId(object.getId());
        object = (CostTypeHierarchy)loadCommand.execute();
        return object;
    }
}
