package org.osbl.inventory.gui;

import org.osbl.client.wings.form.GenericObjectTreeList;
import org.osbl.client.wings.form.GenericObjectTreeNode;
import org.osbl.persistence.RevertCommand;
import org.wings.SComponent;
import org.wings.STree;
import org.wings.tree.SDefaultTreeCellRenderer;

import javax.swing.tree.TreeSelectionModel;

public class CostTypeTreeList
    extends GenericObjectTreeList
{
    public CostTypeTreeList() {
        setModel(new CostTypeTreeModel());
        getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        setCellRenderer(new SDefaultTreeCellRenderer() {
            public SComponent getTreeCellRendererComponent(STree tree, Object value, boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus) {
                SComponent component = super.getTreeCellRendererComponent(tree, value, selected, expanded, leaf, row, hasFocus);

                if (value instanceof CostTypeHierarchyTreeNode)
                    setIcon(InventoryIcons.COST_TYPE_HIERARCHY);
                else if (value instanceof CostTypeTreeNode)
                    setIcon(InventoryIcons.COST_TYPE);

                return component;
            }
        });
    }

    public void refresh() {
    }
}
