package org.osbl.inventory.gui;

import org.osbl.ServiceProvider;
import org.osbl.client.wings.form.GenericObjectTreeModel;
import org.osbl.inventory.logic.InventoryLogic;
import org.osbl.inventory.model.CostType;
import org.osbl.inventory.model.CostTypeHierarchy;
import org.osbl.persistence.Persistence;

/**
 * @author hengels
 * @version $Revision$
 */
public class CostTypeTreeModel
    extends GenericObjectTreeModel
{
    Persistence persistence = (Persistence)ServiceProvider.getInstance().getService("CostTypePersistence");
    InventoryLogic inventoryLogic = (InventoryLogic)ServiceProvider.getInstance().getService("InventoryLogic");

    {
        map.put(CostTypeHierarchy.class, CostTypeHierarchyTreeNode.class);
        map.put(CostType.class, CostTypeTreeNode.class);
    }

    public CostTypeTreeModel() {
        super(new CostTypeHierarchiesTreeNode("Root"));
        getRoot().setModel(this);
    }

    public InventoryLogic getTreeLogic() {
        return inventoryLogic;
    }

    public Persistence getPersistence() {
        return persistence;
    }
}
