package org.osbl.inventory.gui;

import org.osbl.client.wings.form.*;
import org.osbl.inventory.model.Location;
import org.osbl.persistence.*;
import org.osbl.ServiceProvider;
import org.conform.hibernate.HibernateEnvironment;


public class LocationEditor
    extends GenericObjectEditor
{
    Persistence persistence = (Persistence)ServiceProvider.getInstance().getService("LocationPersistence");

    protected ObjectForm initializeForm() {
        return new LocationForm();
    }

    protected ObjectList initializeList() {
        return new LocationList();
    }

    public Class getType() {
        return Location.class;
    }

    public void saveObject(Object object) {
        SaveOrUpdateCommand command = (SaveOrUpdateCommand)persistence.createCommand("save");
        command.setObject(object);
        try {
            HibernateEnvironment.getInstance().beginTransaction();
            command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }

    public void deleteObject(Object object) {
        DeleteCommand command = (DeleteCommand)persistence.createCommand("delete");
        command.setObject(object);
        try {
            HibernateEnvironment.getInstance().beginTransaction();
            command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }

    public void revertObject(Object object) {
        RevertCommand command = (RevertCommand)persistence.createCommand("revert");
        command.setObject(object);
        try {
            HibernateEnvironment.getInstance().beginTransaction();
            command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }
}
