package org.osbl.inventory.gui;

import org.conform.BeanMeta;
import org.conform.VariationBeanMetaProvider;
import org.conform.modifier.InlineModifier;
import org.osbl.client.wings.form.ComponentProvider;
import org.osbl.client.wings.form.GenericObjectForm;
import org.osbl.client.wings.form.layouter.*;
import org.osbl.client.wings.shell.Client;
import org.osbl.inventory.model.Location;

public class LocationForm
    extends GenericObjectForm
{
    protected Instruction createLayoutInstruction() {
        return new PageSet(
            new Page(Location.class.getName(),
                new Division(Location.class.getName(),
                    new Column(
                        new LabelAndEditor(ComponentProvider.ROOT, "key"),
                        new LabelAndEditor(ComponentProvider.ROOT, "name")
                    ),
                    new Column(
                        new LabelAndEditors("businessobject.created",
                            new Editor(ComponentProvider.ROOT, "created"),
                            new Editor(ComponentProvider.ROOT, "createdBy")
                        )
                    )
                )
            )
        );
    }

    protected Object getObject(String path) {
        return object;
    }

    protected void setObject(String path, Object object) {
        this.object = object;
    }

    protected BeanMeta createBeanMeta(String path) {
        VariationBeanMetaProvider provider = new VariationBeanMetaProvider(Client.getInstance().getBeanMetaProvider());
        provider.addModifier(new InlineModifier() {
            protected void configure() {
                property("key").setWritable(true);
            }
        });
        return provider.getBeanMeta(Location.class);
    }
}
