package org.osbl.inventory.gui;

import org.conform.BeanMeta;
import org.conform.VariationBeanMetaProvider;
import org.conform.hibernate.HibernateEnvironment;
import org.conform.modifier.InlineModifier;
import org.osbl.client.wings.form.*;
import org.osbl.client.wings.shell.Client;
import org.osbl.inventory.model.Location;
import org.osbl.persistence.*;
import org.osbl.identity.gui.SimpleQueryCommandTableModel;
import org.osbl.ServiceProvider;

import java.io.Serializable;

public class LocationList
    extends GenericObjectList
{
    private Persistence persistence;

    protected BeanMeta createBeanMeta() {
        return new VariationBeanMetaProvider(Client.getInstance().getBeanMetaProvider()).addModifier(new InlineModifier() {
            protected void configure() {
                property("id").setWritable(false);
                property("key").setWritable(false);
                property("created").setWritable(false);
                property("createdBy").setWritable(false);
                property("name").setWritable(false);
            }
        }).getBeanMeta(Location.class);
    }

    protected ObjectTableModel createModel(BeanMeta beanMeta) {
        SimpleQueryCommand command = (SimpleQueryCommand)getCommandFactory().createCommand("list");
        command.setType(Location.class);
        SimpleQueryCommandTableModel tableModel = new SimpleQueryCommandTableModel(command, beanMeta, "key", "name");
        tableModel.setSortableColumns("key", "name");
        tableModel.setFilterableColumns("key", "name");
        return tableModel;
    }

    public Object getRow(int index) {
        LoadCommand command = (LoadCommand)getCommandFactory().createCommand("load");
        command.setType(Location.class);
        command.setId((Serializable)((ObjectTableModel)getModel()).getRowId(index));
        try {
            HibernateEnvironment.getInstance().beginTransaction();
            return command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }

    public Persistence getCommandFactory() {
        if (persistence == null)
            persistence = (Persistence)ServiceProvider.getInstance().getService("LocationPersistence");
        return persistence;
    }
}
