package org.osbl.inventory.model;

import org.osbl.identity.model.Identity;
import org.conform.Property;
import org.conform.validator.NumberRange;

import java.math.BigDecimal;

public class Allocation
{
    String key;
    @Property (mandatory = "true")
    Identity costCenter;
    @Property (mandatory = "true")
    @NumberRange (from = "0", fromInclusive = false, until = "100", untilInclusive = true)
    BigDecimal percentage;
    @Property (mandatory = "true")
    @NumberRange (from = "0", fromInclusive = false)
    BigDecimal amount;

    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    public Identity getCostCenter() {
        return costCenter;
    }

    public void setCostCenter(Identity costCenter) {
        this.costCenter = costCenter;
    }

    public BigDecimal getPercentage() {
        return percentage;
    }

    public void setPercentage(BigDecimal percentage) {
        this.percentage = percentage;
    }

    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }
}
