package org.osbl.inventory.model;

import org.osbl.persistence.model.Entity;
import org.osbl.identity.model.Identity;
import org.conform.Property;
import org.conform.validator.NumberRange;

import java.sql.Date;
import java.math.BigDecimal;
import java.util.List;

public class Inventory
    extends Entity
{
    String barcode;
    @Property (mandatory = "true")
    String name;
    String description;

    List<Allocation> allocations;
    @Property (mandatory = "true")
    CostType costType;
    Identity employee;
    Location location;

    Identity supplier;
    Date guarantee;
    @Property (mandatory = "true")
    @NumberRange (from = "0", fromInclusive = true)
    BigDecimal costs;
    boolean recurringCosts;

    State state;

    public String getBarcode() {
        return barcode;
    }

    public void setBarcode(String barcode) {
        this.barcode = barcode;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public List<Allocation> getAllocations() {
        return allocations;
    }

    public void setAllocations(List<Allocation> allocations) {
        this.allocations = allocations;
    }

    public CostType getCostType() {
        return costType;
    }

    public void setCostType(CostType costType) {
        this.costType = costType;
    }

    public Identity getEmployee() {
        return employee;
    }

    public void setEmployee(Identity employee) {
        this.employee = employee;
    }

    public Location getLocation() {
        return location;
    }

    public void setLocation(Location location) {
        this.location = location;
    }

    public Identity getSupplier() {
        return supplier;
    }

    public void setSupplier(Identity supplier) {
        this.supplier = supplier;
    }

    public Date getGuarantee() {
        return guarantee;
    }

    public void setGuarantee(Date guarantee) {
        this.guarantee = guarantee;
    }

    public BigDecimal getCosts() {
        return costs;
    }

    public void setCosts(BigDecimal costs) {
        this.costs = costs;
    }

    public boolean isRecurringCosts() {
        return recurringCosts;
    }

    public void setRecurringCosts(boolean recurringCosts) {
        this.recurringCosts = recurringCosts;
    }

    public State getState() {
        return state;
    }

    public void setState(State state) {
        this.state = state;
    }
}
