package org.osbl.authorization;

import org.osbl.*;
import org.osbl.authorization.model.Profile;
import org.osbl.identity.model.*;
import org.osbl.identity.IdentityLocator;
import org.osbl.plugin.PluginManager;
import org.osbl.plugin.Extension;

public class AuthorizationModule
    implements Module
{
    ObjectLocators objectLocators;
    ReferenceCheckers referenceCheckers;

    public void setReferenceCheckers(ReferenceCheckers referenceCheckers) {
        this.referenceCheckers = referenceCheckers;
    }

    public void setObjectLocators(ObjectLocators objectLocators) {
        this.objectLocators = objectLocators;
    }

    public void initialize() {
        referenceCheckers.registerReferenceChecker(Profile.class, new UserToProfileReferenceChecker());
        objectLocators.registerObjectLocator(Profile.class, new ProfileLocator());
    }
}
