package org.osbl.authorization;

import org.osbl.identity.model.Identity;
import org.osbl.identity.model.User;
import org.osbl.ReferenceChecker;
import org.osbl.ServiceProvider;
import org.osbl.authorization.model.Profile;
import org.osbl.authorization.logic.AuthorizationLogic;
import org.osbl.persistence.*;
import org.conform.hibernate.HibernateEnvironment;

import java.util.*;

public class UserToProfileReferenceChecker
    implements ReferenceChecker<Identity, Profile>
{
    private AuthorizationLogic authorizationLogic;

    public AuthorizationLogic getAuthorizationLogic() {
        if (authorizationLogic == null)
            authorizationLogic = (AuthorizationLogic)ServiceProvider.getInstance().getService("AuthorizationLogic");
        return authorizationLogic;
    }

    public Collection<Identity> check(Collection<Profile> objects) {
        try {
            HibernateEnvironment.getInstance().beginTransaction();
            List<Identity> identities = new ArrayList<Identity>();
            for (Profile profile : objects) {
                identities.addAll(getAuthorizationLogic().identitiesWithProfile(profile));
            }
            return identities;
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }
}
