package org.osbl.authorization.gui;

import org.osbl.client.wings.form.*;
import org.osbl.persistence.*;
import org.osbl.ServiceProvider;
import org.osbl.authorization.model.Profile;
import org.conform.hibernate.HibernateEnvironment;


public class ProfileEditor
    extends GenericObjectEditor
{
    Persistence persistence = (Persistence)ServiceProvider.getInstance().getService("AuthorizationPersistence");

    protected ObjectForm initializeForm() {
        return new ProfileForm();
    }

    protected ObjectList initializeList() {
        return new ProfileList();
    }

    public Class getType() {
        return Profile.class;
    }

    public void saveObject(Object object) {
        SaveOrUpdateCommand command = (SaveOrUpdateCommand)persistence.createCommand("save");
        command.setObject(object);
        try {
            HibernateEnvironment.getInstance().beginTransaction();
            command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }

    public void deleteObject(Object object) {
        DeleteCommand command = (DeleteCommand)persistence.createCommand("delete");
        command.setObject(object);
        try {
            HibernateEnvironment.getInstance().beginTransaction();
            command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }

    public void revertObject(Object object) {
        RevertCommand command = (RevertCommand)persistence.createCommand("revert");
        command.setObject(object);
        try {
            HibernateEnvironment.getInstance().beginTransaction();
            command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }
}
