package org.osbl.domain.gui;

import org.osbl.client.wings.form.*;
import org.osbl.client.wings.shell.Environment;
import org.osbl.client.wings.XButton;
import org.osbl.ServiceProvider;
import org.osbl.domain.model.Domain;
import org.osbl.domain.logic.DomainLogic;


public class DomainEditor
    extends GenericObjectEditor
{
    DomainLogic domainLogic = (DomainLogic)ServiceProvider.getInstance().getService("DomainLogic");

    protected ObjectForm initializeForm() {
        return new DomainForm();
    }

    protected ObjectList initializeList() {
        return new DomainList();
    }

    public Class getType() {
        return Domain.class;
    }

    public void saveObject(Object object) {
        domainLogic.updateDomain((Domain)object);
    }

    public void deleteObject(Object object) {
    }

    public void revertObject(Object object) {
    }

    protected void formControls(Environment environment) {
        environment.addControl(new XButton(listAction));
        environment.addControl(new XButton(previousAction));
        environment.addControl(new XButton(nextAction));
        environment.addControl(new XButton(saveAction));
    }

    protected void listControls(Environment environment) {
    }
}
