package org.osbl.domain.gui;

import org.osbl.client.web.spring.SpringWebModule;
import org.osbl.client.wings.form.Editors;
import org.osbl.client.wings.action.ShowEditorAction;
import org.osbl.client.wings.navigation.NavigationStructure;
import org.osbl.client.action.ActionRegistry;
import org.osbl.ItemRegistry;
import org.osbl.domain.model.Domain;
import org.osbl.domain.model.DomainValue;
import org.osbl.item.BeanAuthorizationCollector;
import org.osbl.item.BeanLocalizationCollector;

public class DomainWebModule
    extends SpringWebModule
{
    ItemRegistry authorizationItems;
    ItemRegistry localizationItems;

    public void setAuthorizationItems(ItemRegistry authorizationItems) {
        this.authorizationItems = authorizationItems;
    }

    public void setLocalizationItems(ItemRegistry localizationItems) {
        this.localizationItems = localizationItems;
    }

    public void initialize() {
        authorizationItems.addItems(new BeanAuthorizationCollector(Domain.class));
        authorizationItems.addItems(new BeanAuthorizationCollector(DomainValue.class));

        localizationItems.addItems(new BeanLocalizationCollector(Domain.class));
        localizationItems.addItems(new BeanLocalizationCollector(DomainValue.class));
    }
}
