package org.osbl.identity;

import org.osbl.*;
import org.osbl.ObjectLocators;
import org.osbl.identity.model.*;
import org.osbl.plugin.PluginManager;
import org.osbl.plugin.Extension;

public class IdentityModule
    implements Module
{
    PluginManager pluginManager;
    ObjectLocators objectLocators;

    public void setPluginManager(PluginManager pluginManager) {
        this.pluginManager = pluginManager;
    }

    public void setObjectLocators(ObjectLocators objectLocators) {
        this.objectLocators = objectLocators;
    }

    public void initialize() {
        pluginManager.registerExtension(new Extension("UserConcrete",   Identity.class.getName() + ".concrete", User.class));
        pluginManager.registerExtension(new Extension("PersonConcrete", Identity.class.getName() + ".concrete", Person.class));
        pluginManager.registerExtension(new Extension("DepartmentConcrete", Identity.class.getName() + ".concrete", Department.class));

        objectLocators.registerObjectLocator(Identity.class, new IdentityLocator());
    }
}
