package org.osbl.identity.gui;

import org.osbl.client.wings.form.*;
import org.osbl.client.wings.shell.Client;
import org.osbl.persistence.Persistence;
import org.osbl.identity.model.Address;
import org.conform.BeanMeta;
import org.conform.VariationBeanMetaProvider;
import org.conform.modifier.InlineModifier;

public class AddressList
    extends GenericObjectList
{
    Persistence persistence;

    protected BeanMeta createBeanMeta() {
        return new VariationBeanMetaProvider(Client.getInstance().getBeanMetaProvider()).addModifier(new InlineModifier() {
            protected void configure() {
                property("street").setWritable(false);
                property("postcode").setWritable(false);
                property("city").setWritable(false);
            }
        }).getBeanMeta(Address.class);
    }

    protected ObjectTableModel createModel(BeanMeta beanMeta) {
        return new GenericObjectTableModel(beanMeta, "street", "postcode", "city");
    }

    public Object getRow(int index) {	// was protected
        return ((GenericObjectTableModel)getModel()).getRow(index);
    }
}
