package org.osbl.identity.gui;

import org.osbl.client.wings.form.*;
import org.osbl.ServiceProvider;
import org.osbl.persistence.*;
import org.osbl.identity.model.Identity;
import org.conform.hibernate.HibernateEnvironment;

public class IdentityEditor
    extends GenericObjectEditor
{
    private Persistence persistence;

    protected ObjectForm initializeForm() {
        return new IdentityForm();
    }

    protected ObjectList initializeList() {
        return new IdentityList();
    }

    public Class getType() {
        return Identity.class;
    }

    public void saveObject(Object object) {
        SaveOrUpdateGeneralCommand command = (SaveOrUpdateGeneralCommand)getPersistence().createCommand("save");
        command.setObject(object);
        try {
            HibernateEnvironment.getInstance().beginTransaction();
            command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }

    public void deleteObject(Object object) {
        DeleteCommand command = (DeleteCommand)getPersistence().createCommand("delete");
        command.setObject(object);
        try {
            HibernateEnvironment.getInstance().beginTransaction();
            command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }

    public void revertObject(Object object) {
        RevertCommand command = (RevertCommand)getPersistence().createCommand("revert");
        command.setObject(object);
        try {
            HibernateEnvironment.getInstance().beginTransaction();
            command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }

    public Persistence getPersistence() {
        if (persistence == null)
            persistence = (Persistence)ServiceProvider.getInstance().getService("IdentityPersistence");
        return persistence;
    }
}
