package org.osbl.issue.gui;

import org.osbl.client.wings.concern.ObjectFormViewModes;
import org.osbl.issue.model.Issue;
import org.conform.modifier.InlineModifier;
import org.conform.wings.Editor;
import org.conform.wings.editor.BooleanEditor;
import org.conform.*;

public class AttendToIssueForm
    extends IssueForm
{
    public AttendToIssueForm() {
        addViewModeVariation(ObjectFormViewModes.ACTIVITY_VIEW, new InlineModifier() {
            protected void configure() {
                if (Issue.class == bean().getType()) {
                    property("key").setWritable(false);
                    property("name").setWritable(false);
                    property("due").setWritable(false);
                    property("assignee").setWritable(false);
                    property("links").setWritable(false);
                    property("done").setWritable(false);
                    property("description").setWritable(false);

                    property("description").setWritable(true);
                    property("links").setAttribute(Editor.CUSTOM_EDITOR, new ClickableLinksEditor());
                    property("done").setWritable(true);
                    property("done").setAttribute(DefaultBeanData.PROPERTY_DATA_CLASS, NowOrNeverPropertyData.class.getName());
                    property("done").setAttribute(org.conform.wings.Editor.CUSTOM_EDITOR, new BooleanEditor());
                }
            }
        });
        setViewMode(ObjectFormViewModes.ACTIVITY_VIEW);
    }
}
