package org.osbl.issue.gui;

import org.osbl.client.wings.concern.ObjectFormViewModes;
import org.osbl.client.wings.form.editor.OneToManyInlineEditor;
import org.osbl.issue.model.Issue;
import org.conform.modifier.InlineModifier;

public class CreateIssueForm
    extends IssueForm
{
    public CreateIssueForm() {
        addViewModeVariation(ObjectFormViewModes.CREATE_VIEW, new InlineModifier() {
            protected void configure() {
                if (Issue.class == bean().getType()) {
                    property("key").setWritable(false);
                    property("name").setWritable(false);
                    property("due").setWritable(false);
                    property("assignee").setWritable(false);
                    property("links").setWritable(false);
                    property("done").setWritable(false);
                    property("description").setWritable(false);

                    property("key").setWritable(true);
                    property("due").setWritable(true);
                    property("assignee").setWritable(true);
                    property("links").setWritable(true);
                    property("done").setWritable(false);
                    property("description").setWritable(true);

                    property("links").setAttribute(org.conform.wings.Editor.CUSTOM_EDITOR, new OneToManyInlineEditor());
                }
            }
        });
        setViewMode(ObjectFormViewModes.CREATE_VIEW);
    }
}
