package org.osbl.issue.gui;

import org.osbl.client.web.WebModule;
import org.osbl.plugin.PluginManager;
import org.osbl.plugin.Extension;
import org.osbl.ItemRegistry;
import org.osbl.issue.model.Issue;
import org.osbl.issue.model.Link;
import org.osbl.item.BeanAuthorizationCollector;
import org.osbl.item.BeanLocalizationCollector;

public class IssueWebModule
    implements WebModule
{
    ItemRegistry authorizationItems;
    ItemRegistry localizationItems;

    PluginManager pluginManager;

    public void setAuthorizationItems(ItemRegistry authorizationItems) {
        this.authorizationItems = authorizationItems;
    }

    public void setLocalizationItems(ItemRegistry localizationItems) {
        this.localizationItems = localizationItems;
    }

    public void setPluginManager(PluginManager pluginManager) {
        this.pluginManager = pluginManager;
    }

    public void initialize() {
        authorizationItems.addItems(new BeanAuthorizationCollector(Issue.class));
        authorizationItems.addItems(new BeanAuthorizationCollector(Link.class));

        localizationItems.addItems(new BeanLocalizationCollector(Issue.class));
        localizationItems.addItems(new BeanLocalizationCollector(Link.class));

        pluginManager.registerExtension(new Extension("Issue Tool", "org.osbl.client.wings.form.formTools", IssuingTool.class));
    }
}
