package org.osbl.issue.gui;

import org.conform.*;

/**
 * @author hengels
 * @version $Revision: 840 $
 */
public class NowOrNeverPropertyData
    extends DefaultPropertyData
{
    public NowOrNeverPropertyData(DefaultBeanData beanData, PropertyMeta property) {
        super(beanData, property);
    }

    public Object getValue() {
        return super.getValue() != null;
    }

    public void setValue(Object value) {
        if (Boolean.TRUE.equals(value)) {
            Class type = getPropertyMeta().getType();
            if (java.util.Date.class.equals(type))
                super.setValue(new java.util.Date());
            else if (java.sql.Timestamp.class.equals(type))
                super.setValue(new java.sql.Timestamp(System.currentTimeMillis()));
            else if (java.sql.Date.class.equals(type))
                super.setValue(new java.sql.Date(System.currentTimeMillis()));
            else if (java.sql.Time.class.equals(type))
                super.setValue(new java.sql.Time(System.currentTimeMillis()));
            else if (java.util.Calendar.class.equals(type))
                super.setValue(java.util.Calendar.getInstance());
        }
        else
            super.setValue(null);
    }
}
