package org.osbl.issue.model;

import org.conform.*;
import org.osbl.persistence.model.Entity;

import java.util.Set;
import java.util.List;
import java.sql.Date;
import java.sql.Timestamp;

@Bean (
    format = FormatType.CUSTOM,
    formatClass = "org.osbl.issue.model.IssueFormat"
)
public class Issue
    extends Entity
{
    @Property (mandatory = "true")
    Date due;
    String assignee;
    @Property (mandatory = "true")
    String name;
    String description;
    List<Link> links;
    Timestamp done;

    public Date getDue() {
        return due;
    }

    public void setDue(Date due) {
        this.due = due;
    }

    public String getAssignee() {
        return assignee;
    }

    public void setAssignee(String assignee) {
        this.assignee = assignee;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public List<Link> getLinks() {
        return links;
    }

    public void setLinks(List<Link> links) {
        this.links = links;
    }

    public Timestamp getDone() {
        return done;
    }

    public void setDone(Timestamp done) {
        this.done = done;
    }

    public String toString() {
        return getKey();
    }
}
