package org.osbl.orga;

import org.osbl.ReferenceChecker;
import org.osbl.ServiceProvider;
import org.osbl.identity.model.Identity;
import org.osbl.orga.model.Group;
import org.osbl.orga.model.Member;
import org.osbl.persistence.*;
import org.conform.hibernate.HibernateEnvironment;

import java.util.*;

public class MemberToIdentityReferenceChecker
    implements ReferenceChecker<Member, Identity>
{
    private Persistence persistence;

    public Persistence getPersistence() {
        if (persistence == null)
            persistence = (Persistence)ServiceProvider.getInstance().getService("OrgaPersistence");
        return persistence;
    }

    public Collection<Member> check(Collection<Identity> objects) {
        try {
            HibernateEnvironment.getInstance().beginTransaction();

            JoinedQueryCommand command = (JoinedQueryCommand)getPersistence().createCommand("list");
            command.setType(Member.class);
            command.clearFilters();
            command.addFilter("identity", Operator.IN, objects);
            return (List<Member>)command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }
}
