package org.osbl.orga;

import org.osbl.*;
import org.osbl.orga.model.*;
import org.osbl.identity.model.*;
import org.osbl.plugin.PluginManager;

public class OrgaModule
    implements Module
{
    PluginManager pluginManager;
    ReferenceCheckers referenceCheckers;
    ObjectLocators objectLocators;

    public void setPluginManager(PluginManager pluginManager) {
        this.pluginManager = pluginManager;
    }

    public void setObjectLocators(ObjectLocators objectLocators) {
        this.objectLocators = objectLocators;
    }

    public void setReferenceCheckers(ReferenceCheckers referenceCheckers) {
        this.referenceCheckers = referenceCheckers;
    }

    public void initialize() {
        referenceCheckers.registerReferenceChecker(Identity.class, new MemberToIdentityReferenceChecker());
        referenceCheckers.registerReferenceChecker(Identity.class, new GroupToIdentityReferenceChecker());

        objectLocators.registerObjectLocator(Group.class, new GroupLocator());
        objectLocators.registerObjectLocator(Organisation.class, new OrganisationLocator());
        objectLocators.registerObjectLocator(Membership.class, new MembershipLocator());
    }
}
