package org.osbl.orga.gui;

import org.osbl.client.wings.form.*;
import org.osbl.orga.model.Member;
import org.osbl.persistence.*;
import org.osbl.ServiceProvider;
import org.conform.hibernate.HibernateEnvironment;

public class MemberEditor
    extends GenericObjectEditor
{
    Persistence persistence = (Persistence)ServiceProvider.getInstance().getService("OrgaPersistence");

    protected ObjectForm initializeForm() {
        return new MemberForm();
    }

    protected ObjectList initializeList() {
        return new MemberList();
    }

    public Class getType() {
        return Member.class;
    }

    protected String linkPropertyName() {
        return "identity";
    }

    public void saveObject(Object object) {
        SaveOrUpdateCommand command = (SaveOrUpdateCommand)persistence.createCommand("save");
        command.setObject(object);
        try {
            HibernateEnvironment.getInstance().beginTransaction();
            command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }

    public void deleteObject(Object object) {
        DeleteCommand command = (DeleteCommand)persistence.createCommand("delete");
        command.setObject(object);
        try {
            HibernateEnvironment.getInstance().beginTransaction();
            command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }

    public void revertObject(Object object) {
        RevertCommand command = (RevertCommand)persistence.createCommand("revert");
        command.setObject(object);
        try {
            HibernateEnvironment.getInstance().beginTransaction();
            command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }
}
