package org.osbl.orga.gui;

import org.osbl.client.wings.form.GenericObjectForm;
import org.osbl.client.wings.form.ComponentProvider;
import org.osbl.client.wings.form.format.BusinessObjectFormat;
import org.osbl.client.wings.form.editor.OneToManyCompositionEditor;
import org.osbl.client.wings.form.layouter.*;
import org.osbl.client.wings.shell.Client;
import org.osbl.identity.model.Identity;
import org.osbl.orga.model.Member;
import org.conform.BeanMeta;
import org.conform.VariationBeanMetaProvider;
import org.conform.wings.editor.DefaultEditor;
import org.conform.modifier.InlineModifier;

public class MemberForm
    extends GenericObjectForm
{
    public MemberForm() {
    }

    protected Instruction createLayoutInstruction() {
        return new PageSet(
            new Page(Member.class.getName(),
                new Division(
                    new Column(
                        new Title(Member.class.getName()),
                        new LabelAndEditor(ComponentProvider.ROOT, "identity"),
                        new LabelAndEditor(ComponentProvider.ROOT, "relationships")
                    )
                ))
        );
    }

    protected Object getObject(String path) {
        return object;
    }

    protected void setObject(String path, Object object) {
        this.object = object;
    }

    public void setObject(Object object) {
        context.putObject("member", object);
        if (object != null && context.getObject("organisation") == null)
            context.putObject("organisation", ((Member)object).getOrganisation());
        super.setObject(object);
    }

    protected BeanMeta createBeanMeta(String path) {
        VariationBeanMetaProvider provider = new VariationBeanMetaProvider(Client.getInstance().getBeanMetaProvider());
        provider.addModifier(new InlineModifier() {
            protected void configure() {
                property("identity").setAttribute(org.conform.wings.Editor.CUSTOM_EDITOR, new DefaultEditor());
                property("identity").setFormat(new BusinessObjectFormat());

                property("relationships").setAttribute(org.conform.wings.Editor.CUSTOM_EDITOR, new OneToManyCompositionEditor());
                RelationshipEditor relationshipEditor = new RelationshipEditor();
                relationshipEditor.setContext(getContext());
                property("relationships").setAttribute("objectEditor", relationshipEditor);
            }
        });
        return provider.getBeanMeta(Member.class);
    }
}
