package org.osbl.orga.gui;

import org.osbl.orga.model.*;
import org.osbl.client.wings.form.GenericObjectTreeNode;
import org.osbl.persistence.LoadCommand;
import org.hibernate.Hibernate;

import java.util.*;

/**
 * @author hengels
 * @version $Revision$
 */
public class MembershipTreeNode
    extends GenericObjectTreeNode<Membership>
{
    public MembershipTreeNode() {
    }

    public MembershipTreeNode(Membership membership) {
        this.object = membership;
    }

    public GroupTreeNode getParent() {
        return (GroupTreeNode)parent;
    }

    protected void loadChildren() {
        children = Collections.emptyList();
    }

    public void connect() {
        Membership membership = getObject();
        Group group = (Group)parent.getObject();
        List<Membership> memberships = group.getMemberships();
        if (membership.getGroup() == null) {
            if (memberships == null)
                group.setMemberships(new ArrayList<Membership>());
            memberships.add(membership);
            membership.setGroup(group);
        }
        else {
            Long id = membership.getId();
            for (Iterator<Membership> iterator = memberships.iterator(); iterator.hasNext();) {
                Membership child = iterator.next();
                if (child.getId().equals(id)) {
                    int index = memberships.indexOf(child);
                    memberships.set(index, membership);
                    break;
                }
            }
        }
    }

    public boolean getAllowsChildren() {
        return false;
    }

    public boolean isLeaf() {
        return true;
    }

    public Class getObjectType() {
        return Membership.class;
    }

    public Class[] getChildTypes() {
        return new Class[0];
    }

    public Membership loadObject() {
        Membership object = getObject();
        LoadCommand loadCommand = (LoadCommand)((OrgaTreeModel)getModel()).getPersistence().createCommand("load");
        loadCommand.setType(Membership.class);
        loadCommand.setId(object.getId());
        object = (Membership)loadCommand.execute();
        Hibernate.initialize(object.getMember());
        Hibernate.initialize(object.getGroup());
        return object;
    }
}
