package org.osbl.orga.gui;

import org.osbl.client.wings.form.*;
import org.osbl.persistence.Command;
import org.osbl.persistence.RevertCommand;
import org.wings.*;
import org.wings.tree.SDefaultTreeCellRenderer;

import javax.swing.tree.*;

public class OrgaTreeList
    extends GenericObjectTreeList
{
    public OrgaTreeList() {
        setModel(new OrgaTreeModel());
        getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        setCellRenderer(new SDefaultTreeCellRenderer() {
            public SComponent getTreeCellRendererComponent(STree tree, Object value, boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus) {
                SComponent component = super.getTreeCellRendererComponent(tree, value, selected, expanded, leaf, row, hasFocus);

                if (value instanceof OrganisationTreeNode)
                    setIcon(OrgaIcons.ORGANISATION);
                else if (value instanceof GroupTreeNode)
                    setIcon(OrgaIcons.GROUP);
                else if (value instanceof MembershipTreeNode)
                    setIcon(OrgaIcons.MEMBER);

                return component;
            }
        });
    }

    public void refresh() {
    }
}
