package org.osbl.orga.gui;

import javax.swing.*;

import org.osbl.orga.logic.OrgaStructureLogic;
import org.osbl.orga.model.*;
import org.osbl.ServiceProvider;
import org.osbl.persistence.Persistence;
import org.osbl.client.wings.form.GenericObjectTreeModel;

/**
 * @author hengels
 * @version $Revision$
 */
public class OrgaTreeModel
    extends GenericObjectTreeModel
{
    Persistence persistence = (Persistence)ServiceProvider.getInstance().getService("OrgaPersistence");
    OrgaStructureLogic orgaStructureLogic = (OrgaStructureLogic)ServiceProvider.getInstance().getService("OrgaStructureLogic");

    {
        map.put(Organisation.class, OrganisationTreeNode.class);
        map.put(Group.class, GroupTreeNode.class);
        map.put(Membership.class, MembershipTreeNode.class);
    }

    public OrgaTreeModel() {
        super(new OrganisationsTreeNode("Root"));
        getRoot().setModel(this);
    }

    public OrgaStructureLogic getTreeLogic() {
        return orgaStructureLogic;
    }

    public Persistence getPersistence() {
        return persistence;
    }

    private ComboBoxModel orgaListModel;

    public ComboBoxModel getOrgaListModel() {
        if (orgaListModel == null) {
            orgaListModel = new OrgaListModel((OrganisationsTreeNode)getRoot());
        }
        return orgaListModel;
    }
}
