package org.osbl.orga.gui;

import java.util.*;

import org.osbl.orga.logic.OrgaStructureLogic;
import org.osbl.orga.model.Organisation;
import org.osbl.client.wings.form.GenericObjectTreeNode;
import org.osbl.client.wings.form.ObjectContext;

/**
 * @author hengels
 * @version $Revision$
 */
public class OrganisationsTreeNode
    extends GenericObjectTreeNode
{
    public OrganisationsTreeNode() {
    }

    public OrganisationsTreeNode(String object) {
        this.object = object;
    }

    protected void loadChildren() {
        OrgaTreeModel model = (OrgaTreeModel)getModel();
        OrgaStructureLogic logic = model.getTreeLogic();
        List<Organisation> organisations = logic.trees();
        children = new ArrayList<GenericObjectTreeNode>();
        for (Iterator<Organisation> iterator = organisations.iterator(); iterator.hasNext();) {
            Organisation organisation = iterator.next();
            OrganisationTreeNode child = new OrganisationTreeNode(organisation);
            children.add(child);
            child.setParent(this);
        }
        sortChildren();
    }

    public boolean getAllowsChildren() {
        return true;
    }

    public boolean isLeaf() {
        return false;
    }

    public String toString() {
        return "Orga";
    }

    public Class getObjectType() {
        return String.class;
    }

    public Class[] getChildTypes() {
        return new Class[] { Organisation.class };
    }

    public String loadObject() {
        return (String)object;
    }
}
