package org.osbl.orga.logic;

import org.osbl.orga.model.*;
import org.osbl.persistence.logic.DefaultTreeLogic;
import org.hibernate.*;

import java.util.*;

/**
 * @author hengels
 * @version $Revision$
 */
public class DefaultOrgaStructureLogic
    extends DefaultTreeLogic<Organisation, Group>
    implements OrgaStructureLogic
{
    protected String getNodeType() {
        return Group.class.getName();
    }

    protected String getTreeType() {
        return Organisation.class.getName();
    }

    public List<Group> groupsByContainedGroup(Long tree, Long groupName, String inRole) {
        return null;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public List<Group> groupsByContainedIdentity(Long tree, Long identity, String role) {
        Session session = sessionFactory.getCurrentSession();
        Query query = session.createQuery("select n from Group n join n.memberships as m where n.tree = :tree and m.role = :role and m.member.identity.id = :identity");
        query.setLong("tree", tree);
        query.setLong("identity", identity);
        query.setString("role", role);
        return query.list();
    }

    public List<Membership> memberships(Long identity) {
        Session session = sessionFactory.getCurrentSession();
        Query query = session.createQuery("select m from Membership m where m.member.identity = :identity");
        query.setLong("identity", identity);
        return query.list();
    }

    public List<Relationship> relationships(Long identity) {
        Session session = sessionFactory.getCurrentSession();
        Query query = session.createQuery("select r from Relationship r where r.member.identity = :identity");
        query.setLong("identity", identity);
        return query.list();
    }

    public int importMembers(Organisation organisation, String createdBy) {
        Session session = sessionFactory.getCurrentSession();
        Query query = session.createQuery("insert into Member (key, created, createdBy, organisation, identity)" +
            " select '" + organisation.getKey() + "'||'_'||i.key, current_timestamp(), '" + createdBy + "', (select o from Organisation o where o = :organisation), i from Identity i" +
            " where i not in (select m.identity from Member m where m.organisation = :organisation)");
        query.setParameter("organisation", organisation);
        return query.executeUpdate();
    }
}
