package org.osbl.orga.model;

import org.osbl.identity.model.Identity;
import org.conform.*;

@Bean (format = FormatType.CUSTOM, formatClass = "org.osbl.orga.model.MembershipFormat")
public class Membership
    implements Comparable
{
    Long id;
    @Property (mandatory = "true")
    Member member;
    @Property (mandatory = "true")
    Group group;
    @Property (mandatory = "true")
    String role;

    public Membership() {
    }

    public Membership(Member member, Group group, String role) {
        this.member = member;
        this.group = group;
        this.role = role;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Member getMember() {
        return member;
    }

    public void setMember(Member member) {
        this.member = member;
    }

    public Group getGroup() {
        return group;
    }

    public void setGroup(Group group) {
        this.group = group;
    }

    public String getRole() {
        return role;
    }

    public void setRole(String role) {
        this.role = role;
    }

    public int compareTo(Object o) {
        Membership m = (Membership)o;
        if (id == null && m.id != null)
            return 1;
        else if (id != null && m.id == null)
            return -1;
        else if (id == null && m.id == null)
            return 0;
        else
            return id.compareTo(m.id);
    }
}
