package org.osbl.orga.model;

import org.conform.format.*;
import org.conform.BeanMeta;
import org.conform.BeanMetaProvider;
import org.osbl.ServiceProvider;

public class MembershipFormat
    extends AbstractFormat
{
    BeanMetaProvider staticBeanMetaProvider = (BeanMetaProvider)ServiceProvider.getInstance().getService("StaticBeanMetaProvider");

    public String format(Object value) {
        Membership membership = (Membership)value;

        StringBuilder buffer = new StringBuilder();

        if (membership.getRole() != null) {
            buffer.append(membership.getRole());
            buffer.append(" ");
        }

        if (membership.getMember() != null) {
            BeanMeta beanMeta = staticBeanMetaProvider.getBeanMeta(Member.class);
            Format format = beanMeta.getFormat();
            if (format == null)
                format = new NoFormat();
            buffer.append(format.format(membership.getMember()));
        }
        else
            buffer.append("-");

        return buffer.toString();
    }
}
