/*
 *
 * (c) Copyright 2004 - 2007 osbl development team.
 *
 * This file is part of the osbl (http://osbl.wilken.de).
 *
 * the osbl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.osbl.demo.urlaub.model;

import org.conform.*;

import java.sql.*;

/**
 * @author hengels
 * @version $Revision: 840 $
 */
@Bean (
    format = FormatType.CUSTOM,
    formatClass = "org.osbl.demo.urlaub.model.UrlaubsAntragFormat",
    patternKey = "org.osbl.demo.urlaub.model.UrlaubsAntrag.pattern"
)
public class UrlaubsAntrag
{
    @Property (writable = "false")
    Integer id;

    @Property (writable = "false")
    Timestamp created;
    @Property (writable = "false")
    String createdBy;

    @Property (mandatory = "true")
    Typ typ = Typ.JAHRESURLAUB;

    Date vonDatum;
    Date bisDatum;

    Time vonZeit;
    Time bisZeit;

    String anlass;

    Genehmigung genehmigung = Genehmigung.STEHT_AUS;

    Timestamp gebucht;
    Timestamp benachrichtigt;
    Timestamp eingetragen;
    Timestamp storniert;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Timestamp getCreated() {
        return created;
    }

    public void setCreated(Timestamp created) {
        this.created = created;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Typ getTyp() {
        return typ;
    }

    public void setTyp(Typ typ) {
        this.typ = typ;
    }

    public Date getVonDatum() {
        return vonDatum;
    }

    public void setVonDatum(Date vonDatum) {
        this.vonDatum = vonDatum;
    }

    public Date getBisDatum() {
        return bisDatum;
    }

    public void setBisDatum(Date bisDatum) {
        this.bisDatum = bisDatum;
    }

    public Time getVonZeit() {
        return vonZeit;
    }

    public void setVonZeit(Time vonZeit) {
        this.vonZeit = vonZeit;
    }

    public Time getBisZeit() {
        return bisZeit;
    }

    public void setBisZeit(Time bisZeit) {
        this.bisZeit = bisZeit;
    }

    public String getAnlass() {
        return anlass;
    }

    public void setAnlass(String anlass) {
        this.anlass = anlass;
    }

    public Genehmigung getGenehmigung() {
        return genehmigung;
    }

    public void setGenehmigung(Genehmigung genehmigung) {
        this.genehmigung = genehmigung;
    }

    public Timestamp getGebucht() {
        return gebucht;
    }

    public void setGebucht(Timestamp gebucht) {
        this.gebucht = gebucht;
    }

    public Timestamp getBenachrichtigt() {
        return benachrichtigt;
    }

    public void setBenachrichtigt(Timestamp benachrichtigt) {
        this.benachrichtigt = benachrichtigt;
    }

    public Timestamp getEingetragen() {
        return eingetragen;
    }

    public void setEingetragen(Timestamp eingetragen) {
        this.eingetragen = eingetragen;
    }

    public Timestamp getStorniert() {
        return storniert;
    }

    public void setStorniert(Timestamp storniert) {
        this.storniert = storniert;
    }

    public String toString() {
        return createdBy + "(" + created + ")";
    }
}
