/*
 *
 * (c) Copyright 2004 - 2007 osbl development team.
 *
 * This file is part of the osbl (http://osbl.wilken.de).
 *
 * the osbl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.osbl.demo.urlaub.process;


import org.concern.LoaderException;
import org.osbl.demo.urlaub.model.UrlaubsAntrag;
import org.osbl.demo.urlaub.model.Genehmigung;
import org.concern.controller.AbstractSynchronousActivity;
import org.concern.controller.ActivityExecutionException;

import javax.mail.*;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.sql.Timestamp;
import java.util.*;


public class Benachrichtigen
    extends AbstractSynchronousActivity<UrlaubsAntrag>
{
    private Session session;

    public void execute(UrlaubsAntrag subject) throws ActivityExecutionException {
        try {
        	/*PROTECTED REGION ID(org.osbl.demo.urlaub.process.Benachrichtigen.execute) ENABLED START*/
            MimeMessage m = new MimeMessage(getSession());
            m.setFrom(new InternetAddress("spam@wilken.de"));
            m.setRecipients(Message.RecipientType.TO, new InternetAddress[]{new InternetAddress("spam@wilken.de")});
            m.setSubject(getSubject(subject));
            String entscheidung = subject.getGenehmigung() == Genehmigung.ERTEILT ? "genehmigt" : "abgelehnt";
            m.setContent("Ihr Urlaubsantrag wurde " + entscheidung, "text/plain; charset=UTF-8");
            Transport.send(m);
                subject.setBenachrichtigt(new Timestamp(System.currentTimeMillis()));
        }
        catch (MessagingException e) {
            session = null;
            throw new ActivityExecutionException(e);
        }
        catch (LoaderException e) {
            throw new ActivityExecutionException(e);
        }
        /*PROTECTED REGION END*/
    }

    // TODO: user's locale
    private String getSubject(UrlaubsAntrag subject) throws LoaderException {
        Map map = controller.getLoader().formatSubjectLines(subject);
        return (String)map.get("de_DE");
    }

    public void escalate(UrlaubsAntrag subject) throws ActivityExecutionException {
        UrlaubsAntrag urlaubsAntrag = subject;
        urlaubsAntrag.setBenachrichtigt(new Timestamp(System.currentTimeMillis()));
    }

    public Session getSession() throws ActivityExecutionException {
        if (session == null) {
            try {
                String mailSession = (String)getEnvironment().get("sendmail.session");
                System.out.println("mailSession = " + mailSession);
                session = (Session)new InitialContext().lookup(mailSession);
            }
            catch (NamingException e) {
                throw new ActivityExecutionException(e);
            }
        }
        return session;
    }
}
