package org.osbl.client;

import org.osbl.client.feeder.Feed;
import org.osbl.client.feeder.FeedInitializer;
import org.osbl.client.ClientServiceProvider;
import org.conform.BeanMetaProvider;
import org.conform.format.ResourceProvider;

public class DefaultFeedInitializer
    implements FeedInitializer
{
    public void preInitialization(Feed feed) {
        ClientServiceProvider serviceProvider = ClientServiceProvider.getInstance();
        feed.setServiceProvider(serviceProvider);

        ResourceProvider resourceProvider = (ResourceProvider)serviceProvider.getService("ResourceProvider");
        feed.setResourceProvider(resourceProvider);

        BeanMetaProvider staticBeanMetaProvider = (BeanMetaProvider)serviceProvider.getService("StaticBeanMetaProvider");
        BeanMetaProvider webappBeanMetaProvider = new WebappBeanMetaProvider(staticBeanMetaProvider);
        BeanMetaProvider sessionMetaProvider = new SessionBeanMetaProvider(webappBeanMetaProvider);
        feed.setBeanMetaProvider(sessionMetaProvider);
    }

    public void postInitialization(Feed feed) {
    }
}
