package org.osbl.client;

import org.osbl.client.ClientServiceProvider;

import javax.naming.*;
import java.util.ArrayList;
import java.util.List;

public class DefaultServiceProvider
    extends ClientServiceProvider
{
    public List<String> getServiceNames() {
        try {
            InitialContext ctx = new InitialContext();
            NamingEnumeration<NameClassPair> namingEnumeration = ctx.list("services/");
            List<String> names = new ArrayList<String>();
            while (namingEnumeration.hasMoreElements()) {
                NameClassPair nameClassPair = namingEnumeration.nextElement();
                names.add(nameClassPair.getName());
            }
            return names;
        }
        catch (NamingException e) {
            throw new RuntimeException(e);
        }
    }

    public Object getService(String name) {
        try {
            InitialContext ctx = new InitialContext();
            return ctx.lookup("services/" + name + "/local");
        }
        catch (NamingException e) {
            throw new RuntimeException(e);
        }
    }

    public <T> T getService(Class<T> type) {
        return (T)getService(type.getSimpleName());
    }

    public void autowireServices(Object bean) {
        throw new UnsupportedOperationException();
    }
}
