package org.osbl.client;

import org.conform.*;
import org.conform.format.*;

class FormatModifier
    implements Modifier
{
    public FormatModifier(BeanMetaProvider beanMetaProvider) {
    }

    public void modify(BeanMeta beanMeta) throws ModifierException {
        if (beanMeta.getFormat() != null)
            return;

        Format format = getFormat(beanMeta);
        if (format != null)
            beanMeta.setFormat(format);
    }

    private Format getFormat(BeanMeta beanMeta) {
        boolean name = beanMeta.getProperty("name") != null;
        boolean key = beanMeta.getProperty("key") != null;

        if (name && key)
            return new CallGetterFormat("getName", "getKey");

        if (name)
            return new CallGetterFormat("getName");

        if (key)
            return new CallGetterFormat("getKey");

        return null;
    }
}
