<%@ page import="java.util.*"%>
<%@ page import="java.io.InputStream"%>
<%@ page import="org.concern.controller.spring.BeanFactoryInJndiResourceLocator"%>
<%@ page import="org.conform.format.ResourceProvider"%>
<%@ page language="java" contentType="text/html;charset=utf-8"%>

<%
    String language = request.getParameter("language");
    if (language != null)
        request.getSession().setAttribute("language", language);

    Locale locale = language == null ? Locale.getDefault() : new Locale(language);

    BeanFactoryInJndiResourceLocator resourceLocator = new BeanFactoryInJndiResourceLocator();
    ResourceProvider resourceProvider = (ResourceProvider)resourceLocator.lookup("java:@app.name@/spring-services/ResourceProvider");

    Enumeration requestedLocales = request.getLocales();
    List supportedLocales = resourceProvider.getSupportedLocales();
    System.out.println("supported locales = " + supportedLocales);

    found: while (requestedLocales.hasMoreElements()) {
        Locale current = (Locale)requestedLocales.nextElement();
        for (int i = 0; i < supportedLocales.size(); i++) {
            Locale supportedLocale = (Locale)supportedLocales.get(i);
            if (current.equals(supportedLocale)) {
                locale = supportedLocale;
                break found;
            }
        }
    }


    String username = request.getParameter("username");
    if (username == null)
        username = "";

    String en_checked = "en".equals(language) ? "selected='1'" : "";
    String de_checked = "de".equals(language) ? "selected='1'" : "";

    // show error only when submission was not caused by a language change
    String error = null;
    String localeChange = request.getParameter("locale_change");
    if (localeChange == null || localeChange.length() == 0)
        error = request.getParameter("error");

    boolean demo = "true".equals(session.getServletContext().getInitParameter("demo"));
%>

<html>
<head>
	<title>OS Business Library</title>
    <link rel="shortcut icon" type="image/vnd.microsoft.icon" href="../icon/favicon.ico"/>
    <link rel="stylesheet" type="text/css" href="../stylesheet.css" title="Style"/>
	<script language="JavaScript" type="text/javascript">
	<!--
	if (window.self != window.top) {
	    window.open(".", "_top");
	}

	function localeChange() {
	    document.forms["loginForm"].elements["locale_change"].value = "true";
	    document.forms["loginForm"].submit();
	}
	// -->
	</script>
</head>

<body>
<div align="center">
    <form method="POST" action='<%=response.encodeURL("j_security_check")%>' name="loginForm">
        <input type="hidden" name="locale_change"/>

        <table width="400" cellspacing="10" class="loginForm">
            <tr>
                <th align="left" colspan="2">
                    <img src="../icon/logo.gif"/>
                    <div align="right" style="font-size:18px;">
                        <%=resourceProvider.getMessage(locale, "login.title", new Object[0])%>
                    </div>
                </th>
            </tr>
            <tr>
                <td align="left" colspan="2" style="border-top:1px solid #000000; padding-top:10px;">
                    <% if (demo) { %>
                        <%=resourceProvider.getMessage(locale, "login.demo.description", new Object[0])%><br/>
                        <%=resourceProvider.getMessage(locale, "login.demo.password.help", new Object[0])%>
                    <% } else { %>
                        <%=resourceProvider.getMessage(locale, "login.description", new Object[0])%><br/>
                        <%=resourceProvider.getMessage(locale, "login.password.help", new Object[0])%>
                    <% } %>
                </td>
            </tr>
            <tr>
                <td colspan="2" style="line-height: 5px;">&nbsp;</td>
            </tr>
            <tr>
                <th align="right">
                    <label for="j_username"><%=resourceProvider.getMessage(locale, "login.username", new Object[0])%></label>
                </th>
                <td align="left">
                    <input type="text" name="j_username" size="16" maxlength="16" id="j_username" value="<%=username%>" style="width: 212px;"/>
                </td>
            </tr>
            <tr>
                <th align="right">
                    <label for="j_password"><%=resourceProvider.getMessage(locale, "login.password", new Object[0])%></label>
                </th>
                <td align="left">
                    <input type="password" name="j_password" size="16" maxlength="16" id="j_password" style="width: 212px;"/>
                </td>
            </tr>
            <!-- tr>
		        <th align="right">
		            <label for="locale"><%=resourceProvider.getMessage(locale, "login.locale", new Object[0])%></label>
		        </th>
		        <td align="left">
		            <select name="locale" id="locale" onchange="localeChange()" style="width: 212px;">
		                <option value="en" <%=en_checked%>><%=resourceProvider.getMessage(locale, "locale.english", new Object[0])%></option>
		                <option value="de" <%=de_checked%>><%=resourceProvider.getMessage(locale, "locale.german", new Object[0])%></option>
		            </select>
		        </td>
		    </tr -->

      <% if (error != null) { %>
            <tr>
                <th>&nbsp;</th>
                <th align="left">
                    <font color="#FF0000"><%=resourceProvider.getMessage(locale, error, new Object[0])%></font>
                </th>
            </tr>
      <% } %>
            <tr>
                <td colspan="2" style="line-height: 5px;">&nbsp;</td>
            </tr>
            <!-- login reset buttons layout -->
            <tr>
                <td width="28%" valign="top">&nbsp;</td>
                <td width="72%" valign="top" style="white-space:nowrap;">
                    <input type="submit" value='<%=resourceProvider.getMessage(locale, "login.login", new Object[0])%>' style="width: 100px;"/>
                    &nbsp;&nbsp;
                    <input type="reset" value='<%=resourceProvider.getMessage(locale, "login.reset", new Object[0])%>' style="width: 100px;"/>
                </td>
            </tr>
        </table>
    </form>
</div>

<script language="JavaScript" type="text/javascript">
    <!--
    document.forms["loginForm"].elements["j_username"].focus()
    // -->
</script>

</body>
</html>
