package org.osbl;

import java.util.*;

public class ItemRegistry
{
    List<String> cache;
    List<String> items = new ArrayList<String>();
    List<ItemCollector> itemCollectors = new ArrayList<ItemCollector>();

    public void addItems(ItemCollector itemCollector) {
        int index = itemCollectors.indexOf(itemCollector);
        if (index == -1)
            itemCollectors.add(itemCollector);
        else
            itemCollectors.set(index, itemCollector);
    }

    public void addItem(String item) {
        items.add(item);
    }

    public void refresh() {
        cache = null;
        for (ItemCollector itemCollector : itemCollectors) {
            itemCollector.refresh();
        }
    }

    public List<String> getItems() {
        if (cache == null) {
            cache = new ArrayList<String>();
            cache.addAll(items);
            for (ItemCollector itemCollector : itemCollectors) {
                cache.addAll(itemCollector.getItems());
            }
        }
        return cache;
    }
}
