/*
 *
 * (c) Copyright 2004 - 2007 osbl development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * the osbl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.osbl;

import org.concern.controller.*;
import org.conform.hibernate.HibernateEnvironment;
import org.hibernate.*;
import org.apache.commons.logging.LogFactory;

import javax.transaction.TransactionManager;

/**
 * @author hengels[at]mercatis[dot]de
 * @version $Revision: 1.7 $
 */
public class JTAHibernateEnvironment
    extends HibernateEnvironment
{
    private static org.apache.commons.logging.Log LOG = LogFactory.getLog(HibernateEnvironment.class);

    private Transactions transactions = new Transactions();

    public JTAHibernateEnvironment() {
    }

    public void setTransactionManager(TransactionManager transactionManager) {
        this.transactions.setTransactionManager(transactionManager);
    }

    public void beginTransaction() throws HibernateException {
        LOG.debug("BEGIN TRANSACTION");
        transactions.beginRequired();
    }

    public void setSetRollbackOnly(boolean b) {
        LOG.debug("MARK TRANSACTION ROLLBACK ONLY");
        transactions.setRollbackOnly();
    }

    public void endTransaction() throws HibernateException {
        LOG.debug("END TRANSACTION");
        transactions.endRequired();
    }

    public Transactions getTransactions() {
        return transactions;
    }

    public void ensureTransactionClosed() {
        if (transactions.getPropagationNesting() != 0)
            LOG.warn("Transaction still active. Propagation Nesting: " + transactions.getPropagationNesting());
    }
}
