package org.osbl;

import org.apache.commons.logging.LogFactory;
import org.osbl.ObjectLocator;

import java.util.Map;
import java.util.HashMap;

public class ObjectLocators
{
    private static org.apache.commons.logging.Log LOG = LogFactory.getLog(ObjectLocators.class);

    private final Map<Class, ObjectLocator> queries = new HashMap<Class, ObjectLocator>();

    public void registerObjectLocator(Class type, ObjectLocator objectLocator) {
        LOG.info("Register ObjectLocator: " + objectLocator.getClass().getSimpleName() + " for " + type.getSimpleName());
        queries.put(type, objectLocator);
    }

    public ObjectLocator get(Class type) {
        return queries.get(type);
    }
}
