package org.osbl.agent.gui;

import org.osbl.client.wings.form.*;
import org.concern.*;
import org.concern.controller.LoaderFactory;
import org.conform.hibernate.HibernateEnvironment;

import java.util.*;

public class NestingObjectForm
    extends NestedObjectForm
{
    private Map<String, ObjectForm> nestedForms = new HashMap<String, ObjectForm>();
    private Map<String, List> environments = new HashMap<String, List>();
    private boolean edit;

    public NestingObjectForm() {
    }

    public NestingObjectForm(boolean edit) {
        this.edit = edit;
    }

    public boolean isEdit() {
        return edit;
    }

    public void setEdit(boolean edit) {
        this.edit = edit;
    }

    public Subject getSubject() {
        return (Subject)getObject();
    }

    public void setType(Class type) {
        if (type == null)
            return;

        String key = type.getName();

        if (nestedForm != null)
            nestedForm.getEnvironment().setActive(false);

        nestedForm = nestedForms.get(key);

        if (nestedForm == null) {
            try {
                nestedForm = (ObjectForm)type.newInstance();
                if (nestedForm instanceof ObjectContextAware) {
                    ObjectContextAware contextAware = (ObjectContextAware)nestedForm;
                    contextAware.setContext(getContext());
                }
                nestedForm.getEnvironment().setDelegate(nestedEnvironment);
            }
            catch (Exception e) {
                throw new RuntimeException(e);
            }
            nestedForms.put(key, nestedForm);
        }

        if (nestedForm instanceof ObjectContextAware) {
            ObjectContextAware contextAware = (ObjectContextAware)nestedForm;
            getContext().putObject("environment", environments.get(key));
            contextAware.setContext(getContext());
        }
        nestedForm.getEnvironment().setActive(true);
    }

    public void setObject(Object object) {
        super.setObject(object);

        if (object == null)
            return;

        Subject subject = (Subject)object;

        try {
            Controller controller = ControllerLookup.getInstance().getController(subject.getProcess());
            HibernateEnvironment.getInstance().beginTransaction();
            org.concern.controller.Loader loader = new LoaderFactory().getLoader(controller);
            subject.setSubject(loader.load(subject.getSubjectId()));
            nestedForm.setObject(subject.getSubject());
        }
        catch (Exception e) {
            throw new RuntimeException(e);
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }
}
