
package org.osbl.agent.logic;

import org.conform.BeanMeta;
import org.osbl.agent.model.Rule;
import org.osbl.agent.model.RuleContext;


/**
 * The Class ObjectRuntimeContext.
 * 
 * @author Sebastian Nozzi.
 */
public class ObjectRuntimeContext extends RuntimeContext {

	/* (non-Javadoc)
	 * @see org.osbl.agent.logic.RuntimeContext#populateRuleContext(org.osbl.agent.model.RuleContext, java.lang.Object)
	 */
	public void populateRuleContext(RuleContext rtc, Object target) {

		rtc.setTargetObject(target);
		
		BeanMeta beanMeta = new BeanMeta(target.getClass());
		rtc.put(rtc.BEAN_META, beanMeta);	
	}

	/* (non-Javadoc)
	 * @see org.osbl.agent.logic.RuntimeContext#ruleIsApplicable(org.osbl.agent.model.Rule, java.lang.Object)
	 */
	public boolean ruleIsApplicable(Rule rule, Object target) {
		// We are so generic, all rules are applicable to us
		return true;
	}

}
