package org.osbl.authorization;

import java.security.PermissionCollection;
import java.security.Permission;
import java.util.*;

public class EntityPermission
    extends ActionPermission
{
    String rule;

    public EntityPermission(String name, String actions, String rule) {
        super(name, actions);
        this.rule = rule;
    }

    public String getRule() {
        return rule;
    }

    public PermissionCollection newPermissionCollection() {
        return new PermissionCollection() {
            SortedSet<Permission> permissions = new TreeSet<Permission>();

            public void add(Permission permission) {
                permissions.add(permission);
            }

            public boolean implies(Permission permission) {
                return permissions.contains(permission);
            }

            public Enumeration<Permission> elements() {
                return Collections.enumeration(permissions);
            }
        };
    }
}
