package org.osbl.client;

import java.util.List;

public abstract class ClientServiceProvider
{
    static final ThreadLocal<ClientServiceProvider> INSTANCES = new ThreadLocal<ClientServiceProvider>();

    public static void setInstance(ClientServiceProvider serviceProvider) {
        INSTANCES.set(serviceProvider);
    }

    public static void unsetInstance() {
        INSTANCES.remove();
    }

    public static ClientServiceProvider getInstance() {
        return INSTANCES.get();
    }

    public abstract List<String> getServiceNames();

    public abstract Object getService(String name);

    public abstract <T> T getService(Class<T> type);

    public abstract void autowireServices(Object bean);
}
