package org.osbl.client.action;

import java.util.Map;
import java.util.HashMap;


/**
 * Abstract base class, managing the map of values.
 */
public abstract class AbstractObjectAction
    implements ObjectAction
{
    Map<String, Object> values = new HashMap<String, Object>();
    boolean enabled = true;

    public Object getValue(String key) {
        return values.get(key);
    }

    public void putValue(String key, Object value) {
        if (value == null)
            values.remove(key);
        else
            values.put(key, value);
    }

    public boolean isEnabled() {
        return enabled;
    }

    public void setEnabled(boolean enabled) {
        this.enabled = enabled;
    }
}
