package org.osbl.client.action;

import org.apache.commons.logging.LogFactory;

import java.util.*;

import javax.swing.Action;

/**
 * @author hengels
 * @version $Revision$
 */
public class ActionRegistry
{
    private static org.apache.commons.logging.Log LOG = LogFactory.getLog(ActionRegistry.class);

    private static final Map<String, Action> actions = new HashMap<String, Action>();

    private ActionRegistry() {
    }

    public static void registerAction(Action action) {
        final String cmdKey = (String) action.getValue(Action.ACTION_COMMAND_KEY);
        if (actions.get(cmdKey) == null) {
            actions.put(cmdKey, action);
            LOG.info("Register Action: " + cmdKey);
        }
    }

    public static Action getAction(String command) {
        return actions.get(command);
    }

    public static Collection<Action> getActions() {
        return actions.values();
    }
}
