package org.osbl.client.action;

import java.util.EventObject;

/**
 * The event holds the event source and the target objects, on which the action shall be performed.
 */
public class ObjectActionEvent
    extends EventObject
{
    Object[] targets;

    public ObjectActionEvent(Object source, Object... targets) {
        super(source);
        this.targets = targets;
    }

    /**
     * Return the target objects.
     * @return an array of target objects.
     */
    public Object[] getTargets() {
        return targets;
    }
}
