package org.osbl.client.item;

import org.osbl.client.action.ActionRegistry;
import org.osbl.item.AbstractItemCollector;

import javax.swing.*;
import java.util.*;

public class ActionLocalizationCollector
    extends AbstractItemCollector
{
    List<String> items;

    public ActionLocalizationCollector() {
    }

    public Collection<String> getItems() {
        if (items == null) {
            Collection<Action> actions = ActionRegistry.getActions();
            items = new ArrayList<String>(actions.size());

            for (Action action : actions) {
                items.add((String)action.getValue(Action.ACTION_COMMAND_KEY));
            }
        }
        return items;
    }

    public void refresh() {
        items = null;
    }

    public int hashCode() {
        return getClass().hashCode();
    }

    public boolean equals(Object obj) {
        return obj != null && getClass().equals(obj.getClass());
    }
}
