package org.osbl.client.web;

import org.osbl.client.ClientServiceProvider;

import javax.servlet.*;
import java.io.IOException;

public class ServiceProviderFilter
    implements Filter
{
    private ServletContext servletContext;

    public void init(FilterConfig filterConfig) throws ServletException {
        servletContext = filterConfig.getServletContext();
    }

    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain)
        throws IOException, ServletException
    {
        ClientServiceProvider serviceProvider = (ClientServiceProvider)servletContext.getAttribute("serviceProvider");
        ClientServiceProvider.setInstance(serviceProvider);
        filterChain.doFilter(servletRequest, servletResponse);
        ClientServiceProvider.unsetInstance();
    }

    public void destroy() {
    }
}
