package org.osbl.client.wings;

import org.wings.SButton;
import org.osbl.client.wings.shell.Client;

import javax.swing.*;
import java.awt.event.ActionEvent;

/**
 * XHelpButton
 * <p/>
 */
public class XHelpButton extends SButton {

    /**
     * Help button for individual help tabs shown when button was pressed.
     *
     * @param key The key of the help topic to display on the left
     *            Each help tab will display a {@link org.osbl.client.wings.shell.ContextHelpTool}.
     *            For details about what the key must look like
     * @see org.osbl.client.wings.shell.ContextHelpTool
     * @see Client#showDetailHelp(String)
     */
    public XHelpButton(final String key) {
        setAction(new AbstractAction("?") {
            public void actionPerformed(ActionEvent e) {
                Client.getInstance().showDetailHelp(key);
            }
        });
    }
}
