package org.osbl.client.wings.action;

import org.wings.*;
import org.osbl.client.action.AuthorizedAction;

import javax.swing.*;
import java.util.Map;

/**
 * @author hengels
 * @version $Revision$
 */
public abstract class NavigationAction
    extends AuthorizedAction
    implements Cloneable
{
    protected NavigationAction() {
    }

    protected NavigationAction(String command) {
        putValue(ACTION_COMMAND_KEY, command);
    }

    protected NavigationAction(String command, SIcon icon) {
        putValue(ACTION_COMMAND_KEY, command);
        putValue(SMALL_ICON, icon);
    }

    public abstract void navigate(Object object);
    public abstract void navigate(Map<String,String> query);

    public String toString() {
        return getValue(ACTION_COMMAND_KEY).toString();
    }

    public Object clone() {
        try {
            return super.clone();
        }
        catch (CloneNotSupportedException e) {
            throw new RuntimeException(e);
        }
    }
}
