/*
 *
 * (c) Copyright 2004 - 2007 osbl development team.
 *
 * This file is part of the osbl (http://osbl.wilken.de).
 *
 * the osbl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.osbl.client.wings.action;

import org.wings.*;
import org.osbl.client.wings.shell.Client;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.util.Map;

/**
 * @author hengels
 * @version $Revision: 1.3 $
 */
public class NoAction
    extends NavigationAction
{
    public NoAction(String command, String name, SIcon icon) {
        this(command, name);
        putValue(Action.SMALL_ICON, icon);
    }

    public NoAction(String command, String name) {
        putValue(Action.ACTION_COMMAND_KEY, command);
        putValue(Action.NAME, name);
        putValue(Action.SHORT_DESCRIPTION, "not implemented");
    }

    public void actionPerformed(ActionEvent e) {
        Client.getInstance().show("main", new SLabel(getValue(Action.NAME) + " is not implemented"));
    }

    public void navigate(Object object)  {
        actionPerformed(new ActionEvent(this, -1, toString()));
    }

    public void navigate(Map<String,String> query) {
        actionPerformed(new ActionEvent(this, -1, toString()));
    }
}
