/*
 *
 * (c) Copyright 2004 - 2007 osbl development team.
 *
 * This file is part of the osbl (http://osbl.wilken.de).
 *
 * the osbl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.osbl.client.wings.action;

import java.awt.event.ActionEvent;
import java.util.Map;
import java.util.HashMap;

import org.wings.SIcon;
import org.wings.util.SessionLocal;
import org.osbl.client.wings.shell.*;

/**
 * @author hengels
 * @version $Revision: 1.2 $
 */
public class ShowApplicationAction
    extends NavigationAction
{
    protected Class<? extends Application> type;

    static final SessionLocal windows = new SessionLocal() {
        protected Object initialValue() {
            return new HashMap();
        }
    };

    public ShowApplicationAction(Class<? extends Application> type, String command, SIcon icon) {
        super(command, icon);
        this.type = type;
    }

    public ShowApplicationAction(Class<? extends Application> type, String command) {
        super(command);
        this.type = type;
    }

    public void actionPerformed(ActionEvent event) {
        ApplicationWindow applicationWindow = getApplication();
        Client.getInstance().pushWindow(applicationWindow);
    }

    public void navigate(Object object)  {
        actionPerformed(new ActionEvent(this, -1, toString()));
    }

    public void navigate(Map<String,String> query) {
        actionPerformed(new ActionEvent(this, -1, toString()));
    }

    protected Application createApplicationInstance() {
        try {
            return type.newInstance();
        }
        catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    private ApplicationWindow getApplication() {
        Map<Class, ApplicationWindow> map = (Map<Class, ApplicationWindow>)windows.get();
        ApplicationWindow applicationWindow = map.get(type);
        if (applicationWindow == null) {
            Application application = createApplicationInstance();
            applicationWindow = new ApplicationWindow(application);
            map.put(type, applicationWindow);
        }
        return applicationWindow;
    }

    static class ApplicationWindow
        extends Window
    {
        Application application;

        public ApplicationWindow(Application application) {
            this.application = application;
            application.getEnvironment().setDelegate(this);
        }

        public Application getApplication() {
            return application;
        }
    }
}
