package org.osbl.client.wings.concern;

import org.concern.ControllerLookup;
import org.osbl.client.wings.shell.Client;
import org.wings.*;
import org.wingx.table.EditableTableCellRenderer;

import javax.swing.*;

class ProcessFilterRenderer
    extends SComboBox
    implements EditableTableCellRenderer
{
    public ProcessFilterRenderer() {
        String[] processes = ControllerLookup.getInstance().getControllerNames();
        String[] processesAndAll = new String[processes.length + 1];
        processesAndAll[0] = Client.getInstance().getResourceProvider().getMessage("org.concern.model.Process.messages.allDeployed");
        System.arraycopy(processes, 0, processesAndAll, 1, processes.length);
        setModel(new DefaultComboBoxModel(processesAndAll));
        addActionListener(new NoAction());
    }

    public Object getValue() {
        String process = (String)getSelectedItem();
        boolean all = getSelectedIndex() == 0;
        return all ? null : new String[] { process };
    }

    public SComponent getTableCellRendererComponent(STable table, Object value, boolean isSelected, int row, int column) {
        if (value == null)
            setSelectedIndex(0);
        else
            setSelectedItem(((String[])value)[0]);

        return this;
    }

    public LowLevelEventListener getLowLevelEventListener(STable table, int row, int column) {
        return this;
    }
}
