package org.osbl.client.wings.concern;

import org.concern.Subject;
import org.osbl.agent.gui.DesignContext;
import org.osbl.agent.gui.SubjectDesignContext;
import org.osbl.agent.gui.TaskDesignContext;
import org.osbl.client.wings.shell.AbstractTool;
import org.osbl.client.wings.shell.Client;
import org.osbl.client.wings.shell.Window;
import org.osbl.client.wings.form.*;
import org.wings.SComponent;
import org.wings.SPanel;
import org.wings.session.SessionManager;
import org.conform.BeanMeta;

import java.util.Map;
import java.util.HashMap;

public class SubjectList
    extends GenericObjectList
    implements FilterableObjectList
{
    protected BeanMeta createBeanMeta() {
        return Client.getInstance().getBeanMetaProvider().getBeanMeta(Subject.class);
    }

    protected ObjectTableModel createModel(BeanMeta beanMeta) {
        return new SubjectTableModel(beanMeta);
    }

    // was protected
    public Object getRow(int index) {
        return ((SubjectTableModel)model).getRow(index);
    }

    protected Object idOf(Object object) {
        return ((Subject)object).getSubjectId();
    }

    public void setProcesses(String[] processes) {
        getTableModel().setProcesses(processes);
    }

    public void setAssignee(String assignee) {
        getTableModel().setAssignee(assignee);
    }

    public void setOriginators(String[] originators) {
        getTableModel().setOriginators(originators);
    }

    public void setState(int state) {
        getTableModel().setState(state);
    }

    private SubjectTableModel getTableModel() {
        return (SubjectTableModel)getModel();
    }

    public void clearFilters() {
        super.clearFilters();
        SubjectTableModel tableModel = getTableModel();
        tableModel.setFilter(0, null);
        tableModel.setFilter(1, null);
        tableModel.setFilter(2, null);
        tableModel.setState(0);
        tableModel.setAssignee(null);
    }

    public void setFilter(String property, Object value) {
        super.setFilter(property, value);

        SubjectTableModel tableModel = getTableModel();
        if ("subjectLine".equals(property))
            tableModel.setFilter(0, getFilter("subjectLine"));
        if ("process".equals(property))
            tableModel.setFilter(1, getFilter("process"));
        if ("originator".equals(property))
            tableModel.setFilter(2, substitute((String)getFilter("originator")));
        if ("state".equals(property))
            tableModel.setState(state((Integer)getFilter("state")));
        if ("assignee".equals(property))
            tableModel.setAssignee(substitute((String)getFilter("assignee")));
    }

    protected void initializeList() {
	}

    private int state(Integer integer) {
        return integer != null ? integer : 0;
    }

    private String substitute(String string) {
        if ("{currentUser}".equals(string))
            string = SessionManager.getSession().getServletRequest().getUserPrincipal().getName();
        return string;
    }
}
