package org.osbl.client.wings.concern;

import org.concern.Work;
import org.osbl.agent.gui.DesignContext;
import org.osbl.agent.gui.SidePanel;
import org.osbl.agent.gui.TaskDesignContext;
import org.osbl.client.wings.shell.AbstractTool;
import org.osbl.client.wings.shell.Client;
import org.osbl.client.wings.shell.Window;
import org.osbl.client.wings.form.*;
import org.wings.*;
import org.wings.table.SDefaultTableCellRenderer;
import org.wings.session.SessionManager;
import org.conform.BeanMeta;
import org.wingx.table.XTableColumnModel;

import java.text.DateFormat;
import java.util.Date;

public class TaskList
    extends GenericObjectList
    implements FilterableObjectList
{
	protected BeanMeta createBeanMeta() {
		return Client.getInstance().getBeanMetaProvider().getBeanMeta(Work.class);
	}

	protected ObjectTableModel createModel(BeanMeta beanMeta) {
		return new TaskTableModel(beanMeta);
	}

	public Object getRow(int index) {
		return ((TaskTableModel)model).getRow(index);
	}

	protected Object idOf(Object object) {
		return TaskTableModel.id((Work) object);
	}

    public void clearFilters() {
        super.clearFilters();
        TaskTableModel tableModel = getTableModel();
        tableModel.setFilter(0, null);
        tableModel.setFilter(1, null);
        tableModel.setFilter(2, null);
        tableModel.setUser(null);
    }

    public void setFilter(String property, Object value) {
        super.setFilter(property, value);
        TaskTableModel tableModel = getTableModel();
        if ("subjectLine".equals(property))
            tableModel.setFilter(0, getFilter("subjectLine"));
        if ("process".equals(property))
            tableModel.setFilter(1, getFilter("process"));
        if ("activity".equals(property))
            tableModel.setFilter(2, getFilter("activity"));
        if ("assignee".equals(property))
            tableModel.setUser(substitute((String)getFilter("assignee")));
    }

    protected void initializeList() {
    }

    private TaskTableModel getTableModel() {
        return (TaskTableModel)model;
    }

    private String substitute(String string) {
        if ("{currentUser}".equals(string))
            string = SessionManager.getSession().getServletRequest().getUserPrincipal().getName();
        return string;
    }
}
