package org.osbl.client.wings.control;

import org.osbl.client.wings.shell.Tool;
import org.concern.Controller;
import org.concern.Subject;
import org.wings.*;
import org.wings.table.SDefaultTableCellRenderer;
import org.wingx.XScrollPane;
import org.wingx.XTable;

import java.util.*;

/**
 * @author hengels
 * @version $Revision$
 */
class LogTable
    extends XScrollPane
    implements Plugin
{
    XTable table;
    LogTableModel logModel;

    public LogTable() {
        logModel = new LogTableModel();
        table = new XTable(logModel);
        table.setEditable(false);
        table.setPreferredSize(SDimension.FULLWIDTH);
        table.setSelectionMode(SListSelectionModel.NO_SELECTION);
        table.getColumnModel().getColumn(4).setCellRenderer(new SDefaultTableCellRenderer() {
            public SComponent getTableCellRendererComponent(STable table, Object value, boolean selected, int row, int col) {
                String details = (String)value;
                if (details != null && details.length() > 40)
                    value = details.substring(0, 40) + " ...";

                SComponent component = super.getTableCellRendererComponent(table, value, selected, row, col);
                if (details != value)
                    component.setToolTipText(details);
                return component;
            }
        });
        setViewportView(table);
    }

    public void update() {
        logModel.refresh();
    }

    public void setController(Controller controller) {
        logModel.setController(controller);
    }

    public void setSubject(Subject subject) {
        logModel.setSubject(subject);
    }

    public void setArchive(boolean archive) {
        logModel.setArchive(archive);
    }

    public List<Tool> getTools() {
        return Collections.EMPTY_LIST;
    }
}
