package org.osbl.client.wings.control;

import org.wings.*;
import org.concern.Subject;
import org.osbl.client.wings.concern.SubjectForm;
import org.osbl.client.wings.shell.Tool;

import java.util.*;

/**
 * @author hengels
 * @version $Revision$
 */
public class SubjectPanel
    extends SPanel
    implements Plugin
{
    private Subject subject;
    private SubjectForm subjectForm = new SubjectForm();

    public SubjectPanel() {
        setPreferredSize(SDimension.FULLWIDTH);
        add(new SRawTextComponent(""));
    }

    public void setController(org.concern.Controller controller) {
    }

    public void setSubject(Subject subject) {
        this.subject = subject;
    }

    public void update() {
        if (subject == null)
            return;

        try {
            subjectForm.setSubject(subject);

            SComponent component = subjectForm.getComponent();
            if (component != getComponent(0)) {
                remove(0);
                add(component, SBorderLayout.CENTER);
            }
            
            subjectForm.setObject(subject);
        }
        catch (Exception e) {
            removeAll();
            add(new SRawTextComponent(e.getMessage()));
            e.printStackTrace(System.err);
        }
    }

    public List<Tool> getTools() {
        return new LinkedList<Tool>();
    }
}
