package org.osbl.client.wings.devtools;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.*;

import org.wings.session.SessionManager;
import org.wings.SFrame;
import org.wings.SContainer;
import org.wings.SComponent;

/**
 * TODO: document me!!!
 * <p/>
 * <code>ContainerColoringDevTool</code>.
 * User: rro
 * Date: 31.07.2006
 * Time: 13:58:21
 *
 * @author Roman R&auml;dle
 * @version $Revision$
 */
public class ContainerColoringDevTool extends AbstractAction {

    ColoringTreeWalker treeWalker = new ColoringTreeWalker();

    /**
     * Defines an <code>Action</code> object with a default
     * description string and default icon.
     */
    public ContainerColoringDevTool() {
        treeWalker.colored = (Boolean) SessionManager.getSession().getProperty("ContainerColoringDevTool", Boolean.FALSE);

        putValue(Action.NAME, "Layout Coloring - " + (treeWalker.colored ? "OFF" : "ON"));
        //putValue(Action.SMALL_ICON, XIcons.REPLACE);
    }

    /**
     * Invoked when an action occurs.
     */
    public void actionPerformed(ActionEvent e) {
        SFrame frame = SessionManager.getSession().getRootFrame();

        treeWalker.walk(frame);

        treeWalker.colored = !treeWalker.colored;
        SessionManager.getSession().setProperty("ContainerColoringDevTool", treeWalker.colored);

        putValue(Action.NAME, "Layout Coloring - " + (treeWalker.colored ? "OFF" : "ON"));
    }

    class ColoringTreeWalker implements ComponentTreeWalker {

        private boolean colored;

        private Color[] colors = new Color[] {
                Color.RED,
                Color.GREEN,
                Color.BLUE,
                Color.CYAN,
                Color.MAGENTA,
                Color.ORANGE,
                Color.PINK,
                Color.YELLOW
        };

        private int colorPosition = 0;

        public boolean walk(SComponent c) {

            if (c instanceof SContainer) {

                SContainer container = (SContainer) c;

                Color childColor = colors[colorPosition];

                if (container.getComponentCount() > 0) {

                    boolean colorChanged = false;
                    for (SComponent child : container.getComponents()) {

                        if (child instanceof SContainer) {
                            if (!colored) {
                                child.putClientProperty("default.background", child.getBackground());
                                child.setBackground(childColor);

                                if (!colorChanged) {
                                    colorChanged = true;
                                    colors[colorPosition] = colors[colorPosition].brighter();
                                    colorPosition = ++colorPosition % 8;
                                }
                            }
                            else {
                                colorPosition = 0;
                                Color color = (Color) child.getClientProperty("default.background");
                                child.setBackground(color);
                            }
                        }

                        walk(child);
                    }
                }
            }

            return false;
        }
    }
}
