package org.osbl.client.wings.devtools;

import org.wings.*;
import org.wings.border.SEmptyBorder;
import org.wingx.XDivision;
import org.osbl.client.wings.shell.AbstractTool;
import org.osbl.client.wings.shell.Client;

import javax.swing.*;
import java.util.List;
import java.util.Collections;

public class DevelopmentTool
    extends AbstractTool
{
    protected static final List<Action> NO_ACTIONS = Collections.EMPTY_LIST;

    private SPanel panel;
    private XDivision globalDivision = new XDivision(new SGridLayout());
    private XDivision specificDivision = new XDivision(new SGridLayout());

    private List<Action> specificActions;
    private Action[] globalActions;

    public DevelopmentTool() {
        putValue(Action.NAME, "Development");
    }

    public void setGlobalActions(Action[] globalActions) {
        this.globalActions = globalActions;
    }

    private void initGlobalDevelopmentTools() {
        addActions(globalDivision, globalActions);
    }

    public void setSpecificActions(List<Action> specificActions) {
        if (this.specificActions != specificActions) {
            this.specificActions = specificActions != null ? specificActions : NO_ACTIONS;
            specificDivision.removeAll();
            addActions(specificDivision, this.specificActions.toArray(new Action[this.specificActions.size()]));
            System.out.println("replace development actions = " + this.specificActions);
        }
    }

    private void addActions(SContainer division, Action[] actions) {
        for (Action action : actions) {
            SButton button = new SButton(Client.getInstance().getActionProvider().configure(action));
            button.setPreferredSize(SDimension.FULLWIDTH);
            button.setHorizontalAlignment(SConstants.LEFT_ALIGN);
            division.add(button);
        }
    }

    public SComponent getComponent() {
        if (panel == null) {
            panel = new SPanel(new SGridLayout());
            panel.setBorder(new SEmptyBorder(8,8,8,8));
            panel.setPreferredSize(SDimension.FULLWIDTH);

            globalDivision.setTitle("Global Tools");
            globalDivision.setPreferredSize(SDimension.FULLWIDTH);
            specificDivision.setTitle("Specific Tools");
            specificDivision.setPreferredSize(SDimension.FULLWIDTH);

            panel.add(globalDivision);
            panel.add(specificDivision);

            initGlobalDevelopmentTools();
        }
        return panel;
    }
}
