package org.osbl.client.wings.devtools;

import org.wings.session.SessionManager;
import org.wings.*;
import org.wings.script.ScriptListener;
import org.wings.script.JavaScriptListener;
import org.wings.externalizer.ExternalizeManager;
import org.wings.resource.FileResource;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.util.Map;
import java.util.HashMap;
import java.io.*;

/**
 * TODO: document me!!!
 * <p/>
 * <code>GUIMapGeneratorDevTool</code>.
 * User: rro
 * Date: 31.07.2006
 * Time: 09:08:45
 *
 * @author Roman R&auml;dle
 * @version $Revision$
 */
public class GUIMapGeneratorDevTool extends AbstractAction {

    private StringBuilder builder;

    /**
     * Defines an <code>Action</code> object with a default
     * description string and default icon.
     */
    public GUIMapGeneratorDevTool() {
        putValue(Action.NAME, "GUIMap Generator");
        //putValue(Action.SMALL_ICON, org.osbl.client.wings.XIcons.REPLACE);
    }

    /**
     * Invoked when an action occurs.
     */
    public void actionPerformed(ActionEvent e) {

        builder = new StringBuilder();
        builder.append("<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
        builder.append("<GUIMap KtxInfo=\"Wilken Anmeldung\" Name=\"HTML_MOZ_NACHR\" ScreenType=\"HTML\" LongName=\"Wilken erste Anmeldung\">\n");

        ComponentTreeWalker treeWalker = new ToscaComponentTreeWalker();
        treeWalker.walk(SessionManager.getSession().getRootFrame());

        builder.append("</GUIMap>");

        File file = null;
        try {
            file = File.createTempFile("tosca", ".xml");
        }
        catch (IOException ioe) {
            ioe.printStackTrace();
        }

        BufferedWriter out;
        try {
            out = new BufferedWriter(new FileWriter(file));
            out.write(builder.toString());
            out.flush();
            out.close();
        }
        catch (FileNotFoundException e1) {
            e1.printStackTrace();
        }
        catch (IOException ioe) {
            ioe.printStackTrace();
        }

        FileResource resource = new FileResource(file);
        resource.setExternalizerFlags(resource.getExternalizerFlags() | ExternalizeManager.REQUEST);

        Map headers = new HashMap();
        headers.put("Content-Disposition", "attachment; filename=" + file.getName());
        resource.setHeaders(headers.entrySet());

        final ScriptListener listener = new JavaScriptListener(null, null, "location.href='" + resource.getURL() + "'");
        SessionManager.getSession().getScriptManager().addScriptListener(listener);
    }

    class ToscaComponentTreeWalker implements ComponentTreeWalker {

        public boolean walk(SComponent c) {

            int level = 0;
            for (SContainer parent = c.getParent(); parent != null; parent = parent.getParent()) {
                level++;
            }

            if (c instanceof SContainer) {

                SContainer container = (SContainer) c;

                if (container.getComponentCount() > 0) {

                    for (SComponent child : container.getComponents()) {

                        if (child instanceof SAbstractButton) {

                            if (child instanceof SRadioButton) {
                                builder.append("    <Control Name=\"" + child.getName() + "\" TypeInfo=\"HTMLRadioButton\" Desc=\"id=" + child.getName() + "\" />\n");
                            }
                            else if (child instanceof SCheckBox) {
                                builder.append("    <Control Name=\"" + child.getName() + "\" TypeInfo=\"HTMLCheckbox\" Desc=\"id=" + child.getName() + "\" />\n");
                            }
                            else {
                                builder.append("    <Control Name=\"" + child.getName() + "\" TypeInfo=\"HTMLButton\" Desc=\"id=" + child.getName() + "\" />\n");
                            }
                        }
                        else if (child instanceof STextComponent) {
                            builder.append("    <Control Name=\"" + child.getName() + "\" TypeInfo=\"HTMLEditbox\" Desc=\"id=" + child.getName() + "\" />\n");
                        }
                        else if (child instanceof SComboBox) {
                            builder.append("    <Control Name=\"" + child.getName() + "\" TypeInfo=\"HTMLComboBox\" Desc=\"id=" + child.getName() + "\" />\n");
                        }

                        String tab = "";
                        for (int i = 0; i < level; i++) {
                            tab += "    ";
                        }

                        if (child instanceof LowLevelEventListener) {
                            System.out.println(tab + "==> [LLEL] " + child.getName() + " " + child.getClass());
                        }
                        else {
                            System.out.println(tab + "==> " + child.getName() + " " + child.getClass());
                        }

                        walk(child);
                    }
                }
            }

            return false;
        }
    }
}
