package org.osbl.client.wings.devtools.hibernate;

import org.osbl.plugin.PluginManager;
import org.osbl.plugin.Extension;
import org.osbl.client.ClientServiceProvider;
import org.osbl.client.web.spring.SpringWebModule;
import org.osbl.client.wings.action.ShowViewerAction;
import org.osbl.client.wings.action.ShowApplicationAction;
import org.osbl.client.wings.form.Viewers;
import org.osbl.client.action.ActionRegistry;
import org.osbl.ItemRegistry;

import javax.swing.*;
import java.awt.event.ActionEvent;

public class HibernateQueryWebModule
    extends SpringWebModule
{
    PluginManager pluginManager;

    public void setPluginManager(PluginManager pluginManager) {
        this.pluginManager = pluginManager;
    }

    public void initialize() {
        Viewers.registerViewer(Bean.class, HibernateQueryViewer.class);
        ActionRegistry.registerAction(new ShowViewerAction(Bean.class, "org.osbl.hibernate.hibernate.actions.query"));
        ActionRegistry.registerAction(new ShowApplicationAction(HibernateReferences.class, "org.osbl.hibernate.hibernate.actions.references"));

        pluginManager.registerExtension(new Extension("Hibernate Query Tool", "org.osbl.client.wings.devtools", HibernateQueryDevTool.class));
        pluginManager.registerExtension(new Extension("Hibernate References Tool", "org.osbl.client.wings.devtools", HibernateReferencesDevTool.class));
    }

    public static class HibernateQueryDevTool
        extends AbstractAction
    {
        public HibernateQueryDevTool() {
            putValue(Action.NAME, "Hibernate Query Tool");
        }

        public void actionPerformed(ActionEvent e) {
            Action action = ActionRegistry.getAction("org.osbl.hibernate.hibernate.actions.query");
            action.actionPerformed(new ActionEvent(this, 0, (String)action.getValue(Action.ACTION_COMMAND_KEY)));
        }
    }

    public static class HibernateReferencesDevTool
        extends AbstractAction
    {
        public HibernateReferencesDevTool() {
            putValue(Action.NAME, "Hibernate References Tool");
        }

        public void actionPerformed(ActionEvent e) {
            Action action = ActionRegistry.getAction("org.osbl.hibernate.hibernate.actions.references");
            action.actionPerformed(new ActionEvent(this, 0, (String)action.getValue(Action.ACTION_COMMAND_KEY)));
        }
    }
}
