package org.osbl.client.wings.form;

import org.wings.SLabel;
import org.wings.SComponent;

/**
 * The layout wil retrieve the components from here.
 */
public interface ComponentProvider
{
    String ROOT = "";

    /**
     * Create a title label with the specified message code.
     * @param titleCode the message code
     * @return the title label
     */
    SLabel createTitle(String titleCode);

    /**
     * Get the label for the specified bean and property.
     * @param bean the bean name
     * @param property the property name
     * @return the label
     */
    SLabel getLabel(String bean, String property);

    /**
     * Get the editor component for the specified bean and property.
     * @param bean the bean name
     * @param property the property name
     * @return the editor component
     */
    SComponent getEditorComponent(String bean, String property);

    /**
     * Get the read only component for the specified bean and property.
     * @param bean the bean name
     * @param property the property name
     * @return the read only component
     */
    SComponent getReadOnlyEditorComponent(String bean, String property);

    /**
     * Create a label with the specified message code.
     * @param labelCode the message code
     * @return the label
     */
    SLabel getCustomLabel(String labelCode);

    /**
     * Get a custom component by name.
     * Use it for
     * @param name the property name
     * @return the read only component
     */
    SComponent getCustomComponent(String name);
}
