package org.osbl.client.wings.form;

import org.conform.BeanData;
import org.conform.ValidationException;
import org.wings.SForm;
import org.wings.LowLevelEventListener;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;


/**
 * Created by IntelliJ IDEA.
 * User: hengels
 * Date: Jun 27, 2006
 * Time: 11:27:50 PM
 * To change this template use File | Settings | File Templates.
 */
class DeferredValidationListener
    implements PropertyChangeListener
{
    protected DeferredValidationListener.Trigger trigger;

    public DeferredValidationListener(BeanData beanData) {
        trigger = new DeferredValidationListener.Trigger(beanData);
    }

    public void propertyChange(PropertyChangeEvent evt) {
        SForm.addArmedComponent(trigger);
    }

    private class Trigger
        implements LowLevelEventListener
    {
        private final BeanData beanData;

        public Trigger(BeanData beanData) {
            this.beanData = beanData;
        }

        public void processLowLevelEvent(String name, String[] values) {
        }

        public String getLowLevelEventId() {
            return null;
        }

        public String getEncodedLowLevelEventId() {
            return null;
        }

        public String getName() {
            return null;
        }

        public void fireIntermediateEvents() {
        }

        public void fireFinalEvents() {
            try {
                // TODO: should be selective validation by affected validators only
                // revalidation is more expensive
                beanData.revalidate();
            }
            catch (ValidationException e) {}
        }

        public boolean isEnabled() {
            return false;
        }

        public boolean isEpochCheckEnabled() {
            return false;
        }

        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            final DeferredValidationListener.Trigger that = (DeferredValidationListener.Trigger)o;

            if (!beanData.equals(that.beanData)) return false;

            return true;
        }

        public int hashCode() {
            return beanData.hashCode();
        }
    }
}
