package org.osbl.client.wings.form;

import org.wings.*;
import org.wingx.table.EditableTableCellRenderer;
import org.conform.AbstractDomainProvider;

import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.List;
import java.util.ArrayList;

public class DomainEditableCellRenderer
    extends SComboBox
    implements EditableTableCellRenderer, ActionListener
{
    public DomainEditableCellRenderer(final AbstractDomainProvider domainProvider) {
        List domain = new ArrayList(domainProvider.getDomain());
        if (domain.get(0) != null)
            domain.add(0, null);

        setModel(new DefaultComboBoxModel(domain.toArray()));
        setRenderer(new SDefaultListCellRenderer() {
            public SComponent getListCellRendererComponent(SComponent list, Object value, boolean selected, int row) {
                value = value != null ? domainProvider.format(value) : null;
                return super.getListCellRendererComponent(list, value, selected, row);
            }
        });
        addActionListener(this);
    }

    public SComponent getTableCellRendererComponent(STable table, Object value, boolean isSelected, int row, int column) {
        setSelectedItem(value);
        return this;
    }

    public Object getValue() {
        return getSelectedItem();
    }

    public LowLevelEventListener getLowLevelEventListener(STable table, int row, int col) {
        return this;
    }

    public void actionPerformed(ActionEvent e) {
    }
}
