package org.osbl.client.wings.form;

import org.osbl.client.wings.form.*;
import org.osbl.client.wings.form.editor.ListTableModel;
import org.wings.table.STableColumnModel;

import javax.swing.table.TableModel;
import javax.swing.event.*;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: hengels
 * Date: Jun 2, 2007
 * Time: 7:08:00 PM
 * To change this template use File | Settings | File Templates.
 */
public abstract class GenericCompositionObjectEditor
    extends GenericObjectEditor
    implements CompositionObjectEditor
{
    private EventListenerList listeners = new EventListenerList();

    public void addChangeListener(ChangeListener changeListener) {
        listeners.add(ChangeListener.class, changeListener);
    }
    public void removeChangeListener(ChangeListener changeListener) {
        listeners.remove(ChangeListener.class, changeListener);
    }
    public ChangeListener[] getChangeListeners() {
        return listeners.getListeners(ChangeListener.class);
    }

    public void saveObject(Object object) {
        TableModel tableModel = ((GenericObjectList)getList()).getModel();
        if (tableModel instanceof ListTableModel) {
            ListTableModel listTableModel = (ListTableModel)tableModel;
            List list = listTableModel.getList();
            if (!list.contains(object)) {
                list.add(object);
                listTableModel.fireTableChanged(new TableModelEvent(listTableModel, list.size() - 1, list.size() - 1, TableModelEvent.ALL_COLUMNS, TableModelEvent.INSERT));
            }
            else
                listTableModel.fireTableChanged(new TableModelEvent(listTableModel, list.size() - 1, list.size() - 1, TableModelEvent.ALL_COLUMNS, TableModelEvent.UPDATE));
        }
        ChangeListener[] changeListeners = listeners.getListeners(ChangeListener.class);
        for (int i = 0; i < changeListeners.length; i++) {
            ChangeListener changeListener = changeListeners[i];
            changeListener.stateChanged(new ChangeEvent(this));
        }
    }

    public void deleteObject(Object object) {
        TableModel tableModel = ((GenericObjectList)getList()).getModel();
        if (tableModel instanceof ListTableModel) {
            ListTableModel listTableModel = (ListTableModel)tableModel;
            List list = listTableModel.getList();
            int index = list.indexOf(object);
            list.remove(index);
            listTableModel.fireTableChanged(new TableModelEvent(listTableModel, index, index, TableModelEvent.ALL_COLUMNS, TableModelEvent.DELETE));
        }
        ChangeListener[] changeListeners = listeners.getListeners(ChangeListener.class);
        for (int i = 0; i < changeListeners.length; i++) {
            ChangeListener changeListener = changeListeners[i];
            changeListener.stateChanged(new ChangeEvent(this));
        }
    }

    public void revertObject(Object object) {
    }

    public ObjectTableModel getTableModel() {
        return (ObjectTableModel)((GenericObjectList)getList()).getModel();
    }

    public STableColumnModel getTableColumnModel() {
        return getTableModel().getColumnModel();
    }

    protected String linkPropertyName() {
        return (String)((GenericObjectList)getList()).getColumnModel().getColumn(0).getIdentifier();
    }
}
