package org.osbl.client.wings.form;

import org.wings.*;
import org.wings.event.SMouseListener;
import org.wings.event.SMouseEvent;
import org.wings.border.SLineBorder;
import org.osbl.client.wings.shell.Environment;
import org.osbl.client.action.ObjectAction;
import org.osbl.client.action.ObjectActionEvent;

import javax.swing.tree.*;
import java.awt.*;
import java.util.*;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: hengels
 * Date: Feb 13, 2007
 * Time: 11:49:26 AM
 * To change this template use File | Settings | File Templates.
 */
public abstract class GenericObjectTreeList
    extends STree
    implements ObjectList
{
    protected DelegateEnvironment environment = new DelegateEnvironment();
    Object current;
    private SScrollPane scrollPane;

    public Environment getEnvironment() {
        getComponent();
        return environment;
    }

    public SComponent getComponent() {
        if (scrollPane == null) {
            scrollPane = new SScrollPane(this);
            scrollPane.setPreferredSize(SDimension.FULLAREA);
            scrollPane.setMode(SScrollPane.MODE_COMPLETE);
            scrollPane.setBackground(Color.WHITE);
            scrollPane.setBorder(new SLineBorder(new Color(187,187,187), 1));
        }
        return scrollPane;
    }

    public Class getType() {
        return String.class;
    }

    public GenericObjectTreeModel getModel() {
        return (GenericObjectTreeModel)super.getModel();
    }

    public Object getCurrent() {
        return current;
    }

    public void setCurrent(Object current) {
        this.current = current;
        GenericObjectTreeNode node = (GenericObjectTreeNode)current;
        TreePath path = node != null ? pathForNode(node) : null;
        if (path != null && path.getParentPath() != null)
            expandRow(path.getParentPath());
        setSelectionPath(path);
    }

    private TreePath pathForNode(GenericObjectTreeNode node) {
        java.util.List<GenericObjectTreeNode> list = new ArrayList<GenericObjectTreeNode>();
        do {
            list.add(node);
            node = node.getParent();
        } while (node != null);
        Collections.reverse(list);
        return new TreePath(list.toArray());
    }

    public boolean hasNext() { return false; }

    public void next() {}

    public boolean hasPrevious() { return false; }

    public void previous() {}

    public void setSelectionMode(int selectionMode) {
        switch (selectionMode) {
            case SINGLE_SELECTION:
                getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
                break;
            case MULTIPLE_SELECTION:
                getSelectionModel().setSelectionMode(TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION);
                break;
        }
    }

    public void setSelectedObject(Object object) {
    }

    public Object getSelectedObject() {
        return null;
    }

    public void setSelectedObjects(List objects) {
    }

    public List getSelectedObjects() {
        return null;
    }

    public void setLinkAction(String name, final ObjectAction linkAction) {
        addMouseListener(new SMouseListener() {
            public void mouseClicked(SMouseEvent e) {
                int row = getRowForLocation(e.getPoint());
                TreePath path = getPathForRow(row);
                GenericObjectTreeNode node = (GenericObjectTreeNode)path.getLastPathComponent();
                linkAction.actionPerformed(new ObjectActionEvent(GenericObjectTreeList.this, node));
                e.consume();
            }
        });
    }
}
