package org.osbl.client.wings.form;

import org.osbl.persistence.model.TreeNodeEntity;
import org.osbl.persistence.model.TreeEntity;
import org.osbl.persistence.logic.DefaultTreeLogic;
import org.osbl.persistence.logic.TreeLogic;

import javax.swing.tree.DefaultTreeModel;
import java.util.*;


public abstract class GenericObjectTreeModel
    extends DefaultTreeModel
{
    public static final Comparator<? super TreeNodeEntity> PATH_LENGTH_COMPARATOR = new Comparator<TreeNodeEntity>() {
        public int compare(TreeNodeEntity g1, TreeNodeEntity g2) {
            return g1.getPath().compareTo(g2.getPath());
        }
    };

    protected Map<Class, Class<? extends GenericObjectTreeNode>> map = new HashMap<Class, Class<? extends GenericObjectTreeNode>>();

    public GenericObjectTreeModel(javax.swing.tree.TreeNode treeNode) {
        super(treeNode);
    }

    public GenericObjectTreeNode getRoot() {
        return (GenericObjectTreeNode)super.getRoot();
    }

    public Class<? extends GenericObjectTreeNode> nodeTypeFor(Class childType) {
        return map.get(childType);
    }

    public abstract TreeLogic getTreeLogic();
}
