package org.osbl.client.wings.form;

import org.osbl.client.wings.form.ObjectForm;
import org.osbl.client.wings.form.DelegateEnvironment;
import org.osbl.client.wings.shell.Environment;
import org.wings.SComponent;

public abstract class NestedObjectForm
    implements ObjectForm, ObjectContextAware
{
    protected ObjectForm nestedForm;
    protected Object object;
    protected ObjectContext context;

    protected DelegateEnvironment nestedEnvironment = new DelegateEnvironment();
    protected DelegateEnvironment environment = new DelegateEnvironment();
    {
        environment.setNestedEnvironment(nestedEnvironment);
    }

    public Environment getEnvironment() {
        return environment;
    }

    public ObjectContext getContext() {
        if (context == null) {
            System.out.println("new context: " + context);
            context = new ObjectContext();
        }
        return context;
    }

    public void setContext(ObjectContext context) {
        this.context = context;
    }

    public Object getObject() {
        return object;
    }

    public void setObject(Object object) {
        this.object = object;
    }

    public SComponent getComponent() {
        return nestedForm.getComponent();
    }

    public void setViewMode(int viewMode) {
        nestedForm.setViewMode(viewMode);
    }

    public boolean hasChanges() {
        return nestedForm.hasChanges();
    }

    public boolean hasValidationIssues() {
        return nestedForm.hasValidationIssues();
    }

    public Class getType() {
        return nestedForm.getType();
    }
}
