package org.osbl.client.wings.form;

import org.wings.table.STableColumnModel;
import org.wingx.table.RefreshableModel;

/**
 * A TableModel that assumes, that its rows are bean style objects with identifiers. Furthermore it suspects, that the
 * implementation has sufficient information to create a consistent table column model.
 */
public interface ObjectTableModel
    extends RefreshableModel
{
    /**
     * Create a table column model, that is consistent with this table model.
     * @return a table column model.
     */
    STableColumnModel getColumnModel();

    /**
     * Return the identifier of the row at the specified index.
     * @param rowIndex
     * @return the id of row <code>rowIndex</code>
     */
    Object getRowId(int rowIndex);
}
