package org.osbl.client.wings.form;

import org.osbl.client.wings.form.ObjectViewer;
import org.wings.util.SessionLocal;

import java.util.Map;
import java.util.HashMap;

public class Viewers
{
    private static final Map<Class,Class<? extends ObjectViewer>> viewers = new HashMap<Class,Class<? extends ObjectViewer>>();
    private static final Viewers.Instances instances = new Viewers.Instances();

    public static void registerViewer(Class type, Class<? extends ObjectViewer> viewerClass) {
        viewers.put(type, viewerClass);
    }

    public static ObjectViewer get(Class type) {
        Map<Class, ObjectViewer> map = instances.get();
        ObjectViewer viewer = map.get(type);
        if (viewer == null) {
            try {
                viewer = viewers.get(type).newInstance();
            }
            catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
        return viewer;
    }

    private static class Instances
        extends SessionLocal
    {
        protected Map<Class,ObjectViewer> initialValue() {
            return new HashMap<Class,ObjectViewer>();
        }

        public Map<Class,ObjectViewer> get() {
            return (Map<Class,ObjectViewer>)super.get();
        }
    }
}
