package org.osbl.client.wings.form.editor;

import org.wings.SDefaultListModel;

import java.util.*;

class ListListModel
    extends SDefaultListModel
{
    Comparator sorter;

    public void setSorter(Comparator sorter) {
        this.sorter = sorter;
    }

    public void setList(List list) {
        data.clear();
        data.addAll(list);
        fireContentsChanged(this, 0, list.size() - 1);
    }

    public List getList() {
        return data;
    }

    public boolean remove(Object object) {
        int index = data.indexOf(object);
        if (index != -1) {
            data.remove(index);
            fireIntervalRemoved(this, index, index);
            return true;
        }
        return false;
    }

    public void add(Object object) {
        if (!data.contains(object)) {
            data.add(object);
            int index = data.size() - 1;
            if (sorter != null) {
                Collections.sort(data, sorter);
                index = data.indexOf(object);
            }
            fireIntervalAdded(this, index, index);
        }
    }
}
