package org.osbl.client.wings.form.layouter;

import org.osbl.client.wings.form.ComponentProvider;

import org.wings.*;

/**
 * Place an editor component obtained from the ComponentProvider.
 */
public class CustomEditor extends Editor {
    String name;

    /**
     * Construct a custom editor component placement description.
     * @param name the name of the custom component
     */
    public CustomEditor(String name) {
        this.name = name;
    }

    /**
     * Construct an editor component placement description.
     * @param weight how much of the available vertical space should the line span
     * @param name the name of the custom component
     */
    public CustomEditor(double weight, String name) {
        super(weight);
        this.name = name;
    }

    protected SComponent component(ComponentProvider componentProvider) {
        return componentProvider.getCustomComponent(name);
    }
}
