package org.osbl.client.wings.form.layouter;

import org.osbl.client.wings.form.ComponentProvider;

import org.wings.*;

/**
 * Place an editor component along with a label, both obtained from the ComponentProvider in one line.
 */
public class LabelAndCustomEditor
    extends LabelAndEditor
{
    public String name;

    /**
     * Construct a label and editor component placement description.
     * @param name the name of the custom component
     */
    public LabelAndCustomEditor(String name) {
        this.name = name;
    }

    /**
     * Construct a label and editor component placement description.
     * @param weight how much of the available vertical space should the line span
     * @param name the name of the custom component
     */
    public LabelAndCustomEditor(double weight, String name) {
        super(weight);
        this.name = name;
    }

    protected SLabel label(ComponentProvider componentProvider) {
        SLabel label = componentProvider.getCustomLabel(name);
        label.setVerticalAlignment(SConstants.TOP_ALIGN);
        return label;
    }

    protected SComponent component(ComponentProvider componentProvider) {
        SComponent component = componentProvider.getCustomComponent(name);
        if (component.getVerticalAlignment() == SConstants.NO_ALIGN)
            component.setVerticalAlignment(SConstants.TOP_ALIGN);
        if (component.getHorizontalAlignment() == SConstants.NO_ALIGN)
            component.setHorizontalAlignment(SConstants.LEFT_ALIGN);
        return component;
    }
}
