package org.osbl.client.wings.form.layouter;

import org.wings.SContainer;
import org.wings.SComponent;
import org.osbl.client.wings.form.ComponentProvider;

import java.util.List;

/**
 * A Layouter will arrange SComponents provided by ComponentProvider according to a structural description.
 */
public interface Layouter
{
    /**
     * Construct a container according to the structural description.
     * @param componentProvider fetch components from here
     * @return the container
     */
    SContainer build(ComponentProvider componentProvider);

    List<SComponent> getVisibles();

    List<SComponent> getInvisibles();

    void addVisibilityListener(VisibilityListener listener);

    void removeVisibilityListener(VisibilityListener listener);

    List<SComponent> getFocusableComponents();

    void setApplicability(Instruction instruction, boolean applicable);
}
