package org.osbl.client.wings.form.layouter;

import org.osbl.client.wings.form.ComponentProvider;
import org.wings.*;

import java.util.*;

/**
 * Arranges Pages.
 */
public class PageSet implements Instruction {
    public List<Page> pages;

    /**
     * Construct a structural description of a set of pages.
     * @param pages the pages arranged on in the set.
     */
    public PageSet(Page... pages) {
        this.pages = new ArrayList<Page>(Arrays.asList(pages));
    }

    public void build(ComponentProvider componentProvider, SContainer container) {
    }

    public void follow(Builder builder) {
        for (Page page : pages)
            builder.build(page);
    }
}
