package org.osbl.client.wings.form.layouter;

import org.wings.SComponent;
import org.osbl.client.wings.form.ComponentProvider;

/**
 * Place a renderer component obtained from the ComponentProvider.
 */
public class ReadOnlyEditor
    extends Editor
{
    /**
     * Construct a renderer component placement description.
     * @param bean the bean, whose property is getting readable (typically BeanMeta)
     * @param property the property, which is getting readable (typically PropertyMeta)
     */
    public ReadOnlyEditor(String bean, String property) {
        super(bean, property);
    }

    /**
     * Construct a renderer component placement description.
     * @param weight how much of the available vertical space should the line span
     * @param bean the bean, whose property is getting readable (typically BeanMeta)
     * @param property the property, which is getting readable (typically PropertyMeta)
     */
    public ReadOnlyEditor(double weight, String bean, String property) {
        super(weight, bean, property);
    }

    protected SComponent component(ComponentProvider componentProvider) {
        return componentProvider.getReadOnlyEditorComponent(bean, property);
    }
}
