package org.osbl.client.wings.form.layouter;

import org.wings.*;
import org.wings.border.*;
import org.osbl.client.wings.form.ComponentProvider;

import java.awt.*;


/**
 * Place a title obtained from the ComponentProvider.
 */
public class Title
    extends Line
{
    static private GridBagConstraints titleConstraints = new GridBagConstraints();
    static private GridBagConstraints titleConstraints2 = new GridBagConstraints();
    static {
        titleConstraints = new GridBagConstraints();
        titleConstraints.fill = GridBagConstraints.HORIZONTAL;
        titleConstraints.anchor = GridBagConstraints.SOUTH;
        titleConstraints.gridwidth = GridBagConstraints.RELATIVE;
        titleConstraints.insets = new Insets(0, 0, 10, 0);
        titleConstraints.weightx = 0d;
        titleConstraints2 = new GridBagConstraints();
        titleConstraints2.fill = GridBagConstraints.HORIZONTAL;
        titleConstraints2.anchor = GridBagConstraints.SOUTH;
        titleConstraints2.gridwidth = GridBagConstraints.REMAINDER;
        titleConstraints2.insets = new Insets(0, 0, 10, 0);
        titleConstraints2.weightx = 1d;
    }

    static SAbstractBorder titleBorder = new SLineBorder(Color.ORANGE, 0);
    static SAbstractBorder titleBorder2 = new SLineBorder(Color.ORANGE, 0);
    static {
        titleBorder.setThickness(4, SConstants.BOTTOM);
        titleBorder.setInsets(new Insets(0, 0, 2, 0));
        titleBorder2.setThickness(1, SConstants.BOTTOM);
        titleBorder2.setInsets(new Insets(0, 0, 2, 0));
    }

    public String titleCode;

    /**
     * Construct a title placement description.
     * @param titleCode obtain a title label for this code from the ComponentProvider
     */
    public Title(String titleCode) {
        this.titleCode = titleCode;
    }

    public void build(ComponentProvider componentProvider, SContainer container) {
        SLabel titleLabel = componentProvider.createTitle(titleCode);
        titleLabel.putClientProperty("instruction", this);
        titleLabel.setBorder((SBorder)titleBorder.clone());
        titleLabel.setPreferredSize(SDimension.FULLWIDTH);
        titleLabel.setStyle("SLabel formtitle");

        container.add(titleLabel, titleConstraints);

        SLabel titleLabel2 = new SLabel(" ");
        titleLabel2.setBorder((SBorder)titleBorder2.clone());
        titleLabel2.setPreferredSize(SDimension.FULLWIDTH);
        titleLabel2.setStyle("SLabel formtitle");
        container.add(titleLabel2, titleConstraints2);
    }
}
