/*
 *
 * (c) Copyright 2004 - 2007 osbl development team.
 *
 * This file is part of the osbl (http://osbl.wilken.de).
 *
 * the osbl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.osbl.client.wings.navigation;

import javax.swing.tree.*;

import org.wings.*;
import org.wings.plaf.css.TreeCG;
import org.wings.util.PropertyAccessor;
import org.wings.tree.STreeSelectionModel;
import org.osbl.client.wings.XTitleLabel;

/**
 * @author hengels
 * @version $Revision: 1.3 $
 */
public class Navigation
    extends SPanel
{
    public static final SIcon LEAF = new SResourceIcon("org/wings/icons/transdot.gif");
    public static final SIcon ARROW_DOWN = new SResourceIcon("org/wings/icons/ArrowDown.gif");
    public static final SIcon ARROW_RIGHT = new SResourceIcon("org/wings/icons/ArrowRight.gif");

    private STree tree = new STree();

    public Navigation() {
        super.setLayout(new SBorderLayout(8, 8));

        TreeCG treeCG = new TreeCG();
        tree.setCG(treeCG);
        PropertyAccessor.setProperty(treeCG, "leafControlIcon", LEAF);
        PropertyAccessor.setProperty(treeCG, "collapseControlIcon", ARROW_DOWN);
        PropertyAccessor.setProperty(treeCG, "expandControlIcon", ARROW_RIGHT);

        tree.setStyle("Navigation");
        tree.setCellRenderer(new NavigationTreeCellRenderer());
        tree.getSelectionModel().setSelectionMode(STreeSelectionModel.SINGLE_TREE_SELECTION);
        tree.addMouseListener(new NavigationListener());
        tree.setNodeIndentDepth(12);
        tree.setRootVisible(false);

        add(new XTitleLabel("Navigation"), SBorderLayout.NORTH);
        add(tree, SBorderLayout.CENTER);
    }

    public void setModel(TreeNode root) {
        tree.setModel(new DefaultTreeModel(root));
        for (int i = 0; i < tree.getRowCount(); i++) {
            TreePath path = tree.getPathForRow(i);
            if (path.getPathCount() == 2)
                tree.expandRow(i);
        }
    }
}
