/*
 *
 * (c) Copyright 2004 - 2007 osbl development team.
 *
 * This file is part of the osbl (http://osbl.wilken.de).
 *
 * the osbl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.osbl.client.wings.navigation;

import org.wings.event.SMouseListener;
import org.wings.event.SMouseEvent;
import org.wings.STree;

import javax.swing.*;
import javax.swing.tree.DefaultMutableTreeNode;
import java.awt.event.ActionEvent;

/**
 * @author hengels
 * @version $Revision: 1.4 $
 */
public class NavigationListener
    implements SMouseListener
{
    public void mouseClicked(SMouseEvent e) {
        STree tree = (STree)e.getSource();
        int row = tree.rowAtPoint(e.getPoint());
        DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree.getPathForRow(row).getLastPathComponent();
        Object userObject = node.getUserObject();
        if (userObject instanceof Action) {
            Action action = (Action)userObject;
            action.actionPerformed(new ActionEvent(this, 0, (String)action.getValue(Action.ACTION_COMMAND_KEY)));
        }

        e.consume();
    }
}
