/*
 *
 * (c) Copyright 2004 - 2007 osbl development team.
 *
 * This file is part of the osbl (http://osbl.wilken.de).
 *
 * the osbl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.osbl.client.wings.navigation;

import org.wings.SComponent;
import org.wings.STree;
import org.wings.tree.SDefaultTreeCellRenderer;

import javax.swing.*;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 * @author hengels
 * @version $Revision: 1.1 $
 */
public class NavigationTreeCellRenderer
    extends SDefaultTreeCellRenderer
{
    public SComponent getTreeCellRendererComponent(STree tree, Object value, boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus) {
        super.getTreeCellRendererComponent(tree, value, selected, expanded, leaf, row, hasFocus);

        if (value instanceof DefaultMutableTreeNode) {
            DefaultMutableTreeNode treeNode = (DefaultMutableTreeNode)value;
            Object userObject = treeNode.getUserObject();
            if (userObject instanceof Action) {
                Action action = (Action)userObject;
                if (action.getValue(Action.NAME) == null)
                    action.putValue(Action.NAME, action.getValue(Action.ACTION_COMMAND_KEY));

                setText((String)action.getValue(Action.NAME));
                setToolTipText((String)action.getValue(Action.SHORT_DESCRIPTION));
            }
        }
        setIcon(null);

        if (tree.getPathForRow(row).getPathCount() == 2) {
            String text = getText();
            if (text.startsWith("<html>"))
                text = "<html><b>" + text.substring("<html>".length()) + "</b>";
            else
                text = "<html><b>" + text + "</b>";
            setText(text);
        }

        return this;
    }
}
