package org.osbl.client.wings.shell;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.util.*;

/**
 * @author hengels
 * @version $Revision$
 */
public abstract class AbstractTool
    implements Tool
{
    Map values = new HashMap();
    boolean enabled = true;
    PropertyChangeSupport changeSupport = new PropertyChangeSupport(this);

    public Object getValue(String key) {
        return values.get(key);
    }

    public void putValue(String key, Object value) {
        Object oldValue = values.put(key, value);
        changeSupport.firePropertyChange(key, oldValue, value);
    }

    public boolean isEnabled() {
        return enabled;
    }

    public void setEnabled(boolean enabled) {
        boolean oldEnabled = this.enabled;
        this.enabled = enabled;
        changeSupport.firePropertyChange("enabled", oldEnabled, enabled);
    }

    public void addPropertyChangeListener(PropertyChangeListener listener) {
        changeSupport.addPropertyChangeListener(listener);
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        changeSupport.removePropertyChangeListener(listener);
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        final AbstractTool that = (AbstractTool)o;

        if (values.get(KEY) != null ? !values.get(KEY).equals(that.values.get(KEY)) : that.values.get(KEY) != null) return false;

        return true;
    }

    public int hashCode() {
        return (values.get(KEY) != null ? values.get(KEY).hashCode() : 0);
    }

    public String toString() {
        return (String)values.get(NAME);
    }
}
