package org.osbl.client.wings.shell;

import java.util.List;
import javax.swing.Action;

/**
 * Interface which must be implemented by components that want to display controls in the actionbar.
 * Basically, they must return a list of controls; those controls will appear in the actionbar.
 *
 * @author leon
 */
public interface ButtonsProvider {
 
    /**
     * Returns a list of <code>javax.swing.Action</code>s which will appear in the actionbar.
     * The list may also contain null elements, which will be rendered as spacers.
     *
     * @return a list of <code>javax.swing.Action</code>s which will appear in the actionbar.
     */
    public List<Action> getActions();
}
