package org.osbl.client.wings.shell;

import java.io.File;

import org.wings.*;
import org.wings.session.SessionManager;

/**
 * @author hengels
 * @version $Revision$
 */
public class ContextHelpTool
    extends AbstractTool
{
    protected SRawTextComponent component = new SRawTextComponent();

    public ContextHelpTool() {
        putValue(KEY, "help");
        putValue(NAME, "Help");
    }

    protected String resolve(String helpCode) {
        if (helpCode.endsWith(".title"))
            helpCode = helpCode.substring(0, helpCode.length() - ".title".length()) + ".html";

        String helpDirectory = "/help/" + SessionManager.getSession().getLocale().getLanguage() + "/";
        String fileName = SessionManager.getSession().getServletContext().getRealPath(helpDirectory + helpCode);
        File file = new File(fileName);
        if (file.exists())
            return "../" + helpDirectory + helpCode;
        else
            return null;
    }

    public void setHelpCode(String helpCode) {
        String url = resolve(helpCode);

        if (url == null) {
            component.setText(
                "<div style='margin: 10px; font-size: 12px; font-weight: bold;'>" +
                    Client.getInstance().getResourceProvider().getMessage("help_file_does_not_exist", helpCode) + "</div>");

            setEnabled(false);
        }
        else {
            setHelpUrl(url);
            setEnabled(true);
        }
    }

    protected void setHelpUrl(String url) {
        if (Client.getInstance().isIE())
            component.setText("<iframe" +
                " id=\"" + component.getName() + "\"" +
                " src=\"" + url + "\"" +
                " frameborder=\"0\"" +
                " style=\"position: absolute;" +
                " left: 0px; width: 100%;" +
                " top: 0px; height: 100%;" +
                " border: none; padding: 0px; margin: 0px;\">" +
                "</iframe>");
        else
            component.setText("<iframe" +
                " id=\"" + component.getName() + "\"" +
                " src=\"" + url + "\"" +
                " frameborder=\"0\"" +
                " style=\"position: absolute;" +
                " left: 0px; right: 0px; top: 0px; bottom: 0px;" +
                " border: none; padding: 0px; margin: 0px;\">" +
                "</iframe>");
    }

    public SComponent getComponent() {
        return component;
    }
}
