package org.osbl.client.wings.shell;

/**
 * LazyTab
 * <p/>
 * Page contentPane which implement this interface load their data in a lazy manner.
 */
public interface LazyTab {

    /**
     * This method gets called as soon as the tab gets visible.
     * So do your lazy data loading here.<br>
     *
     * <b>DO NOT CALL THIS METHOD FROM YOUR COMPONENT CONSTRUCTOR</b>
     *
     * You may call this method after the contentPane was initialized, e.g.
     * to reinitialize it.
     */
    public void initTab();
}
