/*
 *
 * (c) Copyright 2004 - 2007 osbl development team.
 *
 * This file is part of con:cern (http://concern.sf.net).
 *
 * the osbl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.osbl.client.wings.shell;

import org.wings.session.SessionManager;
import org.wings.STemplateLayout;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * @version $Revision: 1.2 $
 */
public class Templates
{
    public static URL load(String templateName) {
        try {
            String templateDirectory = (String)SessionManager.getSession().getServletContext().getRealPath("/templates");
            if (templateDirectory == null)
                return SessionManager.getSession().getServletContext().getResource(templateName);

            templateName = templateDirectory + "/" + templateName;

            return new File(templateName).toURL();
        }
        catch (MalformedURLException e) {
            throw new RuntimeException(e);
        }
    }

    public static STemplateLayout loadLayout(String path) {
        try {
            return new STemplateLayout(load(path));
        }
        catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
