package org.osbl.client.wings.shell;

import org.osbl.client.wings.shell.Tool;

import java.util.List;

/**
 * Interface which must be implemented by components that provide tools for the tools sidebar.
 * Basically, they must return a list of components; those components will appear as tabs in
 * the tools sidebar.
 *
 * @author holger
 */
public interface ToolsProvider {
 
    /**
     * Returns a list of <code>org.wings.SComponent</code>s which will appear in the tools sidebar.
     *
     * @return a list of <code>org.wings.SComponent</code>s which will appear in the tools sidebar.
     */
    public List<Tool> getTools();
}
