package org.osbl.client.wings.shell;

import org.osbl.client.ClientResourceProvider;
import org.conform.format.ResourceProvider;
import org.wings.session.SessionManager;

import java.util.List;
import java.util.Locale;

public class WingsClientResourceProvider
    implements ClientResourceProvider
{
    ResourceProvider delegate;

    public void setDelegate(ResourceProvider delegate) {
        this.delegate = delegate;
    }

    /**
     * Resolves a message code with optional arguments.

     * @param code The message code of the label.
     * @param args The optional message arguments.
     * @return A localized message.
     */
    public String getMessage(String code, Object... args) {
        return delegate.getMessage(SessionManager.getSession().getLocale(), code, args);
    }

    public String getMessage(Locale locale, String code, Object... args) {
        return delegate.getMessage(locale, code, args);
    }

    public List<Locale> getSupportedLocales() {
        return delegate.getSupportedLocales();
    }
}
