package org.osbl.concern;

import org.osbl.ObjectLocator;
import org.concern.*;
import org.concern.model.*;

import java.util.Map;
import java.util.HashMap;

public class SubjectLocator
    implements ObjectLocator<Subject>
{
    public Subject objectByQuery(Map<String,String> query) {
        String process = query.get("process");
        String subjectId = query.get("subject");
        String locale = query.get("locale");
        String assignee = query.get("user");
        return ControllerLookup.getInstance().getWorklist().getSubject(process, subjectId, locale, assignee);
    }

    public Map<String,String> queryByObject(Subject subject) {
        Map<String,String> map = new HashMap<String,String>();
        map.put("process", subject.getProcess());
        map.put("subject", subject.getSubjectId());
        return map;
    }
}
