package org.osbl.item;

import java.util.*;

public class EnumLocalizationCollector
    extends AbstractItemCollector
{
    Class enumClass;
    List<String> items;

    public EnumLocalizationCollector(Class enumClass) {
        this.enumClass = enumClass;
    }

    public Collection<String> getItems() {
        if (items == null) {
            try {
                Object[] constants = enumClass.getEnumConstants();

                items = new ArrayList<String>(constants.length);
                StringBuilder builder = new StringBuilder(enumClass.getName());

                for (Object o : constants) {
                    items.add(build(builder, ".", ((Enum)o).name()));
                }
            }
            catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
        return items;
    }
}
