package org.osbl.persistence;

import java.util.*;

public abstract class JoinedQueryCommand<T>
    extends SimpleQueryCommand<T>
{
    protected Map<String,String> joins = new LinkedHashMap<String,String>();

    public JoinedQueryCommand<T> addJoin(String path, String alias) {
        joins.put(path, alias);
        return this;
    }

    public void clearJoins() {
        joins.clear();
    }
}
