package org.osbl.persistence;

import java.io.Serializable;

public abstract class LoadCommand<T>
    implements Command
{
    protected Class<T> type;
    protected Serializable id;

    public LoadCommand<T> setType(Class<T> type) {
        this.type = type;
        return this;
    }

    public LoadCommand<T> setId(Serializable id) {
        this.id = id;
        return this;
    }

    public abstract T execute();
}
