package org.osbl.persistence.hibernate;

import org.osbl.persistence.LoadCommand;
import org.osbl.persistence.GetCommand;
import org.hibernate.SessionFactory;
import org.hibernate.Session;

public class HibernateGetCommand<T>
    extends GetCommand<T>
    implements HibernateCommand
{
    SessionFactory sessionFactory;

    public void setSessionFactory(SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }

    public T execute() {
        Session session = sessionFactory.getCurrentSession();
        return (T)session.get(type, id);
    }
}
