package org.osbl.persistence.hibernate;

import org.osbl.persistence.LoadCommand;
import org.hibernate.*;

public class HibernateLoadCommand<T>
    extends LoadCommand<T>
    implements HibernateCommand
{
    SessionFactory sessionFactory;

    public void setSessionFactory(SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }

    public T execute() {
        Session session = sessionFactory.getCurrentSession();
        return (T)session.load(type, id);
    }
}
