package org.osbl.persistence.hibernate;

import org.osbl.persistence.QueryCommand;
import org.hibernate.*;

import java.util.List;

public class HibernateQueryCommand<T>
    extends QueryCommand<T>
    implements HibernateCommand
{
    SessionFactory sessionFactory;
    String query;

    public void setSessionFactory(SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }

    public HibernateQueryCommand setQuery(String query) {
        this.query = query;

        Session session = sessionFactory.getCurrentSession();
        type = session.createQuery(this.query).getReturnTypes()[0].getReturnedClass();

        return this;
    }

    public Class<T> getType() {
        return type;
    }

    public List<T> execute() {
        Session session = sessionFactory.getCurrentSession();

        if (query != null)
            return session.createQuery(this.query).list();
        else
            return session.createCriteria(type).list();
    }
}
