package org.osbl.persistence.logic;

import org.osbl.persistence.model.TreeEntity;
import org.osbl.persistence.model.TreeNodeEntity;

import java.util.List;

public interface TreeLogic<T extends TreeEntity, N extends TreeNodeEntity>
{
    List<T> trees();
    T tree(String key);

    List<N> roots();
    List<N> roots(Long tree);
    List<N> children(Long tree, Long costType);
    List<N> descendants(Long tree, Long costTypeKey);
    List<N> ancestors(Long tree, Long object);
    List<N> all(Long tree);

    N byPath(String path);

    void connectNodeToNode(N parentTreeNode, N childTreeNode);
    void connectNodeToTree(T tree, N treeNode);
}
