package org.osbl.persistence.model;

import org.conform.Property;
import org.hibernate.Hibernate;

public abstract class Concrete<G extends General>
{
    @Property (writable = "false")
    Long id;
    @Property (writable = "false")
    G general;

    public Concrete() {
    }

    public Concrete(G general) {
        setGeneral(general);
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public G getGeneral() {
        return general;
    }

    public void setGeneral(G general) {
        if (this.general != null)
            this.general.removeConcrete(this);
        this.general = general;
        if (this.general != null)
            this.general.addConcrete(this);
    }

    public String toString() {
        return (general != null ? general.getClass().getSimpleName() : "") + " -> " + getClass().getSimpleName();
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null) return false;

        Concrete concrete = (Concrete)o;

        if (getGeneral() != null ? !getGeneral().equals(concrete.getGeneral()) : concrete.getGeneral() != null) return false;

        return true;
    }

    public int hashCode() {
        return (getGeneral() != null ? getGeneral().hashCode() : 0);
    }
}
