package org.osbl.persistence.model;

import org.conform.Property;

import java.sql.Timestamp;

public abstract class Entity
    implements Comparable
{
    Long id;
    @Property (writable = "false")
    int version;
    @Property (writable = "false", mandatory = "true")
    String key;
    @Property (writable = "false")
    Timestamp created;
    @Property (writable = "false")
    String createdBy;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public int getVersion() {
        return version;
    }

    public void setVersion(int version) {
        this.version = version;
    }

    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    public Timestamp getCreated() {
        return created;
    }

    public void setCreated(Timestamp created) {
        this.created = created;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public int compareTo(Object o) {
        Entity e = (Entity)o;
        if (id == null && e.id != null)
            return 1;
        else if (id != null && e.id == null)
            return -1;
        else if (id == null && e.id == null)
            return 0;
        else
            return id.compareTo(e.id);
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || !(o instanceof Entity)) return false;

        Entity entity = (Entity)o;

        if (getKey() != null ? !getKey().equals(entity.getKey()) : entity.getKey() != null) return false;

        return true;
    }

    public int hashCode() {
        return (getKey() != null ? getKey().hashCode() : 0);
    }

    public String toString() {
        return getKey();
    }
}
