package org.osbl.plugin;

import java.util.List;
import java.util.Arrays;

public class Plugin
{
    String name;
    Plugin parent;
    List<ExtensionPoint> extensionPoints;

    public Plugin(String name, Plugin parent, List<ExtensionPoint> extensionPoints) {
        this.name = name;
        this.parent = parent;
        this.extensionPoints = extensionPoints;
    }

    public Plugin(String name, Plugin parent, ExtensionPoint... extensionPoints) {
        this.name = name;
        this.parent = parent;
        this.extensionPoints = Arrays.asList(extensionPoints);
    }

    public String getName() {
        return name;
    }

    public Plugin getParent() {
        return parent;
    }

    public List<ExtensionPoint> getExtensionPoints() {
        return extensionPoints;
    }
}
