package org.osbl.spring;

import org.springframework.beans.factory.support.DefaultListableBeanFactory;
import org.springframework.beans.factory.xml.XmlBeanDefinitionReader;
import org.springframework.beans.factory.xml.DefaultBeanDefinitionDocumentReader;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.core.io.Resource;

public class DeployedBeanFactory
    extends DefaultListableBeanFactory
{
    private XmlBeanDefinitionReader reader;

    public DeployedBeanFactory(BeanFactory parent) {
        super(parent);
        reader = new XmlBeanDefinitionReader(this);
        reader.setDocumentReaderClass(DefaultBeanDefinitionDocumentReader.class);
    }

    public DeployedBeanFactory() {
        reader = new XmlBeanDefinitionReader(this);
        reader.setDocumentReaderClass(DefaultBeanDefinitionDocumentReader.class);
    }

    public void addResource(Resource resource) {
        this.reader.loadBeanDefinitions(resource);
    }
}
