package org.osbl.riskmanagement;

import org.osbl.*;
import org.osbl.riskmanagement.model.RiskType;
import org.osbl.riskmanagement.model.Risk;
import org.osbl.identity.model.Identity;
import org.osbl.plugin.PluginManager;

public class RiskManagementModule
    implements Module
{
    PluginManager pluginManager;
    ReferenceCheckers referenceCheckers;
    ObjectLocators objectLocators;

    public void setPluginManager(PluginManager pluginManager) {
        this.pluginManager = pluginManager;
    }

    public void setObjectLocators(ObjectLocators objectLocators) {
        this.objectLocators = objectLocators;
    }
    
    public void setReferenceCheckers(ReferenceCheckers referenceCheckers) {
        this.referenceCheckers = referenceCheckers;
    }

    public void initialize() {
        referenceCheckers.registerReferenceChecker(RiskType.class, new RiskToRiskTypeReferenceChecker());
        referenceCheckers.registerReferenceChecker(Identity.class, new RiskTypeToIdentityReferenceChecker());
        referenceCheckers.registerReferenceChecker(Identity.class, new RiskToIdentityReferenceChecker());

        objectLocators.registerObjectLocator(Risk.class, new RiskLocator());
        objectLocators.registerObjectLocator(RiskType.class, new RiskTypeLocator());
    }
}
