package org.osbl.riskmanagement;

import org.osbl.orga.model.Group;
import org.osbl.orga.model.Member;
import org.osbl.ReferenceChecker;
import org.osbl.ServiceProvider;
import org.osbl.identity.model.Identity;
import org.osbl.riskmanagement.model.RiskType;
import org.osbl.riskmanagement.model.Risk;
import org.osbl.persistence.*;
import org.conform.hibernate.HibernateEnvironment;

import java.util.*;

public class RiskToIdentityReferenceChecker
    implements ReferenceChecker<Risk, Identity>
{
    private Persistence persistence;

    public Persistence getPersistence() {
        if (persistence == null)
            persistence = (Persistence)ServiceProvider.getInstance().getService("RiskManagementPersistence");
        return persistence;
    }

    public Collection<Risk> check(Collection<Identity> objects) {
        try {
            HibernateEnvironment.getInstance().beginTransaction();

            JoinedQueryCommand command = (JoinedQueryCommand)getPersistence().createCommand("list");
            command.setType(Risk.class);
            command.clearFilters();
            command.addFilter("assignee", Operator.IN, objects);
            return (List<Risk>)command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }
}
