package org.osbl.riskmanagement;

import org.osbl.riskmanagement.model.RiskType;
import org.osbl.identity.model.Identity;
import org.osbl.ReferenceChecker;
import org.osbl.ServiceProvider;
import org.osbl.persistence.*;
import org.conform.hibernate.HibernateEnvironment;

import java.util.Collection;
import java.util.List;

public class RiskTypeToIdentityReferenceChecker
    implements ReferenceChecker<RiskType, Identity>
{
    private Persistence persistence;

    public Persistence getPersistence() {
        if (persistence == null)
            persistence = (Persistence)ServiceProvider.getInstance().getService("RiskManagementPersistence");
        return persistence;
    }

    public Collection<RiskType> check(Collection<Identity> objects) {
        try {
            HibernateEnvironment.getInstance().beginTransaction();

            JoinedQueryCommand command = (JoinedQueryCommand)getPersistence().createCommand("list");
            command.setType(RiskType.class);
            command.addFilter("responsible", Operator.IN, objects);
            return (List<RiskType>)command.execute();
        }
        finally {
            HibernateEnvironment.getInstance().endTransaction();
        }
    }
}
