package org.osbl.riskmanagement.gui;

import org.conform.BeanMeta;
import org.conform.VariationBeanMetaProvider;
import org.conform.modifier.InlineModifier;
import org.osbl.client.wings.form.ComponentProvider;
import org.osbl.client.wings.form.GenericObjectForm;
import org.osbl.client.wings.form.layouter.*;
import org.osbl.client.wings.shell.Client;
import org.osbl.riskmanagement.model.Classification;

public class ClassificationForm
    extends GenericObjectForm
{
    @Override
    protected Object getObject(String path) {
        if (ComponentProvider.ROOT.equals(path))
            return object;

        return null;
    }

    @Override
    protected void setObject(String path, Object object) {
        if (ComponentProvider.ROOT.equals(path))
            this.object = object;
    }

    @Override
    protected Instruction createLayoutInstruction() {
        return new Page(Classification.class.getName(),
            new Division(Classification.class.getName(),
                         new Column(
                             new LabelAndEditor(ComponentProvider.ROOT, "key"),
                             new LabelAndEditor(ComponentProvider.ROOT, "name")
                         ),
                         new Column(
                             new LabelAndEditors("businessobject.created",
                                 new Editor(ComponentProvider.ROOT, "created"),
                                 new Editor(ComponentProvider.ROOT, "createdBy")
                             )
                         )
            )
        );
    }

    @Override
    protected BeanMeta createBeanMeta(String path) {
        return new VariationBeanMetaProvider(Client.getInstance().getBeanMetaProvider())
            .addModifier(new InlineModifier() {
                protected void configure() {
                    property("key").setWritable(true);
                }
            })
            .getBeanMeta(Classification.class);
    }
}
