package org.osbl.riskmanagement.gui;

import org.osbl.client.wings.form.GenericObjectTreeNode;
import org.osbl.client.wings.form.ObjectContext;
import org.osbl.client.wings.shell.Client;
import org.osbl.riskmanagement.logic.RiskManagementLogic;
import org.osbl.riskmanagement.model.Classification;

import java.util.*;

/**
 * @author hengels
 * @version $Revision$
 */
public class ClassificationsTreeNode
    extends GenericObjectTreeNode
{
    public ClassificationsTreeNode(String object) {
        setObject(object);
    }

    protected void loadChildren() {
        RiskTypeTreeModel model = (RiskTypeTreeModel)getModel();
        RiskManagementLogic logic = model.getTreeLogic();
        List<Classification> riskTypes = logic.trees();
        children = new ArrayList<GenericObjectTreeNode>();
        for (Iterator<Classification> iterator = riskTypes.iterator(); iterator.hasNext();) {
            Classification classification = iterator.next();
            ClassificationTreeNode child = new ClassificationTreeNode(classification);
            children.add(child);
            child.setParent(this);
        }
        sortChildren();
    }

    public boolean getAllowsChildren() {
        return true;
    }

    public boolean isLeaf() {
        return false;
    }

    public String toString() {
        return Client.getInstance().getResourceProvider().getMessage("org.osbl.riskmanagement.actions.manage");
    }

    public Class getObjectType() {
        return String.class;
    }

    public Class[] getChildTypes() {
        return new Class[] { Classification.class };
    }

    public String loadObject() {
        return (String)object;
    }
}
