package org.osbl.riskmanagement.gui;

import org.osbl.client.wings.concern.ObjectFormViewModes;
import org.conform.modifier.InlineModifier;
import org.conform.DefaultBeanData;
import org.conform.wings.editor.BooleanEditor;

public class DiscardRiskForm
    extends RiskForm
{
    public DiscardRiskForm() {
        addViewModeVariation(ObjectFormViewModes.ACTIVITY_VIEW, new InlineModifier() {
            protected void configure() {
                property("type").setWritable(false);
                property("coverage").setWritable(false);
                property("amount").setWritable(false);
                property("probability").setWritable(false);
                property("comment").setWritable(false);
                property("assignee").setWritable(false);
                property("criticality").setWritable(false);
                property("progression").setWritable(false);
                property("obsolete").setWritable(false);

                property("obsolete").setWritable(true);
                property("obsolete").setAttribute(DefaultBeanData.PROPERTY_DATA_CLASS, NowOrNeverPropertyData.class.getName());
                property("obsolete").setAttribute(org.conform.wings.Editor.CUSTOM_EDITOR, new BooleanEditor());
            }
        });
        setViewMode(ObjectFormViewModes.ACTIVITY_VIEW);
    }
}
