package org.osbl.riskmanagement.gui;

import org.conform.*;
import org.osbl.identity.model.Identity;
import org.osbl.identity.model.User;
import org.osbl.persistence.*;
import org.osbl.ServiceProvider;
import org.wings.session.SessionManager;

/**
 * @author hengels
 * @version $Revision: 840 $
 */
public class MePropertyData
    extends DefaultPropertyData
{
    private Identity identity;

    public MePropertyData(DefaultBeanData beanData, PropertyMeta property) {
        super(beanData, property);
    }

    public Object getValue() {
        return super.getValue() != null;
    }

    public void setValue(Object value) {
        if (Boolean.TRUE.equals(value)) {
            super.setValue(getIdentity());
        }
        else
            super.setValue(null);
    }

    private Identity getIdentity() {
        if (identity == null) {
            Persistence persistence = (Persistence)ServiceProvider.getInstance().getService("IdentityPersistence");
            SimpleQueryCommand command = (SimpleQueryCommand)persistence.createCommand("list");
            command.setType(User.class);
            command.addFilter("account", Operator.EQUAL, SessionManager.getSession().getServletRequest().getUserPrincipal().getName());
            User user = (User)command.execute().get(0);
            identity = user.getGeneral();
        }
        return identity;
    }
}
