package org.osbl.riskmanagement.gui;

import org.conform.modifier.InlineModifier;
import org.conform.*;
import org.osbl.ServiceProvider;
import org.osbl.client.wings.form.*;
import org.osbl.client.wings.form.layouter.*;
import org.osbl.client.wings.shell.Client;
import org.osbl.identity.model.*;
import org.osbl.identity.model.Person;
import org.osbl.identity.gui.IdentityConcreteDomainProvider;
import org.osbl.persistence.*;
import org.osbl.riskmanagement.model.RiskType;

import java.util.ArrayList;
import java.util.List;

public class RiskTypeForm
    extends GenericObjectForm
    implements HierarchicalContextAware
{
    IdentityConcreteDomainProvider<Person> personDomain = new IdentityConcreteDomainProvider<Person>(Person.class);

    public void setObject(Object object) {
        super.setObject(object);
    }

    public void setContext(ObjectContext context) {
        super.setContext(context);
        personDomain.refresh();
    }

    @Override
    protected Object getObject(String path) {
        if (ComponentProvider.ROOT.equals(path))
            return object;

        return null;
    }

    @Override
    protected void setObject(String path, Object object) {
        if (ComponentProvider.ROOT.equals(path))
            this.object = object;
    }

    @Override
    protected Instruction createLayoutInstruction() {
        return new Page(RiskType.class.getName(),
            new Division(RiskType.class.getName(),
                new Column(
                    new LabelAndEditor(ComponentProvider.ROOT, "key"),
                    new LabelAndEditor(ComponentProvider.ROOT, "name"),
                    new LabelAndEditor(ComponentProvider.ROOT, "responsible"),
                    new LabelAndEditor(ComponentProvider.ROOT, "amount")
                ),
                new Column(
                    new LabelAndEditors("businessobject.created",
                        new Editor(ComponentProvider.ROOT, "created"),
                        new Editor(ComponentProvider.ROOT, "createdBy")
                    ),
                    new LabelAndEditors("businessobject.valid",
                        new Editor(ComponentProvider.ROOT, "validFrom"),
                        new Editor(ComponentProvider.ROOT, "validUntil")
                    )
                )
            ),
            new Division("businessobject.description",
                new Column(
                    new LabelAndEditor(ComponentProvider.ROOT, "description")
                )
            )
        );
    }

    @Override
    protected BeanMeta createBeanMeta(String path) {
        return new VariationBeanMetaProvider(Client.getInstance().getBeanMetaProvider())
            .addModifier(new InlineModifier() {
                protected void configure() {
                    property("key").setWritable(true);
                    property("responsible").setDomainProvider(personDomain);
                    property("responsible").setFormat(Client.getInstance().getBeanMetaProvider().getBeanMeta(Identity.class).getFormat());
                    property("path").setApplicable(false);
                    property("tree").setApplicable(false);
                }
            })
            .getBeanMeta(RiskType.class);
    }

    public void setNode(GenericObjectTreeNode node) {
    }
}
