package org.osbl.riskmanagement.gui;

import org.osbl.client.wings.form.GenericObjectTreeList;
import org.wings.SComponent;
import org.wings.STree;
import org.wings.tree.SDefaultTreeCellRenderer;

import javax.swing.tree.TreeSelectionModel;

public class RiskTypeTreeList
    extends GenericObjectTreeList
{
    public RiskTypeTreeList() {
        setModel(new RiskTypeTreeModel());
        getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        setCellRenderer(new SDefaultTreeCellRenderer() {
            public SComponent getTreeCellRendererComponent(STree tree, Object value, boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus) {
                SComponent component = super.getTreeCellRendererComponent(tree, value, selected, expanded, leaf, row, hasFocus);

                if (value instanceof ClassificationTreeNode)
                    setIcon(RiskManagementIcons.CLASSIFICATION);
                else if (value instanceof RiskTypeTreeNode)
                    setIcon(RiskManagementIcons.RISKTYPE);

                return component;
            }
        });
    }

    public void refresh() {
    }
}
