package org.osbl.riskmanagement.gui;

import org.osbl.ServiceProvider;
import org.osbl.client.wings.form.GenericObjectTreeModel;
import org.osbl.persistence.Persistence;
import org.osbl.riskmanagement.logic.RiskManagementLogic;
import org.osbl.riskmanagement.model.RiskType;
import org.osbl.riskmanagement.model.Classification;

/**
 * @author hengels
 * @version $Revision$
 */
public class RiskTypeTreeModel
    extends GenericObjectTreeModel
{
    Persistence persistence = (Persistence)ServiceProvider.getInstance().getService("RiskManagementPersistence");
    RiskManagementLogic riskManagementLogic = (RiskManagementLogic)ServiceProvider.getInstance().getService("RiskManagementLogic");

    {
        map.put(Classification.class, ClassificationTreeNode.class);
        map.put(RiskType.class, RiskTypeTreeNode.class);
    }

    public RiskTypeTreeModel() {
        super(new ClassificationsTreeNode("Root"));
        getRoot().setModel(this);
    }

    public RiskManagementLogic getTreeLogic() {
        return riskManagementLogic;
    }

    public Persistence getPersistence() {
        return persistence;
    }
}
