package org.osbl.riskmanagement.gui.report;

import org.wings.*;
import org.wings.session.SessionManager;
import org.wings.event.SMouseListener;
import org.wings.event.SMouseEvent;
import org.wings.table.SDefaultTableCellRenderer;
import org.wingx.XTreeTable;
import org.wingx.treetable.*;
import org.osbl.riskmanagement.gui.RiskManagementIcons;
import org.osbl.client.action.ActionProvider;
import org.osbl.client.wings.shell.Client;
import org.osbl.client.wings.action.ShowEditorAction;

import java.util.Map;
import java.util.HashMap;

public class RiskTreeTable
    extends SScrollPane
{
    RiskTreeTableModel treeTableModel;
    XTreeTable treeTable;

    public RiskTreeTable() {
        treeTableModel = new RiskTreeTableModel();
        treeTable = new XTreeTable(treeTableModel);
        treeTable.getColumnModel().getColumn(0).setCellRenderer(new TreeColumnRenderer() {
            public SComponent getTableCellRendererComponent(STable table, Object value, boolean selected, final int row, final int col) {
                SComponent component = super.getTableCellRendererComponent(table, value, selected, row, col);
                if (treeTableModel.getNodeModel().get(row) instanceof RiskTreeTableNode) {
                    if (!(component.getStyle().indexOf(" link ") > 0)) {
                        component.setStyle(getStyle() + " link ");
                    }
                } else if (component.getStyle() != null) {
                    component.setStyle(component.getStyle().replaceAll(" link ", " "));
                }
                return component;
            }
        });
        treeTable.getColumnModel().getColumn(5).setCellRenderer(new SDefaultTableCellRenderer() {
            public SComponent getTableCellRendererComponent(STable table, Object value, boolean selected, int row, int col) {
                return super.getTableCellRendererComponent(table, RiskManagementIcons.ICONS.get(value), selected, row, col);
            }
        });
        treeTable.addMouseListener(new SMouseListener() {
            public void mouseClicked(SMouseEvent e) {
                int row = treeTable.rowAtPoint(e.getPoint());
                int col = treeTable.columnAtPoint(e.getPoint());
                XTreeTableNode node = (XTreeTableNode)treeTableModel.getNodeModel().get(row);
                if (col == 0 && node instanceof RiskTreeTableNode) {
                    RiskTreeTableNode riskTreeTableNode = (RiskTreeTableNode)node;

                    final ActionProvider sessionActionProvider = Client.getInstance().getActionProvider();
                    ShowEditorAction action = (ShowEditorAction)sessionActionProvider.getAction("org.concern.actions.subjects");
                    if (action != null && action.isEnabled()) {
                        Map query = new HashMap();
                        query.put("process", "RiskManagement");
                        query.put("subject", "" + riskTreeTableNode.getObject().getId());
                        query.put("locale", "" + SessionManager.getSession().getLocale().toString());
                        action.navigate(query);
                    }
                    e.consume();
                }
            }
        });
        setViewportView(treeTable);
        setPreferredSize(SDimension.FULLAREA);
        setMode(SScrollPane.MODE_COMPLETE);
    }
}
