package org.osbl.riskmanagement.gui.report;

import org.wingx.treetable.XTreeTableModel;
import org.wingx.treetable.XTreeTableNode;
import org.osbl.riskmanagement.model.*;
import org.osbl.client.wings.shell.Client;

import java.math.BigDecimal;

public class RiskTreeTableModel
    extends XTreeTableModel
{
    private static final Class[] columnClasses = { String.class, BigDecimal.class, BigDecimal.class, BigDecimal.class, BigDecimal.class, Criticality.class, };
    private static final String[] columnNames = {
        Client.getInstance().getResourceProvider().getMessage(RiskType.class.getName() + ".name"),
        Client.getInstance().getResourceProvider().getMessage(Risk.class.getName() + ".amount"),
        Client.getInstance().getResourceProvider().getMessage(Risk.class.getName() + ".probability"),
        Client.getInstance().getResourceProvider().getMessage(Risk.class.getName() + ".multiplied"),
        Client.getInstance().getResourceProvider().getMessage(Risk.class.getName() + ".coverage"),
        Client.getInstance().getResourceProvider().getMessage(Risk.class.getName() + ".criticality"),
    };

    public RiskTreeTableModel() {
        super(new RiskTreeModel());
    }

    @Override
    public int getColumnCount() {
        return columnClasses.length;
    }

    @Override
    public String getColumnName(int index) {
        return columnNames[index];
    }

    @Override
    public Class<?> getColumnClass(int index) {
        return columnClasses[index];
    }

    public String getFirstColumnValue(int row) {
        XTreeTableNode node = (XTreeTableNode)getNodeModel().get(row);
        return "" + node.getValueAt(0);
    }
}
