package org.osbl.riskmanagement.gui.report;

import org.osbl.client.wings.form.GenericObjectTreeNode;
import org.osbl.riskmanagement.model.Risk;
import org.osbl.riskmanagement.gui.RiskTypeTreeModel;
import org.osbl.persistence.LoadCommand;
import org.wingx.treetable.XTreeTableNode;

import java.util.*;
import java.math.BigDecimal;

/**
 * Created by IntelliJ IDEA.
* User: hengels
* Date: Feb 15, 2007
* Time: 2:52:12 PM
* To change this template use File | Settings | File Templates.
*/
public class RiskTreeTableNode
    extends GenericObjectTreeNode<Risk>
    implements XTreeTableNode
{
    boolean expanded;
    private int depth = -1;

    public RiskTreeTableNode() {
    }

    public RiskTreeTableNode(Risk object) {
        this.object = object;
    }

    protected void loadChildren() {
        children = Collections.EMPTY_LIST;
    }

    public boolean getAllowsChildren() {
        return false;
    }

    public boolean isLeaf() {
        return true;
    }

    public Class getObjectType() {
        return Risk.class;
    }

    public Class[] getChildTypes() {
        return new Class[] { };
    }

    public Object getValueAt(int column) {
        Risk risk = getObject();
        BigDecimal coverage = risk.getCoverage();
        BigDecimal amount = risk.getAmount();
        BigDecimal probability = risk.getProbability();

        switch (column) {
            case 0:
                return risk.getKey();
            case 1:
                return amount;
            case 2:
                return probability;
            case 3:
                if (amount != null && probability != null)
                    return amount.multiply(probability).divide(new BigDecimal(100));
                else
                    return null;
            case 4:
                return coverage;
            case 5:
                return risk.getCriticality();

            default:
                return null;
        }
    }

    public void setValueAt(Object value, int column) {
    }

    public Class getNodeClass() {
        return getObjectType();
    }

    public boolean isExpanded() {
        return expanded;
    }

    public void setExpanded(boolean expanded) {
        this.expanded = expanded;
    }

    public int getDepth() {
        if (depth < 0) {
            XTreeTableNode parent = (XTreeTableNode) getParent();
            depth = (parent != null) ? parent.getDepth() + 1 : 0;
        }
        return this.depth;
    }

    public Risk loadObject() {
        LoadCommand loadCommand = (LoadCommand)((RiskTypeTreeModel)getModel()).getPersistence().createCommand("revert");
        Risk object = getObject();
        loadCommand.setId(object.getId());
        loadCommand.execute();
        return object;
    }
}
