package org.osbl.riskmanagement.gui.report;

import org.wingx.treetable.XTreeTableNode;
import org.osbl.riskmanagement.model.RiskType;
import org.osbl.riskmanagement.logic.RiskManagementLogic;
import org.osbl.client.wings.form.GenericObjectTreeNode;
import org.osbl.client.wings.form.ObjectContext;

import java.util.ArrayList;
import java.util.List;

public class RootTreeTableNode
    extends GenericObjectTreeNode
    implements XTreeTableNode
{
    boolean expanded;

    public RootTreeTableNode() {
    }

    public RootTreeTableNode(Object object) {
        this.object = object;
    }

    public String getObject() {
        return "Report";
    }

    protected void loadChildren() {
        RiskTreeModel model = (RiskTreeModel)getModel();
        RiskManagementLogic logic = model.getTreeLogic();
        List<RiskType> riskTypes = logic.roots();

        children = new ArrayList<GenericObjectTreeNode>(riskTypes.size());
        for (RiskType childRiskType : riskTypes) {
            RiskTypeTreeTableNode child = new RiskTypeTreeTableNode(childRiskType);
            children.add(child);
            child.setParent(this);
        }

        sortChildren();
    }

    public boolean getAllowsChildren() {
        return true;
    }

    public boolean isLeaf() {
        return false;
    }

    public Class getObjectType() {
        return String.class;
    }

    public Class[] getChildTypes() {
        return new Class[] { RiskType.class };
    }

    public Object loadObject() {
        return getObject();
    }

    public Object getValueAt(int column) {
        return "" + column;
    }

    public void setValueAt(Object value, int column) {
    }

    public Class getNodeClass() {
        return getObjectType();
    }

    public boolean isExpanded() {
        return expanded;
    }

    public void setExpanded(boolean expanded) {
        this.expanded = expanded;
    }

    public int getDepth() {
        return 0;
    }
}
