package org.osbl.riskmanagement.logic;

import org.hibernate.*;
import org.osbl.riskmanagement.model.*;
import org.osbl.persistence.logic.DefaultTreeLogic;

import java.util.List;

/**
 * @author hengels
 * @version $Revision$
 */
public class DefaultRiskManagementLogic
    extends DefaultTreeLogic<Classification, RiskType>
    implements RiskManagementLogic
{
    protected String getNodeType() {
        return RiskType.class.getName();
    }

    protected String getTreeType() {
        return Classification.class.getName();
    }

    public List<Risk> risks(Long riskType) {
        Session session = getSessionFactory().getCurrentSession();
        Query query = session.createQuery("from Risk r where r.type.id = :riskType and obsolete is null");
        query.setLong("riskType", riskType);
        return query.list();
    }
}
