package org.osbl.riskmanagement.model;

import org.conform.*;
import org.conform.validator.NumberRange;
import org.osbl.persistence.model.Entity;
import org.osbl.identity.model.Identity;

import java.math.BigDecimal;
import java.sql.Timestamp;

/**
 * @author hengels
 * @version $Revision: 840 $
 */
public class Record
{
    Long id;

    @Property (mandatory = "true")
    Timestamp timestamp;

    @NumberRange (from = "0")
    BigDecimal coverage;
    @NumberRange (from = "0")
    BigDecimal amount;
    @NumberRange (from = "0", fromInclusive = true, until="100", untilInclusive = true)
    BigDecimal probability;

    String comment;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Timestamp getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(Timestamp timestamp) {
        this.timestamp = timestamp;
    }

    public BigDecimal getCoverage() {
        return coverage;
    }

    public void setCoverage(BigDecimal coverage) {
        this.coverage = coverage;
    }

    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    public BigDecimal getProbability() {
        return probability;
    }

    public void setProbability(BigDecimal probability) {
        this.probability = probability;
    }

    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    public String toString() {
        if (amount != null && probability != null)
            return timestamp + " " + amount.multiply(probability);
        else
            return timestamp + "";
    }
}
