/*
 *
 * (c) Copyright 2004 - 2007 osbl development team.
 *
 * This file is part of the osbl (http://osbl.wilken.de).
 *
 * the osbl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * Please see COPYING for the complete licence.
 */
package org.osbl.riskmanagement.model;

import org.conform.Property;
import org.conform.validator.NumberRange;
import org.osbl.identity.model.Identity;
import org.osbl.persistence.model.TreeNodeEntity;

import java.math.BigDecimal;
import java.sql.Date;

/**
 * @author hengels
 * @version $Revision: 840 $
 */
public class RiskType
    extends TreeNodeEntity<Classification>
{
    @Property (mandatory = "true")
    Date validFrom;

    Date validUntil;

    @Property (mandatory = "true")
    String name;
    String description;

    @Property (mandatory = "true")
    Identity responsible;

    @Property (mandatory = "true")
    @NumberRange (from = "0")
    BigDecimal amount;

    public Date getValidFrom() {
        return validFrom;
    }

    public void setValidFrom(Date validFrom) {
        this.validFrom = validFrom;
    }

    public Date getValidUntil() {
        return validUntil;
    }

    public void setValidUntil(Date validUntil) {
        this.validUntil = validUntil;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Identity getResponsible() {
        return responsible;
    }

    public void setResponsible(Identity responsible) {
        this.responsible = responsible;
    }

    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    public String toString() {
        return name;
    }
}
