package org.osbl.riskmanagement.process;

import org.osbl.riskmanagement.model.Risk;
import org.osbl.riskmanagement.model.Record;
import org.concern.library.generic.FormClassNameActivity;
import org.concern.controller.ActivityExecutionException;

import java.math.BigDecimal;
import java.util.List;
import java.util.ArrayList;
import java.sql.Timestamp;

public class Maintain
    extends FormClassNameActivity<Risk>
{
    @Override
    public void delist(Risk risk) throws ActivityExecutionException {
    	/*PROTECTED REGION ID(org.osbl.riskmanagement.process.Maintain.delist) ENABLED START*/
        BigDecimal coverage = risk.getCoverage();
        BigDecimal amount = risk.getAmount();
        BigDecimal probability = risk.getProbability();
        String comment = risk.getComment();

        List<Record> progression = risk.getProgression();
        if (progression == null)
            risk.setProgression(progression = new ArrayList<Record>(1));

        Record record = progression.size() > 0 ? progression.get(progression.size() - 1) : null;
        if (record == null ||
            !coverage.equals(record.getCoverage()) ||
            !amount.equals(record.getAmount()) ||
            !probability.equals(record.getProbability()) ||
            comment == null && record.getComment() != null ||
            (comment != null && !comment.equals(record.getComment())))
        {
            record = new Record();
            record.setTimestamp(new Timestamp(System.currentTimeMillis()));
            record.setCoverage(coverage);
            record.setAmount(amount);
            record.setProbability(probability);
            record.setComment(risk.getComment());
            progression.add(record);
            System.out.println("add record: " + record);
        }
        /*PROTECTED REGION END*/
    }
}
