package org.osbl.riskmanagement.process;

import org.concern.library.generic.FormClassNameActivity;
import org.concern.controller.ActivityExecutionException;
import org.osbl.riskmanagement.model.Risk;
import org.osbl.riskmanagement.model.Record;
import org.osbl.identity.model.Identity;

import java.sql.Timestamp;
import java.math.BigDecimal;
import java.util.List;
import java.util.ArrayList;

public class Qualify
    extends FormClassNameActivity<Risk>
{
    @Override
    public void delist(Risk risk) throws ActivityExecutionException {
    	 /*PROTECTED REGION ID(org.osbl.riskmanagement.process.Qualify.delist) ENABLED START*/
        Identity assignee = risk.getAssignee();
        BigDecimal coverage = risk.getCoverage();
        BigDecimal amount = risk.getAmount();
        BigDecimal probability = risk.getProbability();

        if (assignee != null && coverage != null && amount != null && probability != null) {
            Record record = new Record();
            record.setTimestamp(new Timestamp(System.currentTimeMillis()));
            record.setCoverage(coverage);
            record.setAmount(amount);
            record.setProbability(probability);
            record.setComment(risk.getComment());
            List<Record> progression = new ArrayList<Record>();
            progression.add(record);
            risk.setProgression(progression);
            System.out.println("first record: " + record);
        }
        /*PROTECTED REGION END*/
    }
}
