package org.osbl.riskmanagement.process;

import org.concern.*;
import org.concern.controller.*;

import org.osbl.riskmanagement.model.*;

import java.math.BigDecimal;

public class Update
    extends AbstractSynchronousActivity<Risk>
{
    Integer mediumThreshold;
    Integer highThreshold;
    Integer criticalThreshold;

    public void setMediumThreshold(Integer mediumThreshold) {
        this.mediumThreshold = mediumThreshold;
    }

    public void setHighThreshold(Integer highThreshold) {
        this.highThreshold = highThreshold;
    }

    public void setCriticalThreshold(Integer criticalThreshold) {
        this.criticalThreshold = criticalThreshold;
    }

    public void execute(Risk risk) throws ActivityExecutionException {
    	/*PROTECTED REGION ID(org.osbl.riskmanagement.process.Update.execute) ENABLED START*/
        risk.setCriticality(criticality(risk));
        /*PROTECTED REGION END*/
    }

    private Criticality criticality(Risk risk) {
        BigDecimal amount = risk.getAmount();
        BigDecimal probability = risk.getProbability();
        BigDecimal coverage = risk.getCoverage();
        if (amount == null || probability == null || coverage == null)
            return Criticality.UNKNOWN;

        BigDecimal percentage = amount.multiply(probability).divide(coverage, 2);
        System.out.println("percentage = " + percentage);
        if (percentage.intValue() > criticalThreshold)
            return Criticality.CRITICAL;
        else if (percentage.intValue() > highThreshold)
            return Criticality.HIGH;
        else if (percentage.intValue() > mediumThreshold)
            return Criticality.MEDIUM;
        else
            return Criticality.LOW;
    }
}
