package org.osbl.riskmanagement.model;

import junit.framework.TestCase;
import org.hibernate.*;
import org.hibernate.cfg.Configuration;

public class RiskTypeMappingTest
    extends TestCase
{
    private Session session;
    private Transaction transaction;

    protected void setUp()
        throws Exception
    {
        Configuration configuration = new Configuration();
        configuration.configure("test-hibernate.cfg.xml");
        configuration.addResource("Identity.hbm.xml");
        configuration.addResource("RiskManagement.hbm.xml");

        SessionFactory sessionFactory = configuration.buildSessionFactory();
        session = sessionFactory.openSession();
        transaction = session.beginTransaction();
    }

    public void testCRUD()
    {
        Classification classification = new Classification();

        RiskType rootRiskType = new RiskType();
        rootRiskType.setKey("root");
        rootRiskType.setTree(classification);

        RiskType childRiskType = new RiskType();
        childRiskType.setKey("child");
        childRiskType.setTree(classification);

        session.save(classification);

        session.save(rootRiskType);
        rootRiskType.setPath("/" + rootRiskType.getId() + "/");
        rootRiskType.setDepth(1);

        session.save(childRiskType);
        childRiskType.setPath(rootRiskType.getPath() + childRiskType.getId() + "/");
        childRiskType.setDepth(2);

        session.flush();
        session.clear();

        RiskType loadedRisktype = (RiskType)session.createQuery("from RiskType where key = 'root'").uniqueResult();
        assertNotNull(loadedRisktype);

        loadedRisktype = (RiskType)session.createQuery("from RiskType where key = 'child'").uniqueResult();
        assertNotNull(loadedRisktype);
    }

    protected void tearDown() throws Exception {
        transaction.rollback();
        session.close();
    }
}
