/**
 * 
 */
package generate.utils;

import java.io.File;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.openarchitectureware.workflow.WorkflowContext;
import org.openarchitectureware.workflow.issues.Issues;
import org.openarchitectureware.workflow.lib.AbstractWorkflowComponent2;
import org.openarchitectureware.workflow.monitor.ProgressMonitor;

/**
 * This directory creator is needed for the
 * protected region detection. The protected
 * region detection has to access the source
 * folder to scan for pr before the source
 * creator works on the folder.
 * 
 * @author sh
 */
public class DirectoryCreator extends AbstractWorkflowComponent2 {
	
	private final Log log = LogFactory.getLog(DirectoryCreator.class);
	
	private String directory;

    public void setDirectory(final String directory) {
        this.directory = directory;
    }
    
    public void addDirectory(final String directory) {
    	this.directory = directory;
    }
    
    public String getLogMessage() {
    	return "creating directory '"+directory+"'";
    }

	@Override
	protected void checkConfigurationInternal(Issues issues) {
		if (directory == null || directory.equals("")) {
            issues.addError("No source directory created !");
        }
	}

	@Override
	protected void invokeInternal(WorkflowContext model, ProgressMonitor monitor,
			Issues issues) {
			
		File file = new File(directory);
		if (file.exists() && file.isDirectory()) return;
		file.mkdirs();		
	}
}
